#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 2019
#define LARGE_STATE_COUNT 359
#define SYMBOL_COUNT 188
#define ALIAS_COUNT 0
#define TOKEN_COUNT 84
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 28
#define MAX_ALIAS_SEQUENCE_LENGTH 12
#define PRODUCTION_ID_COUNT 71

enum ts_symbol_identifiers {
  sym__lower_id = 1,
  anon_sym_module = 2,
  anon_sym_LT = 3,
  anon_sym_COMMA = 4,
  anon_sym_GT = 5,
  anon_sym_implements = 6,
  anon_sym_LBRACE = 7,
  anon_sym_RBRACE = 8,
  anon_sym_import = 9,
  anon_sym_as = 10,
  anon_sym_EQ = 11,
  anon_sym_SEMI = 12,
  anon_sym_or = 13,
  anon_sym_LPAREN = 14,
  anon_sym_RPAREN = 15,
  anon_sym_newtype = 16,
  anon_sym_from = 17,
  anon_sym_where = 18,
  anon_sym_select = 19,
  anon_sym_class = 20,
  anon_sym_extends = 21,
  anon_sym_instanceof = 22,
  anon_sym_in = 23,
  anon_sym_not = 24,
  anon_sym_if = 25,
  anon_sym_then = 26,
  anon_sym_else = 27,
  anon_sym_and = 28,
  anon_sym_implies = 29,
  anon_sym_PIPE = 30,
  sym_specialId = 31,
  anon_sym_exists = 32,
  anon_sym_forall = 33,
  anon_sym_forex = 34,
  sym_underscore = 35,
  anon_sym_DOT = 36,
  anon_sym_LBRACK = 37,
  anon_sym_RBRACK = 38,
  anon_sym_DOT_DOT = 39,
  anon_sym_BANG_EQ = 40,
  anon_sym_LT_EQ = 41,
  anon_sym_GT_EQ = 42,
  anon_sym_PLUS = 43,
  anon_sym_DASH = 44,
  anon_sym_STAR = 45,
  anon_sym_SLASH = 46,
  anon_sym_PERCENT = 47,
  anon_sym_asc = 48,
  anon_sym_desc = 49,
  anon_sym_order = 50,
  anon_sym_by = 51,
  sym_qldoc = 52,
  anon_sym_COLON_COLON = 53,
  anon_sym_boolean = 54,
  anon_sym_date = 55,
  anon_sym_float = 56,
  anon_sym_int = 57,
  anon_sym_string = 58,
  sym_dbtype = 59,
  anon_sym_avg = 60,
  anon_sym_concat = 61,
  anon_sym_strictconcat = 62,
  anon_sym_count = 63,
  anon_sym_max = 64,
  anon_sym_min = 65,
  anon_sym_rank = 66,
  anon_sym_strictcount = 67,
  anon_sym_strictsum = 68,
  anon_sym_sum = 69,
  anon_sym_any = 70,
  anon_sym_unique = 71,
  sym__upper_id = 72,
  sym_integer = 73,
  sym_float = 74,
  sym_string = 75,
  sym_line_comment = 76,
  sym_block_comment = 77,
  sym_false = 78,
  sym_predicate = 79,
  sym_result = 80,
  sym_super = 81,
  sym_this = 82,
  sym_true = 83,
  sym_ql = 84,
  sym_module = 85,
  sym_moduleMember = 86,
  sym_importDirective = 87,
  sym_moduleAliasBody = 88,
  sym_predicateAliasBody = 89,
  sym_typeAliasBody = 90,
  sym_typeUnionBody = 91,
  sym_classlessPredicate = 92,
  sym_datatype = 93,
  sym_datatypeBranches = 94,
  sym_datatypeBranch = 95,
  sym_select = 96,
  sym_dataclass = 97,
  sym_classMember = 98,
  sym_charpred = 99,
  sym_memberPredicate = 100,
  sym_field = 101,
  sym__optbody = 102,
  sym_empty = 103,
  sym_body = 104,
  sym_higherOrderTerm = 105,
  sym_special_call = 106,
  sym_prefix_cast = 107,
  sym_unary_expr = 108,
  sym_mul_expr = 109,
  sym_add_expr = 110,
  sym_in_expr = 111,
  sym_comp_term = 112,
  sym_instance_of = 113,
  sym_negation = 114,
  sym_if_term = 115,
  sym_conjunction = 116,
  sym_disjunction = 117,
  sym_implication = 118,
  sym_quantified = 119,
  sym_quantifier = 120,
  sym__call_arg = 121,
  sym_qualifiedRhs = 122,
  sym_call_body = 123,
  sym_unqual_agg_body = 124,
  sym__call_or_unqual_agg_body = 125,
  sym_call_or_unqual_agg_expr = 126,
  sym_qualified_expr = 127,
  sym_super_ref = 128,
  sym_full_aggregate_body = 129,
  sym_expr_aggregate_body = 130,
  sym_aggregate = 131,
  sym_range = 132,
  sym_set_literal = 133,
  sym_par_expr = 134,
  sym_expr_annotation = 135,
  sym__exprOrTerm = 136,
  sym__primary = 137,
  sym_literal = 138,
  sym_bool = 139,
  sym_variable = 140,
  sym_compop = 141,
  sym_unop = 142,
  sym_mulop = 143,
  sym_addop = 144,
  sym_closure = 145,
  sym_direction = 146,
  sym_varDecl = 147,
  sym_moduleParam = 148,
  sym_asExprs = 149,
  sym_asExpr = 150,
  sym_orderBys = 151,
  sym_orderBy = 152,
  sym_literalId = 153,
  sym_annotation = 154,
  sym_annotName = 155,
  sym_annotArg = 156,
  sym_moduleName = 157,
  sym_importModuleExpr = 158,
  sym_moduleExpr = 159,
  sym_moduleInstantiation = 160,
  sym_primitiveType = 161,
  sym_simpleId = 162,
  sym_className = 163,
  sym_typeExpr = 164,
  sym_signatureExpr = 165,
  sym_predicateName = 166,
  sym_aritylessPredicateExpr = 167,
  sym_predicateExpr = 168,
  sym_varName = 169,
  sym_aggId = 170,
  aux_sym_ql_repeat1 = 171,
  aux_sym_module_repeat1 = 172,
  aux_sym_module_repeat2 = 173,
  aux_sym_moduleMember_repeat1 = 174,
  aux_sym_typeUnionBody_repeat1 = 175,
  aux_sym_classlessPredicate_repeat1 = 176,
  aux_sym_datatypeBranches_repeat1 = 177,
  aux_sym_dataclass_repeat1 = 178,
  aux_sym_dataclass_repeat2 = 179,
  aux_sym_higherOrderTerm_repeat1 = 180,
  aux_sym_higherOrderTerm_repeat2 = 181,
  aux_sym_aggregate_repeat1 = 182,
  aux_sym_asExprs_repeat1 = 183,
  aux_sym_orderBys_repeat1 = 184,
  aux_sym_annotation_repeat1 = 185,
  aux_sym_importModuleExpr_repeat1 = 186,
  aux_sym_moduleInstantiation_repeat1 = 187,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym__lower_id] = "_lower_id",
  [anon_sym_module] = "module",
  [anon_sym_LT] = "<",
  [anon_sym_COMMA] = ",",
  [anon_sym_GT] = ">",
  [anon_sym_implements] = "implements",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_import] = "import",
  [anon_sym_as] = "as",
  [anon_sym_EQ] = "=",
  [anon_sym_SEMI] = ";",
  [anon_sym_or] = "or",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_newtype] = "newtype",
  [anon_sym_from] = "from",
  [anon_sym_where] = "where",
  [anon_sym_select] = "select",
  [anon_sym_class] = "class",
  [anon_sym_extends] = "extends",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_in] = "in",
  [anon_sym_not] = "not",
  [anon_sym_if] = "if",
  [anon_sym_then] = "then",
  [anon_sym_else] = "else",
  [anon_sym_and] = "and",
  [anon_sym_implies] = "implies",
  [anon_sym_PIPE] = "|",
  [sym_specialId] = "specialId",
  [anon_sym_exists] = "exists",
  [anon_sym_forall] = "forall",
  [anon_sym_forex] = "forex",
  [sym_underscore] = "underscore",
  [anon_sym_DOT] = ".",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_asc] = "asc",
  [anon_sym_desc] = "desc",
  [anon_sym_order] = "order",
  [anon_sym_by] = "by",
  [sym_qldoc] = "qldoc",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_boolean] = "boolean",
  [anon_sym_date] = "date",
  [anon_sym_float] = "float",
  [anon_sym_int] = "int",
  [anon_sym_string] = "string",
  [sym_dbtype] = "dbtype",
  [anon_sym_avg] = "avg",
  [anon_sym_concat] = "concat",
  [anon_sym_strictconcat] = "strictconcat",
  [anon_sym_count] = "count",
  [anon_sym_max] = "max",
  [anon_sym_min] = "min",
  [anon_sym_rank] = "rank",
  [anon_sym_strictcount] = "strictcount",
  [anon_sym_strictsum] = "strictsum",
  [anon_sym_sum] = "sum",
  [anon_sym_any] = "any",
  [anon_sym_unique] = "unique",
  [sym__upper_id] = "_upper_id",
  [sym_integer] = "integer",
  [sym_float] = "float",
  [sym_string] = "string",
  [sym_line_comment] = "line_comment",
  [sym_block_comment] = "block_comment",
  [sym_false] = "false",
  [sym_predicate] = "predicate",
  [sym_result] = "result",
  [sym_super] = "super",
  [sym_this] = "this",
  [sym_true] = "true",
  [sym_ql] = "ql",
  [sym_module] = "module",
  [sym_moduleMember] = "moduleMember",
  [sym_importDirective] = "importDirective",
  [sym_moduleAliasBody] = "moduleAliasBody",
  [sym_predicateAliasBody] = "predicateAliasBody",
  [sym_typeAliasBody] = "typeAliasBody",
  [sym_typeUnionBody] = "typeUnionBody",
  [sym_classlessPredicate] = "classlessPredicate",
  [sym_datatype] = "datatype",
  [sym_datatypeBranches] = "datatypeBranches",
  [sym_datatypeBranch] = "datatypeBranch",
  [sym_select] = "select",
  [sym_dataclass] = "dataclass",
  [sym_classMember] = "classMember",
  [sym_charpred] = "charpred",
  [sym_memberPredicate] = "memberPredicate",
  [sym_field] = "field",
  [sym__optbody] = "_optbody",
  [sym_empty] = "empty",
  [sym_body] = "body",
  [sym_higherOrderTerm] = "higherOrderTerm",
  [sym_special_call] = "special_call",
  [sym_prefix_cast] = "prefix_cast",
  [sym_unary_expr] = "unary_expr",
  [sym_mul_expr] = "mul_expr",
  [sym_add_expr] = "add_expr",
  [sym_in_expr] = "in_expr",
  [sym_comp_term] = "comp_term",
  [sym_instance_of] = "instance_of",
  [sym_negation] = "negation",
  [sym_if_term] = "if_term",
  [sym_conjunction] = "conjunction",
  [sym_disjunction] = "disjunction",
  [sym_implication] = "implication",
  [sym_quantified] = "quantified",
  [sym_quantifier] = "quantifier",
  [sym__call_arg] = "_call_arg",
  [sym_qualifiedRhs] = "qualifiedRhs",
  [sym_call_body] = "call_body",
  [sym_unqual_agg_body] = "unqual_agg_body",
  [sym__call_or_unqual_agg_body] = "_call_or_unqual_agg_body",
  [sym_call_or_unqual_agg_expr] = "call_or_unqual_agg_expr",
  [sym_qualified_expr] = "qualified_expr",
  [sym_super_ref] = "super_ref",
  [sym_full_aggregate_body] = "full_aggregate_body",
  [sym_expr_aggregate_body] = "expr_aggregate_body",
  [sym_aggregate] = "aggregate",
  [sym_range] = "range",
  [sym_set_literal] = "set_literal",
  [sym_par_expr] = "par_expr",
  [sym_expr_annotation] = "expr_annotation",
  [sym__exprOrTerm] = "_exprOrTerm",
  [sym__primary] = "_primary",
  [sym_literal] = "literal",
  [sym_bool] = "bool",
  [sym_variable] = "variable",
  [sym_compop] = "compop",
  [sym_unop] = "unop",
  [sym_mulop] = "mulop",
  [sym_addop] = "addop",
  [sym_closure] = "closure",
  [sym_direction] = "direction",
  [sym_varDecl] = "varDecl",
  [sym_moduleParam] = "moduleParam",
  [sym_asExprs] = "asExprs",
  [sym_asExpr] = "asExpr",
  [sym_orderBys] = "orderBys",
  [sym_orderBy] = "orderBy",
  [sym_literalId] = "literalId",
  [sym_annotation] = "annotation",
  [sym_annotName] = "annotName",
  [sym_annotArg] = "annotArg",
  [sym_moduleName] = "moduleName",
  [sym_importModuleExpr] = "importModuleExpr",
  [sym_moduleExpr] = "moduleExpr",
  [sym_moduleInstantiation] = "moduleInstantiation",
  [sym_primitiveType] = "primitiveType",
  [sym_simpleId] = "simpleId",
  [sym_className] = "className",
  [sym_typeExpr] = "typeExpr",
  [sym_signatureExpr] = "signatureExpr",
  [sym_predicateName] = "predicateName",
  [sym_aritylessPredicateExpr] = "aritylessPredicateExpr",
  [sym_predicateExpr] = "predicateExpr",
  [sym_varName] = "varName",
  [sym_aggId] = "aggId",
  [aux_sym_ql_repeat1] = "ql_repeat1",
  [aux_sym_module_repeat1] = "module_repeat1",
  [aux_sym_module_repeat2] = "module_repeat2",
  [aux_sym_moduleMember_repeat1] = "moduleMember_repeat1",
  [aux_sym_typeUnionBody_repeat1] = "typeUnionBody_repeat1",
  [aux_sym_classlessPredicate_repeat1] = "classlessPredicate_repeat1",
  [aux_sym_datatypeBranches_repeat1] = "datatypeBranches_repeat1",
  [aux_sym_dataclass_repeat1] = "dataclass_repeat1",
  [aux_sym_dataclass_repeat2] = "dataclass_repeat2",
  [aux_sym_higherOrderTerm_repeat1] = "higherOrderTerm_repeat1",
  [aux_sym_higherOrderTerm_repeat2] = "higherOrderTerm_repeat2",
  [aux_sym_aggregate_repeat1] = "aggregate_repeat1",
  [aux_sym_asExprs_repeat1] = "asExprs_repeat1",
  [aux_sym_orderBys_repeat1] = "orderBys_repeat1",
  [aux_sym_annotation_repeat1] = "annotation_repeat1",
  [aux_sym_importModuleExpr_repeat1] = "importModuleExpr_repeat1",
  [aux_sym_moduleInstantiation_repeat1] = "moduleInstantiation_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym__lower_id] = sym__lower_id,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_implements] = anon_sym_implements,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_newtype] = anon_sym_newtype,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_where] = anon_sym_where,
  [anon_sym_select] = anon_sym_select,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_instanceof] = anon_sym_instanceof,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_then] = anon_sym_then,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_implies] = anon_sym_implies,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [sym_specialId] = sym_specialId,
  [anon_sym_exists] = anon_sym_exists,
  [anon_sym_forall] = anon_sym_forall,
  [anon_sym_forex] = anon_sym_forex,
  [sym_underscore] = sym_underscore,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_asc] = anon_sym_asc,
  [anon_sym_desc] = anon_sym_desc,
  [anon_sym_order] = anon_sym_order,
  [anon_sym_by] = anon_sym_by,
  [sym_qldoc] = sym_qldoc,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_boolean] = anon_sym_boolean,
  [anon_sym_date] = anon_sym_date,
  [anon_sym_float] = anon_sym_float,
  [anon_sym_int] = anon_sym_int,
  [anon_sym_string] = anon_sym_string,
  [sym_dbtype] = sym_dbtype,
  [anon_sym_avg] = anon_sym_avg,
  [anon_sym_concat] = anon_sym_concat,
  [anon_sym_strictconcat] = anon_sym_strictconcat,
  [anon_sym_count] = anon_sym_count,
  [anon_sym_max] = anon_sym_max,
  [anon_sym_min] = anon_sym_min,
  [anon_sym_rank] = anon_sym_rank,
  [anon_sym_strictcount] = anon_sym_strictcount,
  [anon_sym_strictsum] = anon_sym_strictsum,
  [anon_sym_sum] = anon_sym_sum,
  [anon_sym_any] = anon_sym_any,
  [anon_sym_unique] = anon_sym_unique,
  [sym__upper_id] = sym__upper_id,
  [sym_integer] = sym_integer,
  [sym_float] = sym_float,
  [sym_string] = sym_string,
  [sym_line_comment] = sym_line_comment,
  [sym_block_comment] = sym_block_comment,
  [sym_false] = sym_false,
  [sym_predicate] = sym_predicate,
  [sym_result] = sym_result,
  [sym_super] = sym_super,
  [sym_this] = sym_this,
  [sym_true] = sym_true,
  [sym_ql] = sym_ql,
  [sym_module] = sym_module,
  [sym_moduleMember] = sym_moduleMember,
  [sym_importDirective] = sym_importDirective,
  [sym_moduleAliasBody] = sym_moduleAliasBody,
  [sym_predicateAliasBody] = sym_predicateAliasBody,
  [sym_typeAliasBody] = sym_typeAliasBody,
  [sym_typeUnionBody] = sym_typeUnionBody,
  [sym_classlessPredicate] = sym_classlessPredicate,
  [sym_datatype] = sym_datatype,
  [sym_datatypeBranches] = sym_datatypeBranches,
  [sym_datatypeBranch] = sym_datatypeBranch,
  [sym_select] = sym_select,
  [sym_dataclass] = sym_dataclass,
  [sym_classMember] = sym_classMember,
  [sym_charpred] = sym_charpred,
  [sym_memberPredicate] = sym_memberPredicate,
  [sym_field] = sym_field,
  [sym__optbody] = sym__optbody,
  [sym_empty] = sym_empty,
  [sym_body] = sym_body,
  [sym_higherOrderTerm] = sym_higherOrderTerm,
  [sym_special_call] = sym_special_call,
  [sym_prefix_cast] = sym_prefix_cast,
  [sym_unary_expr] = sym_unary_expr,
  [sym_mul_expr] = sym_mul_expr,
  [sym_add_expr] = sym_add_expr,
  [sym_in_expr] = sym_in_expr,
  [sym_comp_term] = sym_comp_term,
  [sym_instance_of] = sym_instance_of,
  [sym_negation] = sym_negation,
  [sym_if_term] = sym_if_term,
  [sym_conjunction] = sym_conjunction,
  [sym_disjunction] = sym_disjunction,
  [sym_implication] = sym_implication,
  [sym_quantified] = sym_quantified,
  [sym_quantifier] = sym_quantifier,
  [sym__call_arg] = sym__call_arg,
  [sym_qualifiedRhs] = sym_qualifiedRhs,
  [sym_call_body] = sym_call_body,
  [sym_unqual_agg_body] = sym_unqual_agg_body,
  [sym__call_or_unqual_agg_body] = sym__call_or_unqual_agg_body,
  [sym_call_or_unqual_agg_expr] = sym_call_or_unqual_agg_expr,
  [sym_qualified_expr] = sym_qualified_expr,
  [sym_super_ref] = sym_super_ref,
  [sym_full_aggregate_body] = sym_full_aggregate_body,
  [sym_expr_aggregate_body] = sym_expr_aggregate_body,
  [sym_aggregate] = sym_aggregate,
  [sym_range] = sym_range,
  [sym_set_literal] = sym_set_literal,
  [sym_par_expr] = sym_par_expr,
  [sym_expr_annotation] = sym_expr_annotation,
  [sym__exprOrTerm] = sym__exprOrTerm,
  [sym__primary] = sym__primary,
  [sym_literal] = sym_literal,
  [sym_bool] = sym_bool,
  [sym_variable] = sym_variable,
  [sym_compop] = sym_compop,
  [sym_unop] = sym_unop,
  [sym_mulop] = sym_mulop,
  [sym_addop] = sym_addop,
  [sym_closure] = sym_closure,
  [sym_direction] = sym_direction,
  [sym_varDecl] = sym_varDecl,
  [sym_moduleParam] = sym_moduleParam,
  [sym_asExprs] = sym_asExprs,
  [sym_asExpr] = sym_asExpr,
  [sym_orderBys] = sym_orderBys,
  [sym_orderBy] = sym_orderBy,
  [sym_literalId] = sym_literalId,
  [sym_annotation] = sym_annotation,
  [sym_annotName] = sym_annotName,
  [sym_annotArg] = sym_annotArg,
  [sym_moduleName] = sym_moduleName,
  [sym_importModuleExpr] = sym_importModuleExpr,
  [sym_moduleExpr] = sym_moduleExpr,
  [sym_moduleInstantiation] = sym_moduleInstantiation,
  [sym_primitiveType] = sym_primitiveType,
  [sym_simpleId] = sym_simpleId,
  [sym_className] = sym_className,
  [sym_typeExpr] = sym_typeExpr,
  [sym_signatureExpr] = sym_signatureExpr,
  [sym_predicateName] = sym_predicateName,
  [sym_aritylessPredicateExpr] = sym_aritylessPredicateExpr,
  [sym_predicateExpr] = sym_predicateExpr,
  [sym_varName] = sym_varName,
  [sym_aggId] = sym_aggId,
  [aux_sym_ql_repeat1] = aux_sym_ql_repeat1,
  [aux_sym_module_repeat1] = aux_sym_module_repeat1,
  [aux_sym_module_repeat2] = aux_sym_module_repeat2,
  [aux_sym_moduleMember_repeat1] = aux_sym_moduleMember_repeat1,
  [aux_sym_typeUnionBody_repeat1] = aux_sym_typeUnionBody_repeat1,
  [aux_sym_classlessPredicate_repeat1] = aux_sym_classlessPredicate_repeat1,
  [aux_sym_datatypeBranches_repeat1] = aux_sym_datatypeBranches_repeat1,
  [aux_sym_dataclass_repeat1] = aux_sym_dataclass_repeat1,
  [aux_sym_dataclass_repeat2] = aux_sym_dataclass_repeat2,
  [aux_sym_higherOrderTerm_repeat1] = aux_sym_higherOrderTerm_repeat1,
  [aux_sym_higherOrderTerm_repeat2] = aux_sym_higherOrderTerm_repeat2,
  [aux_sym_aggregate_repeat1] = aux_sym_aggregate_repeat1,
  [aux_sym_asExprs_repeat1] = aux_sym_asExprs_repeat1,
  [aux_sym_orderBys_repeat1] = aux_sym_orderBys_repeat1,
  [aux_sym_annotation_repeat1] = aux_sym_annotation_repeat1,
  [aux_sym_importModuleExpr_repeat1] = aux_sym_importModuleExpr_repeat1,
  [aux_sym_moduleInstantiation_repeat1] = aux_sym_moduleInstantiation_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym__lower_id] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_newtype] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_where] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_select] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implies] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [sym_specialId] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_exists] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_forall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_forex] = {
    .visible = true,
    .named = false,
  },
  [sym_underscore] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_desc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_order] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_by] = {
    .visible = true,
    .named = false,
  },
  [sym_qldoc] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_date] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_float] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [sym_dbtype] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_avg] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_concat] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_strictconcat] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_count] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_max] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_min] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rank] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_strictcount] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_strictsum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unique] = {
    .visible = true,
    .named = false,
  },
  [sym__upper_id] = {
    .visible = false,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_line_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_block_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_result] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_ql] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_moduleMember] = {
    .visible = true,
    .named = true,
  },
  [sym_importDirective] = {
    .visible = true,
    .named = true,
  },
  [sym_moduleAliasBody] = {
    .visible = true,
    .named = true,
  },
  [sym_predicateAliasBody] = {
    .visible = true,
    .named = true,
  },
  [sym_typeAliasBody] = {
    .visible = true,
    .named = true,
  },
  [sym_typeUnionBody] = {
    .visible = true,
    .named = true,
  },
  [sym_classlessPredicate] = {
    .visible = true,
    .named = true,
  },
  [sym_datatype] = {
    .visible = true,
    .named = true,
  },
  [sym_datatypeBranches] = {
    .visible = true,
    .named = true,
  },
  [sym_datatypeBranch] = {
    .visible = true,
    .named = true,
  },
  [sym_select] = {
    .visible = true,
    .named = true,
  },
  [sym_dataclass] = {
    .visible = true,
    .named = true,
  },
  [sym_classMember] = {
    .visible = true,
    .named = true,
  },
  [sym_charpred] = {
    .visible = true,
    .named = true,
  },
  [sym_memberPredicate] = {
    .visible = true,
    .named = true,
  },
  [sym_field] = {
    .visible = true,
    .named = true,
  },
  [sym__optbody] = {
    .visible = false,
    .named = true,
  },
  [sym_empty] = {
    .visible = true,
    .named = true,
  },
  [sym_body] = {
    .visible = true,
    .named = true,
  },
  [sym_higherOrderTerm] = {
    .visible = true,
    .named = true,
  },
  [sym_special_call] = {
    .visible = true,
    .named = true,
  },
  [sym_prefix_cast] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_mul_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_add_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_in_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_comp_term] = {
    .visible = true,
    .named = true,
  },
  [sym_instance_of] = {
    .visible = true,
    .named = true,
  },
  [sym_negation] = {
    .visible = true,
    .named = true,
  },
  [sym_if_term] = {
    .visible = true,
    .named = true,
  },
  [sym_conjunction] = {
    .visible = true,
    .named = true,
  },
  [sym_disjunction] = {
    .visible = true,
    .named = true,
  },
  [sym_implication] = {
    .visible = true,
    .named = true,
  },
  [sym_quantified] = {
    .visible = true,
    .named = true,
  },
  [sym_quantifier] = {
    .visible = true,
    .named = true,
  },
  [sym__call_arg] = {
    .visible = false,
    .named = true,
  },
  [sym_qualifiedRhs] = {
    .visible = true,
    .named = true,
  },
  [sym_call_body] = {
    .visible = true,
    .named = true,
  },
  [sym_unqual_agg_body] = {
    .visible = true,
    .named = true,
  },
  [sym__call_or_unqual_agg_body] = {
    .visible = false,
    .named = true,
  },
  [sym_call_or_unqual_agg_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_super_ref] = {
    .visible = true,
    .named = true,
  },
  [sym_full_aggregate_body] = {
    .visible = true,
    .named = true,
  },
  [sym_expr_aggregate_body] = {
    .visible = true,
    .named = true,
  },
  [sym_aggregate] = {
    .visible = true,
    .named = true,
  },
  [sym_range] = {
    .visible = true,
    .named = true,
  },
  [sym_set_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_par_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_expr_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__exprOrTerm] = {
    .visible = false,
    .named = true,
  },
  [sym__primary] = {
    .visible = false,
    .named = true,
  },
  [sym_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_bool] = {
    .visible = true,
    .named = true,
  },
  [sym_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_compop] = {
    .visible = true,
    .named = true,
  },
  [sym_unop] = {
    .visible = true,
    .named = true,
  },
  [sym_mulop] = {
    .visible = true,
    .named = true,
  },
  [sym_addop] = {
    .visible = true,
    .named = true,
  },
  [sym_closure] = {
    .visible = true,
    .named = true,
  },
  [sym_direction] = {
    .visible = true,
    .named = true,
  },
  [sym_varDecl] = {
    .visible = true,
    .named = true,
  },
  [sym_moduleParam] = {
    .visible = true,
    .named = true,
  },
  [sym_asExprs] = {
    .visible = true,
    .named = true,
  },
  [sym_asExpr] = {
    .visible = true,
    .named = true,
  },
  [sym_orderBys] = {
    .visible = true,
    .named = true,
  },
  [sym_orderBy] = {
    .visible = true,
    .named = true,
  },
  [sym_literalId] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_annotName] = {
    .visible = true,
    .named = true,
  },
  [sym_annotArg] = {
    .visible = true,
    .named = true,
  },
  [sym_moduleName] = {
    .visible = true,
    .named = true,
  },
  [sym_importModuleExpr] = {
    .visible = true,
    .named = true,
  },
  [sym_moduleExpr] = {
    .visible = true,
    .named = true,
  },
  [sym_moduleInstantiation] = {
    .visible = true,
    .named = true,
  },
  [sym_primitiveType] = {
    .visible = true,
    .named = true,
  },
  [sym_simpleId] = {
    .visible = true,
    .named = true,
  },
  [sym_className] = {
    .visible = true,
    .named = true,
  },
  [sym_typeExpr] = {
    .visible = true,
    .named = true,
  },
  [sym_signatureExpr] = {
    .visible = true,
    .named = true,
  },
  [sym_predicateName] = {
    .visible = true,
    .named = true,
  },
  [sym_aritylessPredicateExpr] = {
    .visible = true,
    .named = true,
  },
  [sym_predicateExpr] = {
    .visible = true,
    .named = true,
  },
  [sym_varName] = {
    .visible = true,
    .named = true,
  },
  [sym_aggId] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_ql_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_module_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_module_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_moduleMember_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_typeUnionBody_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_classlessPredicate_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_datatypeBranches_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dataclass_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dataclass_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_higherOrderTerm_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_higherOrderTerm_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_aggregate_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_asExprs_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_orderBys_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_annotation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_importModuleExpr_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_moduleInstantiation_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum ts_field_identifiers {
  field_annot_arg = 1,
  field_args = 2,
  field_asExprs = 3,
  field_body = 4,
  field_cond = 5,
  field_expr = 6,
  field_extends = 7,
  field_first = 8,
  field_formula = 9,
  field_guard = 10,
  field_implements = 11,
  field_instanceof = 12,
  field_left = 13,
  field_lower = 14,
  field_mod_expr = 15,
  field_name = 16,
  field_orderBys = 17,
  field_parameter = 18,
  field_predicate = 19,
  field_qualName = 20,
  field_qualifier = 21,
  field_range = 22,
  field_returnType = 23,
  field_right = 24,
  field_second = 25,
  field_signature = 26,
  field_type_expr = 27,
  field_upper = 28,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_annot_arg] = "annot_arg",
  [field_args] = "args",
  [field_asExprs] = "asExprs",
  [field_body] = "body",
  [field_cond] = "cond",
  [field_expr] = "expr",
  [field_extends] = "extends",
  [field_first] = "first",
  [field_formula] = "formula",
  [field_guard] = "guard",
  [field_implements] = "implements",
  [field_instanceof] = "instanceof",
  [field_left] = "left",
  [field_lower] = "lower",
  [field_mod_expr] = "mod_expr",
  [field_name] = "name",
  [field_orderBys] = "orderBys",
  [field_parameter] = "parameter",
  [field_predicate] = "predicate",
  [field_qualName] = "qualName",
  [field_qualifier] = "qualifier",
  [field_range] = "range",
  [field_returnType] = "returnType",
  [field_right] = "right",
  [field_second] = "second",
  [field_signature] = "signature",
  [field_type_expr] = "type_expr",
  [field_upper] = "upper",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 1},
  [3] = {.index = 2, .length = 1},
  [4] = {.index = 3, .length = 1},
  [5] = {.index = 4, .length = 2},
  [6] = {.index = 6, .length = 2},
  [7] = {.index = 8, .length = 1},
  [8] = {.index = 9, .length = 1},
  [9] = {.index = 10, .length = 1},
  [10] = {.index = 11, .length = 1},
  [11] = {.index = 12, .length = 2},
  [12] = {.index = 14, .length = 2},
  [13] = {.index = 16, .length = 1},
  [14] = {.index = 17, .length = 2},
  [15] = {.index = 19, .length = 2},
  [16] = {.index = 21, .length = 2},
  [17] = {.index = 23, .length = 1},
  [18] = {.index = 24, .length = 1},
  [19] = {.index = 25, .length = 2},
  [20] = {.index = 27, .length = 3},
  [21] = {.index = 30, .length = 3},
  [22] = {.index = 33, .length = 3},
  [23] = {.index = 36, .length = 1},
  [24] = {.index = 37, .length = 2},
  [25] = {.index = 39, .length = 2},
  [26] = {.index = 41, .length = 1},
  [27] = {.index = 42, .length = 3},
  [28] = {.index = 45, .length = 2},
  [29] = {.index = 47, .length = 2},
  [30] = {.index = 49, .length = 1},
  [31] = {.index = 50, .length = 1},
  [32] = {.index = 51, .length = 1},
  [33] = {.index = 52, .length = 4},
  [34] = {.index = 56, .length = 4},
  [35] = {.index = 60, .length = 3},
  [36] = {.index = 63, .length = 3},
  [37] = {.index = 66, .length = 1},
  [38] = {.index = 67, .length = 2},
  [39] = {.index = 69, .length = 1},
  [40] = {.index = 70, .length = 2},
  [41] = {.index = 72, .length = 2},
  [42] = {.index = 74, .length = 1},
  [43] = {.index = 75, .length = 5},
  [44] = {.index = 80, .length = 3},
  [45] = {.index = 83, .length = 2},
  [46] = {.index = 85, .length = 1},
  [47] = {.index = 86, .length = 2},
  [48] = {.index = 88, .length = 3},
  [49] = {.index = 91, .length = 2},
  [50] = {.index = 93, .length = 1},
  [51] = {.index = 94, .length = 3},
  [52] = {.index = 97, .length = 2},
  [53] = {.index = 99, .length = 2},
  [54] = {.index = 101, .length = 1},
  [55] = {.index = 102, .length = 6},
  [56] = {.index = 108, .length = 6},
  [57] = {.index = 114, .length = 4},
  [58] = {.index = 118, .length = 4},
  [59] = {.index = 122, .length = 2},
  [60] = {.index = 124, .length = 3},
  [61] = {.index = 127, .length = 2},
  [62] = {.index = 129, .length = 3},
  [63] = {.index = 132, .length = 2},
  [64] = {.index = 134, .length = 2},
  [65] = {.index = 136, .length = 1},
  [66] = {.index = 137, .length = 7},
  [67] = {.index = 144, .length = 5},
  [68] = {.index = 149, .length = 2},
  [69] = {.index = 151, .length = 3},
  [70] = {.index = 154, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 0},
  [1] =
    {field_name, 1},
  [2] =
    {field_qualName, 0},
  [3] =
    {field_qualName, 0, .inherited = true},
  [4] =
    {field_qualName, 0, .inherited = true},
    {field_qualName, 1, .inherited = true},
  [6] =
    {field_name, 1},
    {field_returnType, 0},
  [8] =
    {field_mod_expr, 0},
  [9] =
    {field_type_expr, 0},
  [10] =
    {field_predicate, 0},
  [11] =
    {field_name, 2},
  [12] =
    {field_name, 2},
    {field_qualifier, 0},
  [14] =
    {field_left, 0},
    {field_right, 2},
  [16] =
    {field_asExprs, 0},
  [17] =
    {field_args, 2},
    {field_name, 0},
  [19] =
    {field_parameter, 1},
    {field_signature, 0},
  [21] =
    {field_implements, 3},
    {field_name, 1},
  [23] =
    {field_expr, 2},
  [24] =
    {field_guard, 1},
  [25] =
    {field_asExprs, 0},
    {field_orderBys, 1},
  [27] =
    {field_extends, 2},
    {field_extends, 3},
    {field_name, 1},
  [30] =
    {field_instanceof, 2},
    {field_instanceof, 3},
    {field_name, 1},
  [33] =
    {field_args, 2},
    {field_args, 3},
    {field_name, 0},
  [36] =
    {field_parameter, 1},
  [37] =
    {field_name, 1},
    {field_parameter, 3},
  [39] =
    {field_parameter, 0, .inherited = true},
    {field_parameter, 1, .inherited = true},
  [41] =
    {field_implements, 1},
  [42] =
    {field_implements, 3},
    {field_implements, 4, .inherited = true},
    {field_name, 1},
  [45] =
    {field_implements, 0, .inherited = true},
    {field_implements, 1, .inherited = true},
  [47] =
    {field_lower, 1},
    {field_upper, 3},
  [49] =
    {field_range, 3},
  [50] =
    {field_guard, 2},
  [51] =
    {field_asExprs, 2},
  [52] =
    {field_extends, 2},
    {field_extends, 3},
    {field_extends, 4},
    {field_name, 1},
  [56] =
    {field_instanceof, 2},
    {field_instanceof, 3},
    {field_instanceof, 4},
    {field_name, 1},
  [60] =
    {field_name, 1},
    {field_parameter, 3},
    {field_parameter, 4, .inherited = true},
  [63] =
    {field_cond, 1},
    {field_first, 3},
    {field_second, 5},
  [66] =
    {field_range, 4},
  [67] =
    {field_asExprs, 2},
    {field_asExprs, 3},
  [69] =
    {field_guard, 3},
  [70] =
    {field_asExprs, 2},
    {field_orderBys, 3},
  [72] =
    {field_asExprs, 3},
    {field_guard, 1},
  [74] =
    {field_asExprs, 3},
  [75] =
    {field_extends, 2},
    {field_extends, 3},
    {field_instanceof, 4},
    {field_instanceof, 5},
    {field_name, 1},
  [80] =
    {field_implements, 6},
    {field_name, 1},
    {field_parameter, 3},
  [83] =
    {field_formula, 5},
    {field_range, 3},
  [85] =
    {field_range, 5},
  [86] =
    {field_annot_arg, 2},
    {field_name, 0},
  [88] =
    {field_asExprs, 3},
    {field_asExprs, 4},
    {field_guard, 2},
  [91] =
    {field_asExprs, 3},
    {field_asExprs, 4},
  [93] =
    {field_guard, 4},
  [94] =
    {field_asExprs, 3},
    {field_guard, 1},
    {field_orderBys, 4},
  [97] =
    {field_asExprs, 3},
    {field_orderBys, 4},
  [99] =
    {field_asExprs, 4},
    {field_guard, 2},
  [101] =
    {field_asExprs, 4},
  [102] =
    {field_extends, 2},
    {field_extends, 3},
    {field_instanceof, 4},
    {field_instanceof, 5},
    {field_instanceof, 6},
    {field_name, 1},
  [108] =
    {field_extends, 2},
    {field_extends, 3},
    {field_extends, 4},
    {field_instanceof, 5},
    {field_instanceof, 6},
    {field_name, 1},
  [114] =
    {field_implements, 6},
    {field_implements, 7, .inherited = true},
    {field_name, 1},
    {field_parameter, 3},
  [118] =
    {field_implements, 7},
    {field_name, 1},
    {field_parameter, 3},
    {field_parameter, 4, .inherited = true},
  [122] =
    {field_formula, 6},
    {field_range, 4},
  [124] =
    {field_asExprs, 4},
    {field_asExprs, 5},
    {field_guard, 3},
  [127] =
    {field_asExprs, 4},
    {field_asExprs, 5},
  [129] =
    {field_asExprs, 4},
    {field_guard, 2},
    {field_orderBys, 5},
  [132] =
    {field_asExprs, 4},
    {field_orderBys, 5},
  [134] =
    {field_asExprs, 5},
    {field_guard, 3},
  [136] =
    {field_body, 4},
  [137] =
    {field_extends, 2},
    {field_extends, 3},
    {field_extends, 4},
    {field_instanceof, 5},
    {field_instanceof, 6},
    {field_instanceof, 7},
    {field_name, 1},
  [144] =
    {field_implements, 7},
    {field_implements, 8, .inherited = true},
    {field_name, 1},
    {field_parameter, 3},
    {field_parameter, 4, .inherited = true},
  [149] =
    {field_formula, 7},
    {field_range, 5},
  [151] =
    {field_asExprs, 5},
    {field_asExprs, 6},
    {field_guard, 4},
  [154] =
    {field_asExprs, 5},
    {field_guard, 3},
    {field_orderBys, 6},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 4,
  [5] = 2,
  [6] = 6,
  [7] = 4,
  [8] = 6,
  [9] = 4,
  [10] = 2,
  [11] = 6,
  [12] = 6,
  [13] = 6,
  [14] = 4,
  [15] = 2,
  [16] = 6,
  [17] = 2,
  [18] = 4,
  [19] = 4,
  [20] = 6,
  [21] = 2,
  [22] = 4,
  [23] = 23,
  [24] = 23,
  [25] = 23,
  [26] = 23,
  [27] = 23,
  [28] = 23,
  [29] = 23,
  [30] = 30,
  [31] = 31,
  [32] = 32,
  [33] = 31,
  [34] = 30,
  [35] = 30,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 32,
  [40] = 31,
  [41] = 30,
  [42] = 37,
  [43] = 37,
  [44] = 37,
  [45] = 36,
  [46] = 31,
  [47] = 31,
  [48] = 30,
  [49] = 37,
  [50] = 38,
  [51] = 37,
  [52] = 31,
  [53] = 37,
  [54] = 31,
  [55] = 30,
  [56] = 30,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 66,
  [68] = 68,
  [69] = 58,
  [70] = 65,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 57,
  [75] = 75,
  [76] = 76,
  [77] = 68,
  [78] = 58,
  [79] = 71,
  [80] = 72,
  [81] = 57,
  [82] = 76,
  [83] = 58,
  [84] = 72,
  [85] = 72,
  [86] = 86,
  [87] = 57,
  [88] = 76,
  [89] = 73,
  [90] = 58,
  [91] = 91,
  [92] = 72,
  [93] = 93,
  [94] = 57,
  [95] = 76,
  [96] = 96,
  [97] = 97,
  [98] = 58,
  [99] = 72,
  [100] = 75,
  [101] = 57,
  [102] = 76,
  [103] = 58,
  [104] = 104,
  [105] = 72,
  [106] = 106,
  [107] = 57,
  [108] = 76,
  [109] = 76,
  [110] = 110,
  [111] = 111,
  [112] = 91,
  [113] = 104,
  [114] = 106,
  [115] = 59,
  [116] = 60,
  [117] = 63,
  [118] = 91,
  [119] = 104,
  [120] = 106,
  [121] = 59,
  [122] = 60,
  [123] = 63,
  [124] = 91,
  [125] = 104,
  [126] = 106,
  [127] = 59,
  [128] = 60,
  [129] = 63,
  [130] = 91,
  [131] = 104,
  [132] = 106,
  [133] = 59,
  [134] = 60,
  [135] = 63,
  [136] = 91,
  [137] = 104,
  [138] = 106,
  [139] = 59,
  [140] = 60,
  [141] = 63,
  [142] = 91,
  [143] = 104,
  [144] = 106,
  [145] = 59,
  [146] = 60,
  [147] = 63,
  [148] = 148,
  [149] = 149,
  [150] = 150,
  [151] = 151,
  [152] = 152,
  [153] = 149,
  [154] = 150,
  [155] = 152,
  [156] = 150,
  [157] = 149,
  [158] = 151,
  [159] = 152,
  [160] = 150,
  [161] = 150,
  [162] = 152,
  [163] = 163,
  [164] = 152,
  [165] = 163,
  [166] = 163,
  [167] = 151,
  [168] = 152,
  [169] = 152,
  [170] = 150,
  [171] = 149,
  [172] = 150,
  [173] = 173,
  [174] = 174,
  [175] = 175,
  [176] = 176,
  [177] = 177,
  [178] = 178,
  [179] = 179,
  [180] = 180,
  [181] = 181,
  [182] = 182,
  [183] = 174,
  [184] = 175,
  [185] = 176,
  [186] = 177,
  [187] = 178,
  [188] = 179,
  [189] = 180,
  [190] = 181,
  [191] = 182,
  [192] = 174,
  [193] = 193,
  [194] = 173,
  [195] = 195,
  [196] = 175,
  [197] = 176,
  [198] = 174,
  [199] = 199,
  [200] = 175,
  [201] = 177,
  [202] = 176,
  [203] = 177,
  [204] = 178,
  [205] = 178,
  [206] = 179,
  [207] = 179,
  [208] = 180,
  [209] = 209,
  [210] = 180,
  [211] = 211,
  [212] = 193,
  [213] = 213,
  [214] = 181,
  [215] = 215,
  [216] = 199,
  [217] = 181,
  [218] = 218,
  [219] = 182,
  [220] = 220,
  [221] = 193,
  [222] = 174,
  [223] = 223,
  [224] = 199,
  [225] = 175,
  [226] = 199,
  [227] = 176,
  [228] = 177,
  [229] = 178,
  [230] = 179,
  [231] = 180,
  [232] = 181,
  [233] = 193,
  [234] = 182,
  [235] = 235,
  [236] = 236,
  [237] = 174,
  [238] = 199,
  [239] = 175,
  [240] = 193,
  [241] = 176,
  [242] = 177,
  [243] = 178,
  [244] = 193,
  [245] = 179,
  [246] = 246,
  [247] = 247,
  [248] = 180,
  [249] = 199,
  [250] = 181,
  [251] = 182,
  [252] = 182,
  [253] = 253,
  [254] = 254,
  [255] = 193,
  [256] = 256,
  [257] = 257,
  [258] = 174,
  [259] = 199,
  [260] = 175,
  [261] = 176,
  [262] = 177,
  [263] = 178,
  [264] = 179,
  [265] = 193,
  [266] = 236,
  [267] = 218,
  [268] = 220,
  [269] = 235,
  [270] = 180,
  [271] = 247,
  [272] = 253,
  [273] = 254,
  [274] = 257,
  [275] = 181,
  [276] = 276,
  [277] = 213,
  [278] = 236,
  [279] = 218,
  [280] = 220,
  [281] = 223,
  [282] = 235,
  [283] = 253,
  [284] = 254,
  [285] = 257,
  [286] = 276,
  [287] = 182,
  [288] = 213,
  [289] = 236,
  [290] = 218,
  [291] = 220,
  [292] = 223,
  [293] = 235,
  [294] = 253,
  [295] = 254,
  [296] = 257,
  [297] = 174,
  [298] = 276,
  [299] = 213,
  [300] = 175,
  [301] = 236,
  [302] = 218,
  [303] = 220,
  [304] = 223,
  [305] = 235,
  [306] = 253,
  [307] = 254,
  [308] = 257,
  [309] = 176,
  [310] = 177,
  [311] = 276,
  [312] = 178,
  [313] = 179,
  [314] = 213,
  [315] = 180,
  [316] = 236,
  [317] = 218,
  [318] = 220,
  [319] = 223,
  [320] = 235,
  [321] = 253,
  [322] = 254,
  [323] = 257,
  [324] = 181,
  [325] = 276,
  [326] = 213,
  [327] = 236,
  [328] = 218,
  [329] = 220,
  [330] = 223,
  [331] = 235,
  [332] = 253,
  [333] = 254,
  [334] = 257,
  [335] = 276,
  [336] = 276,
  [337] = 182,
  [338] = 213,
  [339] = 236,
  [340] = 218,
  [341] = 341,
  [342] = 209,
  [343] = 341,
  [344] = 215,
  [345] = 256,
  [346] = 211,
  [347] = 256,
  [348] = 211,
  [349] = 256,
  [350] = 211,
  [351] = 256,
  [352] = 211,
  [353] = 256,
  [354] = 211,
  [355] = 256,
  [356] = 211,
  [357] = 256,
  [358] = 223,
  [359] = 359,
  [360] = 359,
  [361] = 359,
  [362] = 359,
  [363] = 359,
  [364] = 359,
  [365] = 359,
  [366] = 359,
  [367] = 367,
  [368] = 368,
  [369] = 368,
  [370] = 368,
  [371] = 367,
  [372] = 368,
  [373] = 373,
  [374] = 374,
  [375] = 375,
  [376] = 376,
  [377] = 377,
  [378] = 378,
  [379] = 379,
  [380] = 380,
  [381] = 374,
  [382] = 380,
  [383] = 375,
  [384] = 378,
  [385] = 385,
  [386] = 386,
  [387] = 376,
  [388] = 386,
  [389] = 373,
  [390] = 390,
  [391] = 373,
  [392] = 390,
  [393] = 390,
  [394] = 374,
  [395] = 395,
  [396] = 373,
  [397] = 377,
  [398] = 375,
  [399] = 377,
  [400] = 395,
  [401] = 395,
  [402] = 376,
  [403] = 379,
  [404] = 380,
  [405] = 377,
  [406] = 378,
  [407] = 380,
  [408] = 395,
  [409] = 374,
  [410] = 376,
  [411] = 386,
  [412] = 379,
  [413] = 379,
  [414] = 375,
  [415] = 385,
  [416] = 378,
  [417] = 386,
  [418] = 390,
  [419] = 419,
  [420] = 419,
  [421] = 419,
  [422] = 419,
  [423] = 423,
  [424] = 424,
  [425] = 425,
  [426] = 426,
  [427] = 427,
  [428] = 428,
  [429] = 429,
  [430] = 430,
  [431] = 431,
  [432] = 432,
  [433] = 433,
  [434] = 434,
  [435] = 435,
  [436] = 423,
  [437] = 437,
  [438] = 438,
  [439] = 439,
  [440] = 440,
  [441] = 441,
  [442] = 442,
  [443] = 443,
  [444] = 444,
  [445] = 445,
  [446] = 446,
  [447] = 447,
  [448] = 448,
  [449] = 449,
  [450] = 450,
  [451] = 451,
  [452] = 452,
  [453] = 453,
  [454] = 454,
  [455] = 455,
  [456] = 456,
  [457] = 457,
  [458] = 458,
  [459] = 459,
  [460] = 460,
  [461] = 461,
  [462] = 462,
  [463] = 463,
  [464] = 464,
  [465] = 465,
  [466] = 466,
  [467] = 467,
  [468] = 468,
  [469] = 469,
  [470] = 424,
  [471] = 425,
  [472] = 426,
  [473] = 427,
  [474] = 428,
  [475] = 429,
  [476] = 430,
  [477] = 431,
  [478] = 432,
  [479] = 433,
  [480] = 434,
  [481] = 435,
  [482] = 423,
  [483] = 437,
  [484] = 438,
  [485] = 439,
  [486] = 440,
  [487] = 441,
  [488] = 442,
  [489] = 443,
  [490] = 444,
  [491] = 445,
  [492] = 446,
  [493] = 447,
  [494] = 448,
  [495] = 449,
  [496] = 450,
  [497] = 451,
  [498] = 452,
  [499] = 453,
  [500] = 454,
  [501] = 455,
  [502] = 456,
  [503] = 457,
  [504] = 458,
  [505] = 459,
  [506] = 460,
  [507] = 461,
  [508] = 462,
  [509] = 463,
  [510] = 464,
  [511] = 465,
  [512] = 466,
  [513] = 424,
  [514] = 425,
  [515] = 515,
  [516] = 427,
  [517] = 428,
  [518] = 429,
  [519] = 430,
  [520] = 431,
  [521] = 432,
  [522] = 433,
  [523] = 434,
  [524] = 435,
  [525] = 423,
  [526] = 437,
  [527] = 438,
  [528] = 439,
  [529] = 440,
  [530] = 441,
  [531] = 442,
  [532] = 443,
  [533] = 444,
  [534] = 445,
  [535] = 446,
  [536] = 447,
  [537] = 448,
  [538] = 449,
  [539] = 450,
  [540] = 451,
  [541] = 452,
  [542] = 453,
  [543] = 454,
  [544] = 455,
  [545] = 456,
  [546] = 457,
  [547] = 458,
  [548] = 459,
  [549] = 460,
  [550] = 461,
  [551] = 462,
  [552] = 463,
  [553] = 464,
  [554] = 465,
  [555] = 466,
  [556] = 424,
  [557] = 425,
  [558] = 426,
  [559] = 427,
  [560] = 428,
  [561] = 429,
  [562] = 430,
  [563] = 431,
  [564] = 432,
  [565] = 433,
  [566] = 434,
  [567] = 435,
  [568] = 437,
  [569] = 438,
  [570] = 439,
  [571] = 440,
  [572] = 441,
  [573] = 442,
  [574] = 443,
  [575] = 444,
  [576] = 445,
  [577] = 446,
  [578] = 447,
  [579] = 448,
  [580] = 449,
  [581] = 450,
  [582] = 451,
  [583] = 452,
  [584] = 453,
  [585] = 454,
  [586] = 455,
  [587] = 456,
  [588] = 457,
  [589] = 458,
  [590] = 459,
  [591] = 460,
  [592] = 461,
  [593] = 462,
  [594] = 463,
  [595] = 464,
  [596] = 465,
  [597] = 466,
  [598] = 426,
  [599] = 599,
  [600] = 600,
  [601] = 601,
  [602] = 600,
  [603] = 603,
  [604] = 604,
  [605] = 605,
  [606] = 603,
  [607] = 607,
  [608] = 604,
  [609] = 605,
  [610] = 610,
  [611] = 611,
  [612] = 612,
  [613] = 613,
  [614] = 614,
  [615] = 600,
  [616] = 616,
  [617] = 612,
  [618] = 610,
  [619] = 611,
  [620] = 616,
  [621] = 610,
  [622] = 611,
  [623] = 613,
  [624] = 607,
  [625] = 613,
  [626] = 614,
  [627] = 599,
  [628] = 603,
  [629] = 607,
  [630] = 604,
  [631] = 614,
  [632] = 599,
  [633] = 633,
  [634] = 634,
  [635] = 605,
  [636] = 603,
  [637] = 607,
  [638] = 638,
  [639] = 601,
  [640] = 614,
  [641] = 599,
  [642] = 633,
  [643] = 634,
  [644] = 600,
  [645] = 633,
  [646] = 634,
  [647] = 612,
  [648] = 633,
  [649] = 604,
  [650] = 605,
  [651] = 634,
  [652] = 638,
  [653] = 612,
  [654] = 638,
  [655] = 601,
  [656] = 601,
  [657] = 616,
  [658] = 616,
  [659] = 638,
  [660] = 610,
  [661] = 611,
  [662] = 613,
  [663] = 663,
  [664] = 664,
  [665] = 665,
  [666] = 666,
  [667] = 667,
  [668] = 668,
  [669] = 669,
  [670] = 670,
  [671] = 671,
  [672] = 672,
  [673] = 673,
  [674] = 664,
  [675] = 675,
  [676] = 670,
  [677] = 668,
  [678] = 678,
  [679] = 679,
  [680] = 680,
  [681] = 681,
  [682] = 682,
  [683] = 683,
  [684] = 669,
  [685] = 680,
  [686] = 672,
  [687] = 667,
  [688] = 671,
  [689] = 679,
  [690] = 665,
  [691] = 666,
  [692] = 673,
  [693] = 675,
  [694] = 678,
  [695] = 695,
  [696] = 696,
  [697] = 663,
  [698] = 681,
  [699] = 682,
  [700] = 683,
  [701] = 696,
  [702] = 702,
  [703] = 702,
  [704] = 368,
  [705] = 419,
  [706] = 464,
  [707] = 707,
  [708] = 708,
  [709] = 709,
  [710] = 710,
  [711] = 465,
  [712] = 430,
  [713] = 713,
  [714] = 453,
  [715] = 466,
  [716] = 431,
  [717] = 429,
  [718] = 432,
  [719] = 455,
  [720] = 456,
  [721] = 457,
  [722] = 458,
  [723] = 459,
  [724] = 460,
  [725] = 725,
  [726] = 726,
  [727] = 727,
  [728] = 454,
  [729] = 729,
  [730] = 461,
  [731] = 433,
  [732] = 434,
  [733] = 435,
  [734] = 423,
  [735] = 437,
  [736] = 438,
  [737] = 452,
  [738] = 738,
  [739] = 739,
  [740] = 450,
  [741] = 741,
  [742] = 739,
  [743] = 743,
  [744] = 744,
  [745] = 745,
  [746] = 746,
  [747] = 729,
  [748] = 709,
  [749] = 710,
  [750] = 462,
  [751] = 463,
  [752] = 725,
  [753] = 726,
  [754] = 727,
  [755] = 738,
  [756] = 756,
  [757] = 707,
  [758] = 708,
  [759] = 713,
  [760] = 451,
  [761] = 439,
  [762] = 440,
  [763] = 441,
  [764] = 756,
  [765] = 442,
  [766] = 380,
  [767] = 424,
  [768] = 768,
  [769] = 769,
  [770] = 741,
  [771] = 425,
  [772] = 426,
  [773] = 427,
  [774] = 443,
  [775] = 444,
  [776] = 445,
  [777] = 446,
  [778] = 428,
  [779] = 447,
  [780] = 448,
  [781] = 449,
  [782] = 743,
  [783] = 744,
  [784] = 745,
  [785] = 746,
  [786] = 769,
  [787] = 377,
  [788] = 613,
  [789] = 633,
  [790] = 634,
  [791] = 376,
  [792] = 616,
  [793] = 607,
  [794] = 604,
  [795] = 612,
  [796] = 379,
  [797] = 614,
  [798] = 605,
  [799] = 374,
  [800] = 638,
  [801] = 601,
  [802] = 599,
  [803] = 610,
  [804] = 611,
  [805] = 375,
  [806] = 378,
  [807] = 386,
  [808] = 390,
  [809] = 373,
  [810] = 603,
  [811] = 395,
  [812] = 600,
  [813] = 380,
  [814] = 380,
  [815] = 368,
  [816] = 816,
  [817] = 816,
  [818] = 368,
  [819] = 367,
  [820] = 379,
  [821] = 376,
  [822] = 374,
  [823] = 375,
  [824] = 378,
  [825] = 386,
  [826] = 390,
  [827] = 373,
  [828] = 377,
  [829] = 395,
  [830] = 380,
  [831] = 831,
  [832] = 376,
  [833] = 390,
  [834] = 373,
  [835] = 835,
  [836] = 395,
  [837] = 831,
  [838] = 374,
  [839] = 379,
  [840] = 379,
  [841] = 378,
  [842] = 386,
  [843] = 376,
  [844] = 377,
  [845] = 831,
  [846] = 831,
  [847] = 385,
  [848] = 831,
  [849] = 831,
  [850] = 831,
  [851] = 395,
  [852] = 374,
  [853] = 375,
  [854] = 377,
  [855] = 378,
  [856] = 386,
  [857] = 390,
  [858] = 373,
  [859] = 375,
  [860] = 419,
  [861] = 861,
  [862] = 862,
  [863] = 862,
  [864] = 385,
  [865] = 861,
  [866] = 861,
  [867] = 861,
  [868] = 861,
  [869] = 861,
  [870] = 861,
  [871] = 419,
  [872] = 458,
  [873] = 442,
  [874] = 430,
  [875] = 443,
  [876] = 444,
  [877] = 445,
  [878] = 446,
  [879] = 447,
  [880] = 880,
  [881] = 431,
  [882] = 448,
  [883] = 424,
  [884] = 884,
  [885] = 425,
  [886] = 886,
  [887] = 432,
  [888] = 441,
  [889] = 434,
  [890] = 449,
  [891] = 426,
  [892] = 892,
  [893] = 435,
  [894] = 423,
  [895] = 895,
  [896] = 427,
  [897] = 897,
  [898] = 898,
  [899] = 437,
  [900] = 438,
  [901] = 901,
  [902] = 428,
  [903] = 433,
  [904] = 439,
  [905] = 440,
  [906] = 906,
  [907] = 907,
  [908] = 441,
  [909] = 450,
  [910] = 910,
  [911] = 451,
  [912] = 912,
  [913] = 442,
  [914] = 429,
  [915] = 915,
  [916] = 916,
  [917] = 917,
  [918] = 443,
  [919] = 444,
  [920] = 452,
  [921] = 445,
  [922] = 453,
  [923] = 454,
  [924] = 455,
  [925] = 446,
  [926] = 926,
  [927] = 456,
  [928] = 447,
  [929] = 884,
  [930] = 886,
  [931] = 430,
  [932] = 926,
  [933] = 933,
  [934] = 910,
  [935] = 457,
  [936] = 448,
  [937] = 897,
  [938] = 431,
  [939] = 898,
  [940] = 906,
  [941] = 907,
  [942] = 915,
  [943] = 916,
  [944] = 449,
  [945] = 434,
  [946] = 897,
  [947] = 459,
  [948] = 898,
  [949] = 949,
  [950] = 906,
  [951] = 907,
  [952] = 915,
  [953] = 916,
  [954] = 897,
  [955] = 440,
  [956] = 439,
  [957] = 450,
  [958] = 916,
  [959] = 897,
  [960] = 898,
  [961] = 898,
  [962] = 906,
  [963] = 907,
  [964] = 461,
  [965] = 915,
  [966] = 916,
  [967] = 933,
  [968] = 451,
  [969] = 969,
  [970] = 970,
  [971] = 971,
  [972] = 432,
  [973] = 897,
  [974] = 898,
  [975] = 462,
  [976] = 906,
  [977] = 907,
  [978] = 915,
  [979] = 916,
  [980] = 452,
  [981] = 463,
  [982] = 453,
  [983] = 897,
  [984] = 898,
  [985] = 906,
  [986] = 464,
  [987] = 907,
  [988] = 915,
  [989] = 916,
  [990] = 990,
  [991] = 454,
  [992] = 433,
  [993] = 455,
  [994] = 917,
  [995] = 465,
  [996] = 996,
  [997] = 435,
  [998] = 970,
  [999] = 423,
  [1000] = 906,
  [1001] = 971,
  [1002] = 466,
  [1003] = 437,
  [1004] = 438,
  [1005] = 892,
  [1006] = 456,
  [1007] = 424,
  [1008] = 907,
  [1009] = 457,
  [1010] = 1010,
  [1011] = 425,
  [1012] = 426,
  [1013] = 427,
  [1014] = 428,
  [1015] = 458,
  [1016] = 459,
  [1017] = 460,
  [1018] = 895,
  [1019] = 901,
  [1020] = 461,
  [1021] = 462,
  [1022] = 463,
  [1023] = 464,
  [1024] = 465,
  [1025] = 466,
  [1026] = 912,
  [1027] = 996,
  [1028] = 915,
  [1029] = 429,
  [1030] = 460,
  [1031] = 1031,
  [1032] = 1032,
  [1033] = 1033,
  [1034] = 1034,
  [1035] = 1035,
  [1036] = 1036,
  [1037] = 1037,
  [1038] = 1038,
  [1039] = 1039,
  [1040] = 610,
  [1041] = 611,
  [1042] = 613,
  [1043] = 1043,
  [1044] = 1044,
  [1045] = 603,
  [1046] = 607,
  [1047] = 614,
  [1048] = 599,
  [1049] = 1049,
  [1050] = 633,
  [1051] = 634,
  [1052] = 1052,
  [1053] = 638,
  [1054] = 601,
  [1055] = 1055,
  [1056] = 607,
  [1057] = 600,
  [1058] = 614,
  [1059] = 599,
  [1060] = 604,
  [1061] = 605,
  [1062] = 612,
  [1063] = 1063,
  [1064] = 616,
  [1065] = 1065,
  [1066] = 610,
  [1067] = 611,
  [1068] = 613,
  [1069] = 1069,
  [1070] = 633,
  [1071] = 634,
  [1072] = 603,
  [1073] = 1073,
  [1074] = 1074,
  [1075] = 638,
  [1076] = 1076,
  [1077] = 601,
  [1078] = 1043,
  [1079] = 1063,
  [1080] = 1065,
  [1081] = 1044,
  [1082] = 1082,
  [1083] = 600,
  [1084] = 1084,
  [1085] = 1085,
  [1086] = 1039,
  [1087] = 1087,
  [1088] = 1088,
  [1089] = 1088,
  [1090] = 604,
  [1091] = 605,
  [1092] = 1031,
  [1093] = 612,
  [1094] = 1094,
  [1095] = 1095,
  [1096] = 1096,
  [1097] = 616,
  [1098] = 1087,
  [1099] = 1099,
  [1100] = 1100,
  [1101] = 1049,
  [1102] = 1035,
  [1103] = 1099,
  [1104] = 1076,
  [1105] = 1105,
  [1106] = 1044,
  [1107] = 1084,
  [1108] = 1085,
  [1109] = 1100,
  [1110] = 1094,
  [1111] = 1096,
  [1112] = 1087,
  [1113] = 1035,
  [1114] = 1114,
  [1115] = 1076,
  [1116] = 1116,
  [1117] = 1044,
  [1118] = 1118,
  [1119] = 1084,
  [1120] = 1085,
  [1121] = 1084,
  [1122] = 1085,
  [1123] = 1094,
  [1124] = 1096,
  [1125] = 1087,
  [1126] = 1035,
  [1127] = 1052,
  [1128] = 1076,
  [1129] = 1044,
  [1130] = 1084,
  [1131] = 1085,
  [1132] = 1036,
  [1133] = 1094,
  [1134] = 1038,
  [1135] = 1096,
  [1136] = 1087,
  [1137] = 1035,
  [1138] = 1076,
  [1139] = 1044,
  [1140] = 1084,
  [1141] = 1085,
  [1142] = 1073,
  [1143] = 1076,
  [1144] = 1094,
  [1145] = 1096,
  [1146] = 1087,
  [1147] = 1035,
  [1148] = 1076,
  [1149] = 1149,
  [1150] = 1044,
  [1151] = 1084,
  [1152] = 1085,
  [1153] = 1153,
  [1154] = 1094,
  [1155] = 1096,
  [1156] = 1087,
  [1157] = 1035,
  [1158] = 1084,
  [1159] = 1069,
  [1160] = 1160,
  [1161] = 1161,
  [1162] = 1037,
  [1163] = 1118,
  [1164] = 1034,
  [1165] = 1114,
  [1166] = 1032,
  [1167] = 1116,
  [1168] = 1160,
  [1169] = 1082,
  [1170] = 1074,
  [1171] = 1055,
  [1172] = 1149,
  [1173] = 1149,
  [1174] = 1149,
  [1175] = 1149,
  [1176] = 1149,
  [1177] = 1149,
  [1178] = 1149,
  [1179] = 1033,
  [1180] = 1094,
  [1181] = 1095,
  [1182] = 1096,
  [1183] = 1161,
  [1184] = 1184,
  [1185] = 1185,
  [1186] = 1186,
  [1187] = 1187,
  [1188] = 1188,
  [1189] = 1189,
  [1190] = 1190,
  [1191] = 1190,
  [1192] = 1192,
  [1193] = 1193,
  [1194] = 1194,
  [1195] = 1195,
  [1196] = 1196,
  [1197] = 1197,
  [1198] = 1198,
  [1199] = 1199,
  [1200] = 1198,
  [1201] = 1193,
  [1202] = 1202,
  [1203] = 1203,
  [1204] = 1204,
  [1205] = 1187,
  [1206] = 1206,
  [1207] = 1192,
  [1208] = 1184,
  [1209] = 1206,
  [1210] = 1194,
  [1211] = 1211,
  [1212] = 1199,
  [1213] = 1202,
  [1214] = 1214,
  [1215] = 1215,
  [1216] = 1203,
  [1217] = 1215,
  [1218] = 1214,
  [1219] = 1204,
  [1220] = 1189,
  [1221] = 1196,
  [1222] = 1195,
  [1223] = 1197,
  [1224] = 1188,
  [1225] = 1193,
  [1226] = 1226,
  [1227] = 1227,
  [1228] = 1228,
  [1229] = 1229,
  [1230] = 1230,
  [1231] = 1231,
  [1232] = 1232,
  [1233] = 1233,
  [1234] = 1234,
  [1235] = 1235,
  [1236] = 1236,
  [1237] = 1237,
  [1238] = 1238,
  [1239] = 1239,
  [1240] = 1240,
  [1241] = 1241,
  [1242] = 1242,
  [1243] = 1243,
  [1244] = 1244,
  [1245] = 1245,
  [1246] = 1246,
  [1247] = 1247,
  [1248] = 1248,
  [1249] = 1249,
  [1250] = 1250,
  [1251] = 1246,
  [1252] = 1247,
  [1253] = 1253,
  [1254] = 1249,
  [1255] = 1255,
  [1256] = 1256,
  [1257] = 1257,
  [1258] = 1250,
  [1259] = 1259,
  [1260] = 1260,
  [1261] = 1261,
  [1262] = 1262,
  [1263] = 1263,
  [1264] = 1264,
  [1265] = 1255,
  [1266] = 1266,
  [1267] = 1267,
  [1268] = 1268,
  [1269] = 1269,
  [1270] = 1270,
  [1271] = 1271,
  [1272] = 1272,
  [1273] = 1273,
  [1274] = 1274,
  [1275] = 1275,
  [1276] = 1276,
  [1277] = 1242,
  [1278] = 1278,
  [1279] = 1279,
  [1280] = 1280,
  [1281] = 1281,
  [1282] = 1282,
  [1283] = 1283,
  [1284] = 1284,
  [1285] = 1285,
  [1286] = 1286,
  [1287] = 1287,
  [1288] = 1256,
  [1289] = 1259,
  [1290] = 1290,
  [1291] = 1291,
  [1292] = 1241,
  [1293] = 1243,
  [1294] = 1260,
  [1295] = 1295,
  [1296] = 1296,
  [1297] = 1287,
  [1298] = 1298,
  [1299] = 1299,
  [1300] = 1228,
  [1301] = 1237,
  [1302] = 1302,
  [1303] = 1303,
  [1304] = 1261,
  [1305] = 1305,
  [1306] = 1257,
  [1307] = 1227,
  [1308] = 1253,
  [1309] = 1309,
  [1310] = 1309,
  [1311] = 1311,
  [1312] = 1236,
  [1313] = 1267,
  [1314] = 1268,
  [1315] = 1315,
  [1316] = 1316,
  [1317] = 1269,
  [1318] = 1303,
  [1319] = 1305,
  [1320] = 1320,
  [1321] = 1231,
  [1322] = 1322,
  [1323] = 1323,
  [1324] = 1270,
  [1325] = 1238,
  [1326] = 1248,
  [1327] = 1263,
  [1328] = 1328,
  [1329] = 1329,
  [1330] = 1296,
  [1331] = 1295,
  [1332] = 1271,
  [1333] = 1272,
  [1334] = 1239,
  [1335] = 1335,
  [1336] = 1336,
  [1337] = 1274,
  [1338] = 1338,
  [1339] = 1278,
  [1340] = 1279,
  [1341] = 1273,
  [1342] = 1342,
  [1343] = 1343,
  [1344] = 1344,
  [1345] = 1275,
  [1346] = 1276,
  [1347] = 1347,
  [1348] = 1281,
  [1349] = 1298,
  [1350] = 1280,
  [1351] = 1240,
  [1352] = 1283,
  [1353] = 1232,
  [1354] = 1311,
  [1355] = 1299,
  [1356] = 1234,
  [1357] = 1235,
  [1358] = 1315,
  [1359] = 1316,
  [1360] = 1320,
  [1361] = 1322,
  [1362] = 1328,
  [1363] = 1363,
  [1364] = 1284,
  [1365] = 1302,
  [1366] = 1363,
  [1367] = 1367,
  [1368] = 1335,
  [1369] = 1336,
  [1370] = 1370,
  [1371] = 1229,
  [1372] = 1233,
  [1373] = 1230,
  [1374] = 1244,
  [1375] = 1245,
  [1376] = 1342,
  [1377] = 1344,
  [1378] = 1262,
  [1379] = 1264,
  [1380] = 1266,
  [1381] = 1290,
  [1382] = 1323,
  [1383] = 1285,
  [1384] = 1347,
  [1385] = 1286,
  [1386] = 1329,
  [1387] = 1291,
  [1388] = 1367,
  [1389] = 1282,
  [1390] = 1370,
  [1391] = 1338,
  [1392] = 1392,
  [1393] = 1393,
  [1394] = 1394,
  [1395] = 1394,
  [1396] = 1396,
  [1397] = 1397,
  [1398] = 1396,
  [1399] = 1399,
  [1400] = 1399,
  [1401] = 1397,
  [1402] = 1402,
  [1403] = 1402,
  [1404] = 1404,
  [1405] = 1405,
  [1406] = 1406,
  [1407] = 1407,
  [1408] = 1408,
  [1409] = 1409,
  [1410] = 1409,
  [1411] = 1407,
  [1412] = 1407,
  [1413] = 1413,
  [1414] = 1407,
  [1415] = 1408,
  [1416] = 1416,
  [1417] = 1407,
  [1418] = 1408,
  [1419] = 1408,
  [1420] = 1407,
  [1421] = 1421,
  [1422] = 1408,
  [1423] = 1423,
  [1424] = 1413,
  [1425] = 1408,
  [1426] = 1407,
  [1427] = 1421,
  [1428] = 1428,
  [1429] = 1429,
  [1430] = 1423,
  [1431] = 1408,
  [1432] = 1428,
  [1433] = 816,
  [1434] = 380,
  [1435] = 1435,
  [1436] = 1436,
  [1437] = 611,
  [1438] = 1438,
  [1439] = 466,
  [1440] = 1440,
  [1441] = 610,
  [1442] = 603,
  [1443] = 613,
  [1444] = 1444,
  [1445] = 1445,
  [1446] = 1446,
  [1447] = 1447,
  [1448] = 1448,
  [1449] = 1448,
  [1450] = 1450,
  [1451] = 1451,
  [1452] = 1452,
  [1453] = 1452,
  [1454] = 933,
  [1455] = 1455,
  [1456] = 1074,
  [1457] = 1069,
  [1458] = 1052,
  [1459] = 1459,
  [1460] = 1459,
  [1461] = 1043,
  [1462] = 1455,
  [1463] = 380,
  [1464] = 1464,
  [1465] = 1465,
  [1466] = 1466,
  [1467] = 1467,
  [1468] = 1468,
  [1469] = 1469,
  [1470] = 1470,
  [1471] = 1471,
  [1472] = 1472,
  [1473] = 1473,
  [1474] = 1474,
  [1475] = 1472,
  [1476] = 1467,
  [1477] = 1472,
  [1478] = 1049,
  [1479] = 1469,
  [1480] = 1470,
  [1481] = 1472,
  [1482] = 1472,
  [1483] = 1483,
  [1484] = 1472,
  [1485] = 1474,
  [1486] = 1472,
  [1487] = 1487,
  [1488] = 1487,
  [1489] = 1473,
  [1490] = 1465,
  [1491] = 1491,
  [1492] = 1492,
  [1493] = 1491,
  [1494] = 1491,
  [1495] = 1495,
  [1496] = 1491,
  [1497] = 1491,
  [1498] = 1498,
  [1499] = 1499,
  [1500] = 1500,
  [1501] = 1501,
  [1502] = 1491,
  [1503] = 1491,
  [1504] = 1492,
  [1505] = 1505,
  [1506] = 1506,
  [1507] = 1491,
  [1508] = 1508,
  [1509] = 1509,
  [1510] = 1510,
  [1511] = 1511,
  [1512] = 1512,
  [1513] = 1513,
  [1514] = 1514,
  [1515] = 1512,
  [1516] = 1509,
  [1517] = 1517,
  [1518] = 1518,
  [1519] = 1511,
  [1520] = 1520,
  [1521] = 1510,
  [1522] = 1522,
  [1523] = 1523,
  [1524] = 1518,
  [1525] = 1522,
  [1526] = 1526,
  [1527] = 1527,
  [1528] = 1526,
  [1529] = 1529,
  [1530] = 1514,
  [1531] = 1523,
  [1532] = 1532,
  [1533] = 1532,
  [1534] = 1512,
  [1535] = 1527,
  [1536] = 1513,
  [1537] = 1537,
  [1538] = 1538,
  [1539] = 1538,
  [1540] = 1540,
  [1541] = 926,
  [1542] = 1542,
  [1543] = 1537,
  [1544] = 1544,
  [1545] = 1545,
  [1546] = 1540,
  [1547] = 1547,
  [1548] = 1548,
  [1549] = 1549,
  [1550] = 1550,
  [1551] = 1540,
  [1552] = 1552,
  [1553] = 1553,
  [1554] = 1554,
  [1555] = 1545,
  [1556] = 1547,
  [1557] = 1557,
  [1558] = 1549,
  [1559] = 1540,
  [1560] = 1560,
  [1561] = 1561,
  [1562] = 912,
  [1563] = 1545,
  [1564] = 1547,
  [1565] = 1565,
  [1566] = 1566,
  [1567] = 1549,
  [1568] = 1560,
  [1569] = 1540,
  [1570] = 1549,
  [1571] = 1544,
  [1572] = 892,
  [1573] = 1573,
  [1574] = 1574,
  [1575] = 1575,
  [1576] = 1561,
  [1577] = 1540,
  [1578] = 1545,
  [1579] = 1574,
  [1580] = 1545,
  [1581] = 1581,
  [1582] = 1537,
  [1583] = 1241,
  [1584] = 1547,
  [1585] = 1550,
  [1586] = 1537,
  [1587] = 1538,
  [1588] = 1588,
  [1589] = 1589,
  [1590] = 1545,
  [1591] = 1547,
  [1592] = 1537,
  [1593] = 1549,
  [1594] = 1594,
  [1595] = 1565,
  [1596] = 1596,
  [1597] = 1537,
  [1598] = 1540,
  [1599] = 1599,
  [1600] = 1549,
  [1601] = 1554,
  [1602] = 1566,
  [1603] = 1547,
  [1604] = 1537,
  [1605] = 1552,
  [1606] = 1545,
  [1607] = 1547,
  [1608] = 1575,
  [1609] = 1594,
  [1610] = 1549,
  [1611] = 1553,
  [1612] = 1612,
  [1613] = 1613,
  [1614] = 892,
  [1615] = 1615,
  [1616] = 1616,
  [1617] = 1617,
  [1618] = 1618,
  [1619] = 1616,
  [1620] = 1620,
  [1621] = 1621,
  [1622] = 1622,
  [1623] = 1623,
  [1624] = 1624,
  [1625] = 1625,
  [1626] = 1613,
  [1627] = 1627,
  [1628] = 1628,
  [1629] = 1082,
  [1630] = 1630,
  [1631] = 1631,
  [1632] = 1625,
  [1633] = 1633,
  [1634] = 1634,
  [1635] = 1635,
  [1636] = 1636,
  [1637] = 1612,
  [1638] = 1638,
  [1639] = 1615,
  [1640] = 1620,
  [1641] = 1616,
  [1642] = 1615,
  [1643] = 1620,
  [1644] = 1616,
  [1645] = 1645,
  [1646] = 1646,
  [1647] = 1613,
  [1648] = 1648,
  [1649] = 1628,
  [1650] = 1650,
  [1651] = 1645,
  [1652] = 1652,
  [1653] = 1625,
  [1654] = 1638,
  [1655] = 1634,
  [1656] = 1063,
  [1657] = 1065,
  [1658] = 1616,
  [1659] = 1634,
  [1660] = 1615,
  [1661] = 1620,
  [1662] = 1662,
  [1663] = 1616,
  [1664] = 1664,
  [1665] = 1665,
  [1666] = 1666,
  [1667] = 1667,
  [1668] = 1668,
  [1669] = 1633,
  [1670] = 912,
  [1671] = 1671,
  [1672] = 1635,
  [1673] = 1673,
  [1674] = 1674,
  [1675] = 1675,
  [1676] = 1676,
  [1677] = 1668,
  [1678] = 1617,
  [1679] = 1679,
  [1680] = 1680,
  [1681] = 1681,
  [1682] = 1622,
  [1683] = 1683,
  [1684] = 1631,
  [1685] = 1685,
  [1686] = 1613,
  [1687] = 1687,
  [1688] = 1688,
  [1689] = 1689,
  [1690] = 1674,
  [1691] = 1691,
  [1692] = 1617,
  [1693] = 1628,
  [1694] = 1694,
  [1695] = 1695,
  [1696] = 1665,
  [1697] = 1665,
  [1698] = 1698,
  [1699] = 1613,
  [1700] = 1088,
  [1701] = 1674,
  [1702] = 1617,
  [1703] = 1703,
  [1704] = 1675,
  [1705] = 1628,
  [1706] = 1634,
  [1707] = 1625,
  [1708] = 1073,
  [1709] = 1709,
  [1710] = 1695,
  [1711] = 1674,
  [1712] = 1617,
  [1713] = 1713,
  [1714] = 1676,
  [1715] = 1613,
  [1716] = 1625,
  [1717] = 1666,
  [1718] = 1674,
  [1719] = 1634,
  [1720] = 1617,
  [1721] = 1618,
  [1722] = 1625,
  [1723] = 1694,
  [1724] = 1628,
  [1725] = 1679,
  [1726] = 1634,
  [1727] = 1727,
  [1728] = 1615,
  [1729] = 1620,
  [1730] = 1674,
  [1731] = 1617,
  [1732] = 1628,
  [1733] = 1616,
  [1734] = 1636,
  [1735] = 1634,
  [1736] = 1630,
  [1737] = 1662,
  [1738] = 1727,
  [1739] = 1630,
  [1740] = 1673,
  [1741] = 1630,
  [1742] = 1695,
  [1743] = 1630,
  [1744] = 1625,
  [1745] = 1630,
  [1746] = 1674,
  [1747] = 1613,
  [1748] = 1630,
  [1749] = 1749,
  [1750] = 926,
  [1751] = 1615,
  [1752] = 1652,
  [1753] = 1753,
  [1754] = 1628,
  [1755] = 1680,
  [1756] = 1615,
  [1757] = 1620,
  [1758] = 1650,
  [1759] = 1671,
  [1760] = 1620,
  [1761] = 1761,
  [1762] = 1762,
  [1763] = 1763,
  [1764] = 1764,
  [1765] = 1765,
  [1766] = 1766,
  [1767] = 1767,
  [1768] = 1768,
  [1769] = 1761,
  [1770] = 1770,
  [1771] = 1770,
  [1772] = 1206,
  [1773] = 1761,
  [1774] = 1774,
  [1775] = 1775,
  [1776] = 1776,
  [1777] = 1777,
  [1778] = 1761,
  [1779] = 1779,
  [1780] = 1780,
  [1781] = 1196,
  [1782] = 1775,
  [1783] = 1761,
  [1784] = 1764,
  [1785] = 1770,
  [1786] = 1770,
  [1787] = 1770,
  [1788] = 1788,
  [1789] = 1761,
  [1790] = 1790,
  [1791] = 1776,
  [1792] = 1792,
  [1793] = 1793,
  [1794] = 1763,
  [1795] = 1770,
  [1796] = 1788,
  [1797] = 1184,
  [1798] = 1770,
  [1799] = 1793,
  [1800] = 1770,
  [1801] = 1801,
  [1802] = 1792,
  [1803] = 1801,
  [1804] = 1804,
  [1805] = 1761,
  [1806] = 1764,
  [1807] = 1764,
  [1808] = 1764,
  [1809] = 1764,
  [1810] = 1764,
  [1811] = 1811,
  [1812] = 1812,
  [1813] = 1813,
  [1814] = 1812,
  [1815] = 1815,
  [1816] = 1816,
  [1817] = 1817,
  [1818] = 1812,
  [1819] = 1816,
  [1820] = 1817,
  [1821] = 1821,
  [1822] = 1821,
  [1823] = 1823,
  [1824] = 1824,
  [1825] = 1825,
  [1826] = 1826,
  [1827] = 1827,
  [1828] = 1828,
  [1829] = 1829,
  [1830] = 1830,
  [1831] = 1823,
  [1832] = 1832,
  [1833] = 1823,
  [1834] = 1834,
  [1835] = 1835,
  [1836] = 1829,
  [1837] = 1837,
  [1838] = 1838,
  [1839] = 1839,
  [1840] = 1813,
  [1841] = 1841,
  [1842] = 1816,
  [1843] = 1843,
  [1844] = 1844,
  [1845] = 1845,
  [1846] = 1812,
  [1847] = 1847,
  [1848] = 1821,
  [1849] = 1838,
  [1850] = 1850,
  [1851] = 1824,
  [1852] = 1852,
  [1853] = 1852,
  [1854] = 1813,
  [1855] = 1815,
  [1856] = 1850,
  [1857] = 1830,
  [1858] = 1828,
  [1859] = 1828,
  [1860] = 1828,
  [1861] = 1861,
  [1862] = 1862,
  [1863] = 1847,
  [1864] = 1837,
  [1865] = 1838,
  [1866] = 1839,
  [1867] = 1823,
  [1868] = 1868,
  [1869] = 1834,
  [1870] = 1870,
  [1871] = 1871,
  [1872] = 1872,
  [1873] = 1873,
  [1874] = 1817,
  [1875] = 1821,
  [1876] = 1876,
  [1877] = 1852,
  [1878] = 1824,
  [1879] = 1821,
  [1880] = 1880,
  [1881] = 1847,
  [1882] = 1882,
  [1883] = 1839,
  [1884] = 1830,
  [1885] = 1824,
  [1886] = 1886,
  [1887] = 1852,
  [1888] = 1830,
  [1889] = 1847,
  [1890] = 1829,
  [1891] = 1837,
  [1892] = 1838,
  [1893] = 1839,
  [1894] = 1823,
  [1895] = 1824,
  [1896] = 1896,
  [1897] = 1897,
  [1898] = 1898,
  [1899] = 1812,
  [1900] = 1900,
  [1901] = 1901,
  [1902] = 1821,
  [1903] = 1847,
  [1904] = 1829,
  [1905] = 1824,
  [1906] = 1861,
  [1907] = 1815,
  [1908] = 1816,
  [1909] = 1861,
  [1910] = 1843,
  [1911] = 1830,
  [1912] = 1815,
  [1913] = 1913,
  [1914] = 1850,
  [1915] = 1915,
  [1916] = 1916,
  [1917] = 1817,
  [1918] = 1837,
  [1919] = 1838,
  [1920] = 1839,
  [1921] = 1827,
  [1922] = 1841,
  [1923] = 1834,
  [1924] = 1850,
  [1925] = 1925,
  [1926] = 1861,
  [1927] = 1841,
  [1928] = 1928,
  [1929] = 1821,
  [1930] = 1930,
  [1931] = 1812,
  [1932] = 1824,
  [1933] = 1841,
  [1934] = 1812,
  [1935] = 1843,
  [1936] = 1823,
  [1937] = 1868,
  [1938] = 1830,
  [1939] = 1828,
  [1940] = 1823,
  [1941] = 1815,
  [1942] = 1834,
  [1943] = 1843,
  [1944] = 1834,
  [1945] = 1850,
  [1946] = 1843,
  [1947] = 1852,
  [1948] = 1897,
  [1949] = 1816,
  [1950] = 1829,
  [1951] = 1828,
  [1952] = 1952,
  [1953] = 1815,
  [1954] = 1850,
  [1955] = 1830,
  [1956] = 1816,
  [1957] = 1852,
  [1958] = 1825,
  [1959] = 1861,
  [1960] = 1817,
  [1961] = 1815,
  [1962] = 1834,
  [1963] = 1897,
  [1964] = 1826,
  [1965] = 1852,
  [1966] = 1825,
  [1967] = 1843,
  [1968] = 1829,
  [1969] = 1861,
  [1970] = 1825,
  [1971] = 1850,
  [1972] = 1829,
  [1973] = 1852,
  [1974] = 1825,
  [1975] = 1817,
  [1976] = 1847,
  [1977] = 1861,
  [1978] = 1825,
  [1979] = 1834,
  [1980] = 1980,
  [1981] = 1816,
  [1982] = 1825,
  [1983] = 1837,
  [1984] = 1841,
  [1985] = 1845,
  [1986] = 1896,
  [1987] = 1900,
  [1988] = 1930,
  [1989] = 1817,
  [1990] = 1886,
  [1991] = 1900,
  [1992] = 1992,
  [1993] = 1837,
  [1994] = 1900,
  [1995] = 1838,
  [1996] = 1828,
  [1997] = 1900,
  [1998] = 1998,
  [1999] = 1880,
  [2000] = 1900,
  [2001] = 1839,
  [2002] = 2002,
  [2003] = 1900,
  [2004] = 1873,
  [2005] = 1847,
  [2006] = 1841,
  [2007] = 1837,
  [2008] = 1838,
  [2009] = 1839,
  [2010] = 1843,
  [2011] = 1915,
  [2012] = 1876,
  [2013] = 1876,
  [2014] = 1876,
  [2015] = 1876,
  [2016] = 1876,
  [2017] = 1876,
  [2018] = 1841,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(17);
      ADVANCE_MAP(
        '!', 12,
        '"', 1,
        '%', 44,
        '(', 27,
        ')', 28,
        '*', 41,
        '+', 39,
        ',', 20,
        '-', 40,
        '.', 32,
        '/', 42,
        ':', 11,
        ';', 26,
        '<', 19,
        '=', 25,
        '>', 22,
        '@', 15,
        '[', 33,
        ']', 34,
        '_', 30,
        '{', 23,
        '|', 29,
        '}', 24,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(50);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(48);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(49);
      END_STATE();
    case 1:
      if (lookahead == '"') ADVANCE(53);
      if (lookahead == '\\') ADVANCE(13);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(1);
      END_STATE();
    case 2:
      ADVANCE_MAP(
        '(', 27,
        ')', 28,
        '*', 41,
        '+', 39,
        ',', 20,
        '.', 31,
        '/', 43,
        ':', 11,
        ';', 26,
        '<', 18,
        '=', 25,
        '>', 21,
        ']', 34,
        '{', 23,
        '|', 29,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(2);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(51);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(48);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(49);
      END_STATE();
    case 3:
      if (lookahead == '*') ADVANCE(5);
      if (lookahead != 0) ADVANCE(9);
      END_STATE();
    case 4:
      if (lookahead == '*') ADVANCE(10);
      if (lookahead != 0) ADVANCE(9);
      END_STATE();
    case 5:
      if (lookahead == '*') ADVANCE(6);
      if (lookahead == '/') ADVANCE(56);
      if (lookahead != 0) ADVANCE(7);
      END_STATE();
    case 6:
      if (lookahead == '*') ADVANCE(6);
      if (lookahead == '/') ADVANCE(45);
      if (lookahead != 0) ADVANCE(7);
      END_STATE();
    case 7:
      if (lookahead == '*') ADVANCE(6);
      if (lookahead != 0) ADVANCE(7);
      END_STATE();
    case 8:
      if (lookahead == '*') ADVANCE(8);
      if (lookahead == '/') ADVANCE(55);
      if (lookahead != 0) ADVANCE(9);
      END_STATE();
    case 9:
      if (lookahead == '*') ADVANCE(8);
      if (lookahead != 0) ADVANCE(9);
      END_STATE();
    case 10:
      if (lookahead == '/') ADVANCE(55);
      END_STATE();
    case 11:
      if (lookahead == ':') ADVANCE(46);
      END_STATE();
    case 12:
      if (lookahead == '=') ADVANCE(36);
      END_STATE();
    case 13:
      if (lookahead == '"' ||
          lookahead == '\\' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          lookahead == 't') ADVANCE(1);
      END_STATE();
    case 14:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(52);
      END_STATE();
    case 15:
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(47);
      END_STATE();
    case 16:
      if (eof) ADVANCE(17);
      ADVANCE_MAP(
        '!', 12,
        '"', 1,
        '%', 44,
        '(', 27,
        ')', 28,
        '*', 41,
        '+', 39,
        ',', 20,
        '-', 40,
        '.', 32,
        '/', 43,
        ':', 11,
        ';', 26,
        '<', 19,
        '=', 25,
        '>', 22,
        '@', 15,
        '[', 33,
        ']', 34,
        '_', 30,
        '{', 23,
        '|', 29,
        '}', 24,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(16);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(50);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(48);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(49);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=') ADVANCE(37);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(38);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(sym_underscore);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(35);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(3);
      if (lookahead == '/') ADVANCE(54);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(4);
      if (lookahead == '/') ADVANCE(54);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(sym_qldoc);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(sym_dbtype);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(47);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(sym__upper_id);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(48);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(sym__lower_id);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(49);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(14);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(50);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(sym_integer);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(51);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(sym_float);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(52);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(sym_string);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(54);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(sym_block_comment);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(sym_block_comment);
      if (lookahead == '*') ADVANCE(6);
      if (lookahead != 0) ADVANCE(7);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        'a', 1,
        'b', 2,
        'c', 3,
        'd', 4,
        'e', 5,
        'f', 6,
        'i', 7,
        'm', 8,
        'n', 9,
        'o', 10,
        'p', 11,
        'r', 12,
        's', 13,
        't', 14,
        'u', 15,
        'w', 16,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'n') ADVANCE(17);
      if (lookahead == 's') ADVANCE(18);
      if (lookahead == 'v') ADVANCE(19);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(20);
      if (lookahead == 'y') ADVANCE(21);
      END_STATE();
    case 3:
      if (lookahead == 'l') ADVANCE(22);
      if (lookahead == 'o') ADVANCE(23);
      END_STATE();
    case 4:
      if (lookahead == 'a') ADVANCE(24);
      if (lookahead == 'e') ADVANCE(25);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(26);
      if (lookahead == 'x') ADVANCE(27);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(28);
      if (lookahead == 'l') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(30);
      if (lookahead == 'r') ADVANCE(31);
      END_STATE();
    case 7:
      if (lookahead == 'f') ADVANCE(32);
      if (lookahead == 'm') ADVANCE(33);
      if (lookahead == 'n') ADVANCE(34);
      END_STATE();
    case 8:
      if (lookahead == 'a') ADVANCE(35);
      if (lookahead == 'i') ADVANCE(36);
      if (lookahead == 'o') ADVANCE(37);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(38);
      if (lookahead == 'o') ADVANCE(39);
      END_STATE();
    case 10:
      if (lookahead == 'r') ADVANCE(40);
      END_STATE();
    case 11:
      if (lookahead == 'r') ADVANCE(41);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(42);
      if (lookahead == 'e') ADVANCE(43);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(44);
      if (lookahead == 't') ADVANCE(45);
      if (lookahead == 'u') ADVANCE(46);
      END_STATE();
    case 14:
      if (lookahead == 'h') ADVANCE(47);
      if (lookahead == 'r') ADVANCE(48);
      END_STATE();
    case 15:
      if (lookahead == 'n') ADVANCE(49);
      END_STATE();
    case 16:
      if (lookahead == 'h') ADVANCE(50);
      END_STATE();
    case 17:
      if (lookahead == 'd') ADVANCE(51);
      if (lookahead == 'y') ADVANCE(52);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'c') ADVANCE(53);
      END_STATE();
    case 19:
      if (lookahead == 'g') ADVANCE(54);
      END_STATE();
    case 20:
      if (lookahead == 'o') ADVANCE(55);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_by);
      END_STATE();
    case 22:
      if (lookahead == 'a') ADVANCE(56);
      END_STATE();
    case 23:
      if (lookahead == 'n') ADVANCE(57);
      if (lookahead == 'u') ADVANCE(58);
      END_STATE();
    case 24:
      if (lookahead == 't') ADVANCE(59);
      END_STATE();
    case 25:
      if (lookahead == 's') ADVANCE(60);
      END_STATE();
    case 26:
      if (lookahead == 's') ADVANCE(61);
      END_STATE();
    case 27:
      if (lookahead == 'i') ADVANCE(62);
      if (lookahead == 't') ADVANCE(63);
      END_STATE();
    case 28:
      if (lookahead == 'l') ADVANCE(64);
      END_STATE();
    case 29:
      if (lookahead == 'o') ADVANCE(65);
      END_STATE();
    case 30:
      if (lookahead == 'r') ADVANCE(66);
      END_STATE();
    case 31:
      if (lookahead == 'o') ADVANCE(67);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 33:
      if (lookahead == 'p') ADVANCE(68);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 's') ADVANCE(69);
      if (lookahead == 't') ADVANCE(70);
      END_STATE();
    case 35:
      if (lookahead == 'x') ADVANCE(71);
      END_STATE();
    case 36:
      if (lookahead == 'n') ADVANCE(72);
      END_STATE();
    case 37:
      if (lookahead == 'd') ADVANCE(73);
      END_STATE();
    case 38:
      if (lookahead == 'w') ADVANCE(74);
      END_STATE();
    case 39:
      if (lookahead == 'n') ADVANCE(75);
      if (lookahead == 't') ADVANCE(76);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_or);
      if (lookahead == 'd') ADVANCE(77);
      END_STATE();
    case 41:
      if (lookahead == 'e') ADVANCE(78);
      END_STATE();
    case 42:
      if (lookahead == 'n') ADVANCE(79);
      END_STATE();
    case 43:
      if (lookahead == 's') ADVANCE(80);
      END_STATE();
    case 44:
      if (lookahead == 'l') ADVANCE(81);
      END_STATE();
    case 45:
      if (lookahead == 'r') ADVANCE(82);
      END_STATE();
    case 46:
      if (lookahead == 'm') ADVANCE(83);
      if (lookahead == 'p') ADVANCE(84);
      END_STATE();
    case 47:
      if (lookahead == 'e') ADVANCE(85);
      if (lookahead == 'i') ADVANCE(86);
      END_STATE();
    case 48:
      if (lookahead == 'u') ADVANCE(87);
      END_STATE();
    case 49:
      if (lookahead == 'i') ADVANCE(88);
      END_STATE();
    case 50:
      if (lookahead == 'e') ADVANCE(89);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_asc);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_avg);
      END_STATE();
    case 55:
      if (lookahead == 'l') ADVANCE(90);
      END_STATE();
    case 56:
      if (lookahead == 's') ADVANCE(91);
      END_STATE();
    case 57:
      if (lookahead == 'c') ADVANCE(92);
      END_STATE();
    case 58:
      if (lookahead == 'n') ADVANCE(93);
      END_STATE();
    case 59:
      if (lookahead == 'e') ADVANCE(94);
      END_STATE();
    case 60:
      if (lookahead == 'c') ADVANCE(95);
      END_STATE();
    case 61:
      if (lookahead == 'e') ADVANCE(96);
      END_STATE();
    case 62:
      if (lookahead == 's') ADVANCE(97);
      END_STATE();
    case 63:
      if (lookahead == 'e') ADVANCE(98);
      END_STATE();
    case 64:
      if (lookahead == 's') ADVANCE(99);
      END_STATE();
    case 65:
      if (lookahead == 'a') ADVANCE(100);
      END_STATE();
    case 66:
      if (lookahead == 'a') ADVANCE(101);
      if (lookahead == 'e') ADVANCE(102);
      END_STATE();
    case 67:
      if (lookahead == 'm') ADVANCE(103);
      END_STATE();
    case 68:
      if (lookahead == 'l') ADVANCE(104);
      if (lookahead == 'o') ADVANCE(105);
      END_STATE();
    case 69:
      if (lookahead == 't') ADVANCE(106);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_int);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_max);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_min);
      END_STATE();
    case 73:
      if (lookahead == 'u') ADVANCE(107);
      END_STATE();
    case 74:
      if (lookahead == 't') ADVANCE(108);
      END_STATE();
    case 75:
      if (lookahead == 'e') ADVANCE(109);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 77:
      if (lookahead == 'e') ADVANCE(110);
      END_STATE();
    case 78:
      if (lookahead == 'd') ADVANCE(111);
      END_STATE();
    case 79:
      if (lookahead == 'k') ADVANCE(112);
      END_STATE();
    case 80:
      if (lookahead == 'u') ADVANCE(113);
      END_STATE();
    case 81:
      if (lookahead == 'e') ADVANCE(114);
      END_STATE();
    case 82:
      if (lookahead == 'i') ADVANCE(115);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_sum);
      END_STATE();
    case 84:
      if (lookahead == 'e') ADVANCE(116);
      END_STATE();
    case 85:
      if (lookahead == 'n') ADVANCE(117);
      END_STATE();
    case 86:
      if (lookahead == 's') ADVANCE(118);
      END_STATE();
    case 87:
      if (lookahead == 'e') ADVANCE(119);
      END_STATE();
    case 88:
      if (lookahead == 'q') ADVANCE(120);
      END_STATE();
    case 89:
      if (lookahead == 'r') ADVANCE(121);
      END_STATE();
    case 90:
      if (lookahead == 'e') ADVANCE(122);
      END_STATE();
    case 91:
      if (lookahead == 's') ADVANCE(123);
      END_STATE();
    case 92:
      if (lookahead == 'a') ADVANCE(124);
      END_STATE();
    case 93:
      if (lookahead == 't') ADVANCE(125);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_date);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_desc);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 97:
      if (lookahead == 't') ADVANCE(126);
      END_STATE();
    case 98:
      if (lookahead == 'n') ADVANCE(127);
      END_STATE();
    case 99:
      if (lookahead == 'e') ADVANCE(128);
      END_STATE();
    case 100:
      if (lookahead == 't') ADVANCE(129);
      END_STATE();
    case 101:
      if (lookahead == 'l') ADVANCE(130);
      END_STATE();
    case 102:
      if (lookahead == 'x') ADVANCE(131);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 104:
      if (lookahead == 'e') ADVANCE(132);
      if (lookahead == 'i') ADVANCE(133);
      END_STATE();
    case 105:
      if (lookahead == 'r') ADVANCE(134);
      END_STATE();
    case 106:
      if (lookahead == 'a') ADVANCE(135);
      END_STATE();
    case 107:
      if (lookahead == 'l') ADVANCE(136);
      END_STATE();
    case 108:
      if (lookahead == 'y') ADVANCE(137);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_specialId);
      END_STATE();
    case 110:
      if (lookahead == 'r') ADVANCE(138);
      END_STATE();
    case 111:
      if (lookahead == 'i') ADVANCE(139);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_rank);
      END_STATE();
    case 113:
      if (lookahead == 'l') ADVANCE(140);
      END_STATE();
    case 114:
      if (lookahead == 'c') ADVANCE(141);
      END_STATE();
    case 115:
      if (lookahead == 'c') ADVANCE(142);
      if (lookahead == 'n') ADVANCE(143);
      END_STATE();
    case 116:
      if (lookahead == 'r') ADVANCE(144);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 120:
      if (lookahead == 'u') ADVANCE(145);
      END_STATE();
    case 121:
      if (lookahead == 'e') ADVANCE(146);
      END_STATE();
    case 122:
      if (lookahead == 'a') ADVANCE(147);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 124:
      if (lookahead == 't') ADVANCE(148);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_count);
      END_STATE();
    case 126:
      if (lookahead == 's') ADVANCE(149);
      END_STATE();
    case 127:
      if (lookahead == 'd') ADVANCE(150);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_float);
      END_STATE();
    case 130:
      if (lookahead == 'l') ADVANCE(151);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_forex);
      END_STATE();
    case 132:
      if (lookahead == 'm') ADVANCE(152);
      END_STATE();
    case 133:
      if (lookahead == 'e') ADVANCE(153);
      END_STATE();
    case 134:
      if (lookahead == 't') ADVANCE(154);
      END_STATE();
    case 135:
      if (lookahead == 'n') ADVANCE(155);
      END_STATE();
    case 136:
      if (lookahead == 'e') ADVANCE(156);
      END_STATE();
    case 137:
      if (lookahead == 'p') ADVANCE(157);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_order);
      END_STATE();
    case 139:
      if (lookahead == 'c') ADVANCE(158);
      END_STATE();
    case 140:
      if (lookahead == 't') ADVANCE(159);
      END_STATE();
    case 141:
      if (lookahead == 't') ADVANCE(160);
      END_STATE();
    case 142:
      if (lookahead == 't') ADVANCE(161);
      END_STATE();
    case 143:
      if (lookahead == 'g') ADVANCE(162);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 145:
      if (lookahead == 'e') ADVANCE(163);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_where);
      END_STATE();
    case 147:
      if (lookahead == 'n') ADVANCE(164);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_concat);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_exists);
      END_STATE();
    case 150:
      if (lookahead == 's') ADVANCE(165);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_forall);
      END_STATE();
    case 152:
      if (lookahead == 'e') ADVANCE(166);
      END_STATE();
    case 153:
      if (lookahead == 's') ADVANCE(167);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 155:
      if (lookahead == 'c') ADVANCE(168);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 157:
      if (lookahead == 'e') ADVANCE(169);
      END_STATE();
    case 158:
      if (lookahead == 'a') ADVANCE(170);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(sym_result);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_select);
      END_STATE();
    case 161:
      if (lookahead == 'c') ADVANCE(171);
      if (lookahead == 's') ADVANCE(172);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_unique);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 166:
      if (lookahead == 'n') ADVANCE(173);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_implies);
      END_STATE();
    case 168:
      if (lookahead == 'e') ADVANCE(174);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_newtype);
      END_STATE();
    case 170:
      if (lookahead == 't') ADVANCE(175);
      END_STATE();
    case 171:
      if (lookahead == 'o') ADVANCE(176);
      END_STATE();
    case 172:
      if (lookahead == 'u') ADVANCE(177);
      END_STATE();
    case 173:
      if (lookahead == 't') ADVANCE(178);
      END_STATE();
    case 174:
      if (lookahead == 'o') ADVANCE(179);
      END_STATE();
    case 175:
      if (lookahead == 'e') ADVANCE(180);
      END_STATE();
    case 176:
      if (lookahead == 'n') ADVANCE(181);
      if (lookahead == 'u') ADVANCE(182);
      END_STATE();
    case 177:
      if (lookahead == 'm') ADVANCE(183);
      END_STATE();
    case 178:
      if (lookahead == 's') ADVANCE(184);
      END_STATE();
    case 179:
      if (lookahead == 'f') ADVANCE(185);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_predicate);
      END_STATE();
    case 181:
      if (lookahead == 'c') ADVANCE(186);
      END_STATE();
    case 182:
      if (lookahead == 'n') ADVANCE(187);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_strictsum);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    case 186:
      if (lookahead == 'a') ADVANCE(188);
      END_STATE();
    case 187:
      if (lookahead == 't') ADVANCE(189);
      END_STATE();
    case 188:
      if (lookahead == 't') ADVANCE(190);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_strictcount);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_strictconcat);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 0},
  [2] = {.lex_state = 16},
  [3] = {.lex_state = 16},
  [4] = {.lex_state = 16},
  [5] = {.lex_state = 16},
  [6] = {.lex_state = 16},
  [7] = {.lex_state = 16},
  [8] = {.lex_state = 16},
  [9] = {.lex_state = 16},
  [10] = {.lex_state = 16},
  [11] = {.lex_state = 16},
  [12] = {.lex_state = 16},
  [13] = {.lex_state = 16},
  [14] = {.lex_state = 16},
  [15] = {.lex_state = 16},
  [16] = {.lex_state = 16},
  [17] = {.lex_state = 16},
  [18] = {.lex_state = 16},
  [19] = {.lex_state = 16},
  [20] = {.lex_state = 16},
  [21] = {.lex_state = 16},
  [22] = {.lex_state = 16},
  [23] = {.lex_state = 16},
  [24] = {.lex_state = 16},
  [25] = {.lex_state = 16},
  [26] = {.lex_state = 16},
  [27] = {.lex_state = 16},
  [28] = {.lex_state = 16},
  [29] = {.lex_state = 16},
  [30] = {.lex_state = 16},
  [31] = {.lex_state = 16},
  [32] = {.lex_state = 16},
  [33] = {.lex_state = 16},
  [34] = {.lex_state = 16},
  [35] = {.lex_state = 16},
  [36] = {.lex_state = 16},
  [37] = {.lex_state = 16},
  [38] = {.lex_state = 16},
  [39] = {.lex_state = 16},
  [40] = {.lex_state = 16},
  [41] = {.lex_state = 16},
  [42] = {.lex_state = 16},
  [43] = {.lex_state = 16},
  [44] = {.lex_state = 16},
  [45] = {.lex_state = 16},
  [46] = {.lex_state = 16},
  [47] = {.lex_state = 16},
  [48] = {.lex_state = 16},
  [49] = {.lex_state = 16},
  [50] = {.lex_state = 16},
  [51] = {.lex_state = 16},
  [52] = {.lex_state = 16},
  [53] = {.lex_state = 16},
  [54] = {.lex_state = 16},
  [55] = {.lex_state = 16},
  [56] = {.lex_state = 16},
  [57] = {.lex_state = 16},
  [58] = {.lex_state = 16},
  [59] = {.lex_state = 16},
  [60] = {.lex_state = 16},
  [61] = {.lex_state = 16},
  [62] = {.lex_state = 16},
  [63] = {.lex_state = 16},
  [64] = {.lex_state = 16},
  [65] = {.lex_state = 16},
  [66] = {.lex_state = 16},
  [67] = {.lex_state = 16},
  [68] = {.lex_state = 16},
  [69] = {.lex_state = 16},
  [70] = {.lex_state = 16},
  [71] = {.lex_state = 16},
  [72] = {.lex_state = 16},
  [73] = {.lex_state = 16},
  [74] = {.lex_state = 16},
  [75] = {.lex_state = 16},
  [76] = {.lex_state = 16},
  [77] = {.lex_state = 16},
  [78] = {.lex_state = 16},
  [79] = {.lex_state = 16},
  [80] = {.lex_state = 16},
  [81] = {.lex_state = 16},
  [82] = {.lex_state = 16},
  [83] = {.lex_state = 16},
  [84] = {.lex_state = 16},
  [85] = {.lex_state = 16},
  [86] = {.lex_state = 16},
  [87] = {.lex_state = 16},
  [88] = {.lex_state = 16},
  [89] = {.lex_state = 16},
  [90] = {.lex_state = 16},
  [91] = {.lex_state = 16},
  [92] = {.lex_state = 16},
  [93] = {.lex_state = 16},
  [94] = {.lex_state = 16},
  [95] = {.lex_state = 16},
  [96] = {.lex_state = 16},
  [97] = {.lex_state = 16},
  [98] = {.lex_state = 16},
  [99] = {.lex_state = 16},
  [100] = {.lex_state = 16},
  [101] = {.lex_state = 16},
  [102] = {.lex_state = 16},
  [103] = {.lex_state = 16},
  [104] = {.lex_state = 16},
  [105] = {.lex_state = 16},
  [106] = {.lex_state = 16},
  [107] = {.lex_state = 16},
  [108] = {.lex_state = 16},
  [109] = {.lex_state = 16},
  [110] = {.lex_state = 16},
  [111] = {.lex_state = 16},
  [112] = {.lex_state = 16},
  [113] = {.lex_state = 16},
  [114] = {.lex_state = 16},
  [115] = {.lex_state = 16},
  [116] = {.lex_state = 16},
  [117] = {.lex_state = 16},
  [118] = {.lex_state = 16},
  [119] = {.lex_state = 16},
  [120] = {.lex_state = 16},
  [121] = {.lex_state = 16},
  [122] = {.lex_state = 16},
  [123] = {.lex_state = 16},
  [124] = {.lex_state = 16},
  [125] = {.lex_state = 16},
  [126] = {.lex_state = 16},
  [127] = {.lex_state = 16},
  [128] = {.lex_state = 16},
  [129] = {.lex_state = 16},
  [130] = {.lex_state = 16},
  [131] = {.lex_state = 16},
  [132] = {.lex_state = 16},
  [133] = {.lex_state = 16},
  [134] = {.lex_state = 16},
  [135] = {.lex_state = 16},
  [136] = {.lex_state = 16},
  [137] = {.lex_state = 16},
  [138] = {.lex_state = 16},
  [139] = {.lex_state = 16},
  [140] = {.lex_state = 16},
  [141] = {.lex_state = 16},
  [142] = {.lex_state = 16},
  [143] = {.lex_state = 16},
  [144] = {.lex_state = 16},
  [145] = {.lex_state = 16},
  [146] = {.lex_state = 16},
  [147] = {.lex_state = 16},
  [148] = {.lex_state = 16},
  [149] = {.lex_state = 16},
  [150] = {.lex_state = 16},
  [151] = {.lex_state = 16},
  [152] = {.lex_state = 16},
  [153] = {.lex_state = 16},
  [154] = {.lex_state = 16},
  [155] = {.lex_state = 16},
  [156] = {.lex_state = 16},
  [157] = {.lex_state = 16},
  [158] = {.lex_state = 16},
  [159] = {.lex_state = 16},
  [160] = {.lex_state = 16},
  [161] = {.lex_state = 16},
  [162] = {.lex_state = 16},
  [163] = {.lex_state = 16},
  [164] = {.lex_state = 16},
  [165] = {.lex_state = 16},
  [166] = {.lex_state = 16},
  [167] = {.lex_state = 16},
  [168] = {.lex_state = 16},
  [169] = {.lex_state = 16},
  [170] = {.lex_state = 16},
  [171] = {.lex_state = 16},
  [172] = {.lex_state = 16},
  [173] = {.lex_state = 16},
  [174] = {.lex_state = 16},
  [175] = {.lex_state = 16},
  [176] = {.lex_state = 16},
  [177] = {.lex_state = 16},
  [178] = {.lex_state = 16},
  [179] = {.lex_state = 16},
  [180] = {.lex_state = 16},
  [181] = {.lex_state = 16},
  [182] = {.lex_state = 16},
  [183] = {.lex_state = 16},
  [184] = {.lex_state = 16},
  [185] = {.lex_state = 16},
  [186] = {.lex_state = 16},
  [187] = {.lex_state = 16},
  [188] = {.lex_state = 16},
  [189] = {.lex_state = 16},
  [190] = {.lex_state = 16},
  [191] = {.lex_state = 16},
  [192] = {.lex_state = 16},
  [193] = {.lex_state = 16},
  [194] = {.lex_state = 16},
  [195] = {.lex_state = 16},
  [196] = {.lex_state = 16},
  [197] = {.lex_state = 16},
  [198] = {.lex_state = 16},
  [199] = {.lex_state = 16},
  [200] = {.lex_state = 16},
  [201] = {.lex_state = 16},
  [202] = {.lex_state = 16},
  [203] = {.lex_state = 16},
  [204] = {.lex_state = 16},
  [205] = {.lex_state = 16},
  [206] = {.lex_state = 16},
  [207] = {.lex_state = 16},
  [208] = {.lex_state = 16},
  [209] = {.lex_state = 16},
  [210] = {.lex_state = 16},
  [211] = {.lex_state = 16},
  [212] = {.lex_state = 16},
  [213] = {.lex_state = 16},
  [214] = {.lex_state = 16},
  [215] = {.lex_state = 16},
  [216] = {.lex_state = 16},
  [217] = {.lex_state = 16},
  [218] = {.lex_state = 16},
  [219] = {.lex_state = 16},
  [220] = {.lex_state = 16},
  [221] = {.lex_state = 16},
  [222] = {.lex_state = 16},
  [223] = {.lex_state = 16},
  [224] = {.lex_state = 16},
  [225] = {.lex_state = 16},
  [226] = {.lex_state = 16},
  [227] = {.lex_state = 16},
  [228] = {.lex_state = 16},
  [229] = {.lex_state = 16},
  [230] = {.lex_state = 16},
  [231] = {.lex_state = 16},
  [232] = {.lex_state = 16},
  [233] = {.lex_state = 16},
  [234] = {.lex_state = 16},
  [235] = {.lex_state = 16},
  [236] = {.lex_state = 16},
  [237] = {.lex_state = 16},
  [238] = {.lex_state = 16},
  [239] = {.lex_state = 16},
  [240] = {.lex_state = 16},
  [241] = {.lex_state = 16},
  [242] = {.lex_state = 16},
  [243] = {.lex_state = 16},
  [244] = {.lex_state = 16},
  [245] = {.lex_state = 16},
  [246] = {.lex_state = 16},
  [247] = {.lex_state = 16},
  [248] = {.lex_state = 16},
  [249] = {.lex_state = 16},
  [250] = {.lex_state = 16},
  [251] = {.lex_state = 16},
  [252] = {.lex_state = 16},
  [253] = {.lex_state = 16},
  [254] = {.lex_state = 16},
  [255] = {.lex_state = 16},
  [256] = {.lex_state = 16},
  [257] = {.lex_state = 16},
  [258] = {.lex_state = 16},
  [259] = {.lex_state = 16},
  [260] = {.lex_state = 16},
  [261] = {.lex_state = 16},
  [262] = {.lex_state = 16},
  [263] = {.lex_state = 16},
  [264] = {.lex_state = 16},
  [265] = {.lex_state = 16},
  [266] = {.lex_state = 16},
  [267] = {.lex_state = 16},
  [268] = {.lex_state = 16},
  [269] = {.lex_state = 16},
  [270] = {.lex_state = 16},
  [271] = {.lex_state = 16},
  [272] = {.lex_state = 16},
  [273] = {.lex_state = 16},
  [274] = {.lex_state = 16},
  [275] = {.lex_state = 16},
  [276] = {.lex_state = 16},
  [277] = {.lex_state = 16},
  [278] = {.lex_state = 16},
  [279] = {.lex_state = 16},
  [280] = {.lex_state = 16},
  [281] = {.lex_state = 16},
  [282] = {.lex_state = 16},
  [283] = {.lex_state = 16},
  [284] = {.lex_state = 16},
  [285] = {.lex_state = 16},
  [286] = {.lex_state = 16},
  [287] = {.lex_state = 16},
  [288] = {.lex_state = 16},
  [289] = {.lex_state = 16},
  [290] = {.lex_state = 16},
  [291] = {.lex_state = 16},
  [292] = {.lex_state = 16},
  [293] = {.lex_state = 16},
  [294] = {.lex_state = 16},
  [295] = {.lex_state = 16},
  [296] = {.lex_state = 16},
  [297] = {.lex_state = 16},
  [298] = {.lex_state = 16},
  [299] = {.lex_state = 16},
  [300] = {.lex_state = 16},
  [301] = {.lex_state = 16},
  [302] = {.lex_state = 16},
  [303] = {.lex_state = 16},
  [304] = {.lex_state = 16},
  [305] = {.lex_state = 16},
  [306] = {.lex_state = 16},
  [307] = {.lex_state = 16},
  [308] = {.lex_state = 16},
  [309] = {.lex_state = 16},
  [310] = {.lex_state = 16},
  [311] = {.lex_state = 16},
  [312] = {.lex_state = 16},
  [313] = {.lex_state = 16},
  [314] = {.lex_state = 16},
  [315] = {.lex_state = 16},
  [316] = {.lex_state = 16},
  [317] = {.lex_state = 16},
  [318] = {.lex_state = 16},
  [319] = {.lex_state = 16},
  [320] = {.lex_state = 16},
  [321] = {.lex_state = 16},
  [322] = {.lex_state = 16},
  [323] = {.lex_state = 16},
  [324] = {.lex_state = 16},
  [325] = {.lex_state = 16},
  [326] = {.lex_state = 16},
  [327] = {.lex_state = 16},
  [328] = {.lex_state = 16},
  [329] = {.lex_state = 16},
  [330] = {.lex_state = 16},
  [331] = {.lex_state = 16},
  [332] = {.lex_state = 16},
  [333] = {.lex_state = 16},
  [334] = {.lex_state = 16},
  [335] = {.lex_state = 16},
  [336] = {.lex_state = 16},
  [337] = {.lex_state = 16},
  [338] = {.lex_state = 16},
  [339] = {.lex_state = 16},
  [340] = {.lex_state = 16},
  [341] = {.lex_state = 16},
  [342] = {.lex_state = 16},
  [343] = {.lex_state = 16},
  [344] = {.lex_state = 16},
  [345] = {.lex_state = 16},
  [346] = {.lex_state = 16},
  [347] = {.lex_state = 16},
  [348] = {.lex_state = 16},
  [349] = {.lex_state = 16},
  [350] = {.lex_state = 16},
  [351] = {.lex_state = 16},
  [352] = {.lex_state = 16},
  [353] = {.lex_state = 16},
  [354] = {.lex_state = 16},
  [355] = {.lex_state = 16},
  [356] = {.lex_state = 16},
  [357] = {.lex_state = 16},
  [358] = {.lex_state = 16},
  [359] = {.lex_state = 16},
  [360] = {.lex_state = 16},
  [361] = {.lex_state = 16},
  [362] = {.lex_state = 16},
  [363] = {.lex_state = 16},
  [364] = {.lex_state = 16},
  [365] = {.lex_state = 16},
  [366] = {.lex_state = 16},
  [367] = {.lex_state = 0},
  [368] = {.lex_state = 0},
  [369] = {.lex_state = 0},
  [370] = {.lex_state = 0},
  [371] = {.lex_state = 0},
  [372] = {.lex_state = 0},
  [373] = {.lex_state = 0},
  [374] = {.lex_state = 0},
  [375] = {.lex_state = 0},
  [376] = {.lex_state = 0},
  [377] = {.lex_state = 0},
  [378] = {.lex_state = 0},
  [379] = {.lex_state = 0},
  [380] = {.lex_state = 0},
  [381] = {.lex_state = 0},
  [382] = {.lex_state = 0},
  [383] = {.lex_state = 0},
  [384] = {.lex_state = 0},
  [385] = {.lex_state = 0},
  [386] = {.lex_state = 0},
  [387] = {.lex_state = 0},
  [388] = {.lex_state = 0},
  [389] = {.lex_state = 0},
  [390] = {.lex_state = 0},
  [391] = {.lex_state = 0},
  [392] = {.lex_state = 0},
  [393] = {.lex_state = 0},
  [394] = {.lex_state = 0},
  [395] = {.lex_state = 0},
  [396] = {.lex_state = 0},
  [397] = {.lex_state = 0},
  [398] = {.lex_state = 0},
  [399] = {.lex_state = 0},
  [400] = {.lex_state = 0},
  [401] = {.lex_state = 0},
  [402] = {.lex_state = 0},
  [403] = {.lex_state = 0},
  [404] = {.lex_state = 0},
  [405] = {.lex_state = 0},
  [406] = {.lex_state = 0},
  [407] = {.lex_state = 0},
  [408] = {.lex_state = 0},
  [409] = {.lex_state = 0},
  [410] = {.lex_state = 0},
  [411] = {.lex_state = 0},
  [412] = {.lex_state = 0},
  [413] = {.lex_state = 0},
  [414] = {.lex_state = 0},
  [415] = {.lex_state = 0},
  [416] = {.lex_state = 0},
  [417] = {.lex_state = 0},
  [418] = {.lex_state = 0},
  [419] = {.lex_state = 0},
  [420] = {.lex_state = 0},
  [421] = {.lex_state = 0},
  [422] = {.lex_state = 0},
  [423] = {.lex_state = 0},
  [424] = {.lex_state = 0},
  [425] = {.lex_state = 0},
  [426] = {.lex_state = 0},
  [427] = {.lex_state = 0},
  [428] = {.lex_state = 0},
  [429] = {.lex_state = 0},
  [430] = {.lex_state = 0},
  [431] = {.lex_state = 0},
  [432] = {.lex_state = 0},
  [433] = {.lex_state = 0},
  [434] = {.lex_state = 0},
  [435] = {.lex_state = 0},
  [436] = {.lex_state = 0},
  [437] = {.lex_state = 0},
  [438] = {.lex_state = 0},
  [439] = {.lex_state = 0},
  [440] = {.lex_state = 0},
  [441] = {.lex_state = 0},
  [442] = {.lex_state = 0},
  [443] = {.lex_state = 0},
  [444] = {.lex_state = 0},
  [445] = {.lex_state = 0},
  [446] = {.lex_state = 0},
  [447] = {.lex_state = 0},
  [448] = {.lex_state = 0},
  [449] = {.lex_state = 0},
  [450] = {.lex_state = 0},
  [451] = {.lex_state = 0},
  [452] = {.lex_state = 0},
  [453] = {.lex_state = 0},
  [454] = {.lex_state = 0},
  [455] = {.lex_state = 0},
  [456] = {.lex_state = 0},
  [457] = {.lex_state = 0},
  [458] = {.lex_state = 0},
  [459] = {.lex_state = 0},
  [460] = {.lex_state = 0},
  [461] = {.lex_state = 0},
  [462] = {.lex_state = 0},
  [463] = {.lex_state = 0},
  [464] = {.lex_state = 0},
  [465] = {.lex_state = 0},
  [466] = {.lex_state = 0},
  [467] = {.lex_state = 16},
  [468] = {.lex_state = 16},
  [469] = {.lex_state = 16},
  [470] = {.lex_state = 0},
  [471] = {.lex_state = 0},
  [472] = {.lex_state = 0},
  [473] = {.lex_state = 0},
  [474] = {.lex_state = 0},
  [475] = {.lex_state = 0},
  [476] = {.lex_state = 0},
  [477] = {.lex_state = 0},
  [478] = {.lex_state = 0},
  [479] = {.lex_state = 0},
  [480] = {.lex_state = 0},
  [481] = {.lex_state = 0},
  [482] = {.lex_state = 0},
  [483] = {.lex_state = 0},
  [484] = {.lex_state = 0},
  [485] = {.lex_state = 0},
  [486] = {.lex_state = 0},
  [487] = {.lex_state = 0},
  [488] = {.lex_state = 0},
  [489] = {.lex_state = 0},
  [490] = {.lex_state = 0},
  [491] = {.lex_state = 0},
  [492] = {.lex_state = 0},
  [493] = {.lex_state = 0},
  [494] = {.lex_state = 0},
  [495] = {.lex_state = 0},
  [496] = {.lex_state = 0},
  [497] = {.lex_state = 0},
  [498] = {.lex_state = 0},
  [499] = {.lex_state = 0},
  [500] = {.lex_state = 0},
  [501] = {.lex_state = 0},
  [502] = {.lex_state = 0},
  [503] = {.lex_state = 0},
  [504] = {.lex_state = 0},
  [505] = {.lex_state = 0},
  [506] = {.lex_state = 0},
  [507] = {.lex_state = 0},
  [508] = {.lex_state = 0},
  [509] = {.lex_state = 0},
  [510] = {.lex_state = 0},
  [511] = {.lex_state = 0},
  [512] = {.lex_state = 0},
  [513] = {.lex_state = 0},
  [514] = {.lex_state = 0},
  [515] = {.lex_state = 16},
  [516] = {.lex_state = 0},
  [517] = {.lex_state = 0},
  [518] = {.lex_state = 0},
  [519] = {.lex_state = 0},
  [520] = {.lex_state = 0},
  [521] = {.lex_state = 0},
  [522] = {.lex_state = 0},
  [523] = {.lex_state = 0},
  [524] = {.lex_state = 0},
  [525] = {.lex_state = 0},
  [526] = {.lex_state = 0},
  [527] = {.lex_state = 0},
  [528] = {.lex_state = 0},
  [529] = {.lex_state = 0},
  [530] = {.lex_state = 0},
  [531] = {.lex_state = 0},
  [532] = {.lex_state = 0},
  [533] = {.lex_state = 0},
  [534] = {.lex_state = 0},
  [535] = {.lex_state = 0},
  [536] = {.lex_state = 0},
  [537] = {.lex_state = 0},
  [538] = {.lex_state = 0},
  [539] = {.lex_state = 0},
  [540] = {.lex_state = 0},
  [541] = {.lex_state = 0},
  [542] = {.lex_state = 0},
  [543] = {.lex_state = 0},
  [544] = {.lex_state = 0},
  [545] = {.lex_state = 0},
  [546] = {.lex_state = 0},
  [547] = {.lex_state = 0},
  [548] = {.lex_state = 0},
  [549] = {.lex_state = 0},
  [550] = {.lex_state = 0},
  [551] = {.lex_state = 0},
  [552] = {.lex_state = 0},
  [553] = {.lex_state = 0},
  [554] = {.lex_state = 0},
  [555] = {.lex_state = 0},
  [556] = {.lex_state = 0},
  [557] = {.lex_state = 0},
  [558] = {.lex_state = 0},
  [559] = {.lex_state = 0},
  [560] = {.lex_state = 0},
  [561] = {.lex_state = 0},
  [562] = {.lex_state = 0},
  [563] = {.lex_state = 0},
  [564] = {.lex_state = 0},
  [565] = {.lex_state = 0},
  [566] = {.lex_state = 0},
  [567] = {.lex_state = 0},
  [568] = {.lex_state = 0},
  [569] = {.lex_state = 0},
  [570] = {.lex_state = 0},
  [571] = {.lex_state = 0},
  [572] = {.lex_state = 0},
  [573] = {.lex_state = 0},
  [574] = {.lex_state = 0},
  [575] = {.lex_state = 0},
  [576] = {.lex_state = 0},
  [577] = {.lex_state = 0},
  [578] = {.lex_state = 0},
  [579] = {.lex_state = 0},
  [580] = {.lex_state = 0},
  [581] = {.lex_state = 0},
  [582] = {.lex_state = 0},
  [583] = {.lex_state = 0},
  [584] = {.lex_state = 0},
  [585] = {.lex_state = 0},
  [586] = {.lex_state = 0},
  [587] = {.lex_state = 0},
  [588] = {.lex_state = 0},
  [589] = {.lex_state = 0},
  [590] = {.lex_state = 0},
  [591] = {.lex_state = 0},
  [592] = {.lex_state = 0},
  [593] = {.lex_state = 0},
  [594] = {.lex_state = 0},
  [595] = {.lex_state = 0},
  [596] = {.lex_state = 0},
  [597] = {.lex_state = 0},
  [598] = {.lex_state = 0},
  [599] = {.lex_state = 0},
  [600] = {.lex_state = 0},
  [601] = {.lex_state = 0},
  [602] = {.lex_state = 0},
  [603] = {.lex_state = 0},
  [604] = {.lex_state = 0},
  [605] = {.lex_state = 0},
  [606] = {.lex_state = 0},
  [607] = {.lex_state = 0},
  [608] = {.lex_state = 0},
  [609] = {.lex_state = 0},
  [610] = {.lex_state = 0},
  [611] = {.lex_state = 0},
  [612] = {.lex_state = 0},
  [613] = {.lex_state = 0},
  [614] = {.lex_state = 0},
  [615] = {.lex_state = 0},
  [616] = {.lex_state = 0},
  [617] = {.lex_state = 0},
  [618] = {.lex_state = 0},
  [619] = {.lex_state = 0},
  [620] = {.lex_state = 0},
  [621] = {.lex_state = 0},
  [622] = {.lex_state = 0},
  [623] = {.lex_state = 0},
  [624] = {.lex_state = 0},
  [625] = {.lex_state = 0},
  [626] = {.lex_state = 0},
  [627] = {.lex_state = 0},
  [628] = {.lex_state = 0},
  [629] = {.lex_state = 0},
  [630] = {.lex_state = 0},
  [631] = {.lex_state = 0},
  [632] = {.lex_state = 0},
  [633] = {.lex_state = 0},
  [634] = {.lex_state = 0},
  [635] = {.lex_state = 0},
  [636] = {.lex_state = 0},
  [637] = {.lex_state = 0},
  [638] = {.lex_state = 0},
  [639] = {.lex_state = 0},
  [640] = {.lex_state = 0},
  [641] = {.lex_state = 0},
  [642] = {.lex_state = 0},
  [643] = {.lex_state = 0},
  [644] = {.lex_state = 0},
  [645] = {.lex_state = 0},
  [646] = {.lex_state = 0},
  [647] = {.lex_state = 0},
  [648] = {.lex_state = 0},
  [649] = {.lex_state = 0},
  [650] = {.lex_state = 0},
  [651] = {.lex_state = 0},
  [652] = {.lex_state = 0},
  [653] = {.lex_state = 0},
  [654] = {.lex_state = 0},
  [655] = {.lex_state = 0},
  [656] = {.lex_state = 0},
  [657] = {.lex_state = 0},
  [658] = {.lex_state = 0},
  [659] = {.lex_state = 0},
  [660] = {.lex_state = 0},
  [661] = {.lex_state = 0},
  [662] = {.lex_state = 0},
  [663] = {.lex_state = 0},
  [664] = {.lex_state = 0},
  [665] = {.lex_state = 0},
  [666] = {.lex_state = 0},
  [667] = {.lex_state = 0},
  [668] = {.lex_state = 0},
  [669] = {.lex_state = 0},
  [670] = {.lex_state = 0},
  [671] = {.lex_state = 0},
  [672] = {.lex_state = 0},
  [673] = {.lex_state = 0},
  [674] = {.lex_state = 0},
  [675] = {.lex_state = 0},
  [676] = {.lex_state = 0},
  [677] = {.lex_state = 0},
  [678] = {.lex_state = 0},
  [679] = {.lex_state = 0},
  [680] = {.lex_state = 0},
  [681] = {.lex_state = 0},
  [682] = {.lex_state = 0},
  [683] = {.lex_state = 0},
  [684] = {.lex_state = 0},
  [685] = {.lex_state = 0},
  [686] = {.lex_state = 0},
  [687] = {.lex_state = 0},
  [688] = {.lex_state = 0},
  [689] = {.lex_state = 0},
  [690] = {.lex_state = 0},
  [691] = {.lex_state = 0},
  [692] = {.lex_state = 0},
  [693] = {.lex_state = 0},
  [694] = {.lex_state = 0},
  [695] = {.lex_state = 0},
  [696] = {.lex_state = 0},
  [697] = {.lex_state = 0},
  [698] = {.lex_state = 0},
  [699] = {.lex_state = 0},
  [700] = {.lex_state = 0},
  [701] = {.lex_state = 0},
  [702] = {.lex_state = 16},
  [703] = {.lex_state = 16},
  [704] = {.lex_state = 16},
  [705] = {.lex_state = 16},
  [706] = {.lex_state = 16},
  [707] = {.lex_state = 0},
  [708] = {.lex_state = 0},
  [709] = {.lex_state = 0},
  [710] = {.lex_state = 0},
  [711] = {.lex_state = 16},
  [712] = {.lex_state = 16},
  [713] = {.lex_state = 0},
  [714] = {.lex_state = 16},
  [715] = {.lex_state = 16},
  [716] = {.lex_state = 16},
  [717] = {.lex_state = 16},
  [718] = {.lex_state = 16},
  [719] = {.lex_state = 16},
  [720] = {.lex_state = 16},
  [721] = {.lex_state = 16},
  [722] = {.lex_state = 16},
  [723] = {.lex_state = 16},
  [724] = {.lex_state = 16},
  [725] = {.lex_state = 0},
  [726] = {.lex_state = 0},
  [727] = {.lex_state = 0},
  [728] = {.lex_state = 16},
  [729] = {.lex_state = 0},
  [730] = {.lex_state = 16},
  [731] = {.lex_state = 16},
  [732] = {.lex_state = 16},
  [733] = {.lex_state = 16},
  [734] = {.lex_state = 16},
  [735] = {.lex_state = 16},
  [736] = {.lex_state = 16},
  [737] = {.lex_state = 16},
  [738] = {.lex_state = 0},
  [739] = {.lex_state = 0},
  [740] = {.lex_state = 16},
  [741] = {.lex_state = 0},
  [742] = {.lex_state = 0},
  [743] = {.lex_state = 0},
  [744] = {.lex_state = 0},
  [745] = {.lex_state = 0},
  [746] = {.lex_state = 0},
  [747] = {.lex_state = 0},
  [748] = {.lex_state = 0},
  [749] = {.lex_state = 0},
  [750] = {.lex_state = 16},
  [751] = {.lex_state = 16},
  [752] = {.lex_state = 0},
  [753] = {.lex_state = 0},
  [754] = {.lex_state = 0},
  [755] = {.lex_state = 0},
  [756] = {.lex_state = 0},
  [757] = {.lex_state = 0},
  [758] = {.lex_state = 0},
  [759] = {.lex_state = 0},
  [760] = {.lex_state = 16},
  [761] = {.lex_state = 16},
  [762] = {.lex_state = 16},
  [763] = {.lex_state = 16},
  [764] = {.lex_state = 0},
  [765] = {.lex_state = 16},
  [766] = {.lex_state = 16},
  [767] = {.lex_state = 16},
  [768] = {.lex_state = 0},
  [769] = {.lex_state = 0},
  [770] = {.lex_state = 0},
  [771] = {.lex_state = 16},
  [772] = {.lex_state = 16},
  [773] = {.lex_state = 16},
  [774] = {.lex_state = 16},
  [775] = {.lex_state = 16},
  [776] = {.lex_state = 16},
  [777] = {.lex_state = 16},
  [778] = {.lex_state = 16},
  [779] = {.lex_state = 16},
  [780] = {.lex_state = 16},
  [781] = {.lex_state = 16},
  [782] = {.lex_state = 0},
  [783] = {.lex_state = 0},
  [784] = {.lex_state = 0},
  [785] = {.lex_state = 0},
  [786] = {.lex_state = 0},
  [787] = {.lex_state = 16},
  [788] = {.lex_state = 16},
  [789] = {.lex_state = 16},
  [790] = {.lex_state = 16},
  [791] = {.lex_state = 16},
  [792] = {.lex_state = 16},
  [793] = {.lex_state = 16},
  [794] = {.lex_state = 16},
  [795] = {.lex_state = 16},
  [796] = {.lex_state = 16},
  [797] = {.lex_state = 16},
  [798] = {.lex_state = 16},
  [799] = {.lex_state = 16},
  [800] = {.lex_state = 16},
  [801] = {.lex_state = 16},
  [802] = {.lex_state = 16},
  [803] = {.lex_state = 16},
  [804] = {.lex_state = 16},
  [805] = {.lex_state = 16},
  [806] = {.lex_state = 16},
  [807] = {.lex_state = 16},
  [808] = {.lex_state = 16},
  [809] = {.lex_state = 16},
  [810] = {.lex_state = 16},
  [811] = {.lex_state = 16},
  [812] = {.lex_state = 16},
  [813] = {.lex_state = 16},
  [814] = {.lex_state = 16},
  [815] = {.lex_state = 16},
  [816] = {.lex_state = 0},
  [817] = {.lex_state = 0},
  [818] = {.lex_state = 16},
  [819] = {.lex_state = 16},
  [820] = {.lex_state = 16},
  [821] = {.lex_state = 16},
  [822] = {.lex_state = 16},
  [823] = {.lex_state = 16},
  [824] = {.lex_state = 16},
  [825] = {.lex_state = 16},
  [826] = {.lex_state = 16},
  [827] = {.lex_state = 16},
  [828] = {.lex_state = 16},
  [829] = {.lex_state = 16},
  [830] = {.lex_state = 16},
  [831] = {.lex_state = 16},
  [832] = {.lex_state = 16},
  [833] = {.lex_state = 16},
  [834] = {.lex_state = 16},
  [835] = {.lex_state = 16},
  [836] = {.lex_state = 16},
  [837] = {.lex_state = 16},
  [838] = {.lex_state = 16},
  [839] = {.lex_state = 16},
  [840] = {.lex_state = 16},
  [841] = {.lex_state = 16},
  [842] = {.lex_state = 16},
  [843] = {.lex_state = 16},
  [844] = {.lex_state = 16},
  [845] = {.lex_state = 16},
  [846] = {.lex_state = 16},
  [847] = {.lex_state = 16},
  [848] = {.lex_state = 16},
  [849] = {.lex_state = 16},
  [850] = {.lex_state = 16},
  [851] = {.lex_state = 16},
  [852] = {.lex_state = 16},
  [853] = {.lex_state = 16},
  [854] = {.lex_state = 16},
  [855] = {.lex_state = 16},
  [856] = {.lex_state = 16},
  [857] = {.lex_state = 16},
  [858] = {.lex_state = 16},
  [859] = {.lex_state = 16},
  [860] = {.lex_state = 16},
  [861] = {.lex_state = 16},
  [862] = {.lex_state = 0},
  [863] = {.lex_state = 0},
  [864] = {.lex_state = 16},
  [865] = {.lex_state = 16},
  [866] = {.lex_state = 16},
  [867] = {.lex_state = 16},
  [868] = {.lex_state = 16},
  [869] = {.lex_state = 16},
  [870] = {.lex_state = 16},
  [871] = {.lex_state = 16},
  [872] = {.lex_state = 16},
  [873] = {.lex_state = 16},
  [874] = {.lex_state = 16},
  [875] = {.lex_state = 16},
  [876] = {.lex_state = 16},
  [877] = {.lex_state = 16},
  [878] = {.lex_state = 16},
  [879] = {.lex_state = 16},
  [880] = {.lex_state = 16},
  [881] = {.lex_state = 16},
  [882] = {.lex_state = 16},
  [883] = {.lex_state = 16},
  [884] = {.lex_state = 0},
  [885] = {.lex_state = 16},
  [886] = {.lex_state = 0},
  [887] = {.lex_state = 16},
  [888] = {.lex_state = 16},
  [889] = {.lex_state = 16},
  [890] = {.lex_state = 16},
  [891] = {.lex_state = 16},
  [892] = {.lex_state = 0},
  [893] = {.lex_state = 16},
  [894] = {.lex_state = 16},
  [895] = {.lex_state = 0},
  [896] = {.lex_state = 16},
  [897] = {.lex_state = 16},
  [898] = {.lex_state = 16},
  [899] = {.lex_state = 16},
  [900] = {.lex_state = 16},
  [901] = {.lex_state = 0},
  [902] = {.lex_state = 16},
  [903] = {.lex_state = 16},
  [904] = {.lex_state = 16},
  [905] = {.lex_state = 16},
  [906] = {.lex_state = 16},
  [907] = {.lex_state = 16},
  [908] = {.lex_state = 16},
  [909] = {.lex_state = 16},
  [910] = {.lex_state = 0},
  [911] = {.lex_state = 16},
  [912] = {.lex_state = 0},
  [913] = {.lex_state = 16},
  [914] = {.lex_state = 16},
  [915] = {.lex_state = 16},
  [916] = {.lex_state = 16},
  [917] = {.lex_state = 0},
  [918] = {.lex_state = 16},
  [919] = {.lex_state = 16},
  [920] = {.lex_state = 16},
  [921] = {.lex_state = 16},
  [922] = {.lex_state = 16},
  [923] = {.lex_state = 16},
  [924] = {.lex_state = 16},
  [925] = {.lex_state = 16},
  [926] = {.lex_state = 0},
  [927] = {.lex_state = 16},
  [928] = {.lex_state = 16},
  [929] = {.lex_state = 0},
  [930] = {.lex_state = 0},
  [931] = {.lex_state = 16},
  [932] = {.lex_state = 0},
  [933] = {.lex_state = 0},
  [934] = {.lex_state = 0},
  [935] = {.lex_state = 16},
  [936] = {.lex_state = 16},
  [937] = {.lex_state = 16},
  [938] = {.lex_state = 16},
  [939] = {.lex_state = 16},
  [940] = {.lex_state = 16},
  [941] = {.lex_state = 16},
  [942] = {.lex_state = 16},
  [943] = {.lex_state = 16},
  [944] = {.lex_state = 16},
  [945] = {.lex_state = 16},
  [946] = {.lex_state = 16},
  [947] = {.lex_state = 16},
  [948] = {.lex_state = 16},
  [949] = {.lex_state = 16},
  [950] = {.lex_state = 16},
  [951] = {.lex_state = 16},
  [952] = {.lex_state = 16},
  [953] = {.lex_state = 16},
  [954] = {.lex_state = 16},
  [955] = {.lex_state = 16},
  [956] = {.lex_state = 16},
  [957] = {.lex_state = 16},
  [958] = {.lex_state = 16},
  [959] = {.lex_state = 16},
  [960] = {.lex_state = 16},
  [961] = {.lex_state = 16},
  [962] = {.lex_state = 16},
  [963] = {.lex_state = 16},
  [964] = {.lex_state = 16},
  [965] = {.lex_state = 16},
  [966] = {.lex_state = 16},
  [967] = {.lex_state = 0},
  [968] = {.lex_state = 16},
  [969] = {.lex_state = 16},
  [970] = {.lex_state = 0},
  [971] = {.lex_state = 0},
  [972] = {.lex_state = 16},
  [973] = {.lex_state = 16},
  [974] = {.lex_state = 16},
  [975] = {.lex_state = 16},
  [976] = {.lex_state = 16},
  [977] = {.lex_state = 16},
  [978] = {.lex_state = 16},
  [979] = {.lex_state = 16},
  [980] = {.lex_state = 16},
  [981] = {.lex_state = 16},
  [982] = {.lex_state = 16},
  [983] = {.lex_state = 16},
  [984] = {.lex_state = 16},
  [985] = {.lex_state = 16},
  [986] = {.lex_state = 16},
  [987] = {.lex_state = 16},
  [988] = {.lex_state = 16},
  [989] = {.lex_state = 16},
  [990] = {.lex_state = 16},
  [991] = {.lex_state = 16},
  [992] = {.lex_state = 16},
  [993] = {.lex_state = 16},
  [994] = {.lex_state = 0},
  [995] = {.lex_state = 16},
  [996] = {.lex_state = 0},
  [997] = {.lex_state = 16},
  [998] = {.lex_state = 0},
  [999] = {.lex_state = 16},
  [1000] = {.lex_state = 16},
  [1001] = {.lex_state = 0},
  [1002] = {.lex_state = 16},
  [1003] = {.lex_state = 16},
  [1004] = {.lex_state = 16},
  [1005] = {.lex_state = 0},
  [1006] = {.lex_state = 16},
  [1007] = {.lex_state = 16},
  [1008] = {.lex_state = 16},
  [1009] = {.lex_state = 16},
  [1010] = {.lex_state = 16},
  [1011] = {.lex_state = 16},
  [1012] = {.lex_state = 16},
  [1013] = {.lex_state = 16},
  [1014] = {.lex_state = 16},
  [1015] = {.lex_state = 16},
  [1016] = {.lex_state = 16},
  [1017] = {.lex_state = 16},
  [1018] = {.lex_state = 0},
  [1019] = {.lex_state = 0},
  [1020] = {.lex_state = 16},
  [1021] = {.lex_state = 16},
  [1022] = {.lex_state = 16},
  [1023] = {.lex_state = 16},
  [1024] = {.lex_state = 16},
  [1025] = {.lex_state = 16},
  [1026] = {.lex_state = 0},
  [1027] = {.lex_state = 0},
  [1028] = {.lex_state = 16},
  [1029] = {.lex_state = 16},
  [1030] = {.lex_state = 16},
  [1031] = {.lex_state = 16},
  [1032] = {.lex_state = 0},
  [1033] = {.lex_state = 0},
  [1034] = {.lex_state = 0},
  [1035] = {.lex_state = 16},
  [1036] = {.lex_state = 0},
  [1037] = {.lex_state = 16},
  [1038] = {.lex_state = 0},
  [1039] = {.lex_state = 0},
  [1040] = {.lex_state = 16},
  [1041] = {.lex_state = 16},
  [1042] = {.lex_state = 16},
  [1043] = {.lex_state = 0},
  [1044] = {.lex_state = 16},
  [1045] = {.lex_state = 16},
  [1046] = {.lex_state = 16},
  [1047] = {.lex_state = 16},
  [1048] = {.lex_state = 16},
  [1049] = {.lex_state = 0},
  [1050] = {.lex_state = 16},
  [1051] = {.lex_state = 16},
  [1052] = {.lex_state = 0},
  [1053] = {.lex_state = 16},
  [1054] = {.lex_state = 16},
  [1055] = {.lex_state = 16},
  [1056] = {.lex_state = 16},
  [1057] = {.lex_state = 16},
  [1058] = {.lex_state = 16},
  [1059] = {.lex_state = 16},
  [1060] = {.lex_state = 16},
  [1061] = {.lex_state = 16},
  [1062] = {.lex_state = 16},
  [1063] = {.lex_state = 0},
  [1064] = {.lex_state = 16},
  [1065] = {.lex_state = 0},
  [1066] = {.lex_state = 16},
  [1067] = {.lex_state = 16},
  [1068] = {.lex_state = 16},
  [1069] = {.lex_state = 0},
  [1070] = {.lex_state = 16},
  [1071] = {.lex_state = 16},
  [1072] = {.lex_state = 16},
  [1073] = {.lex_state = 0},
  [1074] = {.lex_state = 0},
  [1075] = {.lex_state = 16},
  [1076] = {.lex_state = 16},
  [1077] = {.lex_state = 16},
  [1078] = {.lex_state = 0},
  [1079] = {.lex_state = 0},
  [1080] = {.lex_state = 0},
  [1081] = {.lex_state = 16},
  [1082] = {.lex_state = 0},
  [1083] = {.lex_state = 16},
  [1084] = {.lex_state = 16},
  [1085] = {.lex_state = 16},
  [1086] = {.lex_state = 0},
  [1087] = {.lex_state = 16},
  [1088] = {.lex_state = 0},
  [1089] = {.lex_state = 0},
  [1090] = {.lex_state = 16},
  [1091] = {.lex_state = 16},
  [1092] = {.lex_state = 16},
  [1093] = {.lex_state = 16},
  [1094] = {.lex_state = 16},
  [1095] = {.lex_state = 0},
  [1096] = {.lex_state = 16},
  [1097] = {.lex_state = 16},
  [1098] = {.lex_state = 16},
  [1099] = {.lex_state = 0},
  [1100] = {.lex_state = 0},
  [1101] = {.lex_state = 0},
  [1102] = {.lex_state = 16},
  [1103] = {.lex_state = 0},
  [1104] = {.lex_state = 16},
  [1105] = {.lex_state = 16},
  [1106] = {.lex_state = 16},
  [1107] = {.lex_state = 16},
  [1108] = {.lex_state = 16},
  [1109] = {.lex_state = 0},
  [1110] = {.lex_state = 16},
  [1111] = {.lex_state = 16},
  [1112] = {.lex_state = 16},
  [1113] = {.lex_state = 16},
  [1114] = {.lex_state = 0},
  [1115] = {.lex_state = 16},
  [1116] = {.lex_state = 0},
  [1117] = {.lex_state = 16},
  [1118] = {.lex_state = 16},
  [1119] = {.lex_state = 16},
  [1120] = {.lex_state = 16},
  [1121] = {.lex_state = 16},
  [1122] = {.lex_state = 16},
  [1123] = {.lex_state = 16},
  [1124] = {.lex_state = 16},
  [1125] = {.lex_state = 16},
  [1126] = {.lex_state = 16},
  [1127] = {.lex_state = 0},
  [1128] = {.lex_state = 16},
  [1129] = {.lex_state = 16},
  [1130] = {.lex_state = 16},
  [1131] = {.lex_state = 16},
  [1132] = {.lex_state = 0},
  [1133] = {.lex_state = 16},
  [1134] = {.lex_state = 0},
  [1135] = {.lex_state = 16},
  [1136] = {.lex_state = 16},
  [1137] = {.lex_state = 16},
  [1138] = {.lex_state = 16},
  [1139] = {.lex_state = 16},
  [1140] = {.lex_state = 16},
  [1141] = {.lex_state = 16},
  [1142] = {.lex_state = 0},
  [1143] = {.lex_state = 16},
  [1144] = {.lex_state = 16},
  [1145] = {.lex_state = 16},
  [1146] = {.lex_state = 16},
  [1147] = {.lex_state = 16},
  [1148] = {.lex_state = 16},
  [1149] = {.lex_state = 16},
  [1150] = {.lex_state = 16},
  [1151] = {.lex_state = 16},
  [1152] = {.lex_state = 16},
  [1153] = {.lex_state = 16},
  [1154] = {.lex_state = 16},
  [1155] = {.lex_state = 16},
  [1156] = {.lex_state = 16},
  [1157] = {.lex_state = 16},
  [1158] = {.lex_state = 16},
  [1159] = {.lex_state = 0},
  [1160] = {.lex_state = 16},
  [1161] = {.lex_state = 16},
  [1162] = {.lex_state = 16},
  [1163] = {.lex_state = 16},
  [1164] = {.lex_state = 0},
  [1165] = {.lex_state = 0},
  [1166] = {.lex_state = 0},
  [1167] = {.lex_state = 0},
  [1168] = {.lex_state = 16},
  [1169] = {.lex_state = 0},
  [1170] = {.lex_state = 0},
  [1171] = {.lex_state = 16},
  [1172] = {.lex_state = 16},
  [1173] = {.lex_state = 16},
  [1174] = {.lex_state = 16},
  [1175] = {.lex_state = 16},
  [1176] = {.lex_state = 16},
  [1177] = {.lex_state = 16},
  [1178] = {.lex_state = 16},
  [1179] = {.lex_state = 0},
  [1180] = {.lex_state = 16},
  [1181] = {.lex_state = 0},
  [1182] = {.lex_state = 16},
  [1183] = {.lex_state = 16},
  [1184] = {.lex_state = 0},
  [1185] = {.lex_state = 16},
  [1186] = {.lex_state = 16},
  [1187] = {.lex_state = 0},
  [1188] = {.lex_state = 0},
  [1189] = {.lex_state = 0},
  [1190] = {.lex_state = 0},
  [1191] = {.lex_state = 0},
  [1192] = {.lex_state = 0},
  [1193] = {.lex_state = 16},
  [1194] = {.lex_state = 16},
  [1195] = {.lex_state = 0},
  [1196] = {.lex_state = 0},
  [1197] = {.lex_state = 0},
  [1198] = {.lex_state = 16},
  [1199] = {.lex_state = 16},
  [1200] = {.lex_state = 16},
  [1201] = {.lex_state = 16},
  [1202] = {.lex_state = 0},
  [1203] = {.lex_state = 0},
  [1204] = {.lex_state = 0},
  [1205] = {.lex_state = 0},
  [1206] = {.lex_state = 0},
  [1207] = {.lex_state = 0},
  [1208] = {.lex_state = 0},
  [1209] = {.lex_state = 0},
  [1210] = {.lex_state = 16},
  [1211] = {.lex_state = 16},
  [1212] = {.lex_state = 16},
  [1213] = {.lex_state = 0},
  [1214] = {.lex_state = 0},
  [1215] = {.lex_state = 0},
  [1216] = {.lex_state = 0},
  [1217] = {.lex_state = 0},
  [1218] = {.lex_state = 0},
  [1219] = {.lex_state = 0},
  [1220] = {.lex_state = 0},
  [1221] = {.lex_state = 0},
  [1222] = {.lex_state = 0},
  [1223] = {.lex_state = 0},
  [1224] = {.lex_state = 0},
  [1225] = {.lex_state = 16},
  [1226] = {.lex_state = 16},
  [1227] = {.lex_state = 0},
  [1228] = {.lex_state = 0},
  [1229] = {.lex_state = 0},
  [1230] = {.lex_state = 0},
  [1231] = {.lex_state = 0},
  [1232] = {.lex_state = 0},
  [1233] = {.lex_state = 0},
  [1234] = {.lex_state = 0},
  [1235] = {.lex_state = 0},
  [1236] = {.lex_state = 0},
  [1237] = {.lex_state = 0},
  [1238] = {.lex_state = 0},
  [1239] = {.lex_state = 0},
  [1240] = {.lex_state = 0},
  [1241] = {.lex_state = 0},
  [1242] = {.lex_state = 0},
  [1243] = {.lex_state = 0},
  [1244] = {.lex_state = 0},
  [1245] = {.lex_state = 0},
  [1246] = {.lex_state = 0},
  [1247] = {.lex_state = 0},
  [1248] = {.lex_state = 0},
  [1249] = {.lex_state = 0},
  [1250] = {.lex_state = 0},
  [1251] = {.lex_state = 0},
  [1252] = {.lex_state = 0},
  [1253] = {.lex_state = 0},
  [1254] = {.lex_state = 0},
  [1255] = {.lex_state = 0},
  [1256] = {.lex_state = 0},
  [1257] = {.lex_state = 0},
  [1258] = {.lex_state = 0},
  [1259] = {.lex_state = 0},
  [1260] = {.lex_state = 0},
  [1261] = {.lex_state = 0},
  [1262] = {.lex_state = 0},
  [1263] = {.lex_state = 0},
  [1264] = {.lex_state = 0},
  [1265] = {.lex_state = 0},
  [1266] = {.lex_state = 0},
  [1267] = {.lex_state = 0},
  [1268] = {.lex_state = 0},
  [1269] = {.lex_state = 0},
  [1270] = {.lex_state = 0},
  [1271] = {.lex_state = 0},
  [1272] = {.lex_state = 0},
  [1273] = {.lex_state = 0},
  [1274] = {.lex_state = 0},
  [1275] = {.lex_state = 0},
  [1276] = {.lex_state = 0},
  [1277] = {.lex_state = 0},
  [1278] = {.lex_state = 0},
  [1279] = {.lex_state = 0},
  [1280] = {.lex_state = 0},
  [1281] = {.lex_state = 0},
  [1282] = {.lex_state = 0},
  [1283] = {.lex_state = 0},
  [1284] = {.lex_state = 0},
  [1285] = {.lex_state = 0},
  [1286] = {.lex_state = 0},
  [1287] = {.lex_state = 0},
  [1288] = {.lex_state = 0},
  [1289] = {.lex_state = 0},
  [1290] = {.lex_state = 0},
  [1291] = {.lex_state = 0},
  [1292] = {.lex_state = 0},
  [1293] = {.lex_state = 0},
  [1294] = {.lex_state = 0},
  [1295] = {.lex_state = 0},
  [1296] = {.lex_state = 0},
  [1297] = {.lex_state = 0},
  [1298] = {.lex_state = 0},
  [1299] = {.lex_state = 0},
  [1300] = {.lex_state = 0},
  [1301] = {.lex_state = 0},
  [1302] = {.lex_state = 0},
  [1303] = {.lex_state = 0},
  [1304] = {.lex_state = 0},
  [1305] = {.lex_state = 0},
  [1306] = {.lex_state = 0},
  [1307] = {.lex_state = 0},
  [1308] = {.lex_state = 0},
  [1309] = {.lex_state = 0},
  [1310] = {.lex_state = 0},
  [1311] = {.lex_state = 0},
  [1312] = {.lex_state = 0},
  [1313] = {.lex_state = 0},
  [1314] = {.lex_state = 0},
  [1315] = {.lex_state = 0},
  [1316] = {.lex_state = 0},
  [1317] = {.lex_state = 0},
  [1318] = {.lex_state = 0},
  [1319] = {.lex_state = 0},
  [1320] = {.lex_state = 0},
  [1321] = {.lex_state = 0},
  [1322] = {.lex_state = 0},
  [1323] = {.lex_state = 0},
  [1324] = {.lex_state = 0},
  [1325] = {.lex_state = 0},
  [1326] = {.lex_state = 0},
  [1327] = {.lex_state = 0},
  [1328] = {.lex_state = 0},
  [1329] = {.lex_state = 16},
  [1330] = {.lex_state = 0},
  [1331] = {.lex_state = 0},
  [1332] = {.lex_state = 0},
  [1333] = {.lex_state = 0},
  [1334] = {.lex_state = 0},
  [1335] = {.lex_state = 0},
  [1336] = {.lex_state = 0},
  [1337] = {.lex_state = 0},
  [1338] = {.lex_state = 0},
  [1339] = {.lex_state = 0},
  [1340] = {.lex_state = 0},
  [1341] = {.lex_state = 0},
  [1342] = {.lex_state = 0},
  [1343] = {.lex_state = 16},
  [1344] = {.lex_state = 0},
  [1345] = {.lex_state = 0},
  [1346] = {.lex_state = 0},
  [1347] = {.lex_state = 0},
  [1348] = {.lex_state = 0},
  [1349] = {.lex_state = 0},
  [1350] = {.lex_state = 0},
  [1351] = {.lex_state = 0},
  [1352] = {.lex_state = 0},
  [1353] = {.lex_state = 0},
  [1354] = {.lex_state = 0},
  [1355] = {.lex_state = 0},
  [1356] = {.lex_state = 0},
  [1357] = {.lex_state = 0},
  [1358] = {.lex_state = 0},
  [1359] = {.lex_state = 0},
  [1360] = {.lex_state = 0},
  [1361] = {.lex_state = 0},
  [1362] = {.lex_state = 0},
  [1363] = {.lex_state = 0},
  [1364] = {.lex_state = 0},
  [1365] = {.lex_state = 0},
  [1366] = {.lex_state = 0},
  [1367] = {.lex_state = 0},
  [1368] = {.lex_state = 0},
  [1369] = {.lex_state = 0},
  [1370] = {.lex_state = 0},
  [1371] = {.lex_state = 0},
  [1372] = {.lex_state = 0},
  [1373] = {.lex_state = 0},
  [1374] = {.lex_state = 0},
  [1375] = {.lex_state = 0},
  [1376] = {.lex_state = 0},
  [1377] = {.lex_state = 0},
  [1378] = {.lex_state = 0},
  [1379] = {.lex_state = 0},
  [1380] = {.lex_state = 0},
  [1381] = {.lex_state = 0},
  [1382] = {.lex_state = 0},
  [1383] = {.lex_state = 0},
  [1384] = {.lex_state = 0},
  [1385] = {.lex_state = 0},
  [1386] = {.lex_state = 16},
  [1387] = {.lex_state = 0},
  [1388] = {.lex_state = 0},
  [1389] = {.lex_state = 0},
  [1390] = {.lex_state = 0},
  [1391] = {.lex_state = 0},
  [1392] = {.lex_state = 16},
  [1393] = {.lex_state = 16},
  [1394] = {.lex_state = 16},
  [1395] = {.lex_state = 16},
  [1396] = {.lex_state = 16},
  [1397] = {.lex_state = 16},
  [1398] = {.lex_state = 16},
  [1399] = {.lex_state = 16},
  [1400] = {.lex_state = 16},
  [1401] = {.lex_state = 16},
  [1402] = {.lex_state = 16},
  [1403] = {.lex_state = 16},
  [1404] = {.lex_state = 16},
  [1405] = {.lex_state = 16},
  [1406] = {.lex_state = 16},
  [1407] = {.lex_state = 16},
  [1408] = {.lex_state = 16},
  [1409] = {.lex_state = 16},
  [1410] = {.lex_state = 16},
  [1411] = {.lex_state = 16},
  [1412] = {.lex_state = 16},
  [1413] = {.lex_state = 16},
  [1414] = {.lex_state = 16},
  [1415] = {.lex_state = 16},
  [1416] = {.lex_state = 16},
  [1417] = {.lex_state = 16},
  [1418] = {.lex_state = 16},
  [1419] = {.lex_state = 16},
  [1420] = {.lex_state = 16},
  [1421] = {.lex_state = 16},
  [1422] = {.lex_state = 16},
  [1423] = {.lex_state = 16},
  [1424] = {.lex_state = 16},
  [1425] = {.lex_state = 16},
  [1426] = {.lex_state = 16},
  [1427] = {.lex_state = 16},
  [1428] = {.lex_state = 16},
  [1429] = {.lex_state = 16},
  [1430] = {.lex_state = 16},
  [1431] = {.lex_state = 16},
  [1432] = {.lex_state = 16},
  [1433] = {.lex_state = 2},
  [1434] = {.lex_state = 2},
  [1435] = {.lex_state = 2},
  [1436] = {.lex_state = 0},
  [1437] = {.lex_state = 2},
  [1438] = {.lex_state = 0},
  [1439] = {.lex_state = 16},
  [1440] = {.lex_state = 0},
  [1441] = {.lex_state = 2},
  [1442] = {.lex_state = 2},
  [1443] = {.lex_state = 2},
  [1444] = {.lex_state = 0},
  [1445] = {.lex_state = 0},
  [1446] = {.lex_state = 0},
  [1447] = {.lex_state = 0},
  [1448] = {.lex_state = 16},
  [1449] = {.lex_state = 16},
  [1450] = {.lex_state = 16},
  [1451] = {.lex_state = 2},
  [1452] = {.lex_state = 16},
  [1453] = {.lex_state = 16},
  [1454] = {.lex_state = 2},
  [1455] = {.lex_state = 16},
  [1456] = {.lex_state = 2},
  [1457] = {.lex_state = 2},
  [1458] = {.lex_state = 2},
  [1459] = {.lex_state = 0},
  [1460] = {.lex_state = 0},
  [1461] = {.lex_state = 2},
  [1462] = {.lex_state = 16},
  [1463] = {.lex_state = 16},
  [1464] = {.lex_state = 2},
  [1465] = {.lex_state = 16},
  [1466] = {.lex_state = 2},
  [1467] = {.lex_state = 16},
  [1468] = {.lex_state = 16},
  [1469] = {.lex_state = 16},
  [1470] = {.lex_state = 16},
  [1471] = {.lex_state = 16},
  [1472] = {.lex_state = 16},
  [1473] = {.lex_state = 16},
  [1474] = {.lex_state = 16},
  [1475] = {.lex_state = 16},
  [1476] = {.lex_state = 16},
  [1477] = {.lex_state = 16},
  [1478] = {.lex_state = 16},
  [1479] = {.lex_state = 16},
  [1480] = {.lex_state = 16},
  [1481] = {.lex_state = 16},
  [1482] = {.lex_state = 16},
  [1483] = {.lex_state = 16},
  [1484] = {.lex_state = 16},
  [1485] = {.lex_state = 16},
  [1486] = {.lex_state = 16},
  [1487] = {.lex_state = 0},
  [1488] = {.lex_state = 0},
  [1489] = {.lex_state = 16},
  [1490] = {.lex_state = 16},
  [1491] = {.lex_state = 16},
  [1492] = {.lex_state = 16},
  [1493] = {.lex_state = 16},
  [1494] = {.lex_state = 16},
  [1495] = {.lex_state = 2},
  [1496] = {.lex_state = 16},
  [1497] = {.lex_state = 16},
  [1498] = {.lex_state = 16},
  [1499] = {.lex_state = 16},
  [1500] = {.lex_state = 16},
  [1501] = {.lex_state = 16},
  [1502] = {.lex_state = 16},
  [1503] = {.lex_state = 16},
  [1504] = {.lex_state = 16},
  [1505] = {.lex_state = 16},
  [1506] = {.lex_state = 2},
  [1507] = {.lex_state = 16},
  [1508] = {.lex_state = 16},
  [1509] = {.lex_state = 16},
  [1510] = {.lex_state = 16},
  [1511] = {.lex_state = 16},
  [1512] = {.lex_state = 16},
  [1513] = {.lex_state = 16},
  [1514] = {.lex_state = 16},
  [1515] = {.lex_state = 16},
  [1516] = {.lex_state = 16},
  [1517] = {.lex_state = 16},
  [1518] = {.lex_state = 16},
  [1519] = {.lex_state = 16},
  [1520] = {.lex_state = 16},
  [1521] = {.lex_state = 16},
  [1522] = {.lex_state = 16},
  [1523] = {.lex_state = 16},
  [1524] = {.lex_state = 16},
  [1525] = {.lex_state = 16},
  [1526] = {.lex_state = 16},
  [1527] = {.lex_state = 16},
  [1528] = {.lex_state = 16},
  [1529] = {.lex_state = 16},
  [1530] = {.lex_state = 16},
  [1531] = {.lex_state = 16},
  [1532] = {.lex_state = 16},
  [1533] = {.lex_state = 16},
  [1534] = {.lex_state = 16},
  [1535] = {.lex_state = 16},
  [1536] = {.lex_state = 16},
  [1537] = {.lex_state = 16},
  [1538] = {.lex_state = 16},
  [1539] = {.lex_state = 16},
  [1540] = {.lex_state = 16},
  [1541] = {.lex_state = 16},
  [1542] = {.lex_state = 16},
  [1543] = {.lex_state = 16},
  [1544] = {.lex_state = 16},
  [1545] = {.lex_state = 16},
  [1546] = {.lex_state = 16},
  [1547] = {.lex_state = 16},
  [1548] = {.lex_state = 16},
  [1549] = {.lex_state = 16},
  [1550] = {.lex_state = 16},
  [1551] = {.lex_state = 16},
  [1552] = {.lex_state = 16},
  [1553] = {.lex_state = 16},
  [1554] = {.lex_state = 16},
  [1555] = {.lex_state = 16},
  [1556] = {.lex_state = 16},
  [1557] = {.lex_state = 16},
  [1558] = {.lex_state = 16},
  [1559] = {.lex_state = 16},
  [1560] = {.lex_state = 16},
  [1561] = {.lex_state = 16},
  [1562] = {.lex_state = 16},
  [1563] = {.lex_state = 16},
  [1564] = {.lex_state = 16},
  [1565] = {.lex_state = 16},
  [1566] = {.lex_state = 16},
  [1567] = {.lex_state = 16},
  [1568] = {.lex_state = 16},
  [1569] = {.lex_state = 16},
  [1570] = {.lex_state = 16},
  [1571] = {.lex_state = 16},
  [1572] = {.lex_state = 16},
  [1573] = {.lex_state = 16},
  [1574] = {.lex_state = 16},
  [1575] = {.lex_state = 16},
  [1576] = {.lex_state = 16},
  [1577] = {.lex_state = 16},
  [1578] = {.lex_state = 16},
  [1579] = {.lex_state = 16},
  [1580] = {.lex_state = 16},
  [1581] = {.lex_state = 16},
  [1582] = {.lex_state = 16},
  [1583] = {.lex_state = 16},
  [1584] = {.lex_state = 16},
  [1585] = {.lex_state = 16},
  [1586] = {.lex_state = 16},
  [1587] = {.lex_state = 16},
  [1588] = {.lex_state = 16},
  [1589] = {.lex_state = 16},
  [1590] = {.lex_state = 16},
  [1591] = {.lex_state = 16},
  [1592] = {.lex_state = 16},
  [1593] = {.lex_state = 16},
  [1594] = {.lex_state = 16},
  [1595] = {.lex_state = 16},
  [1596] = {.lex_state = 16},
  [1597] = {.lex_state = 16},
  [1598] = {.lex_state = 16},
  [1599] = {.lex_state = 16},
  [1600] = {.lex_state = 16},
  [1601] = {.lex_state = 16},
  [1602] = {.lex_state = 16},
  [1603] = {.lex_state = 16},
  [1604] = {.lex_state = 16},
  [1605] = {.lex_state = 16},
  [1606] = {.lex_state = 16},
  [1607] = {.lex_state = 16},
  [1608] = {.lex_state = 16},
  [1609] = {.lex_state = 16},
  [1610] = {.lex_state = 16},
  [1611] = {.lex_state = 16},
  [1612] = {.lex_state = 16},
  [1613] = {.lex_state = 16},
  [1614] = {.lex_state = 16},
  [1615] = {.lex_state = 16},
  [1616] = {.lex_state = 16},
  [1617] = {.lex_state = 16},
  [1618] = {.lex_state = 16},
  [1619] = {.lex_state = 16},
  [1620] = {.lex_state = 16},
  [1621] = {.lex_state = 16},
  [1622] = {.lex_state = 16},
  [1623] = {.lex_state = 16},
  [1624] = {.lex_state = 16},
  [1625] = {.lex_state = 16},
  [1626] = {.lex_state = 16},
  [1627] = {.lex_state = 16},
  [1628] = {.lex_state = 16},
  [1629] = {.lex_state = 16},
  [1630] = {.lex_state = 16},
  [1631] = {.lex_state = 16},
  [1632] = {.lex_state = 16},
  [1633] = {.lex_state = 2},
  [1634] = {.lex_state = 16},
  [1635] = {.lex_state = 16},
  [1636] = {.lex_state = 16},
  [1637] = {.lex_state = 16},
  [1638] = {.lex_state = 16},
  [1639] = {.lex_state = 16},
  [1640] = {.lex_state = 16},
  [1641] = {.lex_state = 16},
  [1642] = {.lex_state = 16},
  [1643] = {.lex_state = 16},
  [1644] = {.lex_state = 16},
  [1645] = {.lex_state = 16},
  [1646] = {.lex_state = 16},
  [1647] = {.lex_state = 16},
  [1648] = {.lex_state = 16},
  [1649] = {.lex_state = 16},
  [1650] = {.lex_state = 16},
  [1651] = {.lex_state = 16},
  [1652] = {.lex_state = 16},
  [1653] = {.lex_state = 16},
  [1654] = {.lex_state = 16},
  [1655] = {.lex_state = 16},
  [1656] = {.lex_state = 16},
  [1657] = {.lex_state = 16},
  [1658] = {.lex_state = 16},
  [1659] = {.lex_state = 16},
  [1660] = {.lex_state = 16},
  [1661] = {.lex_state = 16},
  [1662] = {.lex_state = 16},
  [1663] = {.lex_state = 16},
  [1664] = {.lex_state = 16},
  [1665] = {.lex_state = 2},
  [1666] = {.lex_state = 16},
  [1667] = {.lex_state = 16},
  [1668] = {.lex_state = 16},
  [1669] = {.lex_state = 2},
  [1670] = {.lex_state = 16},
  [1671] = {.lex_state = 16},
  [1672] = {.lex_state = 16},
  [1673] = {.lex_state = 16},
  [1674] = {.lex_state = 16},
  [1675] = {.lex_state = 2},
  [1676] = {.lex_state = 16},
  [1677] = {.lex_state = 16},
  [1678] = {.lex_state = 16},
  [1679] = {.lex_state = 16},
  [1680] = {.lex_state = 16},
  [1681] = {.lex_state = 16},
  [1682] = {.lex_state = 16},
  [1683] = {.lex_state = 2},
  [1684] = {.lex_state = 16},
  [1685] = {.lex_state = 16},
  [1686] = {.lex_state = 16},
  [1687] = {.lex_state = 2},
  [1688] = {.lex_state = 16},
  [1689] = {.lex_state = 16},
  [1690] = {.lex_state = 16},
  [1691] = {.lex_state = 16},
  [1692] = {.lex_state = 16},
  [1693] = {.lex_state = 16},
  [1694] = {.lex_state = 16},
  [1695] = {.lex_state = 2},
  [1696] = {.lex_state = 2},
  [1697] = {.lex_state = 2},
  [1698] = {.lex_state = 16},
  [1699] = {.lex_state = 16},
  [1700] = {.lex_state = 16},
  [1701] = {.lex_state = 16},
  [1702] = {.lex_state = 16},
  [1703] = {.lex_state = 16},
  [1704] = {.lex_state = 2},
  [1705] = {.lex_state = 16},
  [1706] = {.lex_state = 16},
  [1707] = {.lex_state = 16},
  [1708] = {.lex_state = 16},
  [1709] = {.lex_state = 16},
  [1710] = {.lex_state = 2},
  [1711] = {.lex_state = 16},
  [1712] = {.lex_state = 16},
  [1713] = {.lex_state = 16},
  [1714] = {.lex_state = 16},
  [1715] = {.lex_state = 16},
  [1716] = {.lex_state = 16},
  [1717] = {.lex_state = 16},
  [1718] = {.lex_state = 16},
  [1719] = {.lex_state = 16},
  [1720] = {.lex_state = 16},
  [1721] = {.lex_state = 16},
  [1722] = {.lex_state = 16},
  [1723] = {.lex_state = 16},
  [1724] = {.lex_state = 16},
  [1725] = {.lex_state = 16},
  [1726] = {.lex_state = 16},
  [1727] = {.lex_state = 16},
  [1728] = {.lex_state = 16},
  [1729] = {.lex_state = 16},
  [1730] = {.lex_state = 16},
  [1731] = {.lex_state = 16},
  [1732] = {.lex_state = 16},
  [1733] = {.lex_state = 16},
  [1734] = {.lex_state = 16},
  [1735] = {.lex_state = 16},
  [1736] = {.lex_state = 16},
  [1737] = {.lex_state = 16},
  [1738] = {.lex_state = 16},
  [1739] = {.lex_state = 16},
  [1740] = {.lex_state = 16},
  [1741] = {.lex_state = 16},
  [1742] = {.lex_state = 2},
  [1743] = {.lex_state = 16},
  [1744] = {.lex_state = 16},
  [1745] = {.lex_state = 16},
  [1746] = {.lex_state = 16},
  [1747] = {.lex_state = 16},
  [1748] = {.lex_state = 16},
  [1749] = {.lex_state = 16},
  [1750] = {.lex_state = 16},
  [1751] = {.lex_state = 16},
  [1752] = {.lex_state = 16},
  [1753] = {.lex_state = 16},
  [1754] = {.lex_state = 16},
  [1755] = {.lex_state = 16},
  [1756] = {.lex_state = 16},
  [1757] = {.lex_state = 16},
  [1758] = {.lex_state = 16},
  [1759] = {.lex_state = 16},
  [1760] = {.lex_state = 16},
  [1761] = {.lex_state = 16},
  [1762] = {.lex_state = 16},
  [1763] = {.lex_state = 16},
  [1764] = {.lex_state = 16},
  [1765] = {.lex_state = 16},
  [1766] = {.lex_state = 2},
  [1767] = {.lex_state = 2},
  [1768] = {.lex_state = 16},
  [1769] = {.lex_state = 16},
  [1770] = {.lex_state = 16},
  [1771] = {.lex_state = 16},
  [1772] = {.lex_state = 16},
  [1773] = {.lex_state = 16},
  [1774] = {.lex_state = 16},
  [1775] = {.lex_state = 16},
  [1776] = {.lex_state = 16},
  [1777] = {.lex_state = 16},
  [1778] = {.lex_state = 16},
  [1779] = {.lex_state = 16},
  [1780] = {.lex_state = 2},
  [1781] = {.lex_state = 16},
  [1782] = {.lex_state = 16},
  [1783] = {.lex_state = 16},
  [1784] = {.lex_state = 16},
  [1785] = {.lex_state = 16},
  [1786] = {.lex_state = 16},
  [1787] = {.lex_state = 16},
  [1788] = {.lex_state = 16},
  [1789] = {.lex_state = 16},
  [1790] = {.lex_state = 16},
  [1791] = {.lex_state = 16},
  [1792] = {.lex_state = 16},
  [1793] = {.lex_state = 16},
  [1794] = {.lex_state = 16},
  [1795] = {.lex_state = 16},
  [1796] = {.lex_state = 16},
  [1797] = {.lex_state = 16},
  [1798] = {.lex_state = 16},
  [1799] = {.lex_state = 16},
  [1800] = {.lex_state = 16},
  [1801] = {.lex_state = 16},
  [1802] = {.lex_state = 16},
  [1803] = {.lex_state = 16},
  [1804] = {.lex_state = 16},
  [1805] = {.lex_state = 16},
  [1806] = {.lex_state = 16},
  [1807] = {.lex_state = 16},
  [1808] = {.lex_state = 16},
  [1809] = {.lex_state = 16},
  [1810] = {.lex_state = 16},
  [1811] = {.lex_state = 16},
  [1812] = {.lex_state = 16},
  [1813] = {.lex_state = 16},
  [1814] = {.lex_state = 16},
  [1815] = {.lex_state = 16},
  [1816] = {.lex_state = 16},
  [1817] = {.lex_state = 16},
  [1818] = {.lex_state = 16},
  [1819] = {.lex_state = 16},
  [1820] = {.lex_state = 16},
  [1821] = {.lex_state = 16},
  [1822] = {.lex_state = 16},
  [1823] = {.lex_state = 16},
  [1824] = {.lex_state = 16},
  [1825] = {.lex_state = 16},
  [1826] = {.lex_state = 16},
  [1827] = {.lex_state = 16},
  [1828] = {.lex_state = 16},
  [1829] = {.lex_state = 16},
  [1830] = {.lex_state = 16},
  [1831] = {.lex_state = 16},
  [1832] = {.lex_state = 16},
  [1833] = {.lex_state = 16},
  [1834] = {.lex_state = 16},
  [1835] = {.lex_state = 2},
  [1836] = {.lex_state = 16},
  [1837] = {.lex_state = 16},
  [1838] = {.lex_state = 16},
  [1839] = {.lex_state = 16},
  [1840] = {.lex_state = 16},
  [1841] = {.lex_state = 16},
  [1842] = {.lex_state = 16},
  [1843] = {.lex_state = 16},
  [1844] = {.lex_state = 16},
  [1845] = {.lex_state = 16},
  [1846] = {.lex_state = 16},
  [1847] = {.lex_state = 16},
  [1848] = {.lex_state = 16},
  [1849] = {.lex_state = 16},
  [1850] = {.lex_state = 16},
  [1851] = {.lex_state = 16},
  [1852] = {.lex_state = 16},
  [1853] = {.lex_state = 16},
  [1854] = {.lex_state = 16},
  [1855] = {.lex_state = 16},
  [1856] = {.lex_state = 16},
  [1857] = {.lex_state = 16},
  [1858] = {.lex_state = 16},
  [1859] = {.lex_state = 16},
  [1860] = {.lex_state = 16},
  [1861] = {.lex_state = 16},
  [1862] = {.lex_state = 16},
  [1863] = {.lex_state = 16},
  [1864] = {.lex_state = 16},
  [1865] = {.lex_state = 16},
  [1866] = {.lex_state = 16},
  [1867] = {.lex_state = 16},
  [1868] = {.lex_state = 16},
  [1869] = {.lex_state = 16},
  [1870] = {.lex_state = 16},
  [1871] = {.lex_state = 16},
  [1872] = {.lex_state = 16},
  [1873] = {.lex_state = 16},
  [1874] = {.lex_state = 16},
  [1875] = {.lex_state = 16},
  [1876] = {.lex_state = 16},
  [1877] = {.lex_state = 16},
  [1878] = {.lex_state = 16},
  [1879] = {.lex_state = 16},
  [1880] = {.lex_state = 16},
  [1881] = {.lex_state = 16},
  [1882] = {.lex_state = 16},
  [1883] = {.lex_state = 16},
  [1884] = {.lex_state = 16},
  [1885] = {.lex_state = 16},
  [1886] = {.lex_state = 16},
  [1887] = {.lex_state = 16},
  [1888] = {.lex_state = 16},
  [1889] = {.lex_state = 16},
  [1890] = {.lex_state = 16},
  [1891] = {.lex_state = 16},
  [1892] = {.lex_state = 16},
  [1893] = {.lex_state = 16},
  [1894] = {.lex_state = 16},
  [1895] = {.lex_state = 16},
  [1896] = {.lex_state = 16},
  [1897] = {.lex_state = 16},
  [1898] = {.lex_state = 16},
  [1899] = {.lex_state = 16},
  [1900] = {.lex_state = 16},
  [1901] = {.lex_state = 16},
  [1902] = {.lex_state = 16},
  [1903] = {.lex_state = 16},
  [1904] = {.lex_state = 16},
  [1905] = {.lex_state = 16},
  [1906] = {.lex_state = 16},
  [1907] = {.lex_state = 16},
  [1908] = {.lex_state = 16},
  [1909] = {.lex_state = 16},
  [1910] = {.lex_state = 16},
  [1911] = {.lex_state = 16},
  [1912] = {.lex_state = 16},
  [1913] = {.lex_state = 16},
  [1914] = {.lex_state = 16},
  [1915] = {.lex_state = 16},
  [1916] = {.lex_state = 16},
  [1917] = {.lex_state = 16},
  [1918] = {.lex_state = 16},
  [1919] = {.lex_state = 16},
  [1920] = {.lex_state = 16},
  [1921] = {.lex_state = 16},
  [1922] = {.lex_state = 16},
  [1923] = {.lex_state = 16},
  [1924] = {.lex_state = 16},
  [1925] = {.lex_state = 16},
  [1926] = {.lex_state = 16},
  [1927] = {.lex_state = 16},
  [1928] = {.lex_state = 16},
  [1929] = {.lex_state = 16},
  [1930] = {.lex_state = 16},
  [1931] = {.lex_state = 16},
  [1932] = {.lex_state = 16},
  [1933] = {.lex_state = 16},
  [1934] = {.lex_state = 16},
  [1935] = {.lex_state = 16},
  [1936] = {.lex_state = 16},
  [1937] = {.lex_state = 16},
  [1938] = {.lex_state = 16},
  [1939] = {.lex_state = 16},
  [1940] = {.lex_state = 16},
  [1941] = {.lex_state = 16},
  [1942] = {.lex_state = 16},
  [1943] = {.lex_state = 16},
  [1944] = {.lex_state = 16},
  [1945] = {.lex_state = 16},
  [1946] = {.lex_state = 16},
  [1947] = {.lex_state = 16},
  [1948] = {.lex_state = 16},
  [1949] = {.lex_state = 16},
  [1950] = {.lex_state = 16},
  [1951] = {.lex_state = 16},
  [1952] = {.lex_state = 16},
  [1953] = {.lex_state = 16},
  [1954] = {.lex_state = 16},
  [1955] = {.lex_state = 16},
  [1956] = {.lex_state = 16},
  [1957] = {.lex_state = 16},
  [1958] = {.lex_state = 16},
  [1959] = {.lex_state = 16},
  [1960] = {.lex_state = 16},
  [1961] = {.lex_state = 16},
  [1962] = {.lex_state = 16},
  [1963] = {.lex_state = 16},
  [1964] = {.lex_state = 16},
  [1965] = {.lex_state = 16},
  [1966] = {.lex_state = 16},
  [1967] = {.lex_state = 16},
  [1968] = {.lex_state = 16},
  [1969] = {.lex_state = 16},
  [1970] = {.lex_state = 16},
  [1971] = {.lex_state = 16},
  [1972] = {.lex_state = 16},
  [1973] = {.lex_state = 16},
  [1974] = {.lex_state = 16},
  [1975] = {.lex_state = 16},
  [1976] = {.lex_state = 16},
  [1977] = {.lex_state = 16},
  [1978] = {.lex_state = 16},
  [1979] = {.lex_state = 16},
  [1980] = {.lex_state = 16},
  [1981] = {.lex_state = 16},
  [1982] = {.lex_state = 16},
  [1983] = {.lex_state = 16},
  [1984] = {.lex_state = 16},
  [1985] = {.lex_state = 16},
  [1986] = {.lex_state = 16},
  [1987] = {.lex_state = 16},
  [1988] = {.lex_state = 16},
  [1989] = {.lex_state = 16},
  [1990] = {.lex_state = 16},
  [1991] = {.lex_state = 16},
  [1992] = {.lex_state = 16},
  [1993] = {.lex_state = 16},
  [1994] = {.lex_state = 16},
  [1995] = {.lex_state = 16},
  [1996] = {.lex_state = 16},
  [1997] = {.lex_state = 16},
  [1998] = {.lex_state = 16},
  [1999] = {.lex_state = 16},
  [2000] = {.lex_state = 16},
  [2001] = {.lex_state = 16},
  [2002] = {.lex_state = 16},
  [2003] = {.lex_state = 16},
  [2004] = {.lex_state = 16},
  [2005] = {.lex_state = 16},
  [2006] = {.lex_state = 16},
  [2007] = {.lex_state = 16},
  [2008] = {.lex_state = 16},
  [2009] = {.lex_state = 16},
  [2010] = {.lex_state = 16},
  [2011] = {.lex_state = 16},
  [2012] = {.lex_state = 16},
  [2013] = {.lex_state = 16},
  [2014] = {.lex_state = 16},
  [2015] = {.lex_state = 16},
  [2016] = {.lex_state = 16},
  [2017] = {.lex_state = 16},
  [2018] = {.lex_state = 16},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym__lower_id] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_newtype] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_where] = ACTIONS(1),
    [anon_sym_select] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_implies] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [sym_specialId] = ACTIONS(1),
    [anon_sym_exists] = ACTIONS(1),
    [anon_sym_forall] = ACTIONS(1),
    [anon_sym_forex] = ACTIONS(1),
    [sym_underscore] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_asc] = ACTIONS(1),
    [anon_sym_desc] = ACTIONS(1),
    [anon_sym_order] = ACTIONS(1),
    [anon_sym_by] = ACTIONS(1),
    [sym_qldoc] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_date] = ACTIONS(1),
    [anon_sym_float] = ACTIONS(1),
    [anon_sym_int] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [sym_dbtype] = ACTIONS(1),
    [anon_sym_avg] = ACTIONS(1),
    [anon_sym_concat] = ACTIONS(1),
    [anon_sym_strictconcat] = ACTIONS(1),
    [anon_sym_count] = ACTIONS(1),
    [anon_sym_max] = ACTIONS(1),
    [anon_sym_min] = ACTIONS(1),
    [anon_sym_rank] = ACTIONS(1),
    [anon_sym_strictcount] = ACTIONS(1),
    [anon_sym_strictsum] = ACTIONS(1),
    [anon_sym_sum] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_unique] = ACTIONS(1),
    [sym__upper_id] = ACTIONS(1),
    [sym_integer] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [sym_string] = ACTIONS(1),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_false] = ACTIONS(1),
    [sym_predicate] = ACTIONS(1),
    [sym_result] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
  },
  [1] = {
    [sym_ql] = STATE(1913),
    [sym_module] = STATE(1300),
    [sym_moduleMember] = STATE(695),
    [sym_importDirective] = STATE(1300),
    [sym_classlessPredicate] = STATE(1300),
    [sym_datatype] = STATE(1300),
    [sym_select] = STATE(1300),
    [sym_dataclass] = STATE(1300),
    [sym_annotation] = STATE(702),
    [sym_annotName] = STATE(1392),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1853),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(1451),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1792),
    [aux_sym_ql_repeat1] = STATE(695),
    [aux_sym_moduleMember_repeat1] = STATE(702),
    [ts_builtin_sym_end] = ACTIONS(7),
    [sym__lower_id] = ACTIONS(9),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(13),
    [anon_sym_newtype] = ACTIONS(15),
    [anon_sym_from] = ACTIONS(17),
    [anon_sym_where] = ACTIONS(19),
    [anon_sym_select] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [sym_qldoc] = ACTIONS(25),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [sym__upper_id] = ACTIONS(31),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_predicate] = ACTIONS(33),
  },
  [2] = {
    [sym_special_call] = STATE(847),
    [sym_prefix_cast] = STATE(847),
    [sym_unary_expr] = STATE(847),
    [sym_mul_expr] = STATE(847),
    [sym_add_expr] = STATE(847),
    [sym_in_expr] = STATE(847),
    [sym_comp_term] = STATE(847),
    [sym_instance_of] = STATE(847),
    [sym_negation] = STATE(847),
    [sym_if_term] = STATE(847),
    [sym_conjunction] = STATE(847),
    [sym_disjunction] = STATE(847),
    [sym_implication] = STATE(847),
    [sym_quantified] = STATE(847),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_full_aggregate_body] = STATE(1936),
    [sym_expr_aggregate_body] = STATE(1936),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(847),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_varDecl] = STATE(1573),
    [sym_asExprs] = STATE(1667),
    [sym_asExpr] = STATE(1562),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1999),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1510),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(39),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_PIPE] = ACTIONS(45),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [3] = {
    [sym_special_call] = STATE(847),
    [sym_prefix_cast] = STATE(847),
    [sym_unary_expr] = STATE(847),
    [sym_mul_expr] = STATE(847),
    [sym_add_expr] = STATE(847),
    [sym_in_expr] = STATE(847),
    [sym_comp_term] = STATE(847),
    [sym_instance_of] = STATE(847),
    [sym_negation] = STATE(847),
    [sym_if_term] = STATE(847),
    [sym_conjunction] = STATE(847),
    [sym_disjunction] = STATE(847),
    [sym_implication] = STATE(847),
    [sym_quantified] = STATE(847),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_full_aggregate_body] = STATE(1940),
    [sym_expr_aggregate_body] = STATE(1940),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(847),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_varDecl] = STATE(1573),
    [sym_asExprs] = STATE(1667),
    [sym_asExpr] = STATE(1562),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1999),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1510),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(69),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_PIPE] = ACTIONS(45),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [4] = {
    [sym_special_call] = STATE(847),
    [sym_prefix_cast] = STATE(847),
    [sym_unary_expr] = STATE(847),
    [sym_mul_expr] = STATE(847),
    [sym_add_expr] = STATE(847),
    [sym_in_expr] = STATE(847),
    [sym_comp_term] = STATE(847),
    [sym_instance_of] = STATE(847),
    [sym_negation] = STATE(847),
    [sym_if_term] = STATE(847),
    [sym_conjunction] = STATE(847),
    [sym_disjunction] = STATE(847),
    [sym_implication] = STATE(847),
    [sym_quantified] = STATE(847),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_full_aggregate_body] = STATE(1860),
    [sym_expr_aggregate_body] = STATE(1860),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(847),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_varDecl] = STATE(1573),
    [sym_asExprs] = STATE(1667),
    [sym_asExpr] = STATE(1562),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1999),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1510),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_PIPE] = ACTIONS(45),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [5] = {
    [sym_special_call] = STATE(847),
    [sym_prefix_cast] = STATE(847),
    [sym_unary_expr] = STATE(847),
    [sym_mul_expr] = STATE(847),
    [sym_add_expr] = STATE(847),
    [sym_in_expr] = STATE(847),
    [sym_comp_term] = STATE(847),
    [sym_instance_of] = STATE(847),
    [sym_negation] = STATE(847),
    [sym_if_term] = STATE(847),
    [sym_conjunction] = STATE(847),
    [sym_disjunction] = STATE(847),
    [sym_implication] = STATE(847),
    [sym_quantified] = STATE(847),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_full_aggregate_body] = STATE(1831),
    [sym_expr_aggregate_body] = STATE(1831),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(847),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_varDecl] = STATE(1573),
    [sym_asExprs] = STATE(1667),
    [sym_asExpr] = STATE(1562),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1999),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1510),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_PIPE] = ACTIONS(45),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [6] = {
    [sym_special_call] = STATE(847),
    [sym_prefix_cast] = STATE(847),
    [sym_unary_expr] = STATE(847),
    [sym_mul_expr] = STATE(847),
    [sym_add_expr] = STATE(847),
    [sym_in_expr] = STATE(847),
    [sym_comp_term] = STATE(847),
    [sym_instance_of] = STATE(847),
    [sym_negation] = STATE(847),
    [sym_if_term] = STATE(847),
    [sym_conjunction] = STATE(847),
    [sym_disjunction] = STATE(847),
    [sym_implication] = STATE(847),
    [sym_quantified] = STATE(847),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_full_aggregate_body] = STATE(1910),
    [sym_expr_aggregate_body] = STATE(1910),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(847),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_varDecl] = STATE(1573),
    [sym_asExprs] = STATE(1667),
    [sym_asExpr] = STATE(1562),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1999),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1510),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(75),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_PIPE] = ACTIONS(45),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [7] = {
    [sym_special_call] = STATE(847),
    [sym_prefix_cast] = STATE(847),
    [sym_unary_expr] = STATE(847),
    [sym_mul_expr] = STATE(847),
    [sym_add_expr] = STATE(847),
    [sym_in_expr] = STATE(847),
    [sym_comp_term] = STATE(847),
    [sym_instance_of] = STATE(847),
    [sym_negation] = STATE(847),
    [sym_if_term] = STATE(847),
    [sym_conjunction] = STATE(847),
    [sym_disjunction] = STATE(847),
    [sym_implication] = STATE(847),
    [sym_quantified] = STATE(847),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_full_aggregate_body] = STATE(1951),
    [sym_expr_aggregate_body] = STATE(1951),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(847),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_varDecl] = STATE(1573),
    [sym_asExprs] = STATE(1667),
    [sym_asExpr] = STATE(1562),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1999),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1510),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(77),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_PIPE] = ACTIONS(45),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [8] = {
    [sym_special_call] = STATE(847),
    [sym_prefix_cast] = STATE(847),
    [sym_unary_expr] = STATE(847),
    [sym_mul_expr] = STATE(847),
    [sym_add_expr] = STATE(847),
    [sym_in_expr] = STATE(847),
    [sym_comp_term] = STATE(847),
    [sym_instance_of] = STATE(847),
    [sym_negation] = STATE(847),
    [sym_if_term] = STATE(847),
    [sym_conjunction] = STATE(847),
    [sym_disjunction] = STATE(847),
    [sym_implication] = STATE(847),
    [sym_quantified] = STATE(847),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_full_aggregate_body] = STATE(1967),
    [sym_expr_aggregate_body] = STATE(1967),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(847),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_varDecl] = STATE(1573),
    [sym_asExprs] = STATE(1667),
    [sym_asExpr] = STATE(1562),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1999),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1510),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(79),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_PIPE] = ACTIONS(45),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [9] = {
    [sym_special_call] = STATE(847),
    [sym_prefix_cast] = STATE(847),
    [sym_unary_expr] = STATE(847),
    [sym_mul_expr] = STATE(847),
    [sym_add_expr] = STATE(847),
    [sym_in_expr] = STATE(847),
    [sym_comp_term] = STATE(847),
    [sym_instance_of] = STATE(847),
    [sym_negation] = STATE(847),
    [sym_if_term] = STATE(847),
    [sym_conjunction] = STATE(847),
    [sym_disjunction] = STATE(847),
    [sym_implication] = STATE(847),
    [sym_quantified] = STATE(847),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_full_aggregate_body] = STATE(1939),
    [sym_expr_aggregate_body] = STATE(1939),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(847),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_varDecl] = STATE(1573),
    [sym_asExprs] = STATE(1667),
    [sym_asExpr] = STATE(1562),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1999),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1510),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(81),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_PIPE] = ACTIONS(45),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [10] = {
    [sym_special_call] = STATE(847),
    [sym_prefix_cast] = STATE(847),
    [sym_unary_expr] = STATE(847),
    [sym_mul_expr] = STATE(847),
    [sym_add_expr] = STATE(847),
    [sym_in_expr] = STATE(847),
    [sym_comp_term] = STATE(847),
    [sym_instance_of] = STATE(847),
    [sym_negation] = STATE(847),
    [sym_if_term] = STATE(847),
    [sym_conjunction] = STATE(847),
    [sym_disjunction] = STATE(847),
    [sym_implication] = STATE(847),
    [sym_quantified] = STATE(847),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_full_aggregate_body] = STATE(1823),
    [sym_expr_aggregate_body] = STATE(1823),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(847),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_varDecl] = STATE(1573),
    [sym_asExprs] = STATE(1667),
    [sym_asExpr] = STATE(1562),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1999),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1510),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(83),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_PIPE] = ACTIONS(45),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [11] = {
    [sym_special_call] = STATE(847),
    [sym_prefix_cast] = STATE(847),
    [sym_unary_expr] = STATE(847),
    [sym_mul_expr] = STATE(847),
    [sym_add_expr] = STATE(847),
    [sym_in_expr] = STATE(847),
    [sym_comp_term] = STATE(847),
    [sym_instance_of] = STATE(847),
    [sym_negation] = STATE(847),
    [sym_if_term] = STATE(847),
    [sym_conjunction] = STATE(847),
    [sym_disjunction] = STATE(847),
    [sym_implication] = STATE(847),
    [sym_quantified] = STATE(847),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_full_aggregate_body] = STATE(1935),
    [sym_expr_aggregate_body] = STATE(1935),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(847),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_varDecl] = STATE(1573),
    [sym_asExprs] = STATE(1667),
    [sym_asExpr] = STATE(1562),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1999),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1510),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_PIPE] = ACTIONS(45),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [12] = {
    [sym_special_call] = STATE(847),
    [sym_prefix_cast] = STATE(847),
    [sym_unary_expr] = STATE(847),
    [sym_mul_expr] = STATE(847),
    [sym_add_expr] = STATE(847),
    [sym_in_expr] = STATE(847),
    [sym_comp_term] = STATE(847),
    [sym_instance_of] = STATE(847),
    [sym_negation] = STATE(847),
    [sym_if_term] = STATE(847),
    [sym_conjunction] = STATE(847),
    [sym_disjunction] = STATE(847),
    [sym_implication] = STATE(847),
    [sym_quantified] = STATE(847),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_full_aggregate_body] = STATE(1943),
    [sym_expr_aggregate_body] = STATE(1943),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(847),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_varDecl] = STATE(1573),
    [sym_asExprs] = STATE(1667),
    [sym_asExpr] = STATE(1562),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1999),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1510),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(87),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_PIPE] = ACTIONS(45),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [13] = {
    [sym_special_call] = STATE(847),
    [sym_prefix_cast] = STATE(847),
    [sym_unary_expr] = STATE(847),
    [sym_mul_expr] = STATE(847),
    [sym_add_expr] = STATE(847),
    [sym_in_expr] = STATE(847),
    [sym_comp_term] = STATE(847),
    [sym_instance_of] = STATE(847),
    [sym_negation] = STATE(847),
    [sym_if_term] = STATE(847),
    [sym_conjunction] = STATE(847),
    [sym_disjunction] = STATE(847),
    [sym_implication] = STATE(847),
    [sym_quantified] = STATE(847),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_full_aggregate_body] = STATE(1946),
    [sym_expr_aggregate_body] = STATE(1946),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(847),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_varDecl] = STATE(1573),
    [sym_asExprs] = STATE(1667),
    [sym_asExpr] = STATE(1562),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1999),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1510),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(89),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_PIPE] = ACTIONS(45),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [14] = {
    [sym_special_call] = STATE(847),
    [sym_prefix_cast] = STATE(847),
    [sym_unary_expr] = STATE(847),
    [sym_mul_expr] = STATE(847),
    [sym_add_expr] = STATE(847),
    [sym_in_expr] = STATE(847),
    [sym_comp_term] = STATE(847),
    [sym_instance_of] = STATE(847),
    [sym_negation] = STATE(847),
    [sym_if_term] = STATE(847),
    [sym_conjunction] = STATE(847),
    [sym_disjunction] = STATE(847),
    [sym_implication] = STATE(847),
    [sym_quantified] = STATE(847),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_full_aggregate_body] = STATE(1996),
    [sym_expr_aggregate_body] = STATE(1996),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(847),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_varDecl] = STATE(1573),
    [sym_asExprs] = STATE(1667),
    [sym_asExpr] = STATE(1562),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1999),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1510),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(91),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_PIPE] = ACTIONS(45),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [15] = {
    [sym_special_call] = STATE(847),
    [sym_prefix_cast] = STATE(847),
    [sym_unary_expr] = STATE(847),
    [sym_mul_expr] = STATE(847),
    [sym_add_expr] = STATE(847),
    [sym_in_expr] = STATE(847),
    [sym_comp_term] = STATE(847),
    [sym_instance_of] = STATE(847),
    [sym_negation] = STATE(847),
    [sym_if_term] = STATE(847),
    [sym_conjunction] = STATE(847),
    [sym_disjunction] = STATE(847),
    [sym_implication] = STATE(847),
    [sym_quantified] = STATE(847),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_full_aggregate_body] = STATE(1833),
    [sym_expr_aggregate_body] = STATE(1833),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(847),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_varDecl] = STATE(1573),
    [sym_asExprs] = STATE(1667),
    [sym_asExpr] = STATE(1562),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1999),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1510),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(93),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_PIPE] = ACTIONS(45),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [16] = {
    [sym_special_call] = STATE(847),
    [sym_prefix_cast] = STATE(847),
    [sym_unary_expr] = STATE(847),
    [sym_mul_expr] = STATE(847),
    [sym_add_expr] = STATE(847),
    [sym_in_expr] = STATE(847),
    [sym_comp_term] = STATE(847),
    [sym_instance_of] = STATE(847),
    [sym_negation] = STATE(847),
    [sym_if_term] = STATE(847),
    [sym_conjunction] = STATE(847),
    [sym_disjunction] = STATE(847),
    [sym_implication] = STATE(847),
    [sym_quantified] = STATE(847),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_full_aggregate_body] = STATE(1843),
    [sym_expr_aggregate_body] = STATE(1843),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(847),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_varDecl] = STATE(1573),
    [sym_asExprs] = STATE(1667),
    [sym_asExpr] = STATE(1562),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1999),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1510),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(95),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_PIPE] = ACTIONS(45),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [17] = {
    [sym_special_call] = STATE(847),
    [sym_prefix_cast] = STATE(847),
    [sym_unary_expr] = STATE(847),
    [sym_mul_expr] = STATE(847),
    [sym_add_expr] = STATE(847),
    [sym_in_expr] = STATE(847),
    [sym_comp_term] = STATE(847),
    [sym_instance_of] = STATE(847),
    [sym_negation] = STATE(847),
    [sym_if_term] = STATE(847),
    [sym_conjunction] = STATE(847),
    [sym_disjunction] = STATE(847),
    [sym_implication] = STATE(847),
    [sym_quantified] = STATE(847),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_full_aggregate_body] = STATE(1894),
    [sym_expr_aggregate_body] = STATE(1894),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(847),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_varDecl] = STATE(1573),
    [sym_asExprs] = STATE(1667),
    [sym_asExpr] = STATE(1562),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1999),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1510),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(97),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_PIPE] = ACTIONS(45),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [18] = {
    [sym_special_call] = STATE(847),
    [sym_prefix_cast] = STATE(847),
    [sym_unary_expr] = STATE(847),
    [sym_mul_expr] = STATE(847),
    [sym_add_expr] = STATE(847),
    [sym_in_expr] = STATE(847),
    [sym_comp_term] = STATE(847),
    [sym_instance_of] = STATE(847),
    [sym_negation] = STATE(847),
    [sym_if_term] = STATE(847),
    [sym_conjunction] = STATE(847),
    [sym_disjunction] = STATE(847),
    [sym_implication] = STATE(847),
    [sym_quantified] = STATE(847),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_full_aggregate_body] = STATE(1828),
    [sym_expr_aggregate_body] = STATE(1828),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(847),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_varDecl] = STATE(1573),
    [sym_asExprs] = STATE(1667),
    [sym_asExpr] = STATE(1562),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1999),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1510),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_PIPE] = ACTIONS(45),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [19] = {
    [sym_special_call] = STATE(847),
    [sym_prefix_cast] = STATE(847),
    [sym_unary_expr] = STATE(847),
    [sym_mul_expr] = STATE(847),
    [sym_add_expr] = STATE(847),
    [sym_in_expr] = STATE(847),
    [sym_comp_term] = STATE(847),
    [sym_instance_of] = STATE(847),
    [sym_negation] = STATE(847),
    [sym_if_term] = STATE(847),
    [sym_conjunction] = STATE(847),
    [sym_disjunction] = STATE(847),
    [sym_implication] = STATE(847),
    [sym_quantified] = STATE(847),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_full_aggregate_body] = STATE(1858),
    [sym_expr_aggregate_body] = STATE(1858),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(847),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_varDecl] = STATE(1573),
    [sym_asExprs] = STATE(1667),
    [sym_asExpr] = STATE(1562),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1999),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1510),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_PIPE] = ACTIONS(45),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [20] = {
    [sym_special_call] = STATE(847),
    [sym_prefix_cast] = STATE(847),
    [sym_unary_expr] = STATE(847),
    [sym_mul_expr] = STATE(847),
    [sym_add_expr] = STATE(847),
    [sym_in_expr] = STATE(847),
    [sym_comp_term] = STATE(847),
    [sym_instance_of] = STATE(847),
    [sym_negation] = STATE(847),
    [sym_if_term] = STATE(847),
    [sym_conjunction] = STATE(847),
    [sym_disjunction] = STATE(847),
    [sym_implication] = STATE(847),
    [sym_quantified] = STATE(847),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_full_aggregate_body] = STATE(2010),
    [sym_expr_aggregate_body] = STATE(2010),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(847),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_varDecl] = STATE(1573),
    [sym_asExprs] = STATE(1667),
    [sym_asExpr] = STATE(1562),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1999),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1510),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(103),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_PIPE] = ACTIONS(45),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [21] = {
    [sym_special_call] = STATE(847),
    [sym_prefix_cast] = STATE(847),
    [sym_unary_expr] = STATE(847),
    [sym_mul_expr] = STATE(847),
    [sym_add_expr] = STATE(847),
    [sym_in_expr] = STATE(847),
    [sym_comp_term] = STATE(847),
    [sym_instance_of] = STATE(847),
    [sym_negation] = STATE(847),
    [sym_if_term] = STATE(847),
    [sym_conjunction] = STATE(847),
    [sym_disjunction] = STATE(847),
    [sym_implication] = STATE(847),
    [sym_quantified] = STATE(847),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_full_aggregate_body] = STATE(1867),
    [sym_expr_aggregate_body] = STATE(1867),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(847),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_varDecl] = STATE(1573),
    [sym_asExprs] = STATE(1667),
    [sym_asExpr] = STATE(1562),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1999),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1510),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_PIPE] = ACTIONS(45),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [22] = {
    [sym_special_call] = STATE(847),
    [sym_prefix_cast] = STATE(847),
    [sym_unary_expr] = STATE(847),
    [sym_mul_expr] = STATE(847),
    [sym_add_expr] = STATE(847),
    [sym_in_expr] = STATE(847),
    [sym_comp_term] = STATE(847),
    [sym_instance_of] = STATE(847),
    [sym_negation] = STATE(847),
    [sym_if_term] = STATE(847),
    [sym_conjunction] = STATE(847),
    [sym_disjunction] = STATE(847),
    [sym_implication] = STATE(847),
    [sym_quantified] = STATE(847),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_full_aggregate_body] = STATE(1859),
    [sym_expr_aggregate_body] = STATE(1859),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(847),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_varDecl] = STATE(1573),
    [sym_asExprs] = STATE(1667),
    [sym_asExpr] = STATE(1562),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1999),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1510),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(107),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_PIPE] = ACTIONS(45),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [23] = {
    [sym_special_call] = STATE(880),
    [sym_prefix_cast] = STATE(880),
    [sym_unary_expr] = STATE(880),
    [sym_mul_expr] = STATE(880),
    [sym_add_expr] = STATE(880),
    [sym_in_expr] = STATE(880),
    [sym_comp_term] = STATE(880),
    [sym_instance_of] = STATE(880),
    [sym_negation] = STATE(880),
    [sym_if_term] = STATE(880),
    [sym_conjunction] = STATE(880),
    [sym_disjunction] = STATE(880),
    [sym_implication] = STATE(880),
    [sym_quantified] = STATE(880),
    [sym_quantifier] = STATE(1849),
    [sym__call_arg] = STATE(1705),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(880),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_varDecl] = STATE(1690),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1999),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1521),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(113),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(119),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [sym_underscore] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [24] = {
    [sym_special_call] = STATE(880),
    [sym_prefix_cast] = STATE(880),
    [sym_unary_expr] = STATE(880),
    [sym_mul_expr] = STATE(880),
    [sym_add_expr] = STATE(880),
    [sym_in_expr] = STATE(880),
    [sym_comp_term] = STATE(880),
    [sym_instance_of] = STATE(880),
    [sym_negation] = STATE(880),
    [sym_if_term] = STATE(880),
    [sym_conjunction] = STATE(880),
    [sym_disjunction] = STATE(880),
    [sym_implication] = STATE(880),
    [sym_quantified] = STATE(880),
    [sym_quantifier] = STATE(1849),
    [sym__call_arg] = STATE(1724),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(880),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_varDecl] = STATE(1746),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1999),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1521),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(139),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(141),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [sym_underscore] = ACTIONS(143),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [25] = {
    [sym_special_call] = STATE(880),
    [sym_prefix_cast] = STATE(880),
    [sym_unary_expr] = STATE(880),
    [sym_mul_expr] = STATE(880),
    [sym_add_expr] = STATE(880),
    [sym_in_expr] = STATE(880),
    [sym_comp_term] = STATE(880),
    [sym_instance_of] = STATE(880),
    [sym_negation] = STATE(880),
    [sym_if_term] = STATE(880),
    [sym_conjunction] = STATE(880),
    [sym_disjunction] = STATE(880),
    [sym_implication] = STATE(880),
    [sym_quantified] = STATE(880),
    [sym_quantifier] = STATE(1849),
    [sym__call_arg] = STATE(1732),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(880),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_varDecl] = STATE(1674),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1999),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1521),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(145),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(147),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [sym_underscore] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [26] = {
    [sym_special_call] = STATE(880),
    [sym_prefix_cast] = STATE(880),
    [sym_unary_expr] = STATE(880),
    [sym_mul_expr] = STATE(880),
    [sym_add_expr] = STATE(880),
    [sym_in_expr] = STATE(880),
    [sym_comp_term] = STATE(880),
    [sym_instance_of] = STATE(880),
    [sym_negation] = STATE(880),
    [sym_if_term] = STATE(880),
    [sym_conjunction] = STATE(880),
    [sym_disjunction] = STATE(880),
    [sym_implication] = STATE(880),
    [sym_quantified] = STATE(880),
    [sym_quantifier] = STATE(1849),
    [sym__call_arg] = STATE(1754),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(880),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_varDecl] = STATE(1701),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1999),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1521),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(151),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(153),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [sym_underscore] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [27] = {
    [sym_special_call] = STATE(880),
    [sym_prefix_cast] = STATE(880),
    [sym_unary_expr] = STATE(880),
    [sym_mul_expr] = STATE(880),
    [sym_add_expr] = STATE(880),
    [sym_in_expr] = STATE(880),
    [sym_comp_term] = STATE(880),
    [sym_instance_of] = STATE(880),
    [sym_negation] = STATE(880),
    [sym_if_term] = STATE(880),
    [sym_conjunction] = STATE(880),
    [sym_disjunction] = STATE(880),
    [sym_implication] = STATE(880),
    [sym_quantified] = STATE(880),
    [sym_quantifier] = STATE(1849),
    [sym__call_arg] = STATE(1628),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(880),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_varDecl] = STATE(1718),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1999),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1521),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(157),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(159),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [sym_underscore] = ACTIONS(161),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [28] = {
    [sym_special_call] = STATE(880),
    [sym_prefix_cast] = STATE(880),
    [sym_unary_expr] = STATE(880),
    [sym_mul_expr] = STATE(880),
    [sym_add_expr] = STATE(880),
    [sym_in_expr] = STATE(880),
    [sym_comp_term] = STATE(880),
    [sym_instance_of] = STATE(880),
    [sym_negation] = STATE(880),
    [sym_if_term] = STATE(880),
    [sym_conjunction] = STATE(880),
    [sym_disjunction] = STATE(880),
    [sym_implication] = STATE(880),
    [sym_quantified] = STATE(880),
    [sym_quantifier] = STATE(1849),
    [sym__call_arg] = STATE(1693),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(880),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_varDecl] = STATE(1711),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1999),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1521),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(163),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(165),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [sym_underscore] = ACTIONS(167),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [29] = {
    [sym_special_call] = STATE(880),
    [sym_prefix_cast] = STATE(880),
    [sym_unary_expr] = STATE(880),
    [sym_mul_expr] = STATE(880),
    [sym_add_expr] = STATE(880),
    [sym_in_expr] = STATE(880),
    [sym_comp_term] = STATE(880),
    [sym_instance_of] = STATE(880),
    [sym_negation] = STATE(880),
    [sym_if_term] = STATE(880),
    [sym_conjunction] = STATE(880),
    [sym_disjunction] = STATE(880),
    [sym_implication] = STATE(880),
    [sym_quantified] = STATE(880),
    [sym_quantifier] = STATE(1849),
    [sym__call_arg] = STATE(1649),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(880),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_varDecl] = STATE(1730),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1999),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1521),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(169),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(171),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [sym_underscore] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [30] = {
    [sym_special_call] = STATE(880),
    [sym_prefix_cast] = STATE(880),
    [sym_unary_expr] = STATE(880),
    [sym_mul_expr] = STATE(880),
    [sym_add_expr] = STATE(880),
    [sym_in_expr] = STATE(880),
    [sym_comp_term] = STATE(880),
    [sym_instance_of] = STATE(880),
    [sym_negation] = STATE(880),
    [sym_if_term] = STATE(880),
    [sym_conjunction] = STATE(880),
    [sym_disjunction] = STATE(880),
    [sym_implication] = STATE(880),
    [sym_quantified] = STATE(880),
    [sym_quantifier] = STATE(1849),
    [sym__call_arg] = STATE(1729),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(880),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(175),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [sym_underscore] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [31] = {
    [sym_special_call] = STATE(880),
    [sym_prefix_cast] = STATE(880),
    [sym_unary_expr] = STATE(880),
    [sym_mul_expr] = STATE(880),
    [sym_add_expr] = STATE(880),
    [sym_in_expr] = STATE(880),
    [sym_comp_term] = STATE(880),
    [sym_instance_of] = STATE(880),
    [sym_negation] = STATE(880),
    [sym_if_term] = STATE(880),
    [sym_conjunction] = STATE(880),
    [sym_disjunction] = STATE(880),
    [sym_implication] = STATE(880),
    [sym_quantified] = STATE(880),
    [sym_quantifier] = STATE(1849),
    [sym__call_arg] = STATE(1706),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(880),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(179),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [sym_underscore] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [32] = {
    [sym_special_call] = STATE(880),
    [sym_prefix_cast] = STATE(880),
    [sym_unary_expr] = STATE(880),
    [sym_mul_expr] = STATE(880),
    [sym_add_expr] = STATE(880),
    [sym_in_expr] = STATE(880),
    [sym_comp_term] = STATE(880),
    [sym_instance_of] = STATE(880),
    [sym_negation] = STATE(880),
    [sym_if_term] = STATE(880),
    [sym_conjunction] = STATE(880),
    [sym_disjunction] = STATE(880),
    [sym_implication] = STATE(880),
    [sym_quantified] = STATE(880),
    [sym_quantifier] = STATE(1849),
    [sym__call_arg] = STATE(1622),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(880),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(183),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [sym_underscore] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [33] = {
    [sym_special_call] = STATE(880),
    [sym_prefix_cast] = STATE(880),
    [sym_unary_expr] = STATE(880),
    [sym_mul_expr] = STATE(880),
    [sym_add_expr] = STATE(880),
    [sym_in_expr] = STATE(880),
    [sym_comp_term] = STATE(880),
    [sym_instance_of] = STATE(880),
    [sym_negation] = STATE(880),
    [sym_if_term] = STATE(880),
    [sym_conjunction] = STATE(880),
    [sym_disjunction] = STATE(880),
    [sym_implication] = STATE(880),
    [sym_quantified] = STATE(880),
    [sym_quantifier] = STATE(1849),
    [sym__call_arg] = STATE(1659),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(880),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(187),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [sym_underscore] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [34] = {
    [sym_special_call] = STATE(880),
    [sym_prefix_cast] = STATE(880),
    [sym_unary_expr] = STATE(880),
    [sym_mul_expr] = STATE(880),
    [sym_add_expr] = STATE(880),
    [sym_in_expr] = STATE(880),
    [sym_comp_term] = STATE(880),
    [sym_instance_of] = STATE(880),
    [sym_negation] = STATE(880),
    [sym_if_term] = STATE(880),
    [sym_conjunction] = STATE(880),
    [sym_disjunction] = STATE(880),
    [sym_implication] = STATE(880),
    [sym_quantified] = STATE(880),
    [sym_quantifier] = STATE(1849),
    [sym__call_arg] = STATE(1620),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(880),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(191),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [sym_underscore] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [35] = {
    [sym_special_call] = STATE(880),
    [sym_prefix_cast] = STATE(880),
    [sym_unary_expr] = STATE(880),
    [sym_mul_expr] = STATE(880),
    [sym_add_expr] = STATE(880),
    [sym_in_expr] = STATE(880),
    [sym_comp_term] = STATE(880),
    [sym_instance_of] = STATE(880),
    [sym_negation] = STATE(880),
    [sym_if_term] = STATE(880),
    [sym_conjunction] = STATE(880),
    [sym_disjunction] = STATE(880),
    [sym_implication] = STATE(880),
    [sym_quantified] = STATE(880),
    [sym_quantifier] = STATE(1849),
    [sym__call_arg] = STATE(1757),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(880),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(195),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [sym_underscore] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [36] = {
    [sym_special_call] = STATE(880),
    [sym_prefix_cast] = STATE(880),
    [sym_unary_expr] = STATE(880),
    [sym_mul_expr] = STATE(880),
    [sym_add_expr] = STATE(880),
    [sym_in_expr] = STATE(880),
    [sym_comp_term] = STATE(880),
    [sym_instance_of] = STATE(880),
    [sym_negation] = STATE(880),
    [sym_if_term] = STATE(880),
    [sym_conjunction] = STATE(880),
    [sym_disjunction] = STATE(880),
    [sym_implication] = STATE(880),
    [sym_quantified] = STATE(880),
    [sym_quantifier] = STATE(1849),
    [sym__call_arg] = STATE(1672),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(880),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(199),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [sym_underscore] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [37] = {
    [sym_special_call] = STATE(1129),
    [sym_prefix_cast] = STATE(1129),
    [sym_unary_expr] = STATE(1129),
    [sym_mul_expr] = STATE(1129),
    [sym_add_expr] = STATE(1129),
    [sym_in_expr] = STATE(1129),
    [sym_comp_term] = STATE(1129),
    [sym_instance_of] = STATE(1129),
    [sym_negation] = STATE(1129),
    [sym_if_term] = STATE(1129),
    [sym_conjunction] = STATE(1129),
    [sym_disjunction] = STATE(1129),
    [sym_implication] = STATE(1129),
    [sym_quantified] = STATE(1129),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1129),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_varDecl] = STATE(1549),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1999),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1521),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(205),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [38] = {
    [sym_special_call] = STATE(880),
    [sym_prefix_cast] = STATE(880),
    [sym_unary_expr] = STATE(880),
    [sym_mul_expr] = STATE(880),
    [sym_add_expr] = STATE(880),
    [sym_in_expr] = STATE(880),
    [sym_comp_term] = STATE(880),
    [sym_instance_of] = STATE(880),
    [sym_negation] = STATE(880),
    [sym_if_term] = STATE(880),
    [sym_conjunction] = STATE(880),
    [sym_disjunction] = STATE(880),
    [sym_implication] = STATE(880),
    [sym_quantified] = STATE(880),
    [sym_quantifier] = STATE(1849),
    [sym__call_arg] = STATE(1679),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(880),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(207),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [sym_underscore] = ACTIONS(209),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [39] = {
    [sym_special_call] = STATE(880),
    [sym_prefix_cast] = STATE(880),
    [sym_unary_expr] = STATE(880),
    [sym_mul_expr] = STATE(880),
    [sym_add_expr] = STATE(880),
    [sym_in_expr] = STATE(880),
    [sym_comp_term] = STATE(880),
    [sym_instance_of] = STATE(880),
    [sym_negation] = STATE(880),
    [sym_if_term] = STATE(880),
    [sym_conjunction] = STATE(880),
    [sym_disjunction] = STATE(880),
    [sym_implication] = STATE(880),
    [sym_quantified] = STATE(880),
    [sym_quantifier] = STATE(1849),
    [sym__call_arg] = STATE(1682),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(880),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [sym_underscore] = ACTIONS(213),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [40] = {
    [sym_special_call] = STATE(880),
    [sym_prefix_cast] = STATE(880),
    [sym_unary_expr] = STATE(880),
    [sym_mul_expr] = STATE(880),
    [sym_add_expr] = STATE(880),
    [sym_in_expr] = STATE(880),
    [sym_comp_term] = STATE(880),
    [sym_instance_of] = STATE(880),
    [sym_negation] = STATE(880),
    [sym_if_term] = STATE(880),
    [sym_conjunction] = STATE(880),
    [sym_disjunction] = STATE(880),
    [sym_implication] = STATE(880),
    [sym_quantified] = STATE(880),
    [sym_quantifier] = STATE(1849),
    [sym__call_arg] = STATE(1726),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(880),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [sym_underscore] = ACTIONS(217),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [41] = {
    [sym_special_call] = STATE(880),
    [sym_prefix_cast] = STATE(880),
    [sym_unary_expr] = STATE(880),
    [sym_mul_expr] = STATE(880),
    [sym_add_expr] = STATE(880),
    [sym_in_expr] = STATE(880),
    [sym_comp_term] = STATE(880),
    [sym_instance_of] = STATE(880),
    [sym_negation] = STATE(880),
    [sym_if_term] = STATE(880),
    [sym_conjunction] = STATE(880),
    [sym_disjunction] = STATE(880),
    [sym_implication] = STATE(880),
    [sym_quantified] = STATE(880),
    [sym_quantifier] = STATE(1849),
    [sym__call_arg] = STATE(1760),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(880),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(219),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [sym_underscore] = ACTIONS(221),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [42] = {
    [sym_special_call] = STATE(1106),
    [sym_prefix_cast] = STATE(1106),
    [sym_unary_expr] = STATE(1106),
    [sym_mul_expr] = STATE(1106),
    [sym_add_expr] = STATE(1106),
    [sym_in_expr] = STATE(1106),
    [sym_comp_term] = STATE(1106),
    [sym_instance_of] = STATE(1106),
    [sym_negation] = STATE(1106),
    [sym_if_term] = STATE(1106),
    [sym_conjunction] = STATE(1106),
    [sym_disjunction] = STATE(1106),
    [sym_implication] = STATE(1106),
    [sym_quantified] = STATE(1106),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1106),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_varDecl] = STATE(1593),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1999),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1521),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(225),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [43] = {
    [sym_special_call] = STATE(1081),
    [sym_prefix_cast] = STATE(1081),
    [sym_unary_expr] = STATE(1081),
    [sym_mul_expr] = STATE(1081),
    [sym_add_expr] = STATE(1081),
    [sym_in_expr] = STATE(1081),
    [sym_comp_term] = STATE(1081),
    [sym_instance_of] = STATE(1081),
    [sym_negation] = STATE(1081),
    [sym_if_term] = STATE(1081),
    [sym_conjunction] = STATE(1081),
    [sym_disjunction] = STATE(1081),
    [sym_implication] = STATE(1081),
    [sym_quantified] = STATE(1081),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1081),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_varDecl] = STATE(1600),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1999),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1521),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(227),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(229),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [44] = {
    [sym_special_call] = STATE(1139),
    [sym_prefix_cast] = STATE(1139),
    [sym_unary_expr] = STATE(1139),
    [sym_mul_expr] = STATE(1139),
    [sym_add_expr] = STATE(1139),
    [sym_in_expr] = STATE(1139),
    [sym_comp_term] = STATE(1139),
    [sym_instance_of] = STATE(1139),
    [sym_negation] = STATE(1139),
    [sym_if_term] = STATE(1139),
    [sym_conjunction] = STATE(1139),
    [sym_disjunction] = STATE(1139),
    [sym_implication] = STATE(1139),
    [sym_quantified] = STATE(1139),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1139),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_varDecl] = STATE(1558),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1999),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1521),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(231),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(233),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [45] = {
    [sym_special_call] = STATE(880),
    [sym_prefix_cast] = STATE(880),
    [sym_unary_expr] = STATE(880),
    [sym_mul_expr] = STATE(880),
    [sym_add_expr] = STATE(880),
    [sym_in_expr] = STATE(880),
    [sym_comp_term] = STATE(880),
    [sym_instance_of] = STATE(880),
    [sym_negation] = STATE(880),
    [sym_if_term] = STATE(880),
    [sym_conjunction] = STATE(880),
    [sym_disjunction] = STATE(880),
    [sym_implication] = STATE(880),
    [sym_quantified] = STATE(880),
    [sym_quantifier] = STATE(1849),
    [sym__call_arg] = STATE(1635),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(880),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [sym_underscore] = ACTIONS(237),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [46] = {
    [sym_special_call] = STATE(880),
    [sym_prefix_cast] = STATE(880),
    [sym_unary_expr] = STATE(880),
    [sym_mul_expr] = STATE(880),
    [sym_add_expr] = STATE(880),
    [sym_in_expr] = STATE(880),
    [sym_comp_term] = STATE(880),
    [sym_instance_of] = STATE(880),
    [sym_negation] = STATE(880),
    [sym_if_term] = STATE(880),
    [sym_conjunction] = STATE(880),
    [sym_disjunction] = STATE(880),
    [sym_implication] = STATE(880),
    [sym_quantified] = STATE(880),
    [sym_quantifier] = STATE(1849),
    [sym__call_arg] = STATE(1719),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(880),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(239),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [sym_underscore] = ACTIONS(241),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [47] = {
    [sym_special_call] = STATE(880),
    [sym_prefix_cast] = STATE(880),
    [sym_unary_expr] = STATE(880),
    [sym_mul_expr] = STATE(880),
    [sym_add_expr] = STATE(880),
    [sym_in_expr] = STATE(880),
    [sym_comp_term] = STATE(880),
    [sym_instance_of] = STATE(880),
    [sym_negation] = STATE(880),
    [sym_if_term] = STATE(880),
    [sym_conjunction] = STATE(880),
    [sym_disjunction] = STATE(880),
    [sym_implication] = STATE(880),
    [sym_quantified] = STATE(880),
    [sym_quantifier] = STATE(1849),
    [sym__call_arg] = STATE(1634),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(880),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [sym_underscore] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [48] = {
    [sym_special_call] = STATE(880),
    [sym_prefix_cast] = STATE(880),
    [sym_unary_expr] = STATE(880),
    [sym_mul_expr] = STATE(880),
    [sym_add_expr] = STATE(880),
    [sym_in_expr] = STATE(880),
    [sym_comp_term] = STATE(880),
    [sym_instance_of] = STATE(880),
    [sym_negation] = STATE(880),
    [sym_if_term] = STATE(880),
    [sym_conjunction] = STATE(880),
    [sym_disjunction] = STATE(880),
    [sym_implication] = STATE(880),
    [sym_quantified] = STATE(880),
    [sym_quantifier] = STATE(1849),
    [sym__call_arg] = STATE(1640),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(880),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(247),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [sym_underscore] = ACTIONS(249),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [49] = {
    [sym_special_call] = STATE(1044),
    [sym_prefix_cast] = STATE(1044),
    [sym_unary_expr] = STATE(1044),
    [sym_mul_expr] = STATE(1044),
    [sym_add_expr] = STATE(1044),
    [sym_in_expr] = STATE(1044),
    [sym_comp_term] = STATE(1044),
    [sym_instance_of] = STATE(1044),
    [sym_negation] = STATE(1044),
    [sym_if_term] = STATE(1044),
    [sym_conjunction] = STATE(1044),
    [sym_disjunction] = STATE(1044),
    [sym_implication] = STATE(1044),
    [sym_quantified] = STATE(1044),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1044),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_varDecl] = STATE(1570),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1999),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1521),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(251),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(253),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [50] = {
    [sym_special_call] = STATE(880),
    [sym_prefix_cast] = STATE(880),
    [sym_unary_expr] = STATE(880),
    [sym_mul_expr] = STATE(880),
    [sym_add_expr] = STATE(880),
    [sym_in_expr] = STATE(880),
    [sym_comp_term] = STATE(880),
    [sym_instance_of] = STATE(880),
    [sym_negation] = STATE(880),
    [sym_if_term] = STATE(880),
    [sym_conjunction] = STATE(880),
    [sym_disjunction] = STATE(880),
    [sym_implication] = STATE(880),
    [sym_quantified] = STATE(880),
    [sym_quantifier] = STATE(1849),
    [sym__call_arg] = STATE(1725),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(880),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(255),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [sym_underscore] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [51] = {
    [sym_special_call] = STATE(1150),
    [sym_prefix_cast] = STATE(1150),
    [sym_unary_expr] = STATE(1150),
    [sym_mul_expr] = STATE(1150),
    [sym_add_expr] = STATE(1150),
    [sym_in_expr] = STATE(1150),
    [sym_comp_term] = STATE(1150),
    [sym_instance_of] = STATE(1150),
    [sym_negation] = STATE(1150),
    [sym_if_term] = STATE(1150),
    [sym_conjunction] = STATE(1150),
    [sym_disjunction] = STATE(1150),
    [sym_implication] = STATE(1150),
    [sym_quantified] = STATE(1150),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1150),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_varDecl] = STATE(1567),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1999),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1521),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(259),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(261),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [52] = {
    [sym_special_call] = STATE(880),
    [sym_prefix_cast] = STATE(880),
    [sym_unary_expr] = STATE(880),
    [sym_mul_expr] = STATE(880),
    [sym_add_expr] = STATE(880),
    [sym_in_expr] = STATE(880),
    [sym_comp_term] = STATE(880),
    [sym_instance_of] = STATE(880),
    [sym_negation] = STATE(880),
    [sym_if_term] = STATE(880),
    [sym_conjunction] = STATE(880),
    [sym_disjunction] = STATE(880),
    [sym_implication] = STATE(880),
    [sym_quantified] = STATE(880),
    [sym_quantifier] = STATE(1849),
    [sym__call_arg] = STATE(1735),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(880),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(263),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [sym_underscore] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [53] = {
    [sym_special_call] = STATE(1117),
    [sym_prefix_cast] = STATE(1117),
    [sym_unary_expr] = STATE(1117),
    [sym_mul_expr] = STATE(1117),
    [sym_add_expr] = STATE(1117),
    [sym_in_expr] = STATE(1117),
    [sym_comp_term] = STATE(1117),
    [sym_instance_of] = STATE(1117),
    [sym_negation] = STATE(1117),
    [sym_if_term] = STATE(1117),
    [sym_conjunction] = STATE(1117),
    [sym_disjunction] = STATE(1117),
    [sym_implication] = STATE(1117),
    [sym_quantified] = STATE(1117),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1117),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_varDecl] = STATE(1610),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1999),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1521),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(267),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(269),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [54] = {
    [sym_special_call] = STATE(880),
    [sym_prefix_cast] = STATE(880),
    [sym_unary_expr] = STATE(880),
    [sym_mul_expr] = STATE(880),
    [sym_add_expr] = STATE(880),
    [sym_in_expr] = STATE(880),
    [sym_comp_term] = STATE(880),
    [sym_instance_of] = STATE(880),
    [sym_negation] = STATE(880),
    [sym_if_term] = STATE(880),
    [sym_conjunction] = STATE(880),
    [sym_disjunction] = STATE(880),
    [sym_implication] = STATE(880),
    [sym_quantified] = STATE(880),
    [sym_quantifier] = STATE(1849),
    [sym__call_arg] = STATE(1655),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(880),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(271),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [sym_underscore] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [55] = {
    [sym_special_call] = STATE(880),
    [sym_prefix_cast] = STATE(880),
    [sym_unary_expr] = STATE(880),
    [sym_mul_expr] = STATE(880),
    [sym_add_expr] = STATE(880),
    [sym_in_expr] = STATE(880),
    [sym_comp_term] = STATE(880),
    [sym_instance_of] = STATE(880),
    [sym_negation] = STATE(880),
    [sym_if_term] = STATE(880),
    [sym_conjunction] = STATE(880),
    [sym_disjunction] = STATE(880),
    [sym_implication] = STATE(880),
    [sym_quantified] = STATE(880),
    [sym_quantifier] = STATE(1849),
    [sym__call_arg] = STATE(1661),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(880),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(275),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [sym_underscore] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [56] = {
    [sym_special_call] = STATE(880),
    [sym_prefix_cast] = STATE(880),
    [sym_unary_expr] = STATE(880),
    [sym_mul_expr] = STATE(880),
    [sym_add_expr] = STATE(880),
    [sym_in_expr] = STATE(880),
    [sym_comp_term] = STATE(880),
    [sym_instance_of] = STATE(880),
    [sym_negation] = STATE(880),
    [sym_if_term] = STATE(880),
    [sym_conjunction] = STATE(880),
    [sym_disjunction] = STATE(880),
    [sym_implication] = STATE(880),
    [sym_quantified] = STATE(880),
    [sym_quantifier] = STATE(1849),
    [sym__call_arg] = STATE(1643),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(880),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [sym_underscore] = ACTIONS(281),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [57] = {
    [sym_special_call] = STATE(1008),
    [sym_prefix_cast] = STATE(1008),
    [sym_unary_expr] = STATE(1008),
    [sym_mul_expr] = STATE(1008),
    [sym_add_expr] = STATE(1008),
    [sym_in_expr] = STATE(1008),
    [sym_comp_term] = STATE(1008),
    [sym_instance_of] = STATE(1008),
    [sym_negation] = STATE(1008),
    [sym_if_term] = STATE(1008),
    [sym_conjunction] = STATE(1008),
    [sym_disjunction] = STATE(1008),
    [sym_implication] = STATE(1008),
    [sym_quantified] = STATE(1008),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1008),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(283),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(285),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [58] = {
    [sym_special_call] = STATE(837),
    [sym_prefix_cast] = STATE(837),
    [sym_unary_expr] = STATE(837),
    [sym_mul_expr] = STATE(837),
    [sym_add_expr] = STATE(837),
    [sym_in_expr] = STATE(837),
    [sym_comp_term] = STATE(837),
    [sym_instance_of] = STATE(837),
    [sym_negation] = STATE(837),
    [sym_if_term] = STATE(837),
    [sym_conjunction] = STATE(837),
    [sym_disjunction] = STATE(837),
    [sym_implication] = STATE(837),
    [sym_quantified] = STATE(837),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(837),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(287),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_RBRACK] = ACTIONS(295),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [59] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1855),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [60] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1869),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [61] = {
    [sym_special_call] = STATE(847),
    [sym_prefix_cast] = STATE(847),
    [sym_unary_expr] = STATE(847),
    [sym_mul_expr] = STATE(847),
    [sym_add_expr] = STATE(847),
    [sym_in_expr] = STATE(847),
    [sym_comp_term] = STATE(847),
    [sym_instance_of] = STATE(847),
    [sym_negation] = STATE(847),
    [sym_if_term] = STATE(847),
    [sym_conjunction] = STATE(847),
    [sym_disjunction] = STATE(847),
    [sym_implication] = STATE(847),
    [sym_quantified] = STATE(847),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(847),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_asExprs] = STATE(1621),
    [sym_asExpr] = STATE(1562),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1839),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [62] = {
    [sym_special_call] = STATE(847),
    [sym_prefix_cast] = STATE(847),
    [sym_unary_expr] = STATE(847),
    [sym_mul_expr] = STATE(847),
    [sym_add_expr] = STATE(847),
    [sym_in_expr] = STATE(847),
    [sym_comp_term] = STATE(847),
    [sym_instance_of] = STATE(847),
    [sym_negation] = STATE(847),
    [sym_if_term] = STATE(847),
    [sym_conjunction] = STATE(847),
    [sym_disjunction] = STATE(847),
    [sym_implication] = STATE(847),
    [sym_quantified] = STATE(847),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(847),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_asExprs] = STATE(1623),
    [sym_asExpr] = STATE(1562),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1839),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [63] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1914),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [64] = {
    [sym_special_call] = STATE(847),
    [sym_prefix_cast] = STATE(847),
    [sym_unary_expr] = STATE(847),
    [sym_mul_expr] = STATE(847),
    [sym_add_expr] = STATE(847),
    [sym_in_expr] = STATE(847),
    [sym_comp_term] = STATE(847),
    [sym_instance_of] = STATE(847),
    [sym_negation] = STATE(847),
    [sym_if_term] = STATE(847),
    [sym_conjunction] = STATE(847),
    [sym_disjunction] = STATE(847),
    [sym_implication] = STATE(847),
    [sym_quantified] = STATE(847),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(847),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_asExprs] = STATE(1749),
    [sym_asExpr] = STATE(1562),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1839),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [65] = {
    [sym_special_call] = STATE(415),
    [sym_prefix_cast] = STATE(415),
    [sym_unary_expr] = STATE(415),
    [sym_mul_expr] = STATE(415),
    [sym_add_expr] = STATE(415),
    [sym_in_expr] = STATE(415),
    [sym_comp_term] = STATE(415),
    [sym_instance_of] = STATE(415),
    [sym_negation] = STATE(415),
    [sym_if_term] = STATE(415),
    [sym_conjunction] = STATE(415),
    [sym_disjunction] = STATE(415),
    [sym_implication] = STATE(415),
    [sym_quantified] = STATE(415),
    [sym_quantifier] = STATE(1995),
    [sym_call_or_unqual_agg_expr] = STATE(428),
    [sym_qualified_expr] = STATE(428),
    [sym_super_ref] = STATE(428),
    [sym_aggregate] = STATE(428),
    [sym_range] = STATE(428),
    [sym_set_literal] = STATE(428),
    [sym_par_expr] = STATE(428),
    [sym_expr_annotation] = STATE(428),
    [sym__exprOrTerm] = STATE(415),
    [sym__primary] = STATE(428),
    [sym_literal] = STATE(428),
    [sym_bool] = STATE(424),
    [sym_variable] = STATE(428),
    [sym_unop] = STATE(198),
    [sym_asExprs] = STATE(1038),
    [sym_asExpr] = STATE(1026),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2012),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(422),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(2001),
    [sym_aritylessPredicateExpr] = STATE(1481),
    [sym_varName] = STATE(426),
    [sym_aggId] = STATE(1805),
    [sym__lower_id] = ACTIONS(299),
    [anon_sym_LPAREN] = ACTIONS(301),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(305),
    [sym_specialId] = ACTIONS(307),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(309),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(311),
    [sym_integer] = ACTIONS(313),
    [sym_float] = ACTIONS(315),
    [sym_string] = ACTIONS(315),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(317),
    [sym_result] = ACTIONS(319),
    [sym_super] = ACTIONS(321),
    [sym_this] = ACTIONS(319),
    [sym_true] = ACTIONS(317),
  },
  [66] = {
    [sym_special_call] = STATE(415),
    [sym_prefix_cast] = STATE(415),
    [sym_unary_expr] = STATE(415),
    [sym_mul_expr] = STATE(415),
    [sym_add_expr] = STATE(415),
    [sym_in_expr] = STATE(415),
    [sym_comp_term] = STATE(415),
    [sym_instance_of] = STATE(415),
    [sym_negation] = STATE(415),
    [sym_if_term] = STATE(415),
    [sym_conjunction] = STATE(415),
    [sym_disjunction] = STATE(415),
    [sym_implication] = STATE(415),
    [sym_quantified] = STATE(415),
    [sym_quantifier] = STATE(1995),
    [sym_call_or_unqual_agg_expr] = STATE(428),
    [sym_qualified_expr] = STATE(428),
    [sym_super_ref] = STATE(428),
    [sym_aggregate] = STATE(428),
    [sym_range] = STATE(428),
    [sym_set_literal] = STATE(428),
    [sym_par_expr] = STATE(428),
    [sym_expr_annotation] = STATE(428),
    [sym__exprOrTerm] = STATE(415),
    [sym__primary] = STATE(428),
    [sym_literal] = STATE(428),
    [sym_bool] = STATE(424),
    [sym_variable] = STATE(428),
    [sym_unop] = STATE(198),
    [sym_asExprs] = STATE(1181),
    [sym_asExpr] = STATE(1026),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2012),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(422),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(2001),
    [sym_aritylessPredicateExpr] = STATE(1481),
    [sym_varName] = STATE(426),
    [sym_aggId] = STATE(1805),
    [sym__lower_id] = ACTIONS(299),
    [anon_sym_LPAREN] = ACTIONS(301),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(305),
    [sym_specialId] = ACTIONS(307),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(309),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(311),
    [sym_integer] = ACTIONS(313),
    [sym_float] = ACTIONS(315),
    [sym_string] = ACTIONS(315),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(317),
    [sym_result] = ACTIONS(319),
    [sym_super] = ACTIONS(321),
    [sym_this] = ACTIONS(319),
    [sym_true] = ACTIONS(317),
  },
  [67] = {
    [sym_special_call] = STATE(385),
    [sym_prefix_cast] = STATE(385),
    [sym_unary_expr] = STATE(385),
    [sym_mul_expr] = STATE(385),
    [sym_add_expr] = STATE(385),
    [sym_in_expr] = STATE(385),
    [sym_comp_term] = STATE(385),
    [sym_instance_of] = STATE(385),
    [sym_negation] = STATE(385),
    [sym_if_term] = STATE(385),
    [sym_conjunction] = STATE(385),
    [sym_disjunction] = STATE(385),
    [sym_implication] = STATE(385),
    [sym_quantified] = STATE(385),
    [sym_quantifier] = STATE(1838),
    [sym_call_or_unqual_agg_expr] = STATE(474),
    [sym_qualified_expr] = STATE(474),
    [sym_super_ref] = STATE(474),
    [sym_aggregate] = STATE(474),
    [sym_range] = STATE(474),
    [sym_set_literal] = STATE(474),
    [sym_par_expr] = STATE(474),
    [sym_expr_annotation] = STATE(474),
    [sym__exprOrTerm] = STATE(385),
    [sym__primary] = STATE(474),
    [sym_literal] = STATE(474),
    [sym_bool] = STATE(470),
    [sym_variable] = STATE(474),
    [sym_unop] = STATE(258),
    [sym_asExprs] = STATE(1095),
    [sym_asExpr] = STATE(912),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2014),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(419),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(2009),
    [sym_aritylessPredicateExpr] = STATE(1472),
    [sym_varName] = STATE(472),
    [sym_aggId] = STATE(1773),
    [sym__lower_id] = ACTIONS(323),
    [anon_sym_LPAREN] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(327),
    [anon_sym_if] = ACTIONS(329),
    [sym_specialId] = ACTIONS(331),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(335),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(341),
    [sym_result] = ACTIONS(343),
    [sym_super] = ACTIONS(345),
    [sym_this] = ACTIONS(343),
    [sym_true] = ACTIONS(341),
  },
  [68] = {
    [sym_special_call] = STATE(385),
    [sym_prefix_cast] = STATE(385),
    [sym_unary_expr] = STATE(385),
    [sym_mul_expr] = STATE(385),
    [sym_add_expr] = STATE(385),
    [sym_in_expr] = STATE(385),
    [sym_comp_term] = STATE(385),
    [sym_instance_of] = STATE(385),
    [sym_negation] = STATE(385),
    [sym_if_term] = STATE(385),
    [sym_conjunction] = STATE(385),
    [sym_disjunction] = STATE(385),
    [sym_implication] = STATE(385),
    [sym_quantified] = STATE(385),
    [sym_quantifier] = STATE(1838),
    [sym_call_or_unqual_agg_expr] = STATE(474),
    [sym_qualified_expr] = STATE(474),
    [sym_super_ref] = STATE(474),
    [sym_aggregate] = STATE(474),
    [sym_range] = STATE(474),
    [sym_set_literal] = STATE(474),
    [sym_par_expr] = STATE(474),
    [sym_expr_annotation] = STATE(474),
    [sym__exprOrTerm] = STATE(385),
    [sym__primary] = STATE(474),
    [sym_literal] = STATE(474),
    [sym_bool] = STATE(470),
    [sym_variable] = STATE(474),
    [sym_unop] = STATE(258),
    [sym_asExprs] = STATE(1100),
    [sym_asExpr] = STATE(912),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2014),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(419),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(2009),
    [sym_aritylessPredicateExpr] = STATE(1472),
    [sym_varName] = STATE(472),
    [sym_aggId] = STATE(1773),
    [sym__lower_id] = ACTIONS(323),
    [anon_sym_LPAREN] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(327),
    [anon_sym_if] = ACTIONS(329),
    [sym_specialId] = ACTIONS(331),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(335),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(341),
    [sym_result] = ACTIONS(343),
    [sym_super] = ACTIONS(345),
    [sym_this] = ACTIONS(343),
    [sym_true] = ACTIONS(341),
  },
  [69] = {
    [sym_special_call] = STATE(831),
    [sym_prefix_cast] = STATE(831),
    [sym_unary_expr] = STATE(831),
    [sym_mul_expr] = STATE(831),
    [sym_add_expr] = STATE(831),
    [sym_in_expr] = STATE(831),
    [sym_comp_term] = STATE(831),
    [sym_instance_of] = STATE(831),
    [sym_negation] = STATE(831),
    [sym_if_term] = STATE(831),
    [sym_conjunction] = STATE(831),
    [sym_disjunction] = STATE(831),
    [sym_implication] = STATE(831),
    [sym_quantified] = STATE(831),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(831),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(347),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_RBRACK] = ACTIONS(349),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [70] = {
    [sym_special_call] = STATE(385),
    [sym_prefix_cast] = STATE(385),
    [sym_unary_expr] = STATE(385),
    [sym_mul_expr] = STATE(385),
    [sym_add_expr] = STATE(385),
    [sym_in_expr] = STATE(385),
    [sym_comp_term] = STATE(385),
    [sym_instance_of] = STATE(385),
    [sym_negation] = STATE(385),
    [sym_if_term] = STATE(385),
    [sym_conjunction] = STATE(385),
    [sym_disjunction] = STATE(385),
    [sym_implication] = STATE(385),
    [sym_quantified] = STATE(385),
    [sym_quantifier] = STATE(1838),
    [sym_call_or_unqual_agg_expr] = STATE(474),
    [sym_qualified_expr] = STATE(474),
    [sym_super_ref] = STATE(474),
    [sym_aggregate] = STATE(474),
    [sym_range] = STATE(474),
    [sym_set_literal] = STATE(474),
    [sym_par_expr] = STATE(474),
    [sym_expr_annotation] = STATE(474),
    [sym__exprOrTerm] = STATE(385),
    [sym__primary] = STATE(474),
    [sym_literal] = STATE(474),
    [sym_bool] = STATE(470),
    [sym_variable] = STATE(474),
    [sym_unop] = STATE(258),
    [sym_asExprs] = STATE(1134),
    [sym_asExpr] = STATE(912),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2014),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(419),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(2009),
    [sym_aritylessPredicateExpr] = STATE(1472),
    [sym_varName] = STATE(472),
    [sym_aggId] = STATE(1773),
    [sym__lower_id] = ACTIONS(323),
    [anon_sym_LPAREN] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(327),
    [anon_sym_if] = ACTIONS(329),
    [sym_specialId] = ACTIONS(331),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(335),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(341),
    [sym_result] = ACTIONS(343),
    [sym_super] = ACTIONS(345),
    [sym_this] = ACTIONS(343),
    [sym_true] = ACTIONS(341),
  },
  [71] = {
    [sym_special_call] = STATE(385),
    [sym_prefix_cast] = STATE(385),
    [sym_unary_expr] = STATE(385),
    [sym_mul_expr] = STATE(385),
    [sym_add_expr] = STATE(385),
    [sym_in_expr] = STATE(385),
    [sym_comp_term] = STATE(385),
    [sym_instance_of] = STATE(385),
    [sym_negation] = STATE(385),
    [sym_if_term] = STATE(385),
    [sym_conjunction] = STATE(385),
    [sym_disjunction] = STATE(385),
    [sym_implication] = STATE(385),
    [sym_quantified] = STATE(385),
    [sym_quantifier] = STATE(1838),
    [sym_call_or_unqual_agg_expr] = STATE(474),
    [sym_qualified_expr] = STATE(474),
    [sym_super_ref] = STATE(474),
    [sym_aggregate] = STATE(474),
    [sym_range] = STATE(474),
    [sym_set_literal] = STATE(474),
    [sym_par_expr] = STATE(474),
    [sym_expr_annotation] = STATE(474),
    [sym__exprOrTerm] = STATE(385),
    [sym__primary] = STATE(474),
    [sym_literal] = STATE(474),
    [sym_bool] = STATE(470),
    [sym_variable] = STATE(474),
    [sym_unop] = STATE(258),
    [sym_asExprs] = STATE(1167),
    [sym_asExpr] = STATE(912),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2014),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(419),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(2009),
    [sym_aritylessPredicateExpr] = STATE(1472),
    [sym_varName] = STATE(472),
    [sym_aggId] = STATE(1773),
    [sym__lower_id] = ACTIONS(323),
    [anon_sym_LPAREN] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(327),
    [anon_sym_if] = ACTIONS(329),
    [sym_specialId] = ACTIONS(331),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(335),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(341),
    [sym_result] = ACTIONS(343),
    [sym_super] = ACTIONS(345),
    [sym_this] = ACTIONS(343),
    [sym_true] = ACTIONS(341),
  },
  [72] = {
    [sym_special_call] = STATE(898),
    [sym_prefix_cast] = STATE(898),
    [sym_unary_expr] = STATE(898),
    [sym_mul_expr] = STATE(898),
    [sym_add_expr] = STATE(898),
    [sym_in_expr] = STATE(898),
    [sym_comp_term] = STATE(898),
    [sym_instance_of] = STATE(898),
    [sym_negation] = STATE(898),
    [sym_if_term] = STATE(898),
    [sym_conjunction] = STATE(898),
    [sym_disjunction] = STATE(898),
    [sym_implication] = STATE(898),
    [sym_quantified] = STATE(898),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(898),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(351),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(353),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [73] = {
    [sym_special_call] = STATE(385),
    [sym_prefix_cast] = STATE(385),
    [sym_unary_expr] = STATE(385),
    [sym_mul_expr] = STATE(385),
    [sym_add_expr] = STATE(385),
    [sym_in_expr] = STATE(385),
    [sym_comp_term] = STATE(385),
    [sym_instance_of] = STATE(385),
    [sym_negation] = STATE(385),
    [sym_if_term] = STATE(385),
    [sym_conjunction] = STATE(385),
    [sym_disjunction] = STATE(385),
    [sym_implication] = STATE(385),
    [sym_quantified] = STATE(385),
    [sym_quantifier] = STATE(1838),
    [sym_call_or_unqual_agg_expr] = STATE(474),
    [sym_qualified_expr] = STATE(474),
    [sym_super_ref] = STATE(474),
    [sym_aggregate] = STATE(474),
    [sym_range] = STATE(474),
    [sym_set_literal] = STATE(474),
    [sym_par_expr] = STATE(474),
    [sym_expr_annotation] = STATE(474),
    [sym__exprOrTerm] = STATE(385),
    [sym__primary] = STATE(474),
    [sym_literal] = STATE(474),
    [sym_bool] = STATE(470),
    [sym_variable] = STATE(474),
    [sym_unop] = STATE(258),
    [sym_asExprs] = STATE(1032),
    [sym_asExpr] = STATE(912),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2014),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(419),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(2009),
    [sym_aritylessPredicateExpr] = STATE(1472),
    [sym_varName] = STATE(472),
    [sym_aggId] = STATE(1773),
    [sym__lower_id] = ACTIONS(323),
    [anon_sym_LPAREN] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(327),
    [anon_sym_if] = ACTIONS(329),
    [sym_specialId] = ACTIONS(331),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(335),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(341),
    [sym_result] = ACTIONS(343),
    [sym_super] = ACTIONS(345),
    [sym_this] = ACTIONS(343),
    [sym_true] = ACTIONS(341),
  },
  [74] = {
    [sym_special_call] = STATE(907),
    [sym_prefix_cast] = STATE(907),
    [sym_unary_expr] = STATE(907),
    [sym_mul_expr] = STATE(907),
    [sym_add_expr] = STATE(907),
    [sym_in_expr] = STATE(907),
    [sym_comp_term] = STATE(907),
    [sym_instance_of] = STATE(907),
    [sym_negation] = STATE(907),
    [sym_if_term] = STATE(907),
    [sym_conjunction] = STATE(907),
    [sym_disjunction] = STATE(907),
    [sym_implication] = STATE(907),
    [sym_quantified] = STATE(907),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(907),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(355),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(357),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [75] = {
    [sym_special_call] = STATE(385),
    [sym_prefix_cast] = STATE(385),
    [sym_unary_expr] = STATE(385),
    [sym_mul_expr] = STATE(385),
    [sym_add_expr] = STATE(385),
    [sym_in_expr] = STATE(385),
    [sym_comp_term] = STATE(385),
    [sym_instance_of] = STATE(385),
    [sym_negation] = STATE(385),
    [sym_if_term] = STATE(385),
    [sym_conjunction] = STATE(385),
    [sym_disjunction] = STATE(385),
    [sym_implication] = STATE(385),
    [sym_quantified] = STATE(385),
    [sym_quantifier] = STATE(1838),
    [sym_call_or_unqual_agg_expr] = STATE(474),
    [sym_qualified_expr] = STATE(474),
    [sym_super_ref] = STATE(474),
    [sym_aggregate] = STATE(474),
    [sym_range] = STATE(474),
    [sym_set_literal] = STATE(474),
    [sym_par_expr] = STATE(474),
    [sym_expr_annotation] = STATE(474),
    [sym__exprOrTerm] = STATE(385),
    [sym__primary] = STATE(474),
    [sym_literal] = STATE(474),
    [sym_bool] = STATE(470),
    [sym_variable] = STATE(474),
    [sym_unop] = STATE(258),
    [sym_asExprs] = STATE(1033),
    [sym_asExpr] = STATE(912),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2014),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(419),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(2009),
    [sym_aritylessPredicateExpr] = STATE(1472),
    [sym_varName] = STATE(472),
    [sym_aggId] = STATE(1773),
    [sym__lower_id] = ACTIONS(323),
    [anon_sym_LPAREN] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(327),
    [anon_sym_if] = ACTIONS(329),
    [sym_specialId] = ACTIONS(331),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(335),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(341),
    [sym_result] = ACTIONS(343),
    [sym_super] = ACTIONS(345),
    [sym_this] = ACTIONS(343),
    [sym_true] = ACTIONS(341),
  },
  [76] = {
    [sym_special_call] = STATE(916),
    [sym_prefix_cast] = STATE(916),
    [sym_unary_expr] = STATE(916),
    [sym_mul_expr] = STATE(916),
    [sym_add_expr] = STATE(916),
    [sym_in_expr] = STATE(916),
    [sym_comp_term] = STATE(916),
    [sym_instance_of] = STATE(916),
    [sym_negation] = STATE(916),
    [sym_if_term] = STATE(916),
    [sym_conjunction] = STATE(916),
    [sym_disjunction] = STATE(916),
    [sym_implication] = STATE(916),
    [sym_quantified] = STATE(916),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(916),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(359),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(361),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [77] = {
    [sym_special_call] = STATE(415),
    [sym_prefix_cast] = STATE(415),
    [sym_unary_expr] = STATE(415),
    [sym_mul_expr] = STATE(415),
    [sym_add_expr] = STATE(415),
    [sym_in_expr] = STATE(415),
    [sym_comp_term] = STATE(415),
    [sym_instance_of] = STATE(415),
    [sym_negation] = STATE(415),
    [sym_if_term] = STATE(415),
    [sym_conjunction] = STATE(415),
    [sym_disjunction] = STATE(415),
    [sym_implication] = STATE(415),
    [sym_quantified] = STATE(415),
    [sym_quantifier] = STATE(1995),
    [sym_call_or_unqual_agg_expr] = STATE(428),
    [sym_qualified_expr] = STATE(428),
    [sym_super_ref] = STATE(428),
    [sym_aggregate] = STATE(428),
    [sym_range] = STATE(428),
    [sym_set_literal] = STATE(428),
    [sym_par_expr] = STATE(428),
    [sym_expr_annotation] = STATE(428),
    [sym__exprOrTerm] = STATE(415),
    [sym__primary] = STATE(428),
    [sym_literal] = STATE(428),
    [sym_bool] = STATE(424),
    [sym_variable] = STATE(428),
    [sym_unop] = STATE(198),
    [sym_asExprs] = STATE(1109),
    [sym_asExpr] = STATE(1026),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2012),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(422),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(2001),
    [sym_aritylessPredicateExpr] = STATE(1481),
    [sym_varName] = STATE(426),
    [sym_aggId] = STATE(1805),
    [sym__lower_id] = ACTIONS(299),
    [anon_sym_LPAREN] = ACTIONS(301),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(305),
    [sym_specialId] = ACTIONS(307),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(309),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(311),
    [sym_integer] = ACTIONS(313),
    [sym_float] = ACTIONS(315),
    [sym_string] = ACTIONS(315),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(317),
    [sym_result] = ACTIONS(319),
    [sym_super] = ACTIONS(321),
    [sym_this] = ACTIONS(319),
    [sym_true] = ACTIONS(317),
  },
  [78] = {
    [sym_special_call] = STATE(845),
    [sym_prefix_cast] = STATE(845),
    [sym_unary_expr] = STATE(845),
    [sym_mul_expr] = STATE(845),
    [sym_add_expr] = STATE(845),
    [sym_in_expr] = STATE(845),
    [sym_comp_term] = STATE(845),
    [sym_instance_of] = STATE(845),
    [sym_negation] = STATE(845),
    [sym_if_term] = STATE(845),
    [sym_conjunction] = STATE(845),
    [sym_disjunction] = STATE(845),
    [sym_implication] = STATE(845),
    [sym_quantified] = STATE(845),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(845),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_RBRACK] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [79] = {
    [sym_special_call] = STATE(415),
    [sym_prefix_cast] = STATE(415),
    [sym_unary_expr] = STATE(415),
    [sym_mul_expr] = STATE(415),
    [sym_add_expr] = STATE(415),
    [sym_in_expr] = STATE(415),
    [sym_comp_term] = STATE(415),
    [sym_instance_of] = STATE(415),
    [sym_negation] = STATE(415),
    [sym_if_term] = STATE(415),
    [sym_conjunction] = STATE(415),
    [sym_disjunction] = STATE(415),
    [sym_implication] = STATE(415),
    [sym_quantified] = STATE(415),
    [sym_quantifier] = STATE(1995),
    [sym_call_or_unqual_agg_expr] = STATE(428),
    [sym_qualified_expr] = STATE(428),
    [sym_super_ref] = STATE(428),
    [sym_aggregate] = STATE(428),
    [sym_range] = STATE(428),
    [sym_set_literal] = STATE(428),
    [sym_par_expr] = STATE(428),
    [sym_expr_annotation] = STATE(428),
    [sym__exprOrTerm] = STATE(415),
    [sym__primary] = STATE(428),
    [sym_literal] = STATE(428),
    [sym_bool] = STATE(424),
    [sym_variable] = STATE(428),
    [sym_unop] = STATE(198),
    [sym_asExprs] = STATE(1116),
    [sym_asExpr] = STATE(1026),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2012),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(422),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(2001),
    [sym_aritylessPredicateExpr] = STATE(1481),
    [sym_varName] = STATE(426),
    [sym_aggId] = STATE(1805),
    [sym__lower_id] = ACTIONS(299),
    [anon_sym_LPAREN] = ACTIONS(301),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(305),
    [sym_specialId] = ACTIONS(307),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(309),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(311),
    [sym_integer] = ACTIONS(313),
    [sym_float] = ACTIONS(315),
    [sym_string] = ACTIONS(315),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(317),
    [sym_result] = ACTIONS(319),
    [sym_super] = ACTIONS(321),
    [sym_this] = ACTIONS(319),
    [sym_true] = ACTIONS(317),
  },
  [80] = {
    [sym_special_call] = STATE(939),
    [sym_prefix_cast] = STATE(939),
    [sym_unary_expr] = STATE(939),
    [sym_mul_expr] = STATE(939),
    [sym_add_expr] = STATE(939),
    [sym_in_expr] = STATE(939),
    [sym_comp_term] = STATE(939),
    [sym_instance_of] = STATE(939),
    [sym_negation] = STATE(939),
    [sym_if_term] = STATE(939),
    [sym_conjunction] = STATE(939),
    [sym_disjunction] = STATE(939),
    [sym_implication] = STATE(939),
    [sym_quantified] = STATE(939),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(939),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(369),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [81] = {
    [sym_special_call] = STATE(941),
    [sym_prefix_cast] = STATE(941),
    [sym_unary_expr] = STATE(941),
    [sym_mul_expr] = STATE(941),
    [sym_add_expr] = STATE(941),
    [sym_in_expr] = STATE(941),
    [sym_comp_term] = STATE(941),
    [sym_instance_of] = STATE(941),
    [sym_negation] = STATE(941),
    [sym_if_term] = STATE(941),
    [sym_conjunction] = STATE(941),
    [sym_disjunction] = STATE(941),
    [sym_implication] = STATE(941),
    [sym_quantified] = STATE(941),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(941),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(371),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(373),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [82] = {
    [sym_special_call] = STATE(943),
    [sym_prefix_cast] = STATE(943),
    [sym_unary_expr] = STATE(943),
    [sym_mul_expr] = STATE(943),
    [sym_add_expr] = STATE(943),
    [sym_in_expr] = STATE(943),
    [sym_comp_term] = STATE(943),
    [sym_instance_of] = STATE(943),
    [sym_negation] = STATE(943),
    [sym_if_term] = STATE(943),
    [sym_conjunction] = STATE(943),
    [sym_disjunction] = STATE(943),
    [sym_implication] = STATE(943),
    [sym_quantified] = STATE(943),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(943),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(375),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(377),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [83] = {
    [sym_special_call] = STATE(846),
    [sym_prefix_cast] = STATE(846),
    [sym_unary_expr] = STATE(846),
    [sym_mul_expr] = STATE(846),
    [sym_add_expr] = STATE(846),
    [sym_in_expr] = STATE(846),
    [sym_comp_term] = STATE(846),
    [sym_instance_of] = STATE(846),
    [sym_negation] = STATE(846),
    [sym_if_term] = STATE(846),
    [sym_conjunction] = STATE(846),
    [sym_disjunction] = STATE(846),
    [sym_implication] = STATE(846),
    [sym_quantified] = STATE(846),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(846),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_RBRACK] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [84] = {
    [sym_special_call] = STATE(961),
    [sym_prefix_cast] = STATE(961),
    [sym_unary_expr] = STATE(961),
    [sym_mul_expr] = STATE(961),
    [sym_add_expr] = STATE(961),
    [sym_in_expr] = STATE(961),
    [sym_comp_term] = STATE(961),
    [sym_instance_of] = STATE(961),
    [sym_negation] = STATE(961),
    [sym_if_term] = STATE(961),
    [sym_conjunction] = STATE(961),
    [sym_disjunction] = STATE(961),
    [sym_implication] = STATE(961),
    [sym_quantified] = STATE(961),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(961),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(383),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(385),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [85] = {
    [sym_special_call] = STATE(948),
    [sym_prefix_cast] = STATE(948),
    [sym_unary_expr] = STATE(948),
    [sym_mul_expr] = STATE(948),
    [sym_add_expr] = STATE(948),
    [sym_in_expr] = STATE(948),
    [sym_comp_term] = STATE(948),
    [sym_instance_of] = STATE(948),
    [sym_negation] = STATE(948),
    [sym_if_term] = STATE(948),
    [sym_conjunction] = STATE(948),
    [sym_disjunction] = STATE(948),
    [sym_implication] = STATE(948),
    [sym_quantified] = STATE(948),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(948),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(389),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [86] = {
    [sym_special_call] = STATE(969),
    [sym_prefix_cast] = STATE(969),
    [sym_unary_expr] = STATE(969),
    [sym_mul_expr] = STATE(969),
    [sym_add_expr] = STATE(969),
    [sym_in_expr] = STATE(969),
    [sym_comp_term] = STATE(969),
    [sym_instance_of] = STATE(969),
    [sym_negation] = STATE(969),
    [sym_if_term] = STATE(969),
    [sym_conjunction] = STATE(969),
    [sym_disjunction] = STATE(969),
    [sym_implication] = STATE(969),
    [sym_quantified] = STATE(969),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(969),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(391),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(393),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [87] = {
    [sym_special_call] = STATE(951),
    [sym_prefix_cast] = STATE(951),
    [sym_unary_expr] = STATE(951),
    [sym_mul_expr] = STATE(951),
    [sym_add_expr] = STATE(951),
    [sym_in_expr] = STATE(951),
    [sym_comp_term] = STATE(951),
    [sym_instance_of] = STATE(951),
    [sym_negation] = STATE(951),
    [sym_if_term] = STATE(951),
    [sym_conjunction] = STATE(951),
    [sym_disjunction] = STATE(951),
    [sym_implication] = STATE(951),
    [sym_quantified] = STATE(951),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(951),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(395),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(397),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [88] = {
    [sym_special_call] = STATE(953),
    [sym_prefix_cast] = STATE(953),
    [sym_unary_expr] = STATE(953),
    [sym_mul_expr] = STATE(953),
    [sym_add_expr] = STATE(953),
    [sym_in_expr] = STATE(953),
    [sym_comp_term] = STATE(953),
    [sym_instance_of] = STATE(953),
    [sym_negation] = STATE(953),
    [sym_if_term] = STATE(953),
    [sym_conjunction] = STATE(953),
    [sym_disjunction] = STATE(953),
    [sym_implication] = STATE(953),
    [sym_quantified] = STATE(953),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(953),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(399),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(401),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [89] = {
    [sym_special_call] = STATE(415),
    [sym_prefix_cast] = STATE(415),
    [sym_unary_expr] = STATE(415),
    [sym_mul_expr] = STATE(415),
    [sym_add_expr] = STATE(415),
    [sym_in_expr] = STATE(415),
    [sym_comp_term] = STATE(415),
    [sym_instance_of] = STATE(415),
    [sym_negation] = STATE(415),
    [sym_if_term] = STATE(415),
    [sym_conjunction] = STATE(415),
    [sym_disjunction] = STATE(415),
    [sym_implication] = STATE(415),
    [sym_quantified] = STATE(415),
    [sym_quantifier] = STATE(1995),
    [sym_call_or_unqual_agg_expr] = STATE(428),
    [sym_qualified_expr] = STATE(428),
    [sym_super_ref] = STATE(428),
    [sym_aggregate] = STATE(428),
    [sym_range] = STATE(428),
    [sym_set_literal] = STATE(428),
    [sym_par_expr] = STATE(428),
    [sym_expr_annotation] = STATE(428),
    [sym__exprOrTerm] = STATE(415),
    [sym__primary] = STATE(428),
    [sym_literal] = STATE(428),
    [sym_bool] = STATE(424),
    [sym_variable] = STATE(428),
    [sym_unop] = STATE(198),
    [sym_asExprs] = STATE(1166),
    [sym_asExpr] = STATE(1026),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2012),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(422),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(2001),
    [sym_aritylessPredicateExpr] = STATE(1481),
    [sym_varName] = STATE(426),
    [sym_aggId] = STATE(1805),
    [sym__lower_id] = ACTIONS(299),
    [anon_sym_LPAREN] = ACTIONS(301),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(305),
    [sym_specialId] = ACTIONS(307),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(309),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(311),
    [sym_integer] = ACTIONS(313),
    [sym_float] = ACTIONS(315),
    [sym_string] = ACTIONS(315),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(317),
    [sym_result] = ACTIONS(319),
    [sym_super] = ACTIONS(321),
    [sym_this] = ACTIONS(319),
    [sym_true] = ACTIONS(317),
  },
  [90] = {
    [sym_special_call] = STATE(848),
    [sym_prefix_cast] = STATE(848),
    [sym_unary_expr] = STATE(848),
    [sym_mul_expr] = STATE(848),
    [sym_add_expr] = STATE(848),
    [sym_in_expr] = STATE(848),
    [sym_comp_term] = STATE(848),
    [sym_instance_of] = STATE(848),
    [sym_negation] = STATE(848),
    [sym_if_term] = STATE(848),
    [sym_conjunction] = STATE(848),
    [sym_disjunction] = STATE(848),
    [sym_implication] = STATE(848),
    [sym_quantified] = STATE(848),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(848),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(403),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_RBRACK] = ACTIONS(405),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [91] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1861),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [92] = {
    [sym_special_call] = STATE(960),
    [sym_prefix_cast] = STATE(960),
    [sym_unary_expr] = STATE(960),
    [sym_mul_expr] = STATE(960),
    [sym_add_expr] = STATE(960),
    [sym_in_expr] = STATE(960),
    [sym_comp_term] = STATE(960),
    [sym_instance_of] = STATE(960),
    [sym_negation] = STATE(960),
    [sym_if_term] = STATE(960),
    [sym_conjunction] = STATE(960),
    [sym_disjunction] = STATE(960),
    [sym_implication] = STATE(960),
    [sym_quantified] = STATE(960),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(960),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(407),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(409),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [93] = {
    [sym_special_call] = STATE(880),
    [sym_prefix_cast] = STATE(880),
    [sym_unary_expr] = STATE(880),
    [sym_mul_expr] = STATE(880),
    [sym_add_expr] = STATE(880),
    [sym_in_expr] = STATE(880),
    [sym_comp_term] = STATE(880),
    [sym_instance_of] = STATE(880),
    [sym_negation] = STATE(880),
    [sym_if_term] = STATE(880),
    [sym_conjunction] = STATE(880),
    [sym_disjunction] = STATE(880),
    [sym_implication] = STATE(880),
    [sym_quantified] = STATE(880),
    [sym_quantifier] = STATE(1849),
    [sym__call_arg] = STATE(1779),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(880),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [sym_underscore] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [94] = {
    [sym_special_call] = STATE(963),
    [sym_prefix_cast] = STATE(963),
    [sym_unary_expr] = STATE(963),
    [sym_mul_expr] = STATE(963),
    [sym_add_expr] = STATE(963),
    [sym_in_expr] = STATE(963),
    [sym_comp_term] = STATE(963),
    [sym_instance_of] = STATE(963),
    [sym_negation] = STATE(963),
    [sym_if_term] = STATE(963),
    [sym_conjunction] = STATE(963),
    [sym_disjunction] = STATE(963),
    [sym_implication] = STATE(963),
    [sym_quantified] = STATE(963),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(963),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(413),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(415),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [95] = {
    [sym_special_call] = STATE(966),
    [sym_prefix_cast] = STATE(966),
    [sym_unary_expr] = STATE(966),
    [sym_mul_expr] = STATE(966),
    [sym_add_expr] = STATE(966),
    [sym_in_expr] = STATE(966),
    [sym_comp_term] = STATE(966),
    [sym_instance_of] = STATE(966),
    [sym_negation] = STATE(966),
    [sym_if_term] = STATE(966),
    [sym_conjunction] = STATE(966),
    [sym_disjunction] = STATE(966),
    [sym_implication] = STATE(966),
    [sym_quantified] = STATE(966),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(966),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(417),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(419),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [96] = {
    [sym_special_call] = STATE(847),
    [sym_prefix_cast] = STATE(847),
    [sym_unary_expr] = STATE(847),
    [sym_mul_expr] = STATE(847),
    [sym_add_expr] = STATE(847),
    [sym_in_expr] = STATE(847),
    [sym_comp_term] = STATE(847),
    [sym_instance_of] = STATE(847),
    [sym_negation] = STATE(847),
    [sym_if_term] = STATE(847),
    [sym_conjunction] = STATE(847),
    [sym_disjunction] = STATE(847),
    [sym_implication] = STATE(847),
    [sym_quantified] = STATE(847),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(847),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_asExprs] = STATE(1713),
    [sym_asExpr] = STATE(1562),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1839),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [97] = {
    [sym_special_call] = STATE(990),
    [sym_prefix_cast] = STATE(990),
    [sym_unary_expr] = STATE(990),
    [sym_mul_expr] = STATE(990),
    [sym_add_expr] = STATE(990),
    [sym_in_expr] = STATE(990),
    [sym_comp_term] = STATE(990),
    [sym_instance_of] = STATE(990),
    [sym_negation] = STATE(990),
    [sym_if_term] = STATE(990),
    [sym_conjunction] = STATE(990),
    [sym_disjunction] = STATE(990),
    [sym_implication] = STATE(990),
    [sym_quantified] = STATE(990),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(990),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(421),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(423),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [98] = {
    [sym_special_call] = STATE(849),
    [sym_prefix_cast] = STATE(849),
    [sym_unary_expr] = STATE(849),
    [sym_mul_expr] = STATE(849),
    [sym_add_expr] = STATE(849),
    [sym_in_expr] = STATE(849),
    [sym_comp_term] = STATE(849),
    [sym_instance_of] = STATE(849),
    [sym_negation] = STATE(849),
    [sym_if_term] = STATE(849),
    [sym_conjunction] = STATE(849),
    [sym_disjunction] = STATE(849),
    [sym_implication] = STATE(849),
    [sym_quantified] = STATE(849),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(849),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_RBRACK] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [99] = {
    [sym_special_call] = STATE(974),
    [sym_prefix_cast] = STATE(974),
    [sym_unary_expr] = STATE(974),
    [sym_mul_expr] = STATE(974),
    [sym_add_expr] = STATE(974),
    [sym_in_expr] = STATE(974),
    [sym_comp_term] = STATE(974),
    [sym_instance_of] = STATE(974),
    [sym_negation] = STATE(974),
    [sym_if_term] = STATE(974),
    [sym_conjunction] = STATE(974),
    [sym_disjunction] = STATE(974),
    [sym_implication] = STATE(974),
    [sym_quantified] = STATE(974),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(974),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(429),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(431),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [100] = {
    [sym_special_call] = STATE(415),
    [sym_prefix_cast] = STATE(415),
    [sym_unary_expr] = STATE(415),
    [sym_mul_expr] = STATE(415),
    [sym_add_expr] = STATE(415),
    [sym_in_expr] = STATE(415),
    [sym_comp_term] = STATE(415),
    [sym_instance_of] = STATE(415),
    [sym_negation] = STATE(415),
    [sym_if_term] = STATE(415),
    [sym_conjunction] = STATE(415),
    [sym_disjunction] = STATE(415),
    [sym_implication] = STATE(415),
    [sym_quantified] = STATE(415),
    [sym_quantifier] = STATE(1995),
    [sym_call_or_unqual_agg_expr] = STATE(428),
    [sym_qualified_expr] = STATE(428),
    [sym_super_ref] = STATE(428),
    [sym_aggregate] = STATE(428),
    [sym_range] = STATE(428),
    [sym_set_literal] = STATE(428),
    [sym_par_expr] = STATE(428),
    [sym_expr_annotation] = STATE(428),
    [sym__exprOrTerm] = STATE(415),
    [sym__primary] = STATE(428),
    [sym_literal] = STATE(428),
    [sym_bool] = STATE(424),
    [sym_variable] = STATE(428),
    [sym_unop] = STATE(198),
    [sym_asExprs] = STATE(1179),
    [sym_asExpr] = STATE(1026),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2012),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(422),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(2001),
    [sym_aritylessPredicateExpr] = STATE(1481),
    [sym_varName] = STATE(426),
    [sym_aggId] = STATE(1805),
    [sym__lower_id] = ACTIONS(299),
    [anon_sym_LPAREN] = ACTIONS(301),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(305),
    [sym_specialId] = ACTIONS(307),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(309),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(311),
    [sym_integer] = ACTIONS(313),
    [sym_float] = ACTIONS(315),
    [sym_string] = ACTIONS(315),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(317),
    [sym_result] = ACTIONS(319),
    [sym_super] = ACTIONS(321),
    [sym_this] = ACTIONS(319),
    [sym_true] = ACTIONS(317),
  },
  [101] = {
    [sym_special_call] = STATE(977),
    [sym_prefix_cast] = STATE(977),
    [sym_unary_expr] = STATE(977),
    [sym_mul_expr] = STATE(977),
    [sym_add_expr] = STATE(977),
    [sym_in_expr] = STATE(977),
    [sym_comp_term] = STATE(977),
    [sym_instance_of] = STATE(977),
    [sym_negation] = STATE(977),
    [sym_if_term] = STATE(977),
    [sym_conjunction] = STATE(977),
    [sym_disjunction] = STATE(977),
    [sym_implication] = STATE(977),
    [sym_quantified] = STATE(977),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(977),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(433),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(435),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [102] = {
    [sym_special_call] = STATE(979),
    [sym_prefix_cast] = STATE(979),
    [sym_unary_expr] = STATE(979),
    [sym_mul_expr] = STATE(979),
    [sym_add_expr] = STATE(979),
    [sym_in_expr] = STATE(979),
    [sym_comp_term] = STATE(979),
    [sym_instance_of] = STATE(979),
    [sym_negation] = STATE(979),
    [sym_if_term] = STATE(979),
    [sym_conjunction] = STATE(979),
    [sym_disjunction] = STATE(979),
    [sym_implication] = STATE(979),
    [sym_quantified] = STATE(979),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(979),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(437),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(439),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [103] = {
    [sym_special_call] = STATE(850),
    [sym_prefix_cast] = STATE(850),
    [sym_unary_expr] = STATE(850),
    [sym_mul_expr] = STATE(850),
    [sym_add_expr] = STATE(850),
    [sym_in_expr] = STATE(850),
    [sym_comp_term] = STATE(850),
    [sym_instance_of] = STATE(850),
    [sym_negation] = STATE(850),
    [sym_if_term] = STATE(850),
    [sym_conjunction] = STATE(850),
    [sym_disjunction] = STATE(850),
    [sym_implication] = STATE(850),
    [sym_quantified] = STATE(850),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(850),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(441),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_RBRACK] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [104] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(2018),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [105] = {
    [sym_special_call] = STATE(984),
    [sym_prefix_cast] = STATE(984),
    [sym_unary_expr] = STATE(984),
    [sym_mul_expr] = STATE(984),
    [sym_add_expr] = STATE(984),
    [sym_in_expr] = STATE(984),
    [sym_comp_term] = STATE(984),
    [sym_instance_of] = STATE(984),
    [sym_negation] = STATE(984),
    [sym_if_term] = STATE(984),
    [sym_conjunction] = STATE(984),
    [sym_disjunction] = STATE(984),
    [sym_implication] = STATE(984),
    [sym_quantified] = STATE(984),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(984),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(447),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [106] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1899),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [107] = {
    [sym_special_call] = STATE(987),
    [sym_prefix_cast] = STATE(987),
    [sym_unary_expr] = STATE(987),
    [sym_mul_expr] = STATE(987),
    [sym_add_expr] = STATE(987),
    [sym_in_expr] = STATE(987),
    [sym_comp_term] = STATE(987),
    [sym_instance_of] = STATE(987),
    [sym_negation] = STATE(987),
    [sym_if_term] = STATE(987),
    [sym_conjunction] = STATE(987),
    [sym_disjunction] = STATE(987),
    [sym_implication] = STATE(987),
    [sym_quantified] = STATE(987),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(987),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(449),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(451),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [108] = {
    [sym_special_call] = STATE(958),
    [sym_prefix_cast] = STATE(958),
    [sym_unary_expr] = STATE(958),
    [sym_mul_expr] = STATE(958),
    [sym_add_expr] = STATE(958),
    [sym_in_expr] = STATE(958),
    [sym_comp_term] = STATE(958),
    [sym_instance_of] = STATE(958),
    [sym_negation] = STATE(958),
    [sym_if_term] = STATE(958),
    [sym_conjunction] = STATE(958),
    [sym_disjunction] = STATE(958),
    [sym_implication] = STATE(958),
    [sym_quantified] = STATE(958),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(958),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(453),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(455),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [109] = {
    [sym_special_call] = STATE(989),
    [sym_prefix_cast] = STATE(989),
    [sym_unary_expr] = STATE(989),
    [sym_mul_expr] = STATE(989),
    [sym_add_expr] = STATE(989),
    [sym_in_expr] = STATE(989),
    [sym_comp_term] = STATE(989),
    [sym_instance_of] = STATE(989),
    [sym_negation] = STATE(989),
    [sym_if_term] = STATE(989),
    [sym_conjunction] = STATE(989),
    [sym_disjunction] = STATE(989),
    [sym_implication] = STATE(989),
    [sym_quantified] = STATE(989),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(989),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(457),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(459),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [110] = {
    [sym_special_call] = STATE(847),
    [sym_prefix_cast] = STATE(847),
    [sym_unary_expr] = STATE(847),
    [sym_mul_expr] = STATE(847),
    [sym_add_expr] = STATE(847),
    [sym_in_expr] = STATE(847),
    [sym_comp_term] = STATE(847),
    [sym_instance_of] = STATE(847),
    [sym_negation] = STATE(847),
    [sym_if_term] = STATE(847),
    [sym_conjunction] = STATE(847),
    [sym_disjunction] = STATE(847),
    [sym_implication] = STATE(847),
    [sym_quantified] = STATE(847),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(847),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_asExprs] = STATE(1703),
    [sym_asExpr] = STATE(1562),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1839),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [111] = {
    [sym_special_call] = STATE(847),
    [sym_prefix_cast] = STATE(847),
    [sym_unary_expr] = STATE(847),
    [sym_mul_expr] = STATE(847),
    [sym_add_expr] = STATE(847),
    [sym_in_expr] = STATE(847),
    [sym_comp_term] = STATE(847),
    [sym_instance_of] = STATE(847),
    [sym_negation] = STATE(847),
    [sym_if_term] = STATE(847),
    [sym_conjunction] = STATE(847),
    [sym_disjunction] = STATE(847),
    [sym_implication] = STATE(847),
    [sym_quantified] = STATE(847),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(847),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_asExprs] = STATE(1691),
    [sym_asExpr] = STATE(1562),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1839),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [112] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1977),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [113] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1984),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [114] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1814),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [115] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1912),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [116] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1923),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [117] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1924),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [118] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1909),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [119] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1933),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [120] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1934),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [121] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1941),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [122] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1942),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [123] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1945),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [124] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1969),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [125] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(2006),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [126] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1818),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [127] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1815),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [128] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1834),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [129] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1850),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [130] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1926),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [131] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1922),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [132] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1812),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [133] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1953),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [134] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1979),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [135] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1856),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [136] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1959),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [137] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1841),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [138] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1846),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [139] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1907),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [140] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1944),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [141] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1954),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [142] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1906),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [143] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1927),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [144] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1931),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [145] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1961),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [146] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1962),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [147] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExprs] = STATE(1971),
    [sym_asExpr] = STATE(1670),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [148] = {
    [sym_special_call] = STATE(1010),
    [sym_prefix_cast] = STATE(1010),
    [sym_unary_expr] = STATE(1010),
    [sym_mul_expr] = STATE(1010),
    [sym_add_expr] = STATE(1010),
    [sym_in_expr] = STATE(1010),
    [sym_comp_term] = STATE(1010),
    [sym_instance_of] = STATE(1010),
    [sym_negation] = STATE(1010),
    [sym_if_term] = STATE(1010),
    [sym_conjunction] = STATE(1010),
    [sym_disjunction] = STATE(1010),
    [sym_implication] = STATE(1010),
    [sym_quantified] = STATE(1010),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1010),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(461),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(463),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [149] = {
    [sym_special_call] = STATE(415),
    [sym_prefix_cast] = STATE(415),
    [sym_unary_expr] = STATE(415),
    [sym_mul_expr] = STATE(415),
    [sym_add_expr] = STATE(415),
    [sym_in_expr] = STATE(415),
    [sym_comp_term] = STATE(415),
    [sym_instance_of] = STATE(415),
    [sym_negation] = STATE(415),
    [sym_if_term] = STATE(415),
    [sym_conjunction] = STATE(415),
    [sym_disjunction] = STATE(415),
    [sym_implication] = STATE(415),
    [sym_quantified] = STATE(415),
    [sym_quantifier] = STATE(1995),
    [sym_call_or_unqual_agg_expr] = STATE(428),
    [sym_qualified_expr] = STATE(428),
    [sym_super_ref] = STATE(428),
    [sym_aggregate] = STATE(428),
    [sym_range] = STATE(428),
    [sym_set_literal] = STATE(428),
    [sym_par_expr] = STATE(428),
    [sym_expr_annotation] = STATE(428),
    [sym__exprOrTerm] = STATE(415),
    [sym__primary] = STATE(428),
    [sym_literal] = STATE(428),
    [sym_bool] = STATE(424),
    [sym_variable] = STATE(428),
    [sym_unop] = STATE(198),
    [sym_asExpr] = STATE(1080),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2012),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(422),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(2001),
    [sym_aritylessPredicateExpr] = STATE(1481),
    [sym_varName] = STATE(426),
    [sym_aggId] = STATE(1805),
    [sym__lower_id] = ACTIONS(299),
    [anon_sym_LPAREN] = ACTIONS(301),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(305),
    [sym_specialId] = ACTIONS(307),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(309),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(311),
    [sym_integer] = ACTIONS(313),
    [sym_float] = ACTIONS(315),
    [sym_string] = ACTIONS(315),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(317),
    [sym_result] = ACTIONS(319),
    [sym_super] = ACTIONS(321),
    [sym_this] = ACTIONS(319),
    [sym_true] = ACTIONS(317),
  },
  [150] = {
    [sym_special_call] = STATE(949),
    [sym_prefix_cast] = STATE(949),
    [sym_unary_expr] = STATE(949),
    [sym_mul_expr] = STATE(949),
    [sym_add_expr] = STATE(949),
    [sym_in_expr] = STATE(949),
    [sym_comp_term] = STATE(949),
    [sym_instance_of] = STATE(949),
    [sym_negation] = STATE(949),
    [sym_if_term] = STATE(949),
    [sym_conjunction] = STATE(949),
    [sym_disjunction] = STATE(949),
    [sym_implication] = STATE(949),
    [sym_quantified] = STATE(949),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(949),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_RBRACK] = ACTIONS(465),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [151] = {
    [sym_special_call] = STATE(367),
    [sym_prefix_cast] = STATE(367),
    [sym_unary_expr] = STATE(367),
    [sym_mul_expr] = STATE(367),
    [sym_add_expr] = STATE(367),
    [sym_in_expr] = STATE(367),
    [sym_comp_term] = STATE(367),
    [sym_instance_of] = STATE(367),
    [sym_negation] = STATE(367),
    [sym_if_term] = STATE(367),
    [sym_conjunction] = STATE(367),
    [sym_disjunction] = STATE(367),
    [sym_implication] = STATE(367),
    [sym_quantified] = STATE(367),
    [sym_quantifier] = STATE(1865),
    [sym_call_or_unqual_agg_expr] = STATE(517),
    [sym_qualified_expr] = STATE(517),
    [sym_super_ref] = STATE(517),
    [sym_aggregate] = STATE(517),
    [sym_range] = STATE(517),
    [sym_set_literal] = STATE(517),
    [sym_par_expr] = STATE(517),
    [sym_expr_annotation] = STATE(517),
    [sym__exprOrTerm] = STATE(367),
    [sym__primary] = STATE(517),
    [sym_literal] = STATE(517),
    [sym_bool] = STATE(513),
    [sym_variable] = STATE(517),
    [sym_unop] = STATE(297),
    [sym_orderBy] = STATE(1142),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2015),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(421),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1866),
    [sym_aritylessPredicateExpr] = STATE(1477),
    [sym_varName] = STATE(598),
    [sym_aggId] = STATE(1778),
    [sym__lower_id] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(469),
    [anon_sym_not] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [sym_specialId] = ACTIONS(475),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(479),
    [sym_integer] = ACTIONS(481),
    [sym_float] = ACTIONS(483),
    [sym_string] = ACTIONS(483),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(485),
    [sym_result] = ACTIONS(487),
    [sym_super] = ACTIONS(489),
    [sym_this] = ACTIONS(487),
    [sym_true] = ACTIONS(485),
  },
  [152] = {
    [sym_special_call] = STATE(949),
    [sym_prefix_cast] = STATE(949),
    [sym_unary_expr] = STATE(949),
    [sym_mul_expr] = STATE(949),
    [sym_add_expr] = STATE(949),
    [sym_in_expr] = STATE(949),
    [sym_comp_term] = STATE(949),
    [sym_instance_of] = STATE(949),
    [sym_negation] = STATE(949),
    [sym_if_term] = STATE(949),
    [sym_conjunction] = STATE(949),
    [sym_disjunction] = STATE(949),
    [sym_implication] = STATE(949),
    [sym_quantified] = STATE(949),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(949),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_RBRACK] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [153] = {
    [sym_special_call] = STATE(385),
    [sym_prefix_cast] = STATE(385),
    [sym_unary_expr] = STATE(385),
    [sym_mul_expr] = STATE(385),
    [sym_add_expr] = STATE(385),
    [sym_in_expr] = STATE(385),
    [sym_comp_term] = STATE(385),
    [sym_instance_of] = STATE(385),
    [sym_negation] = STATE(385),
    [sym_if_term] = STATE(385),
    [sym_conjunction] = STATE(385),
    [sym_disjunction] = STATE(385),
    [sym_implication] = STATE(385),
    [sym_quantified] = STATE(385),
    [sym_quantifier] = STATE(1838),
    [sym_call_or_unqual_agg_expr] = STATE(474),
    [sym_qualified_expr] = STATE(474),
    [sym_super_ref] = STATE(474),
    [sym_aggregate] = STATE(474),
    [sym_range] = STATE(474),
    [sym_set_literal] = STATE(474),
    [sym_par_expr] = STATE(474),
    [sym_expr_annotation] = STATE(474),
    [sym__exprOrTerm] = STATE(385),
    [sym__primary] = STATE(474),
    [sym_literal] = STATE(474),
    [sym_bool] = STATE(470),
    [sym_variable] = STATE(474),
    [sym_unop] = STATE(258),
    [sym_asExpr] = STATE(1065),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2014),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(419),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(2009),
    [sym_aritylessPredicateExpr] = STATE(1472),
    [sym_varName] = STATE(472),
    [sym_aggId] = STATE(1773),
    [sym__lower_id] = ACTIONS(323),
    [anon_sym_LPAREN] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(327),
    [anon_sym_if] = ACTIONS(329),
    [sym_specialId] = ACTIONS(331),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(335),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(341),
    [sym_result] = ACTIONS(343),
    [sym_super] = ACTIONS(345),
    [sym_this] = ACTIONS(343),
    [sym_true] = ACTIONS(341),
  },
  [154] = {
    [sym_special_call] = STATE(949),
    [sym_prefix_cast] = STATE(949),
    [sym_unary_expr] = STATE(949),
    [sym_mul_expr] = STATE(949),
    [sym_add_expr] = STATE(949),
    [sym_in_expr] = STATE(949),
    [sym_comp_term] = STATE(949),
    [sym_instance_of] = STATE(949),
    [sym_negation] = STATE(949),
    [sym_if_term] = STATE(949),
    [sym_conjunction] = STATE(949),
    [sym_disjunction] = STATE(949),
    [sym_implication] = STATE(949),
    [sym_quantified] = STATE(949),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(949),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_RBRACK] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [155] = {
    [sym_special_call] = STATE(949),
    [sym_prefix_cast] = STATE(949),
    [sym_unary_expr] = STATE(949),
    [sym_mul_expr] = STATE(949),
    [sym_add_expr] = STATE(949),
    [sym_in_expr] = STATE(949),
    [sym_comp_term] = STATE(949),
    [sym_instance_of] = STATE(949),
    [sym_negation] = STATE(949),
    [sym_if_term] = STATE(949),
    [sym_conjunction] = STATE(949),
    [sym_disjunction] = STATE(949),
    [sym_implication] = STATE(949),
    [sym_quantified] = STATE(949),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(949),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_RBRACK] = ACTIONS(495),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [156] = {
    [sym_special_call] = STATE(949),
    [sym_prefix_cast] = STATE(949),
    [sym_unary_expr] = STATE(949),
    [sym_mul_expr] = STATE(949),
    [sym_add_expr] = STATE(949),
    [sym_in_expr] = STATE(949),
    [sym_comp_term] = STATE(949),
    [sym_instance_of] = STATE(949),
    [sym_negation] = STATE(949),
    [sym_if_term] = STATE(949),
    [sym_conjunction] = STATE(949),
    [sym_disjunction] = STATE(949),
    [sym_implication] = STATE(949),
    [sym_quantified] = STATE(949),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(949),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_RBRACK] = ACTIONS(497),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [157] = {
    [sym_special_call] = STATE(864),
    [sym_prefix_cast] = STATE(864),
    [sym_unary_expr] = STATE(864),
    [sym_mul_expr] = STATE(864),
    [sym_add_expr] = STATE(864),
    [sym_in_expr] = STATE(864),
    [sym_comp_term] = STATE(864),
    [sym_instance_of] = STATE(864),
    [sym_negation] = STATE(864),
    [sym_if_term] = STATE(864),
    [sym_conjunction] = STATE(864),
    [sym_disjunction] = STATE(864),
    [sym_implication] = STATE(864),
    [sym_quantified] = STATE(864),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(864),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_asExpr] = STATE(1657),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [158] = {
    [sym_special_call] = STATE(371),
    [sym_prefix_cast] = STATE(371),
    [sym_unary_expr] = STATE(371),
    [sym_mul_expr] = STATE(371),
    [sym_add_expr] = STATE(371),
    [sym_in_expr] = STATE(371),
    [sym_comp_term] = STATE(371),
    [sym_instance_of] = STATE(371),
    [sym_negation] = STATE(371),
    [sym_if_term] = STATE(371),
    [sym_conjunction] = STATE(371),
    [sym_disjunction] = STATE(371),
    [sym_implication] = STATE(371),
    [sym_quantified] = STATE(371),
    [sym_quantifier] = STATE(1919),
    [sym_call_or_unqual_agg_expr] = STATE(560),
    [sym_qualified_expr] = STATE(560),
    [sym_super_ref] = STATE(560),
    [sym_aggregate] = STATE(560),
    [sym_range] = STATE(560),
    [sym_set_literal] = STATE(560),
    [sym_par_expr] = STATE(560),
    [sym_expr_annotation] = STATE(560),
    [sym__exprOrTerm] = STATE(371),
    [sym__primary] = STATE(560),
    [sym_literal] = STATE(560),
    [sym_bool] = STATE(556),
    [sym_variable] = STATE(560),
    [sym_unop] = STATE(183),
    [sym_orderBy] = STATE(1073),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2017),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(420),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1920),
    [sym_aritylessPredicateExpr] = STATE(1484),
    [sym_varName] = STATE(558),
    [sym_aggId] = STATE(1789),
    [sym__lower_id] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(505),
    [sym_specialId] = ACTIONS(507),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(509),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(511),
    [sym_integer] = ACTIONS(513),
    [sym_float] = ACTIONS(515),
    [sym_string] = ACTIONS(515),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(517),
    [sym_result] = ACTIONS(519),
    [sym_super] = ACTIONS(521),
    [sym_this] = ACTIONS(519),
    [sym_true] = ACTIONS(517),
  },
  [159] = {
    [sym_special_call] = STATE(949),
    [sym_prefix_cast] = STATE(949),
    [sym_unary_expr] = STATE(949),
    [sym_mul_expr] = STATE(949),
    [sym_add_expr] = STATE(949),
    [sym_in_expr] = STATE(949),
    [sym_comp_term] = STATE(949),
    [sym_instance_of] = STATE(949),
    [sym_negation] = STATE(949),
    [sym_if_term] = STATE(949),
    [sym_conjunction] = STATE(949),
    [sym_disjunction] = STATE(949),
    [sym_implication] = STATE(949),
    [sym_quantified] = STATE(949),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(949),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_RBRACK] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [160] = {
    [sym_special_call] = STATE(949),
    [sym_prefix_cast] = STATE(949),
    [sym_unary_expr] = STATE(949),
    [sym_mul_expr] = STATE(949),
    [sym_add_expr] = STATE(949),
    [sym_in_expr] = STATE(949),
    [sym_comp_term] = STATE(949),
    [sym_instance_of] = STATE(949),
    [sym_negation] = STATE(949),
    [sym_if_term] = STATE(949),
    [sym_conjunction] = STATE(949),
    [sym_disjunction] = STATE(949),
    [sym_implication] = STATE(949),
    [sym_quantified] = STATE(949),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(949),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_RBRACK] = ACTIONS(525),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [161] = {
    [sym_special_call] = STATE(949),
    [sym_prefix_cast] = STATE(949),
    [sym_unary_expr] = STATE(949),
    [sym_mul_expr] = STATE(949),
    [sym_add_expr] = STATE(949),
    [sym_in_expr] = STATE(949),
    [sym_comp_term] = STATE(949),
    [sym_instance_of] = STATE(949),
    [sym_negation] = STATE(949),
    [sym_if_term] = STATE(949),
    [sym_conjunction] = STATE(949),
    [sym_disjunction] = STATE(949),
    [sym_implication] = STATE(949),
    [sym_quantified] = STATE(949),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(949),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_RBRACK] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [162] = {
    [sym_special_call] = STATE(949),
    [sym_prefix_cast] = STATE(949),
    [sym_unary_expr] = STATE(949),
    [sym_mul_expr] = STATE(949),
    [sym_add_expr] = STATE(949),
    [sym_in_expr] = STATE(949),
    [sym_comp_term] = STATE(949),
    [sym_instance_of] = STATE(949),
    [sym_negation] = STATE(949),
    [sym_if_term] = STATE(949),
    [sym_conjunction] = STATE(949),
    [sym_disjunction] = STATE(949),
    [sym_implication] = STATE(949),
    [sym_quantified] = STATE(949),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(949),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_RBRACK] = ACTIONS(529),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [163] = {
    [sym_special_call] = STATE(367),
    [sym_prefix_cast] = STATE(367),
    [sym_unary_expr] = STATE(367),
    [sym_mul_expr] = STATE(367),
    [sym_add_expr] = STATE(367),
    [sym_in_expr] = STATE(367),
    [sym_comp_term] = STATE(367),
    [sym_instance_of] = STATE(367),
    [sym_negation] = STATE(367),
    [sym_if_term] = STATE(367),
    [sym_conjunction] = STATE(367),
    [sym_disjunction] = STATE(367),
    [sym_implication] = STATE(367),
    [sym_quantified] = STATE(367),
    [sym_quantifier] = STATE(1865),
    [sym_call_or_unqual_agg_expr] = STATE(517),
    [sym_qualified_expr] = STATE(517),
    [sym_super_ref] = STATE(517),
    [sym_aggregate] = STATE(517),
    [sym_range] = STATE(517),
    [sym_set_literal] = STATE(517),
    [sym_par_expr] = STATE(517),
    [sym_expr_annotation] = STATE(517),
    [sym__exprOrTerm] = STATE(367),
    [sym__primary] = STATE(517),
    [sym_literal] = STATE(517),
    [sym_bool] = STATE(513),
    [sym_variable] = STATE(517),
    [sym_unop] = STATE(297),
    [sym_orderBy] = STATE(1196),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2015),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(421),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1866),
    [sym_aritylessPredicateExpr] = STATE(1477),
    [sym_varName] = STATE(598),
    [sym_aggId] = STATE(1778),
    [sym__lower_id] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(469),
    [anon_sym_not] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [sym_specialId] = ACTIONS(475),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(479),
    [sym_integer] = ACTIONS(481),
    [sym_float] = ACTIONS(483),
    [sym_string] = ACTIONS(483),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(485),
    [sym_result] = ACTIONS(487),
    [sym_super] = ACTIONS(489),
    [sym_this] = ACTIONS(487),
    [sym_true] = ACTIONS(485),
  },
  [164] = {
    [sym_special_call] = STATE(949),
    [sym_prefix_cast] = STATE(949),
    [sym_unary_expr] = STATE(949),
    [sym_mul_expr] = STATE(949),
    [sym_add_expr] = STATE(949),
    [sym_in_expr] = STATE(949),
    [sym_comp_term] = STATE(949),
    [sym_instance_of] = STATE(949),
    [sym_negation] = STATE(949),
    [sym_if_term] = STATE(949),
    [sym_conjunction] = STATE(949),
    [sym_disjunction] = STATE(949),
    [sym_implication] = STATE(949),
    [sym_quantified] = STATE(949),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(949),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_RBRACK] = ACTIONS(531),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [165] = {
    [sym_special_call] = STATE(371),
    [sym_prefix_cast] = STATE(371),
    [sym_unary_expr] = STATE(371),
    [sym_mul_expr] = STATE(371),
    [sym_add_expr] = STATE(371),
    [sym_in_expr] = STATE(371),
    [sym_comp_term] = STATE(371),
    [sym_instance_of] = STATE(371),
    [sym_negation] = STATE(371),
    [sym_if_term] = STATE(371),
    [sym_conjunction] = STATE(371),
    [sym_disjunction] = STATE(371),
    [sym_implication] = STATE(371),
    [sym_quantified] = STATE(371),
    [sym_quantifier] = STATE(1919),
    [sym_call_or_unqual_agg_expr] = STATE(560),
    [sym_qualified_expr] = STATE(560),
    [sym_super_ref] = STATE(560),
    [sym_aggregate] = STATE(560),
    [sym_range] = STATE(560),
    [sym_set_literal] = STATE(560),
    [sym_par_expr] = STATE(560),
    [sym_expr_annotation] = STATE(560),
    [sym__exprOrTerm] = STATE(371),
    [sym__primary] = STATE(560),
    [sym_literal] = STATE(560),
    [sym_bool] = STATE(556),
    [sym_variable] = STATE(560),
    [sym_unop] = STATE(183),
    [sym_orderBy] = STATE(1221),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2017),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(420),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1920),
    [sym_aritylessPredicateExpr] = STATE(1484),
    [sym_varName] = STATE(558),
    [sym_aggId] = STATE(1789),
    [sym__lower_id] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(505),
    [sym_specialId] = ACTIONS(507),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(509),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(511),
    [sym_integer] = ACTIONS(513),
    [sym_float] = ACTIONS(515),
    [sym_string] = ACTIONS(515),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(517),
    [sym_result] = ACTIONS(519),
    [sym_super] = ACTIONS(521),
    [sym_this] = ACTIONS(519),
    [sym_true] = ACTIONS(517),
  },
  [166] = {
    [sym_special_call] = STATE(819),
    [sym_prefix_cast] = STATE(819),
    [sym_unary_expr] = STATE(819),
    [sym_mul_expr] = STATE(819),
    [sym_add_expr] = STATE(819),
    [sym_in_expr] = STATE(819),
    [sym_comp_term] = STATE(819),
    [sym_instance_of] = STATE(819),
    [sym_negation] = STATE(819),
    [sym_if_term] = STATE(819),
    [sym_conjunction] = STATE(819),
    [sym_disjunction] = STATE(819),
    [sym_implication] = STATE(819),
    [sym_quantified] = STATE(819),
    [sym_quantifier] = STATE(1892),
    [sym_call_or_unqual_agg_expr] = STATE(1014),
    [sym_qualified_expr] = STATE(1014),
    [sym_super_ref] = STATE(1014),
    [sym_aggregate] = STATE(1014),
    [sym_range] = STATE(1014),
    [sym_set_literal] = STATE(1014),
    [sym_par_expr] = STATE(1014),
    [sym_expr_annotation] = STATE(1014),
    [sym__exprOrTerm] = STATE(819),
    [sym__primary] = STATE(1014),
    [sym_literal] = STATE(1014),
    [sym_bool] = STATE(1007),
    [sym_variable] = STATE(1014),
    [sym_unop] = STATE(174),
    [sym_orderBy] = STATE(1781),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2016),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(871),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1893),
    [sym_aritylessPredicateExpr] = STATE(1475),
    [sym_varName] = STATE(1012),
    [sym_aggId] = STATE(1761),
    [sym__lower_id] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_not] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(539),
    [sym_specialId] = ACTIONS(541),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(543),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(545),
    [sym_integer] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(551),
    [sym_result] = ACTIONS(553),
    [sym_super] = ACTIONS(555),
    [sym_this] = ACTIONS(553),
    [sym_true] = ACTIONS(551),
  },
  [167] = {
    [sym_special_call] = STATE(819),
    [sym_prefix_cast] = STATE(819),
    [sym_unary_expr] = STATE(819),
    [sym_mul_expr] = STATE(819),
    [sym_add_expr] = STATE(819),
    [sym_in_expr] = STATE(819),
    [sym_comp_term] = STATE(819),
    [sym_instance_of] = STATE(819),
    [sym_negation] = STATE(819),
    [sym_if_term] = STATE(819),
    [sym_conjunction] = STATE(819),
    [sym_disjunction] = STATE(819),
    [sym_implication] = STATE(819),
    [sym_quantified] = STATE(819),
    [sym_quantifier] = STATE(1892),
    [sym_call_or_unqual_agg_expr] = STATE(1014),
    [sym_qualified_expr] = STATE(1014),
    [sym_super_ref] = STATE(1014),
    [sym_aggregate] = STATE(1014),
    [sym_range] = STATE(1014),
    [sym_set_literal] = STATE(1014),
    [sym_par_expr] = STATE(1014),
    [sym_expr_annotation] = STATE(1014),
    [sym__exprOrTerm] = STATE(819),
    [sym__primary] = STATE(1014),
    [sym_literal] = STATE(1014),
    [sym_bool] = STATE(1007),
    [sym_variable] = STATE(1014),
    [sym_unop] = STATE(174),
    [sym_orderBy] = STATE(1708),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2016),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(871),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1893),
    [sym_aritylessPredicateExpr] = STATE(1475),
    [sym_varName] = STATE(1012),
    [sym_aggId] = STATE(1761),
    [sym__lower_id] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_not] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(539),
    [sym_specialId] = ACTIONS(541),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(543),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(545),
    [sym_integer] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(551),
    [sym_result] = ACTIONS(553),
    [sym_super] = ACTIONS(555),
    [sym_this] = ACTIONS(553),
    [sym_true] = ACTIONS(551),
  },
  [168] = {
    [sym_special_call] = STATE(949),
    [sym_prefix_cast] = STATE(949),
    [sym_unary_expr] = STATE(949),
    [sym_mul_expr] = STATE(949),
    [sym_add_expr] = STATE(949),
    [sym_in_expr] = STATE(949),
    [sym_comp_term] = STATE(949),
    [sym_instance_of] = STATE(949),
    [sym_negation] = STATE(949),
    [sym_if_term] = STATE(949),
    [sym_conjunction] = STATE(949),
    [sym_disjunction] = STATE(949),
    [sym_implication] = STATE(949),
    [sym_quantified] = STATE(949),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(949),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_RBRACK] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [169] = {
    [sym_special_call] = STATE(949),
    [sym_prefix_cast] = STATE(949),
    [sym_unary_expr] = STATE(949),
    [sym_mul_expr] = STATE(949),
    [sym_add_expr] = STATE(949),
    [sym_in_expr] = STATE(949),
    [sym_comp_term] = STATE(949),
    [sym_instance_of] = STATE(949),
    [sym_negation] = STATE(949),
    [sym_if_term] = STATE(949),
    [sym_conjunction] = STATE(949),
    [sym_disjunction] = STATE(949),
    [sym_implication] = STATE(949),
    [sym_quantified] = STATE(949),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(949),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [170] = {
    [sym_special_call] = STATE(949),
    [sym_prefix_cast] = STATE(949),
    [sym_unary_expr] = STATE(949),
    [sym_mul_expr] = STATE(949),
    [sym_add_expr] = STATE(949),
    [sym_in_expr] = STATE(949),
    [sym_comp_term] = STATE(949),
    [sym_instance_of] = STATE(949),
    [sym_negation] = STATE(949),
    [sym_if_term] = STATE(949),
    [sym_conjunction] = STATE(949),
    [sym_disjunction] = STATE(949),
    [sym_implication] = STATE(949),
    [sym_quantified] = STATE(949),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(949),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_RBRACK] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [171] = {
    [sym_special_call] = STATE(847),
    [sym_prefix_cast] = STATE(847),
    [sym_unary_expr] = STATE(847),
    [sym_mul_expr] = STATE(847),
    [sym_add_expr] = STATE(847),
    [sym_in_expr] = STATE(847),
    [sym_comp_term] = STATE(847),
    [sym_instance_of] = STATE(847),
    [sym_negation] = STATE(847),
    [sym_if_term] = STATE(847),
    [sym_conjunction] = STATE(847),
    [sym_disjunction] = STATE(847),
    [sym_implication] = STATE(847),
    [sym_quantified] = STATE(847),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(847),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_asExpr] = STATE(1657),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1839),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [172] = {
    [sym_special_call] = STATE(949),
    [sym_prefix_cast] = STATE(949),
    [sym_unary_expr] = STATE(949),
    [sym_mul_expr] = STATE(949),
    [sym_add_expr] = STATE(949),
    [sym_in_expr] = STATE(949),
    [sym_comp_term] = STATE(949),
    [sym_instance_of] = STATE(949),
    [sym_negation] = STATE(949),
    [sym_if_term] = STATE(949),
    [sym_conjunction] = STATE(949),
    [sym_disjunction] = STATE(949),
    [sym_implication] = STATE(949),
    [sym_quantified] = STATE(949),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(949),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_RBRACK] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [173] = {
    [sym_special_call] = STATE(1162),
    [sym_prefix_cast] = STATE(1162),
    [sym_unary_expr] = STATE(1162),
    [sym_mul_expr] = STATE(1162),
    [sym_add_expr] = STATE(1162),
    [sym_in_expr] = STATE(1162),
    [sym_comp_term] = STATE(1162),
    [sym_instance_of] = STATE(1162),
    [sym_negation] = STATE(1162),
    [sym_if_term] = STATE(1162),
    [sym_conjunction] = STATE(1162),
    [sym_disjunction] = STATE(1162),
    [sym_implication] = STATE(1162),
    [sym_quantified] = STATE(1162),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1162),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [174] = {
    [sym_special_call] = STATE(821),
    [sym_prefix_cast] = STATE(821),
    [sym_unary_expr] = STATE(821),
    [sym_mul_expr] = STATE(821),
    [sym_add_expr] = STATE(821),
    [sym_in_expr] = STATE(821),
    [sym_comp_term] = STATE(821),
    [sym_instance_of] = STATE(821),
    [sym_negation] = STATE(821),
    [sym_if_term] = STATE(821),
    [sym_conjunction] = STATE(821),
    [sym_disjunction] = STATE(821),
    [sym_implication] = STATE(821),
    [sym_quantified] = STATE(821),
    [sym_quantifier] = STATE(1892),
    [sym_call_or_unqual_agg_expr] = STATE(1014),
    [sym_qualified_expr] = STATE(1014),
    [sym_super_ref] = STATE(1014),
    [sym_aggregate] = STATE(1014),
    [sym_range] = STATE(1014),
    [sym_set_literal] = STATE(1014),
    [sym_par_expr] = STATE(1014),
    [sym_expr_annotation] = STATE(1014),
    [sym__exprOrTerm] = STATE(821),
    [sym__primary] = STATE(1014),
    [sym_literal] = STATE(1014),
    [sym_bool] = STATE(1007),
    [sym_variable] = STATE(1014),
    [sym_unop] = STATE(174),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2016),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(871),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1893),
    [sym_aritylessPredicateExpr] = STATE(1475),
    [sym_varName] = STATE(1012),
    [sym_aggId] = STATE(1761),
    [sym__lower_id] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_not] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(539),
    [sym_specialId] = ACTIONS(541),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(543),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(545),
    [sym_integer] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(551),
    [sym_result] = ACTIONS(553),
    [sym_super] = ACTIONS(555),
    [sym_this] = ACTIONS(553),
    [sym_true] = ACTIONS(551),
  },
  [175] = {
    [sym_special_call] = STATE(822),
    [sym_prefix_cast] = STATE(822),
    [sym_unary_expr] = STATE(822),
    [sym_mul_expr] = STATE(822),
    [sym_add_expr] = STATE(822),
    [sym_in_expr] = STATE(822),
    [sym_comp_term] = STATE(822),
    [sym_instance_of] = STATE(822),
    [sym_negation] = STATE(822),
    [sym_if_term] = STATE(822),
    [sym_conjunction] = STATE(822),
    [sym_disjunction] = STATE(822),
    [sym_implication] = STATE(822),
    [sym_quantified] = STATE(822),
    [sym_quantifier] = STATE(1892),
    [sym_call_or_unqual_agg_expr] = STATE(1014),
    [sym_qualified_expr] = STATE(1014),
    [sym_super_ref] = STATE(1014),
    [sym_aggregate] = STATE(1014),
    [sym_range] = STATE(1014),
    [sym_set_literal] = STATE(1014),
    [sym_par_expr] = STATE(1014),
    [sym_expr_annotation] = STATE(1014),
    [sym__exprOrTerm] = STATE(822),
    [sym__primary] = STATE(1014),
    [sym_literal] = STATE(1014),
    [sym_bool] = STATE(1007),
    [sym_variable] = STATE(1014),
    [sym_unop] = STATE(174),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2016),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(871),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1893),
    [sym_aritylessPredicateExpr] = STATE(1475),
    [sym_varName] = STATE(1012),
    [sym_aggId] = STATE(1761),
    [sym__lower_id] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_not] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(539),
    [sym_specialId] = ACTIONS(541),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(543),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(545),
    [sym_integer] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(551),
    [sym_result] = ACTIONS(553),
    [sym_super] = ACTIONS(555),
    [sym_this] = ACTIONS(553),
    [sym_true] = ACTIONS(551),
  },
  [176] = {
    [sym_special_call] = STATE(823),
    [sym_prefix_cast] = STATE(823),
    [sym_unary_expr] = STATE(823),
    [sym_mul_expr] = STATE(823),
    [sym_add_expr] = STATE(823),
    [sym_in_expr] = STATE(823),
    [sym_comp_term] = STATE(823),
    [sym_instance_of] = STATE(823),
    [sym_negation] = STATE(823),
    [sym_if_term] = STATE(823),
    [sym_conjunction] = STATE(823),
    [sym_disjunction] = STATE(823),
    [sym_implication] = STATE(823),
    [sym_quantified] = STATE(823),
    [sym_quantifier] = STATE(1892),
    [sym_call_or_unqual_agg_expr] = STATE(1014),
    [sym_qualified_expr] = STATE(1014),
    [sym_super_ref] = STATE(1014),
    [sym_aggregate] = STATE(1014),
    [sym_range] = STATE(1014),
    [sym_set_literal] = STATE(1014),
    [sym_par_expr] = STATE(1014),
    [sym_expr_annotation] = STATE(1014),
    [sym__exprOrTerm] = STATE(823),
    [sym__primary] = STATE(1014),
    [sym_literal] = STATE(1014),
    [sym_bool] = STATE(1007),
    [sym_variable] = STATE(1014),
    [sym_unop] = STATE(174),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2016),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(871),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1893),
    [sym_aritylessPredicateExpr] = STATE(1475),
    [sym_varName] = STATE(1012),
    [sym_aggId] = STATE(1761),
    [sym__lower_id] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_not] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(539),
    [sym_specialId] = ACTIONS(541),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(543),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(545),
    [sym_integer] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(551),
    [sym_result] = ACTIONS(553),
    [sym_super] = ACTIONS(555),
    [sym_this] = ACTIONS(553),
    [sym_true] = ACTIONS(551),
  },
  [177] = {
    [sym_special_call] = STATE(824),
    [sym_prefix_cast] = STATE(824),
    [sym_unary_expr] = STATE(824),
    [sym_mul_expr] = STATE(824),
    [sym_add_expr] = STATE(824),
    [sym_in_expr] = STATE(824),
    [sym_comp_term] = STATE(824),
    [sym_instance_of] = STATE(824),
    [sym_negation] = STATE(824),
    [sym_if_term] = STATE(824),
    [sym_conjunction] = STATE(824),
    [sym_disjunction] = STATE(824),
    [sym_implication] = STATE(824),
    [sym_quantified] = STATE(824),
    [sym_quantifier] = STATE(1892),
    [sym_call_or_unqual_agg_expr] = STATE(1014),
    [sym_qualified_expr] = STATE(1014),
    [sym_super_ref] = STATE(1014),
    [sym_aggregate] = STATE(1014),
    [sym_range] = STATE(1014),
    [sym_set_literal] = STATE(1014),
    [sym_par_expr] = STATE(1014),
    [sym_expr_annotation] = STATE(1014),
    [sym__exprOrTerm] = STATE(824),
    [sym__primary] = STATE(1014),
    [sym_literal] = STATE(1014),
    [sym_bool] = STATE(1007),
    [sym_variable] = STATE(1014),
    [sym_unop] = STATE(174),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2016),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(871),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1893),
    [sym_aritylessPredicateExpr] = STATE(1475),
    [sym_varName] = STATE(1012),
    [sym_aggId] = STATE(1761),
    [sym__lower_id] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_not] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(539),
    [sym_specialId] = ACTIONS(541),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(543),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(545),
    [sym_integer] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(551),
    [sym_result] = ACTIONS(553),
    [sym_super] = ACTIONS(555),
    [sym_this] = ACTIONS(553),
    [sym_true] = ACTIONS(551),
  },
  [178] = {
    [sym_special_call] = STATE(825),
    [sym_prefix_cast] = STATE(825),
    [sym_unary_expr] = STATE(825),
    [sym_mul_expr] = STATE(825),
    [sym_add_expr] = STATE(825),
    [sym_in_expr] = STATE(825),
    [sym_comp_term] = STATE(825),
    [sym_instance_of] = STATE(825),
    [sym_negation] = STATE(825),
    [sym_if_term] = STATE(825),
    [sym_conjunction] = STATE(825),
    [sym_disjunction] = STATE(825),
    [sym_implication] = STATE(825),
    [sym_quantified] = STATE(825),
    [sym_quantifier] = STATE(1892),
    [sym_call_or_unqual_agg_expr] = STATE(1014),
    [sym_qualified_expr] = STATE(1014),
    [sym_super_ref] = STATE(1014),
    [sym_aggregate] = STATE(1014),
    [sym_range] = STATE(1014),
    [sym_set_literal] = STATE(1014),
    [sym_par_expr] = STATE(1014),
    [sym_expr_annotation] = STATE(1014),
    [sym__exprOrTerm] = STATE(825),
    [sym__primary] = STATE(1014),
    [sym_literal] = STATE(1014),
    [sym_bool] = STATE(1007),
    [sym_variable] = STATE(1014),
    [sym_unop] = STATE(174),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2016),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(871),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1893),
    [sym_aritylessPredicateExpr] = STATE(1475),
    [sym_varName] = STATE(1012),
    [sym_aggId] = STATE(1761),
    [sym__lower_id] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_not] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(539),
    [sym_specialId] = ACTIONS(541),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(543),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(545),
    [sym_integer] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(551),
    [sym_result] = ACTIONS(553),
    [sym_super] = ACTIONS(555),
    [sym_this] = ACTIONS(553),
    [sym_true] = ACTIONS(551),
  },
  [179] = {
    [sym_special_call] = STATE(826),
    [sym_prefix_cast] = STATE(826),
    [sym_unary_expr] = STATE(826),
    [sym_mul_expr] = STATE(826),
    [sym_add_expr] = STATE(826),
    [sym_in_expr] = STATE(826),
    [sym_comp_term] = STATE(826),
    [sym_instance_of] = STATE(826),
    [sym_negation] = STATE(826),
    [sym_if_term] = STATE(826),
    [sym_conjunction] = STATE(826),
    [sym_disjunction] = STATE(826),
    [sym_implication] = STATE(826),
    [sym_quantified] = STATE(826),
    [sym_quantifier] = STATE(1892),
    [sym_call_or_unqual_agg_expr] = STATE(1014),
    [sym_qualified_expr] = STATE(1014),
    [sym_super_ref] = STATE(1014),
    [sym_aggregate] = STATE(1014),
    [sym_range] = STATE(1014),
    [sym_set_literal] = STATE(1014),
    [sym_par_expr] = STATE(1014),
    [sym_expr_annotation] = STATE(1014),
    [sym__exprOrTerm] = STATE(826),
    [sym__primary] = STATE(1014),
    [sym_literal] = STATE(1014),
    [sym_bool] = STATE(1007),
    [sym_variable] = STATE(1014),
    [sym_unop] = STATE(174),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2016),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(871),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1893),
    [sym_aritylessPredicateExpr] = STATE(1475),
    [sym_varName] = STATE(1012),
    [sym_aggId] = STATE(1761),
    [sym__lower_id] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_not] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(539),
    [sym_specialId] = ACTIONS(541),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(543),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(545),
    [sym_integer] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(551),
    [sym_result] = ACTIONS(553),
    [sym_super] = ACTIONS(555),
    [sym_this] = ACTIONS(553),
    [sym_true] = ACTIONS(551),
  },
  [180] = {
    [sym_special_call] = STATE(827),
    [sym_prefix_cast] = STATE(827),
    [sym_unary_expr] = STATE(827),
    [sym_mul_expr] = STATE(827),
    [sym_add_expr] = STATE(827),
    [sym_in_expr] = STATE(827),
    [sym_comp_term] = STATE(827),
    [sym_instance_of] = STATE(827),
    [sym_negation] = STATE(827),
    [sym_if_term] = STATE(827),
    [sym_conjunction] = STATE(827),
    [sym_disjunction] = STATE(827),
    [sym_implication] = STATE(827),
    [sym_quantified] = STATE(827),
    [sym_quantifier] = STATE(1892),
    [sym_call_or_unqual_agg_expr] = STATE(1014),
    [sym_qualified_expr] = STATE(1014),
    [sym_super_ref] = STATE(1014),
    [sym_aggregate] = STATE(1014),
    [sym_range] = STATE(1014),
    [sym_set_literal] = STATE(1014),
    [sym_par_expr] = STATE(1014),
    [sym_expr_annotation] = STATE(1014),
    [sym__exprOrTerm] = STATE(827),
    [sym__primary] = STATE(1014),
    [sym_literal] = STATE(1014),
    [sym_bool] = STATE(1007),
    [sym_variable] = STATE(1014),
    [sym_unop] = STATE(174),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2016),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(871),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1893),
    [sym_aritylessPredicateExpr] = STATE(1475),
    [sym_varName] = STATE(1012),
    [sym_aggId] = STATE(1761),
    [sym__lower_id] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_not] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(539),
    [sym_specialId] = ACTIONS(541),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(543),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(545),
    [sym_integer] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(551),
    [sym_result] = ACTIONS(553),
    [sym_super] = ACTIONS(555),
    [sym_this] = ACTIONS(553),
    [sym_true] = ACTIONS(551),
  },
  [181] = {
    [sym_special_call] = STATE(828),
    [sym_prefix_cast] = STATE(828),
    [sym_unary_expr] = STATE(828),
    [sym_mul_expr] = STATE(828),
    [sym_add_expr] = STATE(828),
    [sym_in_expr] = STATE(828),
    [sym_comp_term] = STATE(828),
    [sym_instance_of] = STATE(828),
    [sym_negation] = STATE(828),
    [sym_if_term] = STATE(828),
    [sym_conjunction] = STATE(828),
    [sym_disjunction] = STATE(828),
    [sym_implication] = STATE(828),
    [sym_quantified] = STATE(828),
    [sym_quantifier] = STATE(1892),
    [sym_call_or_unqual_agg_expr] = STATE(1014),
    [sym_qualified_expr] = STATE(1014),
    [sym_super_ref] = STATE(1014),
    [sym_aggregate] = STATE(1014),
    [sym_range] = STATE(1014),
    [sym_set_literal] = STATE(1014),
    [sym_par_expr] = STATE(1014),
    [sym_expr_annotation] = STATE(1014),
    [sym__exprOrTerm] = STATE(828),
    [sym__primary] = STATE(1014),
    [sym_literal] = STATE(1014),
    [sym_bool] = STATE(1007),
    [sym_variable] = STATE(1014),
    [sym_unop] = STATE(174),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2016),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(871),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1893),
    [sym_aritylessPredicateExpr] = STATE(1475),
    [sym_varName] = STATE(1012),
    [sym_aggId] = STATE(1761),
    [sym__lower_id] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_not] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(539),
    [sym_specialId] = ACTIONS(541),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(543),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(545),
    [sym_integer] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(551),
    [sym_result] = ACTIONS(553),
    [sym_super] = ACTIONS(555),
    [sym_this] = ACTIONS(553),
    [sym_true] = ACTIONS(551),
  },
  [182] = {
    [sym_special_call] = STATE(829),
    [sym_prefix_cast] = STATE(829),
    [sym_unary_expr] = STATE(829),
    [sym_mul_expr] = STATE(829),
    [sym_add_expr] = STATE(829),
    [sym_in_expr] = STATE(829),
    [sym_comp_term] = STATE(829),
    [sym_instance_of] = STATE(829),
    [sym_negation] = STATE(829),
    [sym_if_term] = STATE(829),
    [sym_conjunction] = STATE(829),
    [sym_disjunction] = STATE(829),
    [sym_implication] = STATE(829),
    [sym_quantified] = STATE(829),
    [sym_quantifier] = STATE(1892),
    [sym_call_or_unqual_agg_expr] = STATE(1014),
    [sym_qualified_expr] = STATE(1014),
    [sym_super_ref] = STATE(1014),
    [sym_aggregate] = STATE(1014),
    [sym_range] = STATE(1014),
    [sym_set_literal] = STATE(1014),
    [sym_par_expr] = STATE(1014),
    [sym_expr_annotation] = STATE(1014),
    [sym__exprOrTerm] = STATE(829),
    [sym__primary] = STATE(1014),
    [sym_literal] = STATE(1014),
    [sym_bool] = STATE(1007),
    [sym_variable] = STATE(1014),
    [sym_unop] = STATE(174),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2016),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(871),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1893),
    [sym_aritylessPredicateExpr] = STATE(1475),
    [sym_varName] = STATE(1012),
    [sym_aggId] = STATE(1761),
    [sym__lower_id] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_not] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(539),
    [sym_specialId] = ACTIONS(541),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(543),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(545),
    [sym_integer] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(551),
    [sym_result] = ACTIONS(553),
    [sym_super] = ACTIONS(555),
    [sym_this] = ACTIONS(553),
    [sym_true] = ACTIONS(551),
  },
  [183] = {
    [sym_special_call] = STATE(376),
    [sym_prefix_cast] = STATE(376),
    [sym_unary_expr] = STATE(376),
    [sym_mul_expr] = STATE(376),
    [sym_add_expr] = STATE(376),
    [sym_in_expr] = STATE(376),
    [sym_comp_term] = STATE(376),
    [sym_instance_of] = STATE(376),
    [sym_negation] = STATE(376),
    [sym_if_term] = STATE(376),
    [sym_conjunction] = STATE(376),
    [sym_disjunction] = STATE(376),
    [sym_implication] = STATE(376),
    [sym_quantified] = STATE(376),
    [sym_quantifier] = STATE(1919),
    [sym_call_or_unqual_agg_expr] = STATE(560),
    [sym_qualified_expr] = STATE(560),
    [sym_super_ref] = STATE(560),
    [sym_aggregate] = STATE(560),
    [sym_range] = STATE(560),
    [sym_set_literal] = STATE(560),
    [sym_par_expr] = STATE(560),
    [sym_expr_annotation] = STATE(560),
    [sym__exprOrTerm] = STATE(376),
    [sym__primary] = STATE(560),
    [sym_literal] = STATE(560),
    [sym_bool] = STATE(556),
    [sym_variable] = STATE(560),
    [sym_unop] = STATE(183),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2017),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(420),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1920),
    [sym_aritylessPredicateExpr] = STATE(1484),
    [sym_varName] = STATE(558),
    [sym_aggId] = STATE(1789),
    [sym__lower_id] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(505),
    [sym_specialId] = ACTIONS(507),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(509),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(511),
    [sym_integer] = ACTIONS(513),
    [sym_float] = ACTIONS(515),
    [sym_string] = ACTIONS(515),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(517),
    [sym_result] = ACTIONS(519),
    [sym_super] = ACTIONS(521),
    [sym_this] = ACTIONS(519),
    [sym_true] = ACTIONS(517),
  },
  [184] = {
    [sym_special_call] = STATE(394),
    [sym_prefix_cast] = STATE(394),
    [sym_unary_expr] = STATE(394),
    [sym_mul_expr] = STATE(394),
    [sym_add_expr] = STATE(394),
    [sym_in_expr] = STATE(394),
    [sym_comp_term] = STATE(394),
    [sym_instance_of] = STATE(394),
    [sym_negation] = STATE(394),
    [sym_if_term] = STATE(394),
    [sym_conjunction] = STATE(394),
    [sym_disjunction] = STATE(394),
    [sym_implication] = STATE(394),
    [sym_quantified] = STATE(394),
    [sym_quantifier] = STATE(1919),
    [sym_call_or_unqual_agg_expr] = STATE(560),
    [sym_qualified_expr] = STATE(560),
    [sym_super_ref] = STATE(560),
    [sym_aggregate] = STATE(560),
    [sym_range] = STATE(560),
    [sym_set_literal] = STATE(560),
    [sym_par_expr] = STATE(560),
    [sym_expr_annotation] = STATE(560),
    [sym__exprOrTerm] = STATE(394),
    [sym__primary] = STATE(560),
    [sym_literal] = STATE(560),
    [sym_bool] = STATE(556),
    [sym_variable] = STATE(560),
    [sym_unop] = STATE(183),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2017),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(420),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1920),
    [sym_aritylessPredicateExpr] = STATE(1484),
    [sym_varName] = STATE(558),
    [sym_aggId] = STATE(1789),
    [sym__lower_id] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(505),
    [sym_specialId] = ACTIONS(507),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(509),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(511),
    [sym_integer] = ACTIONS(513),
    [sym_float] = ACTIONS(515),
    [sym_string] = ACTIONS(515),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(517),
    [sym_result] = ACTIONS(519),
    [sym_super] = ACTIONS(521),
    [sym_this] = ACTIONS(519),
    [sym_true] = ACTIONS(517),
  },
  [185] = {
    [sym_special_call] = STATE(398),
    [sym_prefix_cast] = STATE(398),
    [sym_unary_expr] = STATE(398),
    [sym_mul_expr] = STATE(398),
    [sym_add_expr] = STATE(398),
    [sym_in_expr] = STATE(398),
    [sym_comp_term] = STATE(398),
    [sym_instance_of] = STATE(398),
    [sym_negation] = STATE(398),
    [sym_if_term] = STATE(398),
    [sym_conjunction] = STATE(398),
    [sym_disjunction] = STATE(398),
    [sym_implication] = STATE(398),
    [sym_quantified] = STATE(398),
    [sym_quantifier] = STATE(1919),
    [sym_call_or_unqual_agg_expr] = STATE(560),
    [sym_qualified_expr] = STATE(560),
    [sym_super_ref] = STATE(560),
    [sym_aggregate] = STATE(560),
    [sym_range] = STATE(560),
    [sym_set_literal] = STATE(560),
    [sym_par_expr] = STATE(560),
    [sym_expr_annotation] = STATE(560),
    [sym__exprOrTerm] = STATE(398),
    [sym__primary] = STATE(560),
    [sym_literal] = STATE(560),
    [sym_bool] = STATE(556),
    [sym_variable] = STATE(560),
    [sym_unop] = STATE(183),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2017),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(420),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1920),
    [sym_aritylessPredicateExpr] = STATE(1484),
    [sym_varName] = STATE(558),
    [sym_aggId] = STATE(1789),
    [sym__lower_id] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(505),
    [sym_specialId] = ACTIONS(507),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(509),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(511),
    [sym_integer] = ACTIONS(513),
    [sym_float] = ACTIONS(515),
    [sym_string] = ACTIONS(515),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(517),
    [sym_result] = ACTIONS(519),
    [sym_super] = ACTIONS(521),
    [sym_this] = ACTIONS(519),
    [sym_true] = ACTIONS(517),
  },
  [186] = {
    [sym_special_call] = STATE(406),
    [sym_prefix_cast] = STATE(406),
    [sym_unary_expr] = STATE(406),
    [sym_mul_expr] = STATE(406),
    [sym_add_expr] = STATE(406),
    [sym_in_expr] = STATE(406),
    [sym_comp_term] = STATE(406),
    [sym_instance_of] = STATE(406),
    [sym_negation] = STATE(406),
    [sym_if_term] = STATE(406),
    [sym_conjunction] = STATE(406),
    [sym_disjunction] = STATE(406),
    [sym_implication] = STATE(406),
    [sym_quantified] = STATE(406),
    [sym_quantifier] = STATE(1919),
    [sym_call_or_unqual_agg_expr] = STATE(560),
    [sym_qualified_expr] = STATE(560),
    [sym_super_ref] = STATE(560),
    [sym_aggregate] = STATE(560),
    [sym_range] = STATE(560),
    [sym_set_literal] = STATE(560),
    [sym_par_expr] = STATE(560),
    [sym_expr_annotation] = STATE(560),
    [sym__exprOrTerm] = STATE(406),
    [sym__primary] = STATE(560),
    [sym_literal] = STATE(560),
    [sym_bool] = STATE(556),
    [sym_variable] = STATE(560),
    [sym_unop] = STATE(183),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2017),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(420),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1920),
    [sym_aritylessPredicateExpr] = STATE(1484),
    [sym_varName] = STATE(558),
    [sym_aggId] = STATE(1789),
    [sym__lower_id] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(505),
    [sym_specialId] = ACTIONS(507),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(509),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(511),
    [sym_integer] = ACTIONS(513),
    [sym_float] = ACTIONS(515),
    [sym_string] = ACTIONS(515),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(517),
    [sym_result] = ACTIONS(519),
    [sym_super] = ACTIONS(521),
    [sym_this] = ACTIONS(519),
    [sym_true] = ACTIONS(517),
  },
  [187] = {
    [sym_special_call] = STATE(411),
    [sym_prefix_cast] = STATE(411),
    [sym_unary_expr] = STATE(411),
    [sym_mul_expr] = STATE(411),
    [sym_add_expr] = STATE(411),
    [sym_in_expr] = STATE(411),
    [sym_comp_term] = STATE(411),
    [sym_instance_of] = STATE(411),
    [sym_negation] = STATE(411),
    [sym_if_term] = STATE(411),
    [sym_conjunction] = STATE(411),
    [sym_disjunction] = STATE(411),
    [sym_implication] = STATE(411),
    [sym_quantified] = STATE(411),
    [sym_quantifier] = STATE(1919),
    [sym_call_or_unqual_agg_expr] = STATE(560),
    [sym_qualified_expr] = STATE(560),
    [sym_super_ref] = STATE(560),
    [sym_aggregate] = STATE(560),
    [sym_range] = STATE(560),
    [sym_set_literal] = STATE(560),
    [sym_par_expr] = STATE(560),
    [sym_expr_annotation] = STATE(560),
    [sym__exprOrTerm] = STATE(411),
    [sym__primary] = STATE(560),
    [sym_literal] = STATE(560),
    [sym_bool] = STATE(556),
    [sym_variable] = STATE(560),
    [sym_unop] = STATE(183),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2017),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(420),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1920),
    [sym_aritylessPredicateExpr] = STATE(1484),
    [sym_varName] = STATE(558),
    [sym_aggId] = STATE(1789),
    [sym__lower_id] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(505),
    [sym_specialId] = ACTIONS(507),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(509),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(511),
    [sym_integer] = ACTIONS(513),
    [sym_float] = ACTIONS(515),
    [sym_string] = ACTIONS(515),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(517),
    [sym_result] = ACTIONS(519),
    [sym_super] = ACTIONS(521),
    [sym_this] = ACTIONS(519),
    [sym_true] = ACTIONS(517),
  },
  [188] = {
    [sym_special_call] = STATE(392),
    [sym_prefix_cast] = STATE(392),
    [sym_unary_expr] = STATE(392),
    [sym_mul_expr] = STATE(392),
    [sym_add_expr] = STATE(392),
    [sym_in_expr] = STATE(392),
    [sym_comp_term] = STATE(392),
    [sym_instance_of] = STATE(392),
    [sym_negation] = STATE(392),
    [sym_if_term] = STATE(392),
    [sym_conjunction] = STATE(392),
    [sym_disjunction] = STATE(392),
    [sym_implication] = STATE(392),
    [sym_quantified] = STATE(392),
    [sym_quantifier] = STATE(1919),
    [sym_call_or_unqual_agg_expr] = STATE(560),
    [sym_qualified_expr] = STATE(560),
    [sym_super_ref] = STATE(560),
    [sym_aggregate] = STATE(560),
    [sym_range] = STATE(560),
    [sym_set_literal] = STATE(560),
    [sym_par_expr] = STATE(560),
    [sym_expr_annotation] = STATE(560),
    [sym__exprOrTerm] = STATE(392),
    [sym__primary] = STATE(560),
    [sym_literal] = STATE(560),
    [sym_bool] = STATE(556),
    [sym_variable] = STATE(560),
    [sym_unop] = STATE(183),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2017),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(420),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1920),
    [sym_aritylessPredicateExpr] = STATE(1484),
    [sym_varName] = STATE(558),
    [sym_aggId] = STATE(1789),
    [sym__lower_id] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(505),
    [sym_specialId] = ACTIONS(507),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(509),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(511),
    [sym_integer] = ACTIONS(513),
    [sym_float] = ACTIONS(515),
    [sym_string] = ACTIONS(515),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(517),
    [sym_result] = ACTIONS(519),
    [sym_super] = ACTIONS(521),
    [sym_this] = ACTIONS(519),
    [sym_true] = ACTIONS(517),
  },
  [189] = {
    [sym_special_call] = STATE(396),
    [sym_prefix_cast] = STATE(396),
    [sym_unary_expr] = STATE(396),
    [sym_mul_expr] = STATE(396),
    [sym_add_expr] = STATE(396),
    [sym_in_expr] = STATE(396),
    [sym_comp_term] = STATE(396),
    [sym_instance_of] = STATE(396),
    [sym_negation] = STATE(396),
    [sym_if_term] = STATE(396),
    [sym_conjunction] = STATE(396),
    [sym_disjunction] = STATE(396),
    [sym_implication] = STATE(396),
    [sym_quantified] = STATE(396),
    [sym_quantifier] = STATE(1919),
    [sym_call_or_unqual_agg_expr] = STATE(560),
    [sym_qualified_expr] = STATE(560),
    [sym_super_ref] = STATE(560),
    [sym_aggregate] = STATE(560),
    [sym_range] = STATE(560),
    [sym_set_literal] = STATE(560),
    [sym_par_expr] = STATE(560),
    [sym_expr_annotation] = STATE(560),
    [sym__exprOrTerm] = STATE(396),
    [sym__primary] = STATE(560),
    [sym_literal] = STATE(560),
    [sym_bool] = STATE(556),
    [sym_variable] = STATE(560),
    [sym_unop] = STATE(183),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2017),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(420),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1920),
    [sym_aritylessPredicateExpr] = STATE(1484),
    [sym_varName] = STATE(558),
    [sym_aggId] = STATE(1789),
    [sym__lower_id] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(505),
    [sym_specialId] = ACTIONS(507),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(509),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(511),
    [sym_integer] = ACTIONS(513),
    [sym_float] = ACTIONS(515),
    [sym_string] = ACTIONS(515),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(517),
    [sym_result] = ACTIONS(519),
    [sym_super] = ACTIONS(521),
    [sym_this] = ACTIONS(519),
    [sym_true] = ACTIONS(517),
  },
  [190] = {
    [sym_special_call] = STATE(377),
    [sym_prefix_cast] = STATE(377),
    [sym_unary_expr] = STATE(377),
    [sym_mul_expr] = STATE(377),
    [sym_add_expr] = STATE(377),
    [sym_in_expr] = STATE(377),
    [sym_comp_term] = STATE(377),
    [sym_instance_of] = STATE(377),
    [sym_negation] = STATE(377),
    [sym_if_term] = STATE(377),
    [sym_conjunction] = STATE(377),
    [sym_disjunction] = STATE(377),
    [sym_implication] = STATE(377),
    [sym_quantified] = STATE(377),
    [sym_quantifier] = STATE(1919),
    [sym_call_or_unqual_agg_expr] = STATE(560),
    [sym_qualified_expr] = STATE(560),
    [sym_super_ref] = STATE(560),
    [sym_aggregate] = STATE(560),
    [sym_range] = STATE(560),
    [sym_set_literal] = STATE(560),
    [sym_par_expr] = STATE(560),
    [sym_expr_annotation] = STATE(560),
    [sym__exprOrTerm] = STATE(377),
    [sym__primary] = STATE(560),
    [sym_literal] = STATE(560),
    [sym_bool] = STATE(556),
    [sym_variable] = STATE(560),
    [sym_unop] = STATE(183),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2017),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(420),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1920),
    [sym_aritylessPredicateExpr] = STATE(1484),
    [sym_varName] = STATE(558),
    [sym_aggId] = STATE(1789),
    [sym__lower_id] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(505),
    [sym_specialId] = ACTIONS(507),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(509),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(511),
    [sym_integer] = ACTIONS(513),
    [sym_float] = ACTIONS(515),
    [sym_string] = ACTIONS(515),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(517),
    [sym_result] = ACTIONS(519),
    [sym_super] = ACTIONS(521),
    [sym_this] = ACTIONS(519),
    [sym_true] = ACTIONS(517),
  },
  [191] = {
    [sym_special_call] = STATE(395),
    [sym_prefix_cast] = STATE(395),
    [sym_unary_expr] = STATE(395),
    [sym_mul_expr] = STATE(395),
    [sym_add_expr] = STATE(395),
    [sym_in_expr] = STATE(395),
    [sym_comp_term] = STATE(395),
    [sym_instance_of] = STATE(395),
    [sym_negation] = STATE(395),
    [sym_if_term] = STATE(395),
    [sym_conjunction] = STATE(395),
    [sym_disjunction] = STATE(395),
    [sym_implication] = STATE(395),
    [sym_quantified] = STATE(395),
    [sym_quantifier] = STATE(1919),
    [sym_call_or_unqual_agg_expr] = STATE(560),
    [sym_qualified_expr] = STATE(560),
    [sym_super_ref] = STATE(560),
    [sym_aggregate] = STATE(560),
    [sym_range] = STATE(560),
    [sym_set_literal] = STATE(560),
    [sym_par_expr] = STATE(560),
    [sym_expr_annotation] = STATE(560),
    [sym__exprOrTerm] = STATE(395),
    [sym__primary] = STATE(560),
    [sym_literal] = STATE(560),
    [sym_bool] = STATE(556),
    [sym_variable] = STATE(560),
    [sym_unop] = STATE(183),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2017),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(420),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1920),
    [sym_aritylessPredicateExpr] = STATE(1484),
    [sym_varName] = STATE(558),
    [sym_aggId] = STATE(1789),
    [sym__lower_id] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(505),
    [sym_specialId] = ACTIONS(507),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(509),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(511),
    [sym_integer] = ACTIONS(513),
    [sym_float] = ACTIONS(515),
    [sym_string] = ACTIONS(515),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(517),
    [sym_result] = ACTIONS(519),
    [sym_super] = ACTIONS(521),
    [sym_this] = ACTIONS(519),
    [sym_true] = ACTIONS(517),
  },
  [192] = {
    [sym_special_call] = STATE(791),
    [sym_prefix_cast] = STATE(791),
    [sym_unary_expr] = STATE(791),
    [sym_mul_expr] = STATE(791),
    [sym_add_expr] = STATE(791),
    [sym_in_expr] = STATE(791),
    [sym_comp_term] = STATE(791),
    [sym_instance_of] = STATE(791),
    [sym_negation] = STATE(791),
    [sym_if_term] = STATE(791),
    [sym_conjunction] = STATE(791),
    [sym_disjunction] = STATE(791),
    [sym_implication] = STATE(791),
    [sym_quantified] = STATE(791),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(791),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [193] = {
    [sym_special_call] = STATE(403),
    [sym_prefix_cast] = STATE(403),
    [sym_unary_expr] = STATE(403),
    [sym_mul_expr] = STATE(403),
    [sym_add_expr] = STATE(403),
    [sym_in_expr] = STATE(403),
    [sym_comp_term] = STATE(403),
    [sym_instance_of] = STATE(403),
    [sym_negation] = STATE(403),
    [sym_if_term] = STATE(403),
    [sym_conjunction] = STATE(403),
    [sym_disjunction] = STATE(403),
    [sym_implication] = STATE(403),
    [sym_quantified] = STATE(403),
    [sym_quantifier] = STATE(1995),
    [sym_call_or_unqual_agg_expr] = STATE(428),
    [sym_qualified_expr] = STATE(428),
    [sym_super_ref] = STATE(428),
    [sym_aggregate] = STATE(428),
    [sym_range] = STATE(428),
    [sym_set_literal] = STATE(428),
    [sym_par_expr] = STATE(428),
    [sym_expr_annotation] = STATE(428),
    [sym__exprOrTerm] = STATE(403),
    [sym__primary] = STATE(428),
    [sym_literal] = STATE(428),
    [sym_bool] = STATE(424),
    [sym_variable] = STATE(428),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2012),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(422),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(2001),
    [sym_aritylessPredicateExpr] = STATE(1481),
    [sym_varName] = STATE(426),
    [sym_aggId] = STATE(1805),
    [sym__lower_id] = ACTIONS(299),
    [anon_sym_LPAREN] = ACTIONS(301),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(305),
    [sym_specialId] = ACTIONS(307),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(309),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(311),
    [sym_integer] = ACTIONS(313),
    [sym_float] = ACTIONS(315),
    [sym_string] = ACTIONS(315),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(317),
    [sym_result] = ACTIONS(319),
    [sym_super] = ACTIONS(321),
    [sym_this] = ACTIONS(319),
    [sym_true] = ACTIONS(317),
  },
  [194] = {
    [sym_special_call] = STATE(1037),
    [sym_prefix_cast] = STATE(1037),
    [sym_unary_expr] = STATE(1037),
    [sym_mul_expr] = STATE(1037),
    [sym_add_expr] = STATE(1037),
    [sym_in_expr] = STATE(1037),
    [sym_comp_term] = STATE(1037),
    [sym_instance_of] = STATE(1037),
    [sym_negation] = STATE(1037),
    [sym_if_term] = STATE(1037),
    [sym_conjunction] = STATE(1037),
    [sym_disjunction] = STATE(1037),
    [sym_implication] = STATE(1037),
    [sym_quantified] = STATE(1037),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1037),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [195] = {
    [sym_special_call] = STATE(1153),
    [sym_prefix_cast] = STATE(1153),
    [sym_unary_expr] = STATE(1153),
    [sym_mul_expr] = STATE(1153),
    [sym_add_expr] = STATE(1153),
    [sym_in_expr] = STATE(1153),
    [sym_comp_term] = STATE(1153),
    [sym_instance_of] = STATE(1153),
    [sym_negation] = STATE(1153),
    [sym_if_term] = STATE(1153),
    [sym_conjunction] = STATE(1153),
    [sym_disjunction] = STATE(1153),
    [sym_implication] = STATE(1153),
    [sym_quantified] = STATE(1153),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1153),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [196] = {
    [sym_special_call] = STATE(799),
    [sym_prefix_cast] = STATE(799),
    [sym_unary_expr] = STATE(799),
    [sym_mul_expr] = STATE(799),
    [sym_add_expr] = STATE(799),
    [sym_in_expr] = STATE(799),
    [sym_comp_term] = STATE(799),
    [sym_instance_of] = STATE(799),
    [sym_negation] = STATE(799),
    [sym_if_term] = STATE(799),
    [sym_conjunction] = STATE(799),
    [sym_disjunction] = STATE(799),
    [sym_implication] = STATE(799),
    [sym_quantified] = STATE(799),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(799),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [197] = {
    [sym_special_call] = STATE(805),
    [sym_prefix_cast] = STATE(805),
    [sym_unary_expr] = STATE(805),
    [sym_mul_expr] = STATE(805),
    [sym_add_expr] = STATE(805),
    [sym_in_expr] = STATE(805),
    [sym_comp_term] = STATE(805),
    [sym_instance_of] = STATE(805),
    [sym_negation] = STATE(805),
    [sym_if_term] = STATE(805),
    [sym_conjunction] = STATE(805),
    [sym_disjunction] = STATE(805),
    [sym_implication] = STATE(805),
    [sym_quantified] = STATE(805),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(805),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [198] = {
    [sym_special_call] = STATE(402),
    [sym_prefix_cast] = STATE(402),
    [sym_unary_expr] = STATE(402),
    [sym_mul_expr] = STATE(402),
    [sym_add_expr] = STATE(402),
    [sym_in_expr] = STATE(402),
    [sym_comp_term] = STATE(402),
    [sym_instance_of] = STATE(402),
    [sym_negation] = STATE(402),
    [sym_if_term] = STATE(402),
    [sym_conjunction] = STATE(402),
    [sym_disjunction] = STATE(402),
    [sym_implication] = STATE(402),
    [sym_quantified] = STATE(402),
    [sym_quantifier] = STATE(1995),
    [sym_call_or_unqual_agg_expr] = STATE(428),
    [sym_qualified_expr] = STATE(428),
    [sym_super_ref] = STATE(428),
    [sym_aggregate] = STATE(428),
    [sym_range] = STATE(428),
    [sym_set_literal] = STATE(428),
    [sym_par_expr] = STATE(428),
    [sym_expr_annotation] = STATE(428),
    [sym__exprOrTerm] = STATE(402),
    [sym__primary] = STATE(428),
    [sym_literal] = STATE(428),
    [sym_bool] = STATE(424),
    [sym_variable] = STATE(428),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2012),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(422),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(2001),
    [sym_aritylessPredicateExpr] = STATE(1481),
    [sym_varName] = STATE(426),
    [sym_aggId] = STATE(1805),
    [sym__lower_id] = ACTIONS(299),
    [anon_sym_LPAREN] = ACTIONS(301),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(305),
    [sym_specialId] = ACTIONS(307),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(309),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(311),
    [sym_integer] = ACTIONS(313),
    [sym_float] = ACTIONS(315),
    [sym_string] = ACTIONS(315),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(317),
    [sym_result] = ACTIONS(319),
    [sym_super] = ACTIONS(321),
    [sym_this] = ACTIONS(319),
    [sym_true] = ACTIONS(317),
  },
  [199] = {
    [sym_special_call] = STATE(1076),
    [sym_prefix_cast] = STATE(1076),
    [sym_unary_expr] = STATE(1076),
    [sym_mul_expr] = STATE(1076),
    [sym_add_expr] = STATE(1076),
    [sym_in_expr] = STATE(1076),
    [sym_comp_term] = STATE(1076),
    [sym_instance_of] = STATE(1076),
    [sym_negation] = STATE(1076),
    [sym_if_term] = STATE(1076),
    [sym_conjunction] = STATE(1076),
    [sym_disjunction] = STATE(1076),
    [sym_implication] = STATE(1076),
    [sym_quantified] = STATE(1076),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1076),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [200] = {
    [sym_special_call] = STATE(409),
    [sym_prefix_cast] = STATE(409),
    [sym_unary_expr] = STATE(409),
    [sym_mul_expr] = STATE(409),
    [sym_add_expr] = STATE(409),
    [sym_in_expr] = STATE(409),
    [sym_comp_term] = STATE(409),
    [sym_instance_of] = STATE(409),
    [sym_negation] = STATE(409),
    [sym_if_term] = STATE(409),
    [sym_conjunction] = STATE(409),
    [sym_disjunction] = STATE(409),
    [sym_implication] = STATE(409),
    [sym_quantified] = STATE(409),
    [sym_quantifier] = STATE(1995),
    [sym_call_or_unqual_agg_expr] = STATE(428),
    [sym_qualified_expr] = STATE(428),
    [sym_super_ref] = STATE(428),
    [sym_aggregate] = STATE(428),
    [sym_range] = STATE(428),
    [sym_set_literal] = STATE(428),
    [sym_par_expr] = STATE(428),
    [sym_expr_annotation] = STATE(428),
    [sym__exprOrTerm] = STATE(409),
    [sym__primary] = STATE(428),
    [sym_literal] = STATE(428),
    [sym_bool] = STATE(424),
    [sym_variable] = STATE(428),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2012),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(422),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(2001),
    [sym_aritylessPredicateExpr] = STATE(1481),
    [sym_varName] = STATE(426),
    [sym_aggId] = STATE(1805),
    [sym__lower_id] = ACTIONS(299),
    [anon_sym_LPAREN] = ACTIONS(301),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(305),
    [sym_specialId] = ACTIONS(307),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(309),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(311),
    [sym_integer] = ACTIONS(313),
    [sym_float] = ACTIONS(315),
    [sym_string] = ACTIONS(315),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(317),
    [sym_result] = ACTIONS(319),
    [sym_super] = ACTIONS(321),
    [sym_this] = ACTIONS(319),
    [sym_true] = ACTIONS(317),
  },
  [201] = {
    [sym_special_call] = STATE(806),
    [sym_prefix_cast] = STATE(806),
    [sym_unary_expr] = STATE(806),
    [sym_mul_expr] = STATE(806),
    [sym_add_expr] = STATE(806),
    [sym_in_expr] = STATE(806),
    [sym_comp_term] = STATE(806),
    [sym_instance_of] = STATE(806),
    [sym_negation] = STATE(806),
    [sym_if_term] = STATE(806),
    [sym_conjunction] = STATE(806),
    [sym_disjunction] = STATE(806),
    [sym_implication] = STATE(806),
    [sym_quantified] = STATE(806),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(806),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [202] = {
    [sym_special_call] = STATE(414),
    [sym_prefix_cast] = STATE(414),
    [sym_unary_expr] = STATE(414),
    [sym_mul_expr] = STATE(414),
    [sym_add_expr] = STATE(414),
    [sym_in_expr] = STATE(414),
    [sym_comp_term] = STATE(414),
    [sym_instance_of] = STATE(414),
    [sym_negation] = STATE(414),
    [sym_if_term] = STATE(414),
    [sym_conjunction] = STATE(414),
    [sym_disjunction] = STATE(414),
    [sym_implication] = STATE(414),
    [sym_quantified] = STATE(414),
    [sym_quantifier] = STATE(1995),
    [sym_call_or_unqual_agg_expr] = STATE(428),
    [sym_qualified_expr] = STATE(428),
    [sym_super_ref] = STATE(428),
    [sym_aggregate] = STATE(428),
    [sym_range] = STATE(428),
    [sym_set_literal] = STATE(428),
    [sym_par_expr] = STATE(428),
    [sym_expr_annotation] = STATE(428),
    [sym__exprOrTerm] = STATE(414),
    [sym__primary] = STATE(428),
    [sym_literal] = STATE(428),
    [sym_bool] = STATE(424),
    [sym_variable] = STATE(428),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2012),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(422),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(2001),
    [sym_aritylessPredicateExpr] = STATE(1481),
    [sym_varName] = STATE(426),
    [sym_aggId] = STATE(1805),
    [sym__lower_id] = ACTIONS(299),
    [anon_sym_LPAREN] = ACTIONS(301),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(305),
    [sym_specialId] = ACTIONS(307),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(309),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(311),
    [sym_integer] = ACTIONS(313),
    [sym_float] = ACTIONS(315),
    [sym_string] = ACTIONS(315),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(317),
    [sym_result] = ACTIONS(319),
    [sym_super] = ACTIONS(321),
    [sym_this] = ACTIONS(319),
    [sym_true] = ACTIONS(317),
  },
  [203] = {
    [sym_special_call] = STATE(416),
    [sym_prefix_cast] = STATE(416),
    [sym_unary_expr] = STATE(416),
    [sym_mul_expr] = STATE(416),
    [sym_add_expr] = STATE(416),
    [sym_in_expr] = STATE(416),
    [sym_comp_term] = STATE(416),
    [sym_instance_of] = STATE(416),
    [sym_negation] = STATE(416),
    [sym_if_term] = STATE(416),
    [sym_conjunction] = STATE(416),
    [sym_disjunction] = STATE(416),
    [sym_implication] = STATE(416),
    [sym_quantified] = STATE(416),
    [sym_quantifier] = STATE(1995),
    [sym_call_or_unqual_agg_expr] = STATE(428),
    [sym_qualified_expr] = STATE(428),
    [sym_super_ref] = STATE(428),
    [sym_aggregate] = STATE(428),
    [sym_range] = STATE(428),
    [sym_set_literal] = STATE(428),
    [sym_par_expr] = STATE(428),
    [sym_expr_annotation] = STATE(428),
    [sym__exprOrTerm] = STATE(416),
    [sym__primary] = STATE(428),
    [sym_literal] = STATE(428),
    [sym_bool] = STATE(424),
    [sym_variable] = STATE(428),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2012),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(422),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(2001),
    [sym_aritylessPredicateExpr] = STATE(1481),
    [sym_varName] = STATE(426),
    [sym_aggId] = STATE(1805),
    [sym__lower_id] = ACTIONS(299),
    [anon_sym_LPAREN] = ACTIONS(301),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(305),
    [sym_specialId] = ACTIONS(307),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(309),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(311),
    [sym_integer] = ACTIONS(313),
    [sym_float] = ACTIONS(315),
    [sym_string] = ACTIONS(315),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(317),
    [sym_result] = ACTIONS(319),
    [sym_super] = ACTIONS(321),
    [sym_this] = ACTIONS(319),
    [sym_true] = ACTIONS(317),
  },
  [204] = {
    [sym_special_call] = STATE(807),
    [sym_prefix_cast] = STATE(807),
    [sym_unary_expr] = STATE(807),
    [sym_mul_expr] = STATE(807),
    [sym_add_expr] = STATE(807),
    [sym_in_expr] = STATE(807),
    [sym_comp_term] = STATE(807),
    [sym_instance_of] = STATE(807),
    [sym_negation] = STATE(807),
    [sym_if_term] = STATE(807),
    [sym_conjunction] = STATE(807),
    [sym_disjunction] = STATE(807),
    [sym_implication] = STATE(807),
    [sym_quantified] = STATE(807),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(807),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [205] = {
    [sym_special_call] = STATE(417),
    [sym_prefix_cast] = STATE(417),
    [sym_unary_expr] = STATE(417),
    [sym_mul_expr] = STATE(417),
    [sym_add_expr] = STATE(417),
    [sym_in_expr] = STATE(417),
    [sym_comp_term] = STATE(417),
    [sym_instance_of] = STATE(417),
    [sym_negation] = STATE(417),
    [sym_if_term] = STATE(417),
    [sym_conjunction] = STATE(417),
    [sym_disjunction] = STATE(417),
    [sym_implication] = STATE(417),
    [sym_quantified] = STATE(417),
    [sym_quantifier] = STATE(1995),
    [sym_call_or_unqual_agg_expr] = STATE(428),
    [sym_qualified_expr] = STATE(428),
    [sym_super_ref] = STATE(428),
    [sym_aggregate] = STATE(428),
    [sym_range] = STATE(428),
    [sym_set_literal] = STATE(428),
    [sym_par_expr] = STATE(428),
    [sym_expr_annotation] = STATE(428),
    [sym__exprOrTerm] = STATE(417),
    [sym__primary] = STATE(428),
    [sym_literal] = STATE(428),
    [sym_bool] = STATE(424),
    [sym_variable] = STATE(428),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2012),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(422),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(2001),
    [sym_aritylessPredicateExpr] = STATE(1481),
    [sym_varName] = STATE(426),
    [sym_aggId] = STATE(1805),
    [sym__lower_id] = ACTIONS(299),
    [anon_sym_LPAREN] = ACTIONS(301),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(305),
    [sym_specialId] = ACTIONS(307),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(309),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(311),
    [sym_integer] = ACTIONS(313),
    [sym_float] = ACTIONS(315),
    [sym_string] = ACTIONS(315),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(317),
    [sym_result] = ACTIONS(319),
    [sym_super] = ACTIONS(321),
    [sym_this] = ACTIONS(319),
    [sym_true] = ACTIONS(317),
  },
  [206] = {
    [sym_special_call] = STATE(808),
    [sym_prefix_cast] = STATE(808),
    [sym_unary_expr] = STATE(808),
    [sym_mul_expr] = STATE(808),
    [sym_add_expr] = STATE(808),
    [sym_in_expr] = STATE(808),
    [sym_comp_term] = STATE(808),
    [sym_instance_of] = STATE(808),
    [sym_negation] = STATE(808),
    [sym_if_term] = STATE(808),
    [sym_conjunction] = STATE(808),
    [sym_disjunction] = STATE(808),
    [sym_implication] = STATE(808),
    [sym_quantified] = STATE(808),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(808),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [207] = {
    [sym_special_call] = STATE(418),
    [sym_prefix_cast] = STATE(418),
    [sym_unary_expr] = STATE(418),
    [sym_mul_expr] = STATE(418),
    [sym_add_expr] = STATE(418),
    [sym_in_expr] = STATE(418),
    [sym_comp_term] = STATE(418),
    [sym_instance_of] = STATE(418),
    [sym_negation] = STATE(418),
    [sym_if_term] = STATE(418),
    [sym_conjunction] = STATE(418),
    [sym_disjunction] = STATE(418),
    [sym_implication] = STATE(418),
    [sym_quantified] = STATE(418),
    [sym_quantifier] = STATE(1995),
    [sym_call_or_unqual_agg_expr] = STATE(428),
    [sym_qualified_expr] = STATE(428),
    [sym_super_ref] = STATE(428),
    [sym_aggregate] = STATE(428),
    [sym_range] = STATE(428),
    [sym_set_literal] = STATE(428),
    [sym_par_expr] = STATE(428),
    [sym_expr_annotation] = STATE(428),
    [sym__exprOrTerm] = STATE(418),
    [sym__primary] = STATE(428),
    [sym_literal] = STATE(428),
    [sym_bool] = STATE(424),
    [sym_variable] = STATE(428),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2012),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(422),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(2001),
    [sym_aritylessPredicateExpr] = STATE(1481),
    [sym_varName] = STATE(426),
    [sym_aggId] = STATE(1805),
    [sym__lower_id] = ACTIONS(299),
    [anon_sym_LPAREN] = ACTIONS(301),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(305),
    [sym_specialId] = ACTIONS(307),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(309),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(311),
    [sym_integer] = ACTIONS(313),
    [sym_float] = ACTIONS(315),
    [sym_string] = ACTIONS(315),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(317),
    [sym_result] = ACTIONS(319),
    [sym_super] = ACTIONS(321),
    [sym_this] = ACTIONS(319),
    [sym_true] = ACTIONS(317),
  },
  [208] = {
    [sym_special_call] = STATE(809),
    [sym_prefix_cast] = STATE(809),
    [sym_unary_expr] = STATE(809),
    [sym_mul_expr] = STATE(809),
    [sym_add_expr] = STATE(809),
    [sym_in_expr] = STATE(809),
    [sym_comp_term] = STATE(809),
    [sym_instance_of] = STATE(809),
    [sym_negation] = STATE(809),
    [sym_if_term] = STATE(809),
    [sym_conjunction] = STATE(809),
    [sym_disjunction] = STATE(809),
    [sym_implication] = STATE(809),
    [sym_quantified] = STATE(809),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(809),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [209] = {
    [sym_special_call] = STATE(1183),
    [sym_prefix_cast] = STATE(1183),
    [sym_unary_expr] = STATE(1183),
    [sym_mul_expr] = STATE(1183),
    [sym_add_expr] = STATE(1183),
    [sym_in_expr] = STATE(1183),
    [sym_comp_term] = STATE(1183),
    [sym_instance_of] = STATE(1183),
    [sym_negation] = STATE(1183),
    [sym_if_term] = STATE(1183),
    [sym_conjunction] = STATE(1183),
    [sym_disjunction] = STATE(1183),
    [sym_implication] = STATE(1183),
    [sym_quantified] = STATE(1183),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1183),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [210] = {
    [sym_special_call] = STATE(389),
    [sym_prefix_cast] = STATE(389),
    [sym_unary_expr] = STATE(389),
    [sym_mul_expr] = STATE(389),
    [sym_add_expr] = STATE(389),
    [sym_in_expr] = STATE(389),
    [sym_comp_term] = STATE(389),
    [sym_instance_of] = STATE(389),
    [sym_negation] = STATE(389),
    [sym_if_term] = STATE(389),
    [sym_conjunction] = STATE(389),
    [sym_disjunction] = STATE(389),
    [sym_implication] = STATE(389),
    [sym_quantified] = STATE(389),
    [sym_quantifier] = STATE(1995),
    [sym_call_or_unqual_agg_expr] = STATE(428),
    [sym_qualified_expr] = STATE(428),
    [sym_super_ref] = STATE(428),
    [sym_aggregate] = STATE(428),
    [sym_range] = STATE(428),
    [sym_set_literal] = STATE(428),
    [sym_par_expr] = STATE(428),
    [sym_expr_annotation] = STATE(428),
    [sym__exprOrTerm] = STATE(389),
    [sym__primary] = STATE(428),
    [sym_literal] = STATE(428),
    [sym_bool] = STATE(424),
    [sym_variable] = STATE(428),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2012),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(422),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(2001),
    [sym_aritylessPredicateExpr] = STATE(1481),
    [sym_varName] = STATE(426),
    [sym_aggId] = STATE(1805),
    [sym__lower_id] = ACTIONS(299),
    [anon_sym_LPAREN] = ACTIONS(301),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(305),
    [sym_specialId] = ACTIONS(307),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(309),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(311),
    [sym_integer] = ACTIONS(313),
    [sym_float] = ACTIONS(315),
    [sym_string] = ACTIONS(315),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(317),
    [sym_result] = ACTIONS(319),
    [sym_super] = ACTIONS(321),
    [sym_this] = ACTIONS(319),
    [sym_true] = ACTIONS(317),
  },
  [211] = {
    [sym_special_call] = STATE(861),
    [sym_prefix_cast] = STATE(861),
    [sym_unary_expr] = STATE(861),
    [sym_mul_expr] = STATE(861),
    [sym_add_expr] = STATE(861),
    [sym_in_expr] = STATE(861),
    [sym_comp_term] = STATE(861),
    [sym_instance_of] = STATE(861),
    [sym_negation] = STATE(861),
    [sym_if_term] = STATE(861),
    [sym_conjunction] = STATE(861),
    [sym_disjunction] = STATE(861),
    [sym_implication] = STATE(861),
    [sym_quantified] = STATE(861),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(861),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [212] = {
    [sym_special_call] = STATE(820),
    [sym_prefix_cast] = STATE(820),
    [sym_unary_expr] = STATE(820),
    [sym_mul_expr] = STATE(820),
    [sym_add_expr] = STATE(820),
    [sym_in_expr] = STATE(820),
    [sym_comp_term] = STATE(820),
    [sym_instance_of] = STATE(820),
    [sym_negation] = STATE(820),
    [sym_if_term] = STATE(820),
    [sym_conjunction] = STATE(820),
    [sym_disjunction] = STATE(820),
    [sym_implication] = STATE(820),
    [sym_quantified] = STATE(820),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(820),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [213] = {
    [sym_special_call] = STATE(1035),
    [sym_prefix_cast] = STATE(1035),
    [sym_unary_expr] = STATE(1035),
    [sym_mul_expr] = STATE(1035),
    [sym_add_expr] = STATE(1035),
    [sym_in_expr] = STATE(1035),
    [sym_comp_term] = STATE(1035),
    [sym_instance_of] = STATE(1035),
    [sym_negation] = STATE(1035),
    [sym_if_term] = STATE(1035),
    [sym_conjunction] = STATE(1035),
    [sym_disjunction] = STATE(1035),
    [sym_implication] = STATE(1035),
    [sym_quantified] = STATE(1035),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1035),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [214] = {
    [sym_special_call] = STATE(405),
    [sym_prefix_cast] = STATE(405),
    [sym_unary_expr] = STATE(405),
    [sym_mul_expr] = STATE(405),
    [sym_add_expr] = STATE(405),
    [sym_in_expr] = STATE(405),
    [sym_comp_term] = STATE(405),
    [sym_instance_of] = STATE(405),
    [sym_negation] = STATE(405),
    [sym_if_term] = STATE(405),
    [sym_conjunction] = STATE(405),
    [sym_disjunction] = STATE(405),
    [sym_implication] = STATE(405),
    [sym_quantified] = STATE(405),
    [sym_quantifier] = STATE(1995),
    [sym_call_or_unqual_agg_expr] = STATE(428),
    [sym_qualified_expr] = STATE(428),
    [sym_super_ref] = STATE(428),
    [sym_aggregate] = STATE(428),
    [sym_range] = STATE(428),
    [sym_set_literal] = STATE(428),
    [sym_par_expr] = STATE(428),
    [sym_expr_annotation] = STATE(428),
    [sym__exprOrTerm] = STATE(405),
    [sym__primary] = STATE(428),
    [sym_literal] = STATE(428),
    [sym_bool] = STATE(424),
    [sym_variable] = STATE(428),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2012),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(422),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(2001),
    [sym_aritylessPredicateExpr] = STATE(1481),
    [sym_varName] = STATE(426),
    [sym_aggId] = STATE(1805),
    [sym__lower_id] = ACTIONS(299),
    [anon_sym_LPAREN] = ACTIONS(301),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(305),
    [sym_specialId] = ACTIONS(307),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(309),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(311),
    [sym_integer] = ACTIONS(313),
    [sym_float] = ACTIONS(315),
    [sym_string] = ACTIONS(315),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(317),
    [sym_result] = ACTIONS(319),
    [sym_super] = ACTIONS(321),
    [sym_this] = ACTIONS(319),
    [sym_true] = ACTIONS(317),
  },
  [215] = {
    [sym_special_call] = STATE(1118),
    [sym_prefix_cast] = STATE(1118),
    [sym_unary_expr] = STATE(1118),
    [sym_mul_expr] = STATE(1118),
    [sym_add_expr] = STATE(1118),
    [sym_in_expr] = STATE(1118),
    [sym_comp_term] = STATE(1118),
    [sym_instance_of] = STATE(1118),
    [sym_negation] = STATE(1118),
    [sym_if_term] = STATE(1118),
    [sym_conjunction] = STATE(1118),
    [sym_disjunction] = STATE(1118),
    [sym_implication] = STATE(1118),
    [sym_quantified] = STATE(1118),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1118),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [216] = {
    [sym_special_call] = STATE(1104),
    [sym_prefix_cast] = STATE(1104),
    [sym_unary_expr] = STATE(1104),
    [sym_mul_expr] = STATE(1104),
    [sym_add_expr] = STATE(1104),
    [sym_in_expr] = STATE(1104),
    [sym_comp_term] = STATE(1104),
    [sym_instance_of] = STATE(1104),
    [sym_negation] = STATE(1104),
    [sym_if_term] = STATE(1104),
    [sym_conjunction] = STATE(1104),
    [sym_disjunction] = STATE(1104),
    [sym_implication] = STATE(1104),
    [sym_quantified] = STATE(1104),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1104),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [217] = {
    [sym_special_call] = STATE(787),
    [sym_prefix_cast] = STATE(787),
    [sym_unary_expr] = STATE(787),
    [sym_mul_expr] = STATE(787),
    [sym_add_expr] = STATE(787),
    [sym_in_expr] = STATE(787),
    [sym_comp_term] = STATE(787),
    [sym_instance_of] = STATE(787),
    [sym_negation] = STATE(787),
    [sym_if_term] = STATE(787),
    [sym_conjunction] = STATE(787),
    [sym_disjunction] = STATE(787),
    [sym_implication] = STATE(787),
    [sym_quantified] = STATE(787),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(787),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [218] = {
    [sym_special_call] = STATE(1121),
    [sym_prefix_cast] = STATE(1121),
    [sym_unary_expr] = STATE(1121),
    [sym_mul_expr] = STATE(1121),
    [sym_add_expr] = STATE(1121),
    [sym_in_expr] = STATE(1121),
    [sym_comp_term] = STATE(1121),
    [sym_instance_of] = STATE(1121),
    [sym_negation] = STATE(1121),
    [sym_if_term] = STATE(1121),
    [sym_conjunction] = STATE(1121),
    [sym_disjunction] = STATE(1121),
    [sym_implication] = STATE(1121),
    [sym_quantified] = STATE(1121),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1121),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [219] = {
    [sym_special_call] = STATE(408),
    [sym_prefix_cast] = STATE(408),
    [sym_unary_expr] = STATE(408),
    [sym_mul_expr] = STATE(408),
    [sym_add_expr] = STATE(408),
    [sym_in_expr] = STATE(408),
    [sym_comp_term] = STATE(408),
    [sym_instance_of] = STATE(408),
    [sym_negation] = STATE(408),
    [sym_if_term] = STATE(408),
    [sym_conjunction] = STATE(408),
    [sym_disjunction] = STATE(408),
    [sym_implication] = STATE(408),
    [sym_quantified] = STATE(408),
    [sym_quantifier] = STATE(1995),
    [sym_call_or_unqual_agg_expr] = STATE(428),
    [sym_qualified_expr] = STATE(428),
    [sym_super_ref] = STATE(428),
    [sym_aggregate] = STATE(428),
    [sym_range] = STATE(428),
    [sym_set_literal] = STATE(428),
    [sym_par_expr] = STATE(428),
    [sym_expr_annotation] = STATE(428),
    [sym__exprOrTerm] = STATE(408),
    [sym__primary] = STATE(428),
    [sym_literal] = STATE(428),
    [sym_bool] = STATE(424),
    [sym_variable] = STATE(428),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2012),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(422),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(2001),
    [sym_aritylessPredicateExpr] = STATE(1481),
    [sym_varName] = STATE(426),
    [sym_aggId] = STATE(1805),
    [sym__lower_id] = ACTIONS(299),
    [anon_sym_LPAREN] = ACTIONS(301),
    [anon_sym_not] = ACTIONS(303),
    [anon_sym_if] = ACTIONS(305),
    [sym_specialId] = ACTIONS(307),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(309),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(311),
    [sym_integer] = ACTIONS(313),
    [sym_float] = ACTIONS(315),
    [sym_string] = ACTIONS(315),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(317),
    [sym_result] = ACTIONS(319),
    [sym_super] = ACTIONS(321),
    [sym_this] = ACTIONS(319),
    [sym_true] = ACTIONS(317),
  },
  [220] = {
    [sym_special_call] = STATE(1122),
    [sym_prefix_cast] = STATE(1122),
    [sym_unary_expr] = STATE(1122),
    [sym_mul_expr] = STATE(1122),
    [sym_add_expr] = STATE(1122),
    [sym_in_expr] = STATE(1122),
    [sym_comp_term] = STATE(1122),
    [sym_instance_of] = STATE(1122),
    [sym_negation] = STATE(1122),
    [sym_if_term] = STATE(1122),
    [sym_conjunction] = STATE(1122),
    [sym_disjunction] = STATE(1122),
    [sym_implication] = STATE(1122),
    [sym_quantified] = STATE(1122),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1122),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [221] = {
    [sym_special_call] = STATE(839),
    [sym_prefix_cast] = STATE(839),
    [sym_unary_expr] = STATE(839),
    [sym_mul_expr] = STATE(839),
    [sym_add_expr] = STATE(839),
    [sym_in_expr] = STATE(839),
    [sym_comp_term] = STATE(839),
    [sym_instance_of] = STATE(839),
    [sym_negation] = STATE(839),
    [sym_if_term] = STATE(839),
    [sym_conjunction] = STATE(839),
    [sym_disjunction] = STATE(839),
    [sym_implication] = STATE(839),
    [sym_quantified] = STATE(839),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(839),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1839),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [222] = {
    [sym_special_call] = STATE(832),
    [sym_prefix_cast] = STATE(832),
    [sym_unary_expr] = STATE(832),
    [sym_mul_expr] = STATE(832),
    [sym_add_expr] = STATE(832),
    [sym_in_expr] = STATE(832),
    [sym_comp_term] = STATE(832),
    [sym_instance_of] = STATE(832),
    [sym_negation] = STATE(832),
    [sym_if_term] = STATE(832),
    [sym_conjunction] = STATE(832),
    [sym_disjunction] = STATE(832),
    [sym_implication] = STATE(832),
    [sym_quantified] = STATE(832),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(832),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [223] = {
    [sym_special_call] = STATE(954),
    [sym_prefix_cast] = STATE(954),
    [sym_unary_expr] = STATE(954),
    [sym_mul_expr] = STATE(954),
    [sym_add_expr] = STATE(954),
    [sym_in_expr] = STATE(954),
    [sym_comp_term] = STATE(954),
    [sym_instance_of] = STATE(954),
    [sym_negation] = STATE(954),
    [sym_if_term] = STATE(954),
    [sym_conjunction] = STATE(954),
    [sym_disjunction] = STATE(954),
    [sym_implication] = STATE(954),
    [sym_quantified] = STATE(954),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(954),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [224] = {
    [sym_special_call] = STATE(1143),
    [sym_prefix_cast] = STATE(1143),
    [sym_unary_expr] = STATE(1143),
    [sym_mul_expr] = STATE(1143),
    [sym_add_expr] = STATE(1143),
    [sym_in_expr] = STATE(1143),
    [sym_comp_term] = STATE(1143),
    [sym_instance_of] = STATE(1143),
    [sym_negation] = STATE(1143),
    [sym_if_term] = STATE(1143),
    [sym_conjunction] = STATE(1143),
    [sym_disjunction] = STATE(1143),
    [sym_implication] = STATE(1143),
    [sym_quantified] = STATE(1143),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1143),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [225] = {
    [sym_special_call] = STATE(852),
    [sym_prefix_cast] = STATE(852),
    [sym_unary_expr] = STATE(852),
    [sym_mul_expr] = STATE(852),
    [sym_add_expr] = STATE(852),
    [sym_in_expr] = STATE(852),
    [sym_comp_term] = STATE(852),
    [sym_instance_of] = STATE(852),
    [sym_negation] = STATE(852),
    [sym_if_term] = STATE(852),
    [sym_conjunction] = STATE(852),
    [sym_disjunction] = STATE(852),
    [sym_implication] = STATE(852),
    [sym_quantified] = STATE(852),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(852),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [226] = {
    [sym_special_call] = STATE(1115),
    [sym_prefix_cast] = STATE(1115),
    [sym_unary_expr] = STATE(1115),
    [sym_mul_expr] = STATE(1115),
    [sym_add_expr] = STATE(1115),
    [sym_in_expr] = STATE(1115),
    [sym_comp_term] = STATE(1115),
    [sym_instance_of] = STATE(1115),
    [sym_negation] = STATE(1115),
    [sym_if_term] = STATE(1115),
    [sym_conjunction] = STATE(1115),
    [sym_disjunction] = STATE(1115),
    [sym_implication] = STATE(1115),
    [sym_quantified] = STATE(1115),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1115),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [227] = {
    [sym_special_call] = STATE(853),
    [sym_prefix_cast] = STATE(853),
    [sym_unary_expr] = STATE(853),
    [sym_mul_expr] = STATE(853),
    [sym_add_expr] = STATE(853),
    [sym_in_expr] = STATE(853),
    [sym_comp_term] = STATE(853),
    [sym_instance_of] = STATE(853),
    [sym_negation] = STATE(853),
    [sym_if_term] = STATE(853),
    [sym_conjunction] = STATE(853),
    [sym_disjunction] = STATE(853),
    [sym_implication] = STATE(853),
    [sym_quantified] = STATE(853),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(853),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [228] = {
    [sym_special_call] = STATE(855),
    [sym_prefix_cast] = STATE(855),
    [sym_unary_expr] = STATE(855),
    [sym_mul_expr] = STATE(855),
    [sym_add_expr] = STATE(855),
    [sym_in_expr] = STATE(855),
    [sym_comp_term] = STATE(855),
    [sym_instance_of] = STATE(855),
    [sym_negation] = STATE(855),
    [sym_if_term] = STATE(855),
    [sym_conjunction] = STATE(855),
    [sym_disjunction] = STATE(855),
    [sym_implication] = STATE(855),
    [sym_quantified] = STATE(855),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(855),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [229] = {
    [sym_special_call] = STATE(856),
    [sym_prefix_cast] = STATE(856),
    [sym_unary_expr] = STATE(856),
    [sym_mul_expr] = STATE(856),
    [sym_add_expr] = STATE(856),
    [sym_in_expr] = STATE(856),
    [sym_comp_term] = STATE(856),
    [sym_instance_of] = STATE(856),
    [sym_negation] = STATE(856),
    [sym_if_term] = STATE(856),
    [sym_conjunction] = STATE(856),
    [sym_disjunction] = STATE(856),
    [sym_implication] = STATE(856),
    [sym_quantified] = STATE(856),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(856),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [230] = {
    [sym_special_call] = STATE(833),
    [sym_prefix_cast] = STATE(833),
    [sym_unary_expr] = STATE(833),
    [sym_mul_expr] = STATE(833),
    [sym_add_expr] = STATE(833),
    [sym_in_expr] = STATE(833),
    [sym_comp_term] = STATE(833),
    [sym_instance_of] = STATE(833),
    [sym_negation] = STATE(833),
    [sym_if_term] = STATE(833),
    [sym_conjunction] = STATE(833),
    [sym_disjunction] = STATE(833),
    [sym_implication] = STATE(833),
    [sym_quantified] = STATE(833),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(833),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [231] = {
    [sym_special_call] = STATE(834),
    [sym_prefix_cast] = STATE(834),
    [sym_unary_expr] = STATE(834),
    [sym_mul_expr] = STATE(834),
    [sym_add_expr] = STATE(834),
    [sym_in_expr] = STATE(834),
    [sym_comp_term] = STATE(834),
    [sym_instance_of] = STATE(834),
    [sym_negation] = STATE(834),
    [sym_if_term] = STATE(834),
    [sym_conjunction] = STATE(834),
    [sym_disjunction] = STATE(834),
    [sym_implication] = STATE(834),
    [sym_quantified] = STATE(834),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(834),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [232] = {
    [sym_special_call] = STATE(854),
    [sym_prefix_cast] = STATE(854),
    [sym_unary_expr] = STATE(854),
    [sym_mul_expr] = STATE(854),
    [sym_add_expr] = STATE(854),
    [sym_in_expr] = STATE(854),
    [sym_comp_term] = STATE(854),
    [sym_instance_of] = STATE(854),
    [sym_negation] = STATE(854),
    [sym_if_term] = STATE(854),
    [sym_conjunction] = STATE(854),
    [sym_disjunction] = STATE(854),
    [sym_implication] = STATE(854),
    [sym_quantified] = STATE(854),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(854),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [233] = {
    [sym_special_call] = STATE(379),
    [sym_prefix_cast] = STATE(379),
    [sym_unary_expr] = STATE(379),
    [sym_mul_expr] = STATE(379),
    [sym_add_expr] = STATE(379),
    [sym_in_expr] = STATE(379),
    [sym_comp_term] = STATE(379),
    [sym_instance_of] = STATE(379),
    [sym_negation] = STATE(379),
    [sym_if_term] = STATE(379),
    [sym_conjunction] = STATE(379),
    [sym_disjunction] = STATE(379),
    [sym_implication] = STATE(379),
    [sym_quantified] = STATE(379),
    [sym_quantifier] = STATE(1838),
    [sym_call_or_unqual_agg_expr] = STATE(474),
    [sym_qualified_expr] = STATE(474),
    [sym_super_ref] = STATE(474),
    [sym_aggregate] = STATE(474),
    [sym_range] = STATE(474),
    [sym_set_literal] = STATE(474),
    [sym_par_expr] = STATE(474),
    [sym_expr_annotation] = STATE(474),
    [sym__exprOrTerm] = STATE(379),
    [sym__primary] = STATE(474),
    [sym_literal] = STATE(474),
    [sym_bool] = STATE(470),
    [sym_variable] = STATE(474),
    [sym_unop] = STATE(258),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2014),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(419),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(2009),
    [sym_aritylessPredicateExpr] = STATE(1472),
    [sym_varName] = STATE(472),
    [sym_aggId] = STATE(1773),
    [sym__lower_id] = ACTIONS(323),
    [anon_sym_LPAREN] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(327),
    [anon_sym_if] = ACTIONS(329),
    [sym_specialId] = ACTIONS(331),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(335),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(341),
    [sym_result] = ACTIONS(343),
    [sym_super] = ACTIONS(345),
    [sym_this] = ACTIONS(343),
    [sym_true] = ACTIONS(341),
  },
  [234] = {
    [sym_special_call] = STATE(836),
    [sym_prefix_cast] = STATE(836),
    [sym_unary_expr] = STATE(836),
    [sym_mul_expr] = STATE(836),
    [sym_add_expr] = STATE(836),
    [sym_in_expr] = STATE(836),
    [sym_comp_term] = STATE(836),
    [sym_instance_of] = STATE(836),
    [sym_negation] = STATE(836),
    [sym_if_term] = STATE(836),
    [sym_conjunction] = STATE(836),
    [sym_disjunction] = STATE(836),
    [sym_implication] = STATE(836),
    [sym_quantified] = STATE(836),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(836),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [235] = {
    [sym_special_call] = STATE(1000),
    [sym_prefix_cast] = STATE(1000),
    [sym_unary_expr] = STATE(1000),
    [sym_mul_expr] = STATE(1000),
    [sym_add_expr] = STATE(1000),
    [sym_in_expr] = STATE(1000),
    [sym_comp_term] = STATE(1000),
    [sym_instance_of] = STATE(1000),
    [sym_negation] = STATE(1000),
    [sym_if_term] = STATE(1000),
    [sym_conjunction] = STATE(1000),
    [sym_disjunction] = STATE(1000),
    [sym_implication] = STATE(1000),
    [sym_quantified] = STATE(1000),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1000),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [236] = {
    [sym_special_call] = STATE(1143),
    [sym_prefix_cast] = STATE(1143),
    [sym_unary_expr] = STATE(1143),
    [sym_mul_expr] = STATE(1143),
    [sym_add_expr] = STATE(1143),
    [sym_in_expr] = STATE(1143),
    [sym_comp_term] = STATE(1143),
    [sym_instance_of] = STATE(1143),
    [sym_negation] = STATE(1143),
    [sym_if_term] = STATE(1143),
    [sym_conjunction] = STATE(1143),
    [sym_disjunction] = STATE(1143),
    [sym_implication] = STATE(1143),
    [sym_quantified] = STATE(1143),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1143),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1785),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [237] = {
    [sym_special_call] = STATE(843),
    [sym_prefix_cast] = STATE(843),
    [sym_unary_expr] = STATE(843),
    [sym_mul_expr] = STATE(843),
    [sym_add_expr] = STATE(843),
    [sym_in_expr] = STATE(843),
    [sym_comp_term] = STATE(843),
    [sym_instance_of] = STATE(843),
    [sym_negation] = STATE(843),
    [sym_if_term] = STATE(843),
    [sym_conjunction] = STATE(843),
    [sym_disjunction] = STATE(843),
    [sym_implication] = STATE(843),
    [sym_quantified] = STATE(843),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(843),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1839),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [238] = {
    [sym_special_call] = STATE(1128),
    [sym_prefix_cast] = STATE(1128),
    [sym_unary_expr] = STATE(1128),
    [sym_mul_expr] = STATE(1128),
    [sym_add_expr] = STATE(1128),
    [sym_in_expr] = STATE(1128),
    [sym_comp_term] = STATE(1128),
    [sym_instance_of] = STATE(1128),
    [sym_negation] = STATE(1128),
    [sym_if_term] = STATE(1128),
    [sym_conjunction] = STATE(1128),
    [sym_disjunction] = STATE(1128),
    [sym_implication] = STATE(1128),
    [sym_quantified] = STATE(1128),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1128),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [239] = {
    [sym_special_call] = STATE(838),
    [sym_prefix_cast] = STATE(838),
    [sym_unary_expr] = STATE(838),
    [sym_mul_expr] = STATE(838),
    [sym_add_expr] = STATE(838),
    [sym_in_expr] = STATE(838),
    [sym_comp_term] = STATE(838),
    [sym_instance_of] = STATE(838),
    [sym_negation] = STATE(838),
    [sym_if_term] = STATE(838),
    [sym_conjunction] = STATE(838),
    [sym_disjunction] = STATE(838),
    [sym_implication] = STATE(838),
    [sym_quantified] = STATE(838),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(838),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1839),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [240] = {
    [sym_special_call] = STATE(796),
    [sym_prefix_cast] = STATE(796),
    [sym_unary_expr] = STATE(796),
    [sym_mul_expr] = STATE(796),
    [sym_add_expr] = STATE(796),
    [sym_in_expr] = STATE(796),
    [sym_comp_term] = STATE(796),
    [sym_instance_of] = STATE(796),
    [sym_negation] = STATE(796),
    [sym_if_term] = STATE(796),
    [sym_conjunction] = STATE(796),
    [sym_disjunction] = STATE(796),
    [sym_implication] = STATE(796),
    [sym_quantified] = STATE(796),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(796),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [241] = {
    [sym_special_call] = STATE(859),
    [sym_prefix_cast] = STATE(859),
    [sym_unary_expr] = STATE(859),
    [sym_mul_expr] = STATE(859),
    [sym_add_expr] = STATE(859),
    [sym_in_expr] = STATE(859),
    [sym_comp_term] = STATE(859),
    [sym_instance_of] = STATE(859),
    [sym_negation] = STATE(859),
    [sym_if_term] = STATE(859),
    [sym_conjunction] = STATE(859),
    [sym_disjunction] = STATE(859),
    [sym_implication] = STATE(859),
    [sym_quantified] = STATE(859),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(859),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1839),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [242] = {
    [sym_special_call] = STATE(841),
    [sym_prefix_cast] = STATE(841),
    [sym_unary_expr] = STATE(841),
    [sym_mul_expr] = STATE(841),
    [sym_add_expr] = STATE(841),
    [sym_in_expr] = STATE(841),
    [sym_comp_term] = STATE(841),
    [sym_instance_of] = STATE(841),
    [sym_negation] = STATE(841),
    [sym_if_term] = STATE(841),
    [sym_conjunction] = STATE(841),
    [sym_disjunction] = STATE(841),
    [sym_implication] = STATE(841),
    [sym_quantified] = STATE(841),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(841),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1839),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [243] = {
    [sym_special_call] = STATE(842),
    [sym_prefix_cast] = STATE(842),
    [sym_unary_expr] = STATE(842),
    [sym_mul_expr] = STATE(842),
    [sym_add_expr] = STATE(842),
    [sym_in_expr] = STATE(842),
    [sym_comp_term] = STATE(842),
    [sym_instance_of] = STATE(842),
    [sym_negation] = STATE(842),
    [sym_if_term] = STATE(842),
    [sym_conjunction] = STATE(842),
    [sym_disjunction] = STATE(842),
    [sym_implication] = STATE(842),
    [sym_quantified] = STATE(842),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(842),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1839),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [244] = {
    [sym_special_call] = STATE(412),
    [sym_prefix_cast] = STATE(412),
    [sym_unary_expr] = STATE(412),
    [sym_mul_expr] = STATE(412),
    [sym_add_expr] = STATE(412),
    [sym_in_expr] = STATE(412),
    [sym_comp_term] = STATE(412),
    [sym_instance_of] = STATE(412),
    [sym_negation] = STATE(412),
    [sym_if_term] = STATE(412),
    [sym_conjunction] = STATE(412),
    [sym_disjunction] = STATE(412),
    [sym_implication] = STATE(412),
    [sym_quantified] = STATE(412),
    [sym_quantifier] = STATE(1865),
    [sym_call_or_unqual_agg_expr] = STATE(517),
    [sym_qualified_expr] = STATE(517),
    [sym_super_ref] = STATE(517),
    [sym_aggregate] = STATE(517),
    [sym_range] = STATE(517),
    [sym_set_literal] = STATE(517),
    [sym_par_expr] = STATE(517),
    [sym_expr_annotation] = STATE(517),
    [sym__exprOrTerm] = STATE(412),
    [sym__primary] = STATE(517),
    [sym_literal] = STATE(517),
    [sym_bool] = STATE(513),
    [sym_variable] = STATE(517),
    [sym_unop] = STATE(297),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2015),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(421),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1866),
    [sym_aritylessPredicateExpr] = STATE(1477),
    [sym_varName] = STATE(598),
    [sym_aggId] = STATE(1778),
    [sym__lower_id] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(469),
    [anon_sym_not] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [sym_specialId] = ACTIONS(475),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(479),
    [sym_integer] = ACTIONS(481),
    [sym_float] = ACTIONS(483),
    [sym_string] = ACTIONS(483),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(485),
    [sym_result] = ACTIONS(487),
    [sym_super] = ACTIONS(489),
    [sym_this] = ACTIONS(487),
    [sym_true] = ACTIONS(485),
  },
  [245] = {
    [sym_special_call] = STATE(857),
    [sym_prefix_cast] = STATE(857),
    [sym_unary_expr] = STATE(857),
    [sym_mul_expr] = STATE(857),
    [sym_add_expr] = STATE(857),
    [sym_in_expr] = STATE(857),
    [sym_comp_term] = STATE(857),
    [sym_instance_of] = STATE(857),
    [sym_negation] = STATE(857),
    [sym_if_term] = STATE(857),
    [sym_conjunction] = STATE(857),
    [sym_disjunction] = STATE(857),
    [sym_implication] = STATE(857),
    [sym_quantified] = STATE(857),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(857),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1839),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [246] = {
    [sym_special_call] = STATE(949),
    [sym_prefix_cast] = STATE(949),
    [sym_unary_expr] = STATE(949),
    [sym_mul_expr] = STATE(949),
    [sym_add_expr] = STATE(949),
    [sym_in_expr] = STATE(949),
    [sym_comp_term] = STATE(949),
    [sym_instance_of] = STATE(949),
    [sym_negation] = STATE(949),
    [sym_if_term] = STATE(949),
    [sym_conjunction] = STATE(949),
    [sym_disjunction] = STATE(949),
    [sym_implication] = STATE(949),
    [sym_quantified] = STATE(949),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(949),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [247] = {
    [sym_special_call] = STATE(1031),
    [sym_prefix_cast] = STATE(1031),
    [sym_unary_expr] = STATE(1031),
    [sym_mul_expr] = STATE(1031),
    [sym_add_expr] = STATE(1031),
    [sym_in_expr] = STATE(1031),
    [sym_comp_term] = STATE(1031),
    [sym_instance_of] = STATE(1031),
    [sym_negation] = STATE(1031),
    [sym_if_term] = STATE(1031),
    [sym_conjunction] = STATE(1031),
    [sym_disjunction] = STATE(1031),
    [sym_implication] = STATE(1031),
    [sym_quantified] = STATE(1031),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1031),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [248] = {
    [sym_special_call] = STATE(858),
    [sym_prefix_cast] = STATE(858),
    [sym_unary_expr] = STATE(858),
    [sym_mul_expr] = STATE(858),
    [sym_add_expr] = STATE(858),
    [sym_in_expr] = STATE(858),
    [sym_comp_term] = STATE(858),
    [sym_instance_of] = STATE(858),
    [sym_negation] = STATE(858),
    [sym_if_term] = STATE(858),
    [sym_conjunction] = STATE(858),
    [sym_disjunction] = STATE(858),
    [sym_implication] = STATE(858),
    [sym_quantified] = STATE(858),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(858),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1839),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [249] = {
    [sym_special_call] = STATE(1138),
    [sym_prefix_cast] = STATE(1138),
    [sym_unary_expr] = STATE(1138),
    [sym_mul_expr] = STATE(1138),
    [sym_add_expr] = STATE(1138),
    [sym_in_expr] = STATE(1138),
    [sym_comp_term] = STATE(1138),
    [sym_instance_of] = STATE(1138),
    [sym_negation] = STATE(1138),
    [sym_if_term] = STATE(1138),
    [sym_conjunction] = STATE(1138),
    [sym_disjunction] = STATE(1138),
    [sym_implication] = STATE(1138),
    [sym_quantified] = STATE(1138),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1138),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [250] = {
    [sym_special_call] = STATE(844),
    [sym_prefix_cast] = STATE(844),
    [sym_unary_expr] = STATE(844),
    [sym_mul_expr] = STATE(844),
    [sym_add_expr] = STATE(844),
    [sym_in_expr] = STATE(844),
    [sym_comp_term] = STATE(844),
    [sym_instance_of] = STATE(844),
    [sym_negation] = STATE(844),
    [sym_if_term] = STATE(844),
    [sym_conjunction] = STATE(844),
    [sym_disjunction] = STATE(844),
    [sym_implication] = STATE(844),
    [sym_quantified] = STATE(844),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(844),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1839),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [251] = {
    [sym_special_call] = STATE(811),
    [sym_prefix_cast] = STATE(811),
    [sym_unary_expr] = STATE(811),
    [sym_mul_expr] = STATE(811),
    [sym_add_expr] = STATE(811),
    [sym_in_expr] = STATE(811),
    [sym_comp_term] = STATE(811),
    [sym_instance_of] = STATE(811),
    [sym_negation] = STATE(811),
    [sym_if_term] = STATE(811),
    [sym_conjunction] = STATE(811),
    [sym_disjunction] = STATE(811),
    [sym_implication] = STATE(811),
    [sym_quantified] = STATE(811),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(811),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [252] = {
    [sym_special_call] = STATE(851),
    [sym_prefix_cast] = STATE(851),
    [sym_unary_expr] = STATE(851),
    [sym_mul_expr] = STATE(851),
    [sym_add_expr] = STATE(851),
    [sym_in_expr] = STATE(851),
    [sym_comp_term] = STATE(851),
    [sym_instance_of] = STATE(851),
    [sym_negation] = STATE(851),
    [sym_if_term] = STATE(851),
    [sym_conjunction] = STATE(851),
    [sym_disjunction] = STATE(851),
    [sym_implication] = STATE(851),
    [sym_quantified] = STATE(851),
    [sym_quantifier] = STATE(2008),
    [sym_call_or_unqual_agg_expr] = STATE(902),
    [sym_qualified_expr] = STATE(902),
    [sym_super_ref] = STATE(902),
    [sym_aggregate] = STATE(902),
    [sym_range] = STATE(902),
    [sym_set_literal] = STATE(902),
    [sym_par_expr] = STATE(902),
    [sym_expr_annotation] = STATE(902),
    [sym__exprOrTerm] = STATE(851),
    [sym__primary] = STATE(902),
    [sym_literal] = STATE(902),
    [sym_bool] = STATE(883),
    [sym_variable] = STATE(902),
    [sym_unop] = STATE(237),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2013),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(860),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1839),
    [sym_aritylessPredicateExpr] = STATE(1482),
    [sym_varName] = STATE(891),
    [sym_aggId] = STATE(1769),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_not] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [sym_specialId] = ACTIONS(47),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(57),
    [sym_integer] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(63),
    [sym_result] = ACTIONS(65),
    [sym_super] = ACTIONS(67),
    [sym_this] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
  },
  [253] = {
    [sym_special_call] = STATE(1180),
    [sym_prefix_cast] = STATE(1180),
    [sym_unary_expr] = STATE(1180),
    [sym_mul_expr] = STATE(1180),
    [sym_add_expr] = STATE(1180),
    [sym_in_expr] = STATE(1180),
    [sym_comp_term] = STATE(1180),
    [sym_instance_of] = STATE(1180),
    [sym_negation] = STATE(1180),
    [sym_if_term] = STATE(1180),
    [sym_conjunction] = STATE(1180),
    [sym_disjunction] = STATE(1180),
    [sym_implication] = STATE(1180),
    [sym_quantified] = STATE(1180),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1180),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [254] = {
    [sym_special_call] = STATE(1028),
    [sym_prefix_cast] = STATE(1028),
    [sym_unary_expr] = STATE(1028),
    [sym_mul_expr] = STATE(1028),
    [sym_add_expr] = STATE(1028),
    [sym_in_expr] = STATE(1028),
    [sym_comp_term] = STATE(1028),
    [sym_instance_of] = STATE(1028),
    [sym_negation] = STATE(1028),
    [sym_if_term] = STATE(1028),
    [sym_conjunction] = STATE(1028),
    [sym_disjunction] = STATE(1028),
    [sym_implication] = STATE(1028),
    [sym_quantified] = STATE(1028),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1028),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [255] = {
    [sym_special_call] = STATE(840),
    [sym_prefix_cast] = STATE(840),
    [sym_unary_expr] = STATE(840),
    [sym_mul_expr] = STATE(840),
    [sym_add_expr] = STATE(840),
    [sym_in_expr] = STATE(840),
    [sym_comp_term] = STATE(840),
    [sym_instance_of] = STATE(840),
    [sym_negation] = STATE(840),
    [sym_if_term] = STATE(840),
    [sym_conjunction] = STATE(840),
    [sym_disjunction] = STATE(840),
    [sym_implication] = STATE(840),
    [sym_quantified] = STATE(840),
    [sym_quantifier] = STATE(1892),
    [sym_call_or_unqual_agg_expr] = STATE(1014),
    [sym_qualified_expr] = STATE(1014),
    [sym_super_ref] = STATE(1014),
    [sym_aggregate] = STATE(1014),
    [sym_range] = STATE(1014),
    [sym_set_literal] = STATE(1014),
    [sym_par_expr] = STATE(1014),
    [sym_expr_annotation] = STATE(1014),
    [sym__exprOrTerm] = STATE(840),
    [sym__primary] = STATE(1014),
    [sym_literal] = STATE(1014),
    [sym_bool] = STATE(1007),
    [sym_variable] = STATE(1014),
    [sym_unop] = STATE(174),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2016),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(871),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1893),
    [sym_aritylessPredicateExpr] = STATE(1475),
    [sym_varName] = STATE(1012),
    [sym_aggId] = STATE(1761),
    [sym__lower_id] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_not] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(539),
    [sym_specialId] = ACTIONS(541),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(543),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(545),
    [sym_integer] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(551),
    [sym_result] = ACTIONS(553),
    [sym_super] = ACTIONS(555),
    [sym_this] = ACTIONS(553),
    [sym_true] = ACTIONS(551),
  },
  [256] = {
    [sym_special_call] = STATE(1149),
    [sym_prefix_cast] = STATE(1149),
    [sym_unary_expr] = STATE(1149),
    [sym_mul_expr] = STATE(1149),
    [sym_add_expr] = STATE(1149),
    [sym_in_expr] = STATE(1149),
    [sym_comp_term] = STATE(1149),
    [sym_instance_of] = STATE(1149),
    [sym_negation] = STATE(1149),
    [sym_if_term] = STATE(1149),
    [sym_conjunction] = STATE(1149),
    [sym_disjunction] = STATE(1149),
    [sym_implication] = STATE(1149),
    [sym_quantified] = STATE(1149),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1149),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [257] = {
    [sym_special_call] = STATE(1182),
    [sym_prefix_cast] = STATE(1182),
    [sym_unary_expr] = STATE(1182),
    [sym_mul_expr] = STATE(1182),
    [sym_add_expr] = STATE(1182),
    [sym_in_expr] = STATE(1182),
    [sym_comp_term] = STATE(1182),
    [sym_instance_of] = STATE(1182),
    [sym_negation] = STATE(1182),
    [sym_if_term] = STATE(1182),
    [sym_conjunction] = STATE(1182),
    [sym_disjunction] = STATE(1182),
    [sym_implication] = STATE(1182),
    [sym_quantified] = STATE(1182),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1182),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [258] = {
    [sym_special_call] = STATE(387),
    [sym_prefix_cast] = STATE(387),
    [sym_unary_expr] = STATE(387),
    [sym_mul_expr] = STATE(387),
    [sym_add_expr] = STATE(387),
    [sym_in_expr] = STATE(387),
    [sym_comp_term] = STATE(387),
    [sym_instance_of] = STATE(387),
    [sym_negation] = STATE(387),
    [sym_if_term] = STATE(387),
    [sym_conjunction] = STATE(387),
    [sym_disjunction] = STATE(387),
    [sym_implication] = STATE(387),
    [sym_quantified] = STATE(387),
    [sym_quantifier] = STATE(1838),
    [sym_call_or_unqual_agg_expr] = STATE(474),
    [sym_qualified_expr] = STATE(474),
    [sym_super_ref] = STATE(474),
    [sym_aggregate] = STATE(474),
    [sym_range] = STATE(474),
    [sym_set_literal] = STATE(474),
    [sym_par_expr] = STATE(474),
    [sym_expr_annotation] = STATE(474),
    [sym__exprOrTerm] = STATE(387),
    [sym__primary] = STATE(474),
    [sym_literal] = STATE(474),
    [sym_bool] = STATE(470),
    [sym_variable] = STATE(474),
    [sym_unop] = STATE(258),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2014),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(419),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(2009),
    [sym_aritylessPredicateExpr] = STATE(1472),
    [sym_varName] = STATE(472),
    [sym_aggId] = STATE(1773),
    [sym__lower_id] = ACTIONS(323),
    [anon_sym_LPAREN] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(327),
    [anon_sym_if] = ACTIONS(329),
    [sym_specialId] = ACTIONS(331),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(335),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(341),
    [sym_result] = ACTIONS(343),
    [sym_super] = ACTIONS(345),
    [sym_this] = ACTIONS(343),
    [sym_true] = ACTIONS(341),
  },
  [259] = {
    [sym_special_call] = STATE(1148),
    [sym_prefix_cast] = STATE(1148),
    [sym_unary_expr] = STATE(1148),
    [sym_mul_expr] = STATE(1148),
    [sym_add_expr] = STATE(1148),
    [sym_in_expr] = STATE(1148),
    [sym_comp_term] = STATE(1148),
    [sym_instance_of] = STATE(1148),
    [sym_negation] = STATE(1148),
    [sym_if_term] = STATE(1148),
    [sym_conjunction] = STATE(1148),
    [sym_disjunction] = STATE(1148),
    [sym_implication] = STATE(1148),
    [sym_quantified] = STATE(1148),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1148),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [260] = {
    [sym_special_call] = STATE(374),
    [sym_prefix_cast] = STATE(374),
    [sym_unary_expr] = STATE(374),
    [sym_mul_expr] = STATE(374),
    [sym_add_expr] = STATE(374),
    [sym_in_expr] = STATE(374),
    [sym_comp_term] = STATE(374),
    [sym_instance_of] = STATE(374),
    [sym_negation] = STATE(374),
    [sym_if_term] = STATE(374),
    [sym_conjunction] = STATE(374),
    [sym_disjunction] = STATE(374),
    [sym_implication] = STATE(374),
    [sym_quantified] = STATE(374),
    [sym_quantifier] = STATE(1838),
    [sym_call_or_unqual_agg_expr] = STATE(474),
    [sym_qualified_expr] = STATE(474),
    [sym_super_ref] = STATE(474),
    [sym_aggregate] = STATE(474),
    [sym_range] = STATE(474),
    [sym_set_literal] = STATE(474),
    [sym_par_expr] = STATE(474),
    [sym_expr_annotation] = STATE(474),
    [sym__exprOrTerm] = STATE(374),
    [sym__primary] = STATE(474),
    [sym_literal] = STATE(474),
    [sym_bool] = STATE(470),
    [sym_variable] = STATE(474),
    [sym_unop] = STATE(258),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2014),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(419),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(2009),
    [sym_aritylessPredicateExpr] = STATE(1472),
    [sym_varName] = STATE(472),
    [sym_aggId] = STATE(1773),
    [sym__lower_id] = ACTIONS(323),
    [anon_sym_LPAREN] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(327),
    [anon_sym_if] = ACTIONS(329),
    [sym_specialId] = ACTIONS(331),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(335),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(341),
    [sym_result] = ACTIONS(343),
    [sym_super] = ACTIONS(345),
    [sym_this] = ACTIONS(343),
    [sym_true] = ACTIONS(341),
  },
  [261] = {
    [sym_special_call] = STATE(375),
    [sym_prefix_cast] = STATE(375),
    [sym_unary_expr] = STATE(375),
    [sym_mul_expr] = STATE(375),
    [sym_add_expr] = STATE(375),
    [sym_in_expr] = STATE(375),
    [sym_comp_term] = STATE(375),
    [sym_instance_of] = STATE(375),
    [sym_negation] = STATE(375),
    [sym_if_term] = STATE(375),
    [sym_conjunction] = STATE(375),
    [sym_disjunction] = STATE(375),
    [sym_implication] = STATE(375),
    [sym_quantified] = STATE(375),
    [sym_quantifier] = STATE(1838),
    [sym_call_or_unqual_agg_expr] = STATE(474),
    [sym_qualified_expr] = STATE(474),
    [sym_super_ref] = STATE(474),
    [sym_aggregate] = STATE(474),
    [sym_range] = STATE(474),
    [sym_set_literal] = STATE(474),
    [sym_par_expr] = STATE(474),
    [sym_expr_annotation] = STATE(474),
    [sym__exprOrTerm] = STATE(375),
    [sym__primary] = STATE(474),
    [sym_literal] = STATE(474),
    [sym_bool] = STATE(470),
    [sym_variable] = STATE(474),
    [sym_unop] = STATE(258),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2014),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(419),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(2009),
    [sym_aritylessPredicateExpr] = STATE(1472),
    [sym_varName] = STATE(472),
    [sym_aggId] = STATE(1773),
    [sym__lower_id] = ACTIONS(323),
    [anon_sym_LPAREN] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(327),
    [anon_sym_if] = ACTIONS(329),
    [sym_specialId] = ACTIONS(331),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(335),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(341),
    [sym_result] = ACTIONS(343),
    [sym_super] = ACTIONS(345),
    [sym_this] = ACTIONS(343),
    [sym_true] = ACTIONS(341),
  },
  [262] = {
    [sym_special_call] = STATE(378),
    [sym_prefix_cast] = STATE(378),
    [sym_unary_expr] = STATE(378),
    [sym_mul_expr] = STATE(378),
    [sym_add_expr] = STATE(378),
    [sym_in_expr] = STATE(378),
    [sym_comp_term] = STATE(378),
    [sym_instance_of] = STATE(378),
    [sym_negation] = STATE(378),
    [sym_if_term] = STATE(378),
    [sym_conjunction] = STATE(378),
    [sym_disjunction] = STATE(378),
    [sym_implication] = STATE(378),
    [sym_quantified] = STATE(378),
    [sym_quantifier] = STATE(1838),
    [sym_call_or_unqual_agg_expr] = STATE(474),
    [sym_qualified_expr] = STATE(474),
    [sym_super_ref] = STATE(474),
    [sym_aggregate] = STATE(474),
    [sym_range] = STATE(474),
    [sym_set_literal] = STATE(474),
    [sym_par_expr] = STATE(474),
    [sym_expr_annotation] = STATE(474),
    [sym__exprOrTerm] = STATE(378),
    [sym__primary] = STATE(474),
    [sym_literal] = STATE(474),
    [sym_bool] = STATE(470),
    [sym_variable] = STATE(474),
    [sym_unop] = STATE(258),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2014),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(419),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(2009),
    [sym_aritylessPredicateExpr] = STATE(1472),
    [sym_varName] = STATE(472),
    [sym_aggId] = STATE(1773),
    [sym__lower_id] = ACTIONS(323),
    [anon_sym_LPAREN] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(327),
    [anon_sym_if] = ACTIONS(329),
    [sym_specialId] = ACTIONS(331),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(335),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(341),
    [sym_result] = ACTIONS(343),
    [sym_super] = ACTIONS(345),
    [sym_this] = ACTIONS(343),
    [sym_true] = ACTIONS(341),
  },
  [263] = {
    [sym_special_call] = STATE(388),
    [sym_prefix_cast] = STATE(388),
    [sym_unary_expr] = STATE(388),
    [sym_mul_expr] = STATE(388),
    [sym_add_expr] = STATE(388),
    [sym_in_expr] = STATE(388),
    [sym_comp_term] = STATE(388),
    [sym_instance_of] = STATE(388),
    [sym_negation] = STATE(388),
    [sym_if_term] = STATE(388),
    [sym_conjunction] = STATE(388),
    [sym_disjunction] = STATE(388),
    [sym_implication] = STATE(388),
    [sym_quantified] = STATE(388),
    [sym_quantifier] = STATE(1838),
    [sym_call_or_unqual_agg_expr] = STATE(474),
    [sym_qualified_expr] = STATE(474),
    [sym_super_ref] = STATE(474),
    [sym_aggregate] = STATE(474),
    [sym_range] = STATE(474),
    [sym_set_literal] = STATE(474),
    [sym_par_expr] = STATE(474),
    [sym_expr_annotation] = STATE(474),
    [sym__exprOrTerm] = STATE(388),
    [sym__primary] = STATE(474),
    [sym_literal] = STATE(474),
    [sym_bool] = STATE(470),
    [sym_variable] = STATE(474),
    [sym_unop] = STATE(258),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2014),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(419),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(2009),
    [sym_aritylessPredicateExpr] = STATE(1472),
    [sym_varName] = STATE(472),
    [sym_aggId] = STATE(1773),
    [sym__lower_id] = ACTIONS(323),
    [anon_sym_LPAREN] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(327),
    [anon_sym_if] = ACTIONS(329),
    [sym_specialId] = ACTIONS(331),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(335),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(341),
    [sym_result] = ACTIONS(343),
    [sym_super] = ACTIONS(345),
    [sym_this] = ACTIONS(343),
    [sym_true] = ACTIONS(341),
  },
  [264] = {
    [sym_special_call] = STATE(390),
    [sym_prefix_cast] = STATE(390),
    [sym_unary_expr] = STATE(390),
    [sym_mul_expr] = STATE(390),
    [sym_add_expr] = STATE(390),
    [sym_in_expr] = STATE(390),
    [sym_comp_term] = STATE(390),
    [sym_instance_of] = STATE(390),
    [sym_negation] = STATE(390),
    [sym_if_term] = STATE(390),
    [sym_conjunction] = STATE(390),
    [sym_disjunction] = STATE(390),
    [sym_implication] = STATE(390),
    [sym_quantified] = STATE(390),
    [sym_quantifier] = STATE(1838),
    [sym_call_or_unqual_agg_expr] = STATE(474),
    [sym_qualified_expr] = STATE(474),
    [sym_super_ref] = STATE(474),
    [sym_aggregate] = STATE(474),
    [sym_range] = STATE(474),
    [sym_set_literal] = STATE(474),
    [sym_par_expr] = STATE(474),
    [sym_expr_annotation] = STATE(474),
    [sym__exprOrTerm] = STATE(390),
    [sym__primary] = STATE(474),
    [sym_literal] = STATE(474),
    [sym_bool] = STATE(470),
    [sym_variable] = STATE(474),
    [sym_unop] = STATE(258),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2014),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(419),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(2009),
    [sym_aritylessPredicateExpr] = STATE(1472),
    [sym_varName] = STATE(472),
    [sym_aggId] = STATE(1773),
    [sym__lower_id] = ACTIONS(323),
    [anon_sym_LPAREN] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(327),
    [anon_sym_if] = ACTIONS(329),
    [sym_specialId] = ACTIONS(331),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(335),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(341),
    [sym_result] = ACTIONS(343),
    [sym_super] = ACTIONS(345),
    [sym_this] = ACTIONS(343),
    [sym_true] = ACTIONS(341),
  },
  [265] = {
    [sym_special_call] = STATE(413),
    [sym_prefix_cast] = STATE(413),
    [sym_unary_expr] = STATE(413),
    [sym_mul_expr] = STATE(413),
    [sym_add_expr] = STATE(413),
    [sym_in_expr] = STATE(413),
    [sym_comp_term] = STATE(413),
    [sym_instance_of] = STATE(413),
    [sym_negation] = STATE(413),
    [sym_if_term] = STATE(413),
    [sym_conjunction] = STATE(413),
    [sym_disjunction] = STATE(413),
    [sym_implication] = STATE(413),
    [sym_quantified] = STATE(413),
    [sym_quantifier] = STATE(1919),
    [sym_call_or_unqual_agg_expr] = STATE(560),
    [sym_qualified_expr] = STATE(560),
    [sym_super_ref] = STATE(560),
    [sym_aggregate] = STATE(560),
    [sym_range] = STATE(560),
    [sym_set_literal] = STATE(560),
    [sym_par_expr] = STATE(560),
    [sym_expr_annotation] = STATE(560),
    [sym__exprOrTerm] = STATE(413),
    [sym__primary] = STATE(560),
    [sym_literal] = STATE(560),
    [sym_bool] = STATE(556),
    [sym_variable] = STATE(560),
    [sym_unop] = STATE(183),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2017),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(420),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1920),
    [sym_aritylessPredicateExpr] = STATE(1484),
    [sym_varName] = STATE(558),
    [sym_aggId] = STATE(1789),
    [sym__lower_id] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(505),
    [sym_specialId] = ACTIONS(507),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(509),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(511),
    [sym_integer] = ACTIONS(513),
    [sym_float] = ACTIONS(515),
    [sym_string] = ACTIONS(515),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(517),
    [sym_result] = ACTIONS(519),
    [sym_super] = ACTIONS(521),
    [sym_this] = ACTIONS(519),
    [sym_true] = ACTIONS(517),
  },
  [266] = {
    [sym_special_call] = STATE(1076),
    [sym_prefix_cast] = STATE(1076),
    [sym_unary_expr] = STATE(1076),
    [sym_mul_expr] = STATE(1076),
    [sym_add_expr] = STATE(1076),
    [sym_in_expr] = STATE(1076),
    [sym_comp_term] = STATE(1076),
    [sym_instance_of] = STATE(1076),
    [sym_negation] = STATE(1076),
    [sym_if_term] = STATE(1076),
    [sym_conjunction] = STATE(1076),
    [sym_disjunction] = STATE(1076),
    [sym_implication] = STATE(1076),
    [sym_quantified] = STATE(1076),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1076),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1798),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [267] = {
    [sym_special_call] = STATE(1084),
    [sym_prefix_cast] = STATE(1084),
    [sym_unary_expr] = STATE(1084),
    [sym_mul_expr] = STATE(1084),
    [sym_add_expr] = STATE(1084),
    [sym_in_expr] = STATE(1084),
    [sym_comp_term] = STATE(1084),
    [sym_instance_of] = STATE(1084),
    [sym_negation] = STATE(1084),
    [sym_if_term] = STATE(1084),
    [sym_conjunction] = STATE(1084),
    [sym_disjunction] = STATE(1084),
    [sym_implication] = STATE(1084),
    [sym_quantified] = STATE(1084),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1084),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [268] = {
    [sym_special_call] = STATE(1085),
    [sym_prefix_cast] = STATE(1085),
    [sym_unary_expr] = STATE(1085),
    [sym_mul_expr] = STATE(1085),
    [sym_add_expr] = STATE(1085),
    [sym_in_expr] = STATE(1085),
    [sym_comp_term] = STATE(1085),
    [sym_instance_of] = STATE(1085),
    [sym_negation] = STATE(1085),
    [sym_if_term] = STATE(1085),
    [sym_conjunction] = STATE(1085),
    [sym_disjunction] = STATE(1085),
    [sym_implication] = STATE(1085),
    [sym_quantified] = STATE(1085),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1085),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [269] = {
    [sym_special_call] = STATE(906),
    [sym_prefix_cast] = STATE(906),
    [sym_unary_expr] = STATE(906),
    [sym_mul_expr] = STATE(906),
    [sym_add_expr] = STATE(906),
    [sym_in_expr] = STATE(906),
    [sym_comp_term] = STATE(906),
    [sym_instance_of] = STATE(906),
    [sym_negation] = STATE(906),
    [sym_if_term] = STATE(906),
    [sym_conjunction] = STATE(906),
    [sym_disjunction] = STATE(906),
    [sym_implication] = STATE(906),
    [sym_quantified] = STATE(906),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(906),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [270] = {
    [sym_special_call] = STATE(391),
    [sym_prefix_cast] = STATE(391),
    [sym_unary_expr] = STATE(391),
    [sym_mul_expr] = STATE(391),
    [sym_add_expr] = STATE(391),
    [sym_in_expr] = STATE(391),
    [sym_comp_term] = STATE(391),
    [sym_instance_of] = STATE(391),
    [sym_negation] = STATE(391),
    [sym_if_term] = STATE(391),
    [sym_conjunction] = STATE(391),
    [sym_disjunction] = STATE(391),
    [sym_implication] = STATE(391),
    [sym_quantified] = STATE(391),
    [sym_quantifier] = STATE(1838),
    [sym_call_or_unqual_agg_expr] = STATE(474),
    [sym_qualified_expr] = STATE(474),
    [sym_super_ref] = STATE(474),
    [sym_aggregate] = STATE(474),
    [sym_range] = STATE(474),
    [sym_set_literal] = STATE(474),
    [sym_par_expr] = STATE(474),
    [sym_expr_annotation] = STATE(474),
    [sym__exprOrTerm] = STATE(391),
    [sym__primary] = STATE(474),
    [sym_literal] = STATE(474),
    [sym_bool] = STATE(470),
    [sym_variable] = STATE(474),
    [sym_unop] = STATE(258),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2014),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(419),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(2009),
    [sym_aritylessPredicateExpr] = STATE(1472),
    [sym_varName] = STATE(472),
    [sym_aggId] = STATE(1773),
    [sym__lower_id] = ACTIONS(323),
    [anon_sym_LPAREN] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(327),
    [anon_sym_if] = ACTIONS(329),
    [sym_specialId] = ACTIONS(331),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(335),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(341),
    [sym_result] = ACTIONS(343),
    [sym_super] = ACTIONS(345),
    [sym_this] = ACTIONS(343),
    [sym_true] = ACTIONS(341),
  },
  [271] = {
    [sym_special_call] = STATE(1092),
    [sym_prefix_cast] = STATE(1092),
    [sym_unary_expr] = STATE(1092),
    [sym_mul_expr] = STATE(1092),
    [sym_add_expr] = STATE(1092),
    [sym_in_expr] = STATE(1092),
    [sym_comp_term] = STATE(1092),
    [sym_instance_of] = STATE(1092),
    [sym_negation] = STATE(1092),
    [sym_if_term] = STATE(1092),
    [sym_conjunction] = STATE(1092),
    [sym_disjunction] = STATE(1092),
    [sym_implication] = STATE(1092),
    [sym_quantified] = STATE(1092),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1092),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [272] = {
    [sym_special_call] = STATE(1094),
    [sym_prefix_cast] = STATE(1094),
    [sym_unary_expr] = STATE(1094),
    [sym_mul_expr] = STATE(1094),
    [sym_add_expr] = STATE(1094),
    [sym_in_expr] = STATE(1094),
    [sym_comp_term] = STATE(1094),
    [sym_instance_of] = STATE(1094),
    [sym_negation] = STATE(1094),
    [sym_if_term] = STATE(1094),
    [sym_conjunction] = STATE(1094),
    [sym_disjunction] = STATE(1094),
    [sym_implication] = STATE(1094),
    [sym_quantified] = STATE(1094),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1094),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [273] = {
    [sym_special_call] = STATE(915),
    [sym_prefix_cast] = STATE(915),
    [sym_unary_expr] = STATE(915),
    [sym_mul_expr] = STATE(915),
    [sym_add_expr] = STATE(915),
    [sym_in_expr] = STATE(915),
    [sym_comp_term] = STATE(915),
    [sym_instance_of] = STATE(915),
    [sym_negation] = STATE(915),
    [sym_if_term] = STATE(915),
    [sym_conjunction] = STATE(915),
    [sym_disjunction] = STATE(915),
    [sym_implication] = STATE(915),
    [sym_quantified] = STATE(915),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(915),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [274] = {
    [sym_special_call] = STATE(1096),
    [sym_prefix_cast] = STATE(1096),
    [sym_unary_expr] = STATE(1096),
    [sym_mul_expr] = STATE(1096),
    [sym_add_expr] = STATE(1096),
    [sym_in_expr] = STATE(1096),
    [sym_comp_term] = STATE(1096),
    [sym_instance_of] = STATE(1096),
    [sym_negation] = STATE(1096),
    [sym_if_term] = STATE(1096),
    [sym_conjunction] = STATE(1096),
    [sym_disjunction] = STATE(1096),
    [sym_implication] = STATE(1096),
    [sym_quantified] = STATE(1096),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1096),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [275] = {
    [sym_special_call] = STATE(397),
    [sym_prefix_cast] = STATE(397),
    [sym_unary_expr] = STATE(397),
    [sym_mul_expr] = STATE(397),
    [sym_add_expr] = STATE(397),
    [sym_in_expr] = STATE(397),
    [sym_comp_term] = STATE(397),
    [sym_instance_of] = STATE(397),
    [sym_negation] = STATE(397),
    [sym_if_term] = STATE(397),
    [sym_conjunction] = STATE(397),
    [sym_disjunction] = STATE(397),
    [sym_implication] = STATE(397),
    [sym_quantified] = STATE(397),
    [sym_quantifier] = STATE(1838),
    [sym_call_or_unqual_agg_expr] = STATE(474),
    [sym_qualified_expr] = STATE(474),
    [sym_super_ref] = STATE(474),
    [sym_aggregate] = STATE(474),
    [sym_range] = STATE(474),
    [sym_set_literal] = STATE(474),
    [sym_par_expr] = STATE(474),
    [sym_expr_annotation] = STATE(474),
    [sym__exprOrTerm] = STATE(397),
    [sym__primary] = STATE(474),
    [sym_literal] = STATE(474),
    [sym_bool] = STATE(470),
    [sym_variable] = STATE(474),
    [sym_unop] = STATE(258),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2014),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(419),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(2009),
    [sym_aritylessPredicateExpr] = STATE(1472),
    [sym_varName] = STATE(472),
    [sym_aggId] = STATE(1773),
    [sym__lower_id] = ACTIONS(323),
    [anon_sym_LPAREN] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(327),
    [anon_sym_if] = ACTIONS(329),
    [sym_specialId] = ACTIONS(331),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(335),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(341),
    [sym_result] = ACTIONS(343),
    [sym_super] = ACTIONS(345),
    [sym_this] = ACTIONS(343),
    [sym_true] = ACTIONS(341),
  },
  [276] = {
    [sym_special_call] = STATE(1098),
    [sym_prefix_cast] = STATE(1098),
    [sym_unary_expr] = STATE(1098),
    [sym_mul_expr] = STATE(1098),
    [sym_add_expr] = STATE(1098),
    [sym_in_expr] = STATE(1098),
    [sym_comp_term] = STATE(1098),
    [sym_instance_of] = STATE(1098),
    [sym_negation] = STATE(1098),
    [sym_if_term] = STATE(1098),
    [sym_conjunction] = STATE(1098),
    [sym_disjunction] = STATE(1098),
    [sym_implication] = STATE(1098),
    [sym_quantified] = STATE(1098),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1098),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [277] = {
    [sym_special_call] = STATE(1102),
    [sym_prefix_cast] = STATE(1102),
    [sym_unary_expr] = STATE(1102),
    [sym_mul_expr] = STATE(1102),
    [sym_add_expr] = STATE(1102),
    [sym_in_expr] = STATE(1102),
    [sym_comp_term] = STATE(1102),
    [sym_instance_of] = STATE(1102),
    [sym_negation] = STATE(1102),
    [sym_if_term] = STATE(1102),
    [sym_conjunction] = STATE(1102),
    [sym_disjunction] = STATE(1102),
    [sym_implication] = STATE(1102),
    [sym_quantified] = STATE(1102),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1102),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [278] = {
    [sym_special_call] = STATE(1143),
    [sym_prefix_cast] = STATE(1143),
    [sym_unary_expr] = STATE(1143),
    [sym_mul_expr] = STATE(1143),
    [sym_add_expr] = STATE(1143),
    [sym_in_expr] = STATE(1143),
    [sym_comp_term] = STATE(1143),
    [sym_instance_of] = STATE(1143),
    [sym_negation] = STATE(1143),
    [sym_if_term] = STATE(1143),
    [sym_conjunction] = STATE(1143),
    [sym_disjunction] = STATE(1143),
    [sym_implication] = STATE(1143),
    [sym_quantified] = STATE(1143),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1143),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1770),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [279] = {
    [sym_special_call] = STATE(1107),
    [sym_prefix_cast] = STATE(1107),
    [sym_unary_expr] = STATE(1107),
    [sym_mul_expr] = STATE(1107),
    [sym_add_expr] = STATE(1107),
    [sym_in_expr] = STATE(1107),
    [sym_comp_term] = STATE(1107),
    [sym_instance_of] = STATE(1107),
    [sym_negation] = STATE(1107),
    [sym_if_term] = STATE(1107),
    [sym_conjunction] = STATE(1107),
    [sym_disjunction] = STATE(1107),
    [sym_implication] = STATE(1107),
    [sym_quantified] = STATE(1107),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1107),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [280] = {
    [sym_special_call] = STATE(1108),
    [sym_prefix_cast] = STATE(1108),
    [sym_unary_expr] = STATE(1108),
    [sym_mul_expr] = STATE(1108),
    [sym_add_expr] = STATE(1108),
    [sym_in_expr] = STATE(1108),
    [sym_comp_term] = STATE(1108),
    [sym_instance_of] = STATE(1108),
    [sym_negation] = STATE(1108),
    [sym_if_term] = STATE(1108),
    [sym_conjunction] = STATE(1108),
    [sym_disjunction] = STATE(1108),
    [sym_implication] = STATE(1108),
    [sym_quantified] = STATE(1108),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1108),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [281] = {
    [sym_special_call] = STATE(937),
    [sym_prefix_cast] = STATE(937),
    [sym_unary_expr] = STATE(937),
    [sym_mul_expr] = STATE(937),
    [sym_add_expr] = STATE(937),
    [sym_in_expr] = STATE(937),
    [sym_comp_term] = STATE(937),
    [sym_instance_of] = STATE(937),
    [sym_negation] = STATE(937),
    [sym_if_term] = STATE(937),
    [sym_conjunction] = STATE(937),
    [sym_disjunction] = STATE(937),
    [sym_implication] = STATE(937),
    [sym_quantified] = STATE(937),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(937),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [282] = {
    [sym_special_call] = STATE(940),
    [sym_prefix_cast] = STATE(940),
    [sym_unary_expr] = STATE(940),
    [sym_mul_expr] = STATE(940),
    [sym_add_expr] = STATE(940),
    [sym_in_expr] = STATE(940),
    [sym_comp_term] = STATE(940),
    [sym_instance_of] = STATE(940),
    [sym_negation] = STATE(940),
    [sym_if_term] = STATE(940),
    [sym_conjunction] = STATE(940),
    [sym_disjunction] = STATE(940),
    [sym_implication] = STATE(940),
    [sym_quantified] = STATE(940),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(940),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [283] = {
    [sym_special_call] = STATE(1110),
    [sym_prefix_cast] = STATE(1110),
    [sym_unary_expr] = STATE(1110),
    [sym_mul_expr] = STATE(1110),
    [sym_add_expr] = STATE(1110),
    [sym_in_expr] = STATE(1110),
    [sym_comp_term] = STATE(1110),
    [sym_instance_of] = STATE(1110),
    [sym_negation] = STATE(1110),
    [sym_if_term] = STATE(1110),
    [sym_conjunction] = STATE(1110),
    [sym_disjunction] = STATE(1110),
    [sym_implication] = STATE(1110),
    [sym_quantified] = STATE(1110),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1110),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [284] = {
    [sym_special_call] = STATE(942),
    [sym_prefix_cast] = STATE(942),
    [sym_unary_expr] = STATE(942),
    [sym_mul_expr] = STATE(942),
    [sym_add_expr] = STATE(942),
    [sym_in_expr] = STATE(942),
    [sym_comp_term] = STATE(942),
    [sym_instance_of] = STATE(942),
    [sym_negation] = STATE(942),
    [sym_if_term] = STATE(942),
    [sym_conjunction] = STATE(942),
    [sym_disjunction] = STATE(942),
    [sym_implication] = STATE(942),
    [sym_quantified] = STATE(942),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(942),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [285] = {
    [sym_special_call] = STATE(1111),
    [sym_prefix_cast] = STATE(1111),
    [sym_unary_expr] = STATE(1111),
    [sym_mul_expr] = STATE(1111),
    [sym_add_expr] = STATE(1111),
    [sym_in_expr] = STATE(1111),
    [sym_comp_term] = STATE(1111),
    [sym_instance_of] = STATE(1111),
    [sym_negation] = STATE(1111),
    [sym_if_term] = STATE(1111),
    [sym_conjunction] = STATE(1111),
    [sym_disjunction] = STATE(1111),
    [sym_implication] = STATE(1111),
    [sym_quantified] = STATE(1111),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1111),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [286] = {
    [sym_special_call] = STATE(1112),
    [sym_prefix_cast] = STATE(1112),
    [sym_unary_expr] = STATE(1112),
    [sym_mul_expr] = STATE(1112),
    [sym_add_expr] = STATE(1112),
    [sym_in_expr] = STATE(1112),
    [sym_comp_term] = STATE(1112),
    [sym_instance_of] = STATE(1112),
    [sym_negation] = STATE(1112),
    [sym_if_term] = STATE(1112),
    [sym_conjunction] = STATE(1112),
    [sym_disjunction] = STATE(1112),
    [sym_implication] = STATE(1112),
    [sym_quantified] = STATE(1112),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1112),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [287] = {
    [sym_special_call] = STATE(400),
    [sym_prefix_cast] = STATE(400),
    [sym_unary_expr] = STATE(400),
    [sym_mul_expr] = STATE(400),
    [sym_add_expr] = STATE(400),
    [sym_in_expr] = STATE(400),
    [sym_comp_term] = STATE(400),
    [sym_instance_of] = STATE(400),
    [sym_negation] = STATE(400),
    [sym_if_term] = STATE(400),
    [sym_conjunction] = STATE(400),
    [sym_disjunction] = STATE(400),
    [sym_implication] = STATE(400),
    [sym_quantified] = STATE(400),
    [sym_quantifier] = STATE(1838),
    [sym_call_or_unqual_agg_expr] = STATE(474),
    [sym_qualified_expr] = STATE(474),
    [sym_super_ref] = STATE(474),
    [sym_aggregate] = STATE(474),
    [sym_range] = STATE(474),
    [sym_set_literal] = STATE(474),
    [sym_par_expr] = STATE(474),
    [sym_expr_annotation] = STATE(474),
    [sym__exprOrTerm] = STATE(400),
    [sym__primary] = STATE(474),
    [sym_literal] = STATE(474),
    [sym_bool] = STATE(470),
    [sym_variable] = STATE(474),
    [sym_unop] = STATE(258),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2014),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(419),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(2009),
    [sym_aritylessPredicateExpr] = STATE(1472),
    [sym_varName] = STATE(472),
    [sym_aggId] = STATE(1773),
    [sym__lower_id] = ACTIONS(323),
    [anon_sym_LPAREN] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(327),
    [anon_sym_if] = ACTIONS(329),
    [sym_specialId] = ACTIONS(331),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(335),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(341),
    [sym_result] = ACTIONS(343),
    [sym_super] = ACTIONS(345),
    [sym_this] = ACTIONS(343),
    [sym_true] = ACTIONS(341),
  },
  [288] = {
    [sym_special_call] = STATE(1113),
    [sym_prefix_cast] = STATE(1113),
    [sym_unary_expr] = STATE(1113),
    [sym_mul_expr] = STATE(1113),
    [sym_add_expr] = STATE(1113),
    [sym_in_expr] = STATE(1113),
    [sym_comp_term] = STATE(1113),
    [sym_instance_of] = STATE(1113),
    [sym_negation] = STATE(1113),
    [sym_if_term] = STATE(1113),
    [sym_conjunction] = STATE(1113),
    [sym_disjunction] = STATE(1113),
    [sym_implication] = STATE(1113),
    [sym_quantified] = STATE(1113),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1113),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [289] = {
    [sym_special_call] = STATE(1104),
    [sym_prefix_cast] = STATE(1104),
    [sym_unary_expr] = STATE(1104),
    [sym_mul_expr] = STATE(1104),
    [sym_add_expr] = STATE(1104),
    [sym_in_expr] = STATE(1104),
    [sym_comp_term] = STATE(1104),
    [sym_instance_of] = STATE(1104),
    [sym_negation] = STATE(1104),
    [sym_if_term] = STATE(1104),
    [sym_conjunction] = STATE(1104),
    [sym_disjunction] = STATE(1104),
    [sym_implication] = STATE(1104),
    [sym_quantified] = STATE(1104),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1104),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1795),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [290] = {
    [sym_special_call] = STATE(1119),
    [sym_prefix_cast] = STATE(1119),
    [sym_unary_expr] = STATE(1119),
    [sym_mul_expr] = STATE(1119),
    [sym_add_expr] = STATE(1119),
    [sym_in_expr] = STATE(1119),
    [sym_comp_term] = STATE(1119),
    [sym_instance_of] = STATE(1119),
    [sym_negation] = STATE(1119),
    [sym_if_term] = STATE(1119),
    [sym_conjunction] = STATE(1119),
    [sym_disjunction] = STATE(1119),
    [sym_implication] = STATE(1119),
    [sym_quantified] = STATE(1119),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1119),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [291] = {
    [sym_special_call] = STATE(1120),
    [sym_prefix_cast] = STATE(1120),
    [sym_unary_expr] = STATE(1120),
    [sym_mul_expr] = STATE(1120),
    [sym_add_expr] = STATE(1120),
    [sym_in_expr] = STATE(1120),
    [sym_comp_term] = STATE(1120),
    [sym_instance_of] = STATE(1120),
    [sym_negation] = STATE(1120),
    [sym_if_term] = STATE(1120),
    [sym_conjunction] = STATE(1120),
    [sym_disjunction] = STATE(1120),
    [sym_implication] = STATE(1120),
    [sym_quantified] = STATE(1120),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1120),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [292] = {
    [sym_special_call] = STATE(946),
    [sym_prefix_cast] = STATE(946),
    [sym_unary_expr] = STATE(946),
    [sym_mul_expr] = STATE(946),
    [sym_add_expr] = STATE(946),
    [sym_in_expr] = STATE(946),
    [sym_comp_term] = STATE(946),
    [sym_instance_of] = STATE(946),
    [sym_negation] = STATE(946),
    [sym_if_term] = STATE(946),
    [sym_conjunction] = STATE(946),
    [sym_disjunction] = STATE(946),
    [sym_implication] = STATE(946),
    [sym_quantified] = STATE(946),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(946),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [293] = {
    [sym_special_call] = STATE(950),
    [sym_prefix_cast] = STATE(950),
    [sym_unary_expr] = STATE(950),
    [sym_mul_expr] = STATE(950),
    [sym_add_expr] = STATE(950),
    [sym_in_expr] = STATE(950),
    [sym_comp_term] = STATE(950),
    [sym_instance_of] = STATE(950),
    [sym_negation] = STATE(950),
    [sym_if_term] = STATE(950),
    [sym_conjunction] = STATE(950),
    [sym_disjunction] = STATE(950),
    [sym_implication] = STATE(950),
    [sym_quantified] = STATE(950),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(950),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [294] = {
    [sym_special_call] = STATE(1123),
    [sym_prefix_cast] = STATE(1123),
    [sym_unary_expr] = STATE(1123),
    [sym_mul_expr] = STATE(1123),
    [sym_add_expr] = STATE(1123),
    [sym_in_expr] = STATE(1123),
    [sym_comp_term] = STATE(1123),
    [sym_instance_of] = STATE(1123),
    [sym_negation] = STATE(1123),
    [sym_if_term] = STATE(1123),
    [sym_conjunction] = STATE(1123),
    [sym_disjunction] = STATE(1123),
    [sym_implication] = STATE(1123),
    [sym_quantified] = STATE(1123),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1123),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [295] = {
    [sym_special_call] = STATE(952),
    [sym_prefix_cast] = STATE(952),
    [sym_unary_expr] = STATE(952),
    [sym_mul_expr] = STATE(952),
    [sym_add_expr] = STATE(952),
    [sym_in_expr] = STATE(952),
    [sym_comp_term] = STATE(952),
    [sym_instance_of] = STATE(952),
    [sym_negation] = STATE(952),
    [sym_if_term] = STATE(952),
    [sym_conjunction] = STATE(952),
    [sym_disjunction] = STATE(952),
    [sym_implication] = STATE(952),
    [sym_quantified] = STATE(952),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(952),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [296] = {
    [sym_special_call] = STATE(1124),
    [sym_prefix_cast] = STATE(1124),
    [sym_unary_expr] = STATE(1124),
    [sym_mul_expr] = STATE(1124),
    [sym_add_expr] = STATE(1124),
    [sym_in_expr] = STATE(1124),
    [sym_comp_term] = STATE(1124),
    [sym_instance_of] = STATE(1124),
    [sym_negation] = STATE(1124),
    [sym_if_term] = STATE(1124),
    [sym_conjunction] = STATE(1124),
    [sym_disjunction] = STATE(1124),
    [sym_implication] = STATE(1124),
    [sym_quantified] = STATE(1124),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1124),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [297] = {
    [sym_special_call] = STATE(410),
    [sym_prefix_cast] = STATE(410),
    [sym_unary_expr] = STATE(410),
    [sym_mul_expr] = STATE(410),
    [sym_add_expr] = STATE(410),
    [sym_in_expr] = STATE(410),
    [sym_comp_term] = STATE(410),
    [sym_instance_of] = STATE(410),
    [sym_negation] = STATE(410),
    [sym_if_term] = STATE(410),
    [sym_conjunction] = STATE(410),
    [sym_disjunction] = STATE(410),
    [sym_implication] = STATE(410),
    [sym_quantified] = STATE(410),
    [sym_quantifier] = STATE(1865),
    [sym_call_or_unqual_agg_expr] = STATE(517),
    [sym_qualified_expr] = STATE(517),
    [sym_super_ref] = STATE(517),
    [sym_aggregate] = STATE(517),
    [sym_range] = STATE(517),
    [sym_set_literal] = STATE(517),
    [sym_par_expr] = STATE(517),
    [sym_expr_annotation] = STATE(517),
    [sym__exprOrTerm] = STATE(410),
    [sym__primary] = STATE(517),
    [sym_literal] = STATE(517),
    [sym_bool] = STATE(513),
    [sym_variable] = STATE(517),
    [sym_unop] = STATE(297),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2015),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(421),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1866),
    [sym_aritylessPredicateExpr] = STATE(1477),
    [sym_varName] = STATE(598),
    [sym_aggId] = STATE(1778),
    [sym__lower_id] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(469),
    [anon_sym_not] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [sym_specialId] = ACTIONS(475),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(479),
    [sym_integer] = ACTIONS(481),
    [sym_float] = ACTIONS(483),
    [sym_string] = ACTIONS(483),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(485),
    [sym_result] = ACTIONS(487),
    [sym_super] = ACTIONS(489),
    [sym_this] = ACTIONS(487),
    [sym_true] = ACTIONS(485),
  },
  [298] = {
    [sym_special_call] = STATE(1125),
    [sym_prefix_cast] = STATE(1125),
    [sym_unary_expr] = STATE(1125),
    [sym_mul_expr] = STATE(1125),
    [sym_add_expr] = STATE(1125),
    [sym_in_expr] = STATE(1125),
    [sym_comp_term] = STATE(1125),
    [sym_instance_of] = STATE(1125),
    [sym_negation] = STATE(1125),
    [sym_if_term] = STATE(1125),
    [sym_conjunction] = STATE(1125),
    [sym_disjunction] = STATE(1125),
    [sym_implication] = STATE(1125),
    [sym_quantified] = STATE(1125),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1125),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [299] = {
    [sym_special_call] = STATE(1126),
    [sym_prefix_cast] = STATE(1126),
    [sym_unary_expr] = STATE(1126),
    [sym_mul_expr] = STATE(1126),
    [sym_add_expr] = STATE(1126),
    [sym_in_expr] = STATE(1126),
    [sym_comp_term] = STATE(1126),
    [sym_instance_of] = STATE(1126),
    [sym_negation] = STATE(1126),
    [sym_if_term] = STATE(1126),
    [sym_conjunction] = STATE(1126),
    [sym_disjunction] = STATE(1126),
    [sym_implication] = STATE(1126),
    [sym_quantified] = STATE(1126),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1126),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [300] = {
    [sym_special_call] = STATE(381),
    [sym_prefix_cast] = STATE(381),
    [sym_unary_expr] = STATE(381),
    [sym_mul_expr] = STATE(381),
    [sym_add_expr] = STATE(381),
    [sym_in_expr] = STATE(381),
    [sym_comp_term] = STATE(381),
    [sym_instance_of] = STATE(381),
    [sym_negation] = STATE(381),
    [sym_if_term] = STATE(381),
    [sym_conjunction] = STATE(381),
    [sym_disjunction] = STATE(381),
    [sym_implication] = STATE(381),
    [sym_quantified] = STATE(381),
    [sym_quantifier] = STATE(1865),
    [sym_call_or_unqual_agg_expr] = STATE(517),
    [sym_qualified_expr] = STATE(517),
    [sym_super_ref] = STATE(517),
    [sym_aggregate] = STATE(517),
    [sym_range] = STATE(517),
    [sym_set_literal] = STATE(517),
    [sym_par_expr] = STATE(517),
    [sym_expr_annotation] = STATE(517),
    [sym__exprOrTerm] = STATE(381),
    [sym__primary] = STATE(517),
    [sym_literal] = STATE(517),
    [sym_bool] = STATE(513),
    [sym_variable] = STATE(517),
    [sym_unop] = STATE(297),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2015),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(421),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1866),
    [sym_aritylessPredicateExpr] = STATE(1477),
    [sym_varName] = STATE(598),
    [sym_aggId] = STATE(1778),
    [sym__lower_id] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(469),
    [anon_sym_not] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [sym_specialId] = ACTIONS(475),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(479),
    [sym_integer] = ACTIONS(481),
    [sym_float] = ACTIONS(483),
    [sym_string] = ACTIONS(483),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(485),
    [sym_result] = ACTIONS(487),
    [sym_super] = ACTIONS(489),
    [sym_this] = ACTIONS(487),
    [sym_true] = ACTIONS(485),
  },
  [301] = {
    [sym_special_call] = STATE(1115),
    [sym_prefix_cast] = STATE(1115),
    [sym_unary_expr] = STATE(1115),
    [sym_mul_expr] = STATE(1115),
    [sym_add_expr] = STATE(1115),
    [sym_in_expr] = STATE(1115),
    [sym_comp_term] = STATE(1115),
    [sym_instance_of] = STATE(1115),
    [sym_negation] = STATE(1115),
    [sym_if_term] = STATE(1115),
    [sym_conjunction] = STATE(1115),
    [sym_disjunction] = STATE(1115),
    [sym_implication] = STATE(1115),
    [sym_quantified] = STATE(1115),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1115),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1787),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [302] = {
    [sym_special_call] = STATE(1130),
    [sym_prefix_cast] = STATE(1130),
    [sym_unary_expr] = STATE(1130),
    [sym_mul_expr] = STATE(1130),
    [sym_add_expr] = STATE(1130),
    [sym_in_expr] = STATE(1130),
    [sym_comp_term] = STATE(1130),
    [sym_instance_of] = STATE(1130),
    [sym_negation] = STATE(1130),
    [sym_if_term] = STATE(1130),
    [sym_conjunction] = STATE(1130),
    [sym_disjunction] = STATE(1130),
    [sym_implication] = STATE(1130),
    [sym_quantified] = STATE(1130),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1130),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [303] = {
    [sym_special_call] = STATE(1131),
    [sym_prefix_cast] = STATE(1131),
    [sym_unary_expr] = STATE(1131),
    [sym_mul_expr] = STATE(1131),
    [sym_add_expr] = STATE(1131),
    [sym_in_expr] = STATE(1131),
    [sym_comp_term] = STATE(1131),
    [sym_instance_of] = STATE(1131),
    [sym_negation] = STATE(1131),
    [sym_if_term] = STATE(1131),
    [sym_conjunction] = STATE(1131),
    [sym_disjunction] = STATE(1131),
    [sym_implication] = STATE(1131),
    [sym_quantified] = STATE(1131),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1131),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [304] = {
    [sym_special_call] = STATE(959),
    [sym_prefix_cast] = STATE(959),
    [sym_unary_expr] = STATE(959),
    [sym_mul_expr] = STATE(959),
    [sym_add_expr] = STATE(959),
    [sym_in_expr] = STATE(959),
    [sym_comp_term] = STATE(959),
    [sym_instance_of] = STATE(959),
    [sym_negation] = STATE(959),
    [sym_if_term] = STATE(959),
    [sym_conjunction] = STATE(959),
    [sym_disjunction] = STATE(959),
    [sym_implication] = STATE(959),
    [sym_quantified] = STATE(959),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(959),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [305] = {
    [sym_special_call] = STATE(962),
    [sym_prefix_cast] = STATE(962),
    [sym_unary_expr] = STATE(962),
    [sym_mul_expr] = STATE(962),
    [sym_add_expr] = STATE(962),
    [sym_in_expr] = STATE(962),
    [sym_comp_term] = STATE(962),
    [sym_instance_of] = STATE(962),
    [sym_negation] = STATE(962),
    [sym_if_term] = STATE(962),
    [sym_conjunction] = STATE(962),
    [sym_disjunction] = STATE(962),
    [sym_implication] = STATE(962),
    [sym_quantified] = STATE(962),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(962),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [306] = {
    [sym_special_call] = STATE(1133),
    [sym_prefix_cast] = STATE(1133),
    [sym_unary_expr] = STATE(1133),
    [sym_mul_expr] = STATE(1133),
    [sym_add_expr] = STATE(1133),
    [sym_in_expr] = STATE(1133),
    [sym_comp_term] = STATE(1133),
    [sym_instance_of] = STATE(1133),
    [sym_negation] = STATE(1133),
    [sym_if_term] = STATE(1133),
    [sym_conjunction] = STATE(1133),
    [sym_disjunction] = STATE(1133),
    [sym_implication] = STATE(1133),
    [sym_quantified] = STATE(1133),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1133),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [307] = {
    [sym_special_call] = STATE(965),
    [sym_prefix_cast] = STATE(965),
    [sym_unary_expr] = STATE(965),
    [sym_mul_expr] = STATE(965),
    [sym_add_expr] = STATE(965),
    [sym_in_expr] = STATE(965),
    [sym_comp_term] = STATE(965),
    [sym_instance_of] = STATE(965),
    [sym_negation] = STATE(965),
    [sym_if_term] = STATE(965),
    [sym_conjunction] = STATE(965),
    [sym_disjunction] = STATE(965),
    [sym_implication] = STATE(965),
    [sym_quantified] = STATE(965),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(965),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [308] = {
    [sym_special_call] = STATE(1135),
    [sym_prefix_cast] = STATE(1135),
    [sym_unary_expr] = STATE(1135),
    [sym_mul_expr] = STATE(1135),
    [sym_add_expr] = STATE(1135),
    [sym_in_expr] = STATE(1135),
    [sym_comp_term] = STATE(1135),
    [sym_instance_of] = STATE(1135),
    [sym_negation] = STATE(1135),
    [sym_if_term] = STATE(1135),
    [sym_conjunction] = STATE(1135),
    [sym_disjunction] = STATE(1135),
    [sym_implication] = STATE(1135),
    [sym_quantified] = STATE(1135),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1135),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [309] = {
    [sym_special_call] = STATE(383),
    [sym_prefix_cast] = STATE(383),
    [sym_unary_expr] = STATE(383),
    [sym_mul_expr] = STATE(383),
    [sym_add_expr] = STATE(383),
    [sym_in_expr] = STATE(383),
    [sym_comp_term] = STATE(383),
    [sym_instance_of] = STATE(383),
    [sym_negation] = STATE(383),
    [sym_if_term] = STATE(383),
    [sym_conjunction] = STATE(383),
    [sym_disjunction] = STATE(383),
    [sym_implication] = STATE(383),
    [sym_quantified] = STATE(383),
    [sym_quantifier] = STATE(1865),
    [sym_call_or_unqual_agg_expr] = STATE(517),
    [sym_qualified_expr] = STATE(517),
    [sym_super_ref] = STATE(517),
    [sym_aggregate] = STATE(517),
    [sym_range] = STATE(517),
    [sym_set_literal] = STATE(517),
    [sym_par_expr] = STATE(517),
    [sym_expr_annotation] = STATE(517),
    [sym__exprOrTerm] = STATE(383),
    [sym__primary] = STATE(517),
    [sym_literal] = STATE(517),
    [sym_bool] = STATE(513),
    [sym_variable] = STATE(517),
    [sym_unop] = STATE(297),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2015),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(421),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1866),
    [sym_aritylessPredicateExpr] = STATE(1477),
    [sym_varName] = STATE(598),
    [sym_aggId] = STATE(1778),
    [sym__lower_id] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(469),
    [anon_sym_not] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [sym_specialId] = ACTIONS(475),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(479),
    [sym_integer] = ACTIONS(481),
    [sym_float] = ACTIONS(483),
    [sym_string] = ACTIONS(483),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(485),
    [sym_result] = ACTIONS(487),
    [sym_super] = ACTIONS(489),
    [sym_this] = ACTIONS(487),
    [sym_true] = ACTIONS(485),
  },
  [310] = {
    [sym_special_call] = STATE(384),
    [sym_prefix_cast] = STATE(384),
    [sym_unary_expr] = STATE(384),
    [sym_mul_expr] = STATE(384),
    [sym_add_expr] = STATE(384),
    [sym_in_expr] = STATE(384),
    [sym_comp_term] = STATE(384),
    [sym_instance_of] = STATE(384),
    [sym_negation] = STATE(384),
    [sym_if_term] = STATE(384),
    [sym_conjunction] = STATE(384),
    [sym_disjunction] = STATE(384),
    [sym_implication] = STATE(384),
    [sym_quantified] = STATE(384),
    [sym_quantifier] = STATE(1865),
    [sym_call_or_unqual_agg_expr] = STATE(517),
    [sym_qualified_expr] = STATE(517),
    [sym_super_ref] = STATE(517),
    [sym_aggregate] = STATE(517),
    [sym_range] = STATE(517),
    [sym_set_literal] = STATE(517),
    [sym_par_expr] = STATE(517),
    [sym_expr_annotation] = STATE(517),
    [sym__exprOrTerm] = STATE(384),
    [sym__primary] = STATE(517),
    [sym_literal] = STATE(517),
    [sym_bool] = STATE(513),
    [sym_variable] = STATE(517),
    [sym_unop] = STATE(297),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2015),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(421),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1866),
    [sym_aritylessPredicateExpr] = STATE(1477),
    [sym_varName] = STATE(598),
    [sym_aggId] = STATE(1778),
    [sym__lower_id] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(469),
    [anon_sym_not] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [sym_specialId] = ACTIONS(475),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(479),
    [sym_integer] = ACTIONS(481),
    [sym_float] = ACTIONS(483),
    [sym_string] = ACTIONS(483),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(485),
    [sym_result] = ACTIONS(487),
    [sym_super] = ACTIONS(489),
    [sym_this] = ACTIONS(487),
    [sym_true] = ACTIONS(485),
  },
  [311] = {
    [sym_special_call] = STATE(1136),
    [sym_prefix_cast] = STATE(1136),
    [sym_unary_expr] = STATE(1136),
    [sym_mul_expr] = STATE(1136),
    [sym_add_expr] = STATE(1136),
    [sym_in_expr] = STATE(1136),
    [sym_comp_term] = STATE(1136),
    [sym_instance_of] = STATE(1136),
    [sym_negation] = STATE(1136),
    [sym_if_term] = STATE(1136),
    [sym_conjunction] = STATE(1136),
    [sym_disjunction] = STATE(1136),
    [sym_implication] = STATE(1136),
    [sym_quantified] = STATE(1136),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1136),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [312] = {
    [sym_special_call] = STATE(386),
    [sym_prefix_cast] = STATE(386),
    [sym_unary_expr] = STATE(386),
    [sym_mul_expr] = STATE(386),
    [sym_add_expr] = STATE(386),
    [sym_in_expr] = STATE(386),
    [sym_comp_term] = STATE(386),
    [sym_instance_of] = STATE(386),
    [sym_negation] = STATE(386),
    [sym_if_term] = STATE(386),
    [sym_conjunction] = STATE(386),
    [sym_disjunction] = STATE(386),
    [sym_implication] = STATE(386),
    [sym_quantified] = STATE(386),
    [sym_quantifier] = STATE(1865),
    [sym_call_or_unqual_agg_expr] = STATE(517),
    [sym_qualified_expr] = STATE(517),
    [sym_super_ref] = STATE(517),
    [sym_aggregate] = STATE(517),
    [sym_range] = STATE(517),
    [sym_set_literal] = STATE(517),
    [sym_par_expr] = STATE(517),
    [sym_expr_annotation] = STATE(517),
    [sym__exprOrTerm] = STATE(386),
    [sym__primary] = STATE(517),
    [sym_literal] = STATE(517),
    [sym_bool] = STATE(513),
    [sym_variable] = STATE(517),
    [sym_unop] = STATE(297),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2015),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(421),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1866),
    [sym_aritylessPredicateExpr] = STATE(1477),
    [sym_varName] = STATE(598),
    [sym_aggId] = STATE(1778),
    [sym__lower_id] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(469),
    [anon_sym_not] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [sym_specialId] = ACTIONS(475),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(479),
    [sym_integer] = ACTIONS(481),
    [sym_float] = ACTIONS(483),
    [sym_string] = ACTIONS(483),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(485),
    [sym_result] = ACTIONS(487),
    [sym_super] = ACTIONS(489),
    [sym_this] = ACTIONS(487),
    [sym_true] = ACTIONS(485),
  },
  [313] = {
    [sym_special_call] = STATE(393),
    [sym_prefix_cast] = STATE(393),
    [sym_unary_expr] = STATE(393),
    [sym_mul_expr] = STATE(393),
    [sym_add_expr] = STATE(393),
    [sym_in_expr] = STATE(393),
    [sym_comp_term] = STATE(393),
    [sym_instance_of] = STATE(393),
    [sym_negation] = STATE(393),
    [sym_if_term] = STATE(393),
    [sym_conjunction] = STATE(393),
    [sym_disjunction] = STATE(393),
    [sym_implication] = STATE(393),
    [sym_quantified] = STATE(393),
    [sym_quantifier] = STATE(1865),
    [sym_call_or_unqual_agg_expr] = STATE(517),
    [sym_qualified_expr] = STATE(517),
    [sym_super_ref] = STATE(517),
    [sym_aggregate] = STATE(517),
    [sym_range] = STATE(517),
    [sym_set_literal] = STATE(517),
    [sym_par_expr] = STATE(517),
    [sym_expr_annotation] = STATE(517),
    [sym__exprOrTerm] = STATE(393),
    [sym__primary] = STATE(517),
    [sym_literal] = STATE(517),
    [sym_bool] = STATE(513),
    [sym_variable] = STATE(517),
    [sym_unop] = STATE(297),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2015),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(421),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1866),
    [sym_aritylessPredicateExpr] = STATE(1477),
    [sym_varName] = STATE(598),
    [sym_aggId] = STATE(1778),
    [sym__lower_id] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(469),
    [anon_sym_not] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [sym_specialId] = ACTIONS(475),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(479),
    [sym_integer] = ACTIONS(481),
    [sym_float] = ACTIONS(483),
    [sym_string] = ACTIONS(483),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(485),
    [sym_result] = ACTIONS(487),
    [sym_super] = ACTIONS(489),
    [sym_this] = ACTIONS(487),
    [sym_true] = ACTIONS(485),
  },
  [314] = {
    [sym_special_call] = STATE(1137),
    [sym_prefix_cast] = STATE(1137),
    [sym_unary_expr] = STATE(1137),
    [sym_mul_expr] = STATE(1137),
    [sym_add_expr] = STATE(1137),
    [sym_in_expr] = STATE(1137),
    [sym_comp_term] = STATE(1137),
    [sym_instance_of] = STATE(1137),
    [sym_negation] = STATE(1137),
    [sym_if_term] = STATE(1137),
    [sym_conjunction] = STATE(1137),
    [sym_disjunction] = STATE(1137),
    [sym_implication] = STATE(1137),
    [sym_quantified] = STATE(1137),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1137),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [315] = {
    [sym_special_call] = STATE(373),
    [sym_prefix_cast] = STATE(373),
    [sym_unary_expr] = STATE(373),
    [sym_mul_expr] = STATE(373),
    [sym_add_expr] = STATE(373),
    [sym_in_expr] = STATE(373),
    [sym_comp_term] = STATE(373),
    [sym_instance_of] = STATE(373),
    [sym_negation] = STATE(373),
    [sym_if_term] = STATE(373),
    [sym_conjunction] = STATE(373),
    [sym_disjunction] = STATE(373),
    [sym_implication] = STATE(373),
    [sym_quantified] = STATE(373),
    [sym_quantifier] = STATE(1865),
    [sym_call_or_unqual_agg_expr] = STATE(517),
    [sym_qualified_expr] = STATE(517),
    [sym_super_ref] = STATE(517),
    [sym_aggregate] = STATE(517),
    [sym_range] = STATE(517),
    [sym_set_literal] = STATE(517),
    [sym_par_expr] = STATE(517),
    [sym_expr_annotation] = STATE(517),
    [sym__exprOrTerm] = STATE(373),
    [sym__primary] = STATE(517),
    [sym_literal] = STATE(517),
    [sym_bool] = STATE(513),
    [sym_variable] = STATE(517),
    [sym_unop] = STATE(297),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2015),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(421),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1866),
    [sym_aritylessPredicateExpr] = STATE(1477),
    [sym_varName] = STATE(598),
    [sym_aggId] = STATE(1778),
    [sym__lower_id] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(469),
    [anon_sym_not] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [sym_specialId] = ACTIONS(475),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(479),
    [sym_integer] = ACTIONS(481),
    [sym_float] = ACTIONS(483),
    [sym_string] = ACTIONS(483),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(485),
    [sym_result] = ACTIONS(487),
    [sym_super] = ACTIONS(489),
    [sym_this] = ACTIONS(487),
    [sym_true] = ACTIONS(485),
  },
  [316] = {
    [sym_special_call] = STATE(1128),
    [sym_prefix_cast] = STATE(1128),
    [sym_unary_expr] = STATE(1128),
    [sym_mul_expr] = STATE(1128),
    [sym_add_expr] = STATE(1128),
    [sym_in_expr] = STATE(1128),
    [sym_comp_term] = STATE(1128),
    [sym_instance_of] = STATE(1128),
    [sym_negation] = STATE(1128),
    [sym_if_term] = STATE(1128),
    [sym_conjunction] = STATE(1128),
    [sym_disjunction] = STATE(1128),
    [sym_implication] = STATE(1128),
    [sym_quantified] = STATE(1128),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1128),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1786),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [317] = {
    [sym_special_call] = STATE(1140),
    [sym_prefix_cast] = STATE(1140),
    [sym_unary_expr] = STATE(1140),
    [sym_mul_expr] = STATE(1140),
    [sym_add_expr] = STATE(1140),
    [sym_in_expr] = STATE(1140),
    [sym_comp_term] = STATE(1140),
    [sym_instance_of] = STATE(1140),
    [sym_negation] = STATE(1140),
    [sym_if_term] = STATE(1140),
    [sym_conjunction] = STATE(1140),
    [sym_disjunction] = STATE(1140),
    [sym_implication] = STATE(1140),
    [sym_quantified] = STATE(1140),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1140),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [318] = {
    [sym_special_call] = STATE(1141),
    [sym_prefix_cast] = STATE(1141),
    [sym_unary_expr] = STATE(1141),
    [sym_mul_expr] = STATE(1141),
    [sym_add_expr] = STATE(1141),
    [sym_in_expr] = STATE(1141),
    [sym_comp_term] = STATE(1141),
    [sym_instance_of] = STATE(1141),
    [sym_negation] = STATE(1141),
    [sym_if_term] = STATE(1141),
    [sym_conjunction] = STATE(1141),
    [sym_disjunction] = STATE(1141),
    [sym_implication] = STATE(1141),
    [sym_quantified] = STATE(1141),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1141),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [319] = {
    [sym_special_call] = STATE(973),
    [sym_prefix_cast] = STATE(973),
    [sym_unary_expr] = STATE(973),
    [sym_mul_expr] = STATE(973),
    [sym_add_expr] = STATE(973),
    [sym_in_expr] = STATE(973),
    [sym_comp_term] = STATE(973),
    [sym_instance_of] = STATE(973),
    [sym_negation] = STATE(973),
    [sym_if_term] = STATE(973),
    [sym_conjunction] = STATE(973),
    [sym_disjunction] = STATE(973),
    [sym_implication] = STATE(973),
    [sym_quantified] = STATE(973),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(973),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [320] = {
    [sym_special_call] = STATE(976),
    [sym_prefix_cast] = STATE(976),
    [sym_unary_expr] = STATE(976),
    [sym_mul_expr] = STATE(976),
    [sym_add_expr] = STATE(976),
    [sym_in_expr] = STATE(976),
    [sym_comp_term] = STATE(976),
    [sym_instance_of] = STATE(976),
    [sym_negation] = STATE(976),
    [sym_if_term] = STATE(976),
    [sym_conjunction] = STATE(976),
    [sym_disjunction] = STATE(976),
    [sym_implication] = STATE(976),
    [sym_quantified] = STATE(976),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(976),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [321] = {
    [sym_special_call] = STATE(1144),
    [sym_prefix_cast] = STATE(1144),
    [sym_unary_expr] = STATE(1144),
    [sym_mul_expr] = STATE(1144),
    [sym_add_expr] = STATE(1144),
    [sym_in_expr] = STATE(1144),
    [sym_comp_term] = STATE(1144),
    [sym_instance_of] = STATE(1144),
    [sym_negation] = STATE(1144),
    [sym_if_term] = STATE(1144),
    [sym_conjunction] = STATE(1144),
    [sym_disjunction] = STATE(1144),
    [sym_implication] = STATE(1144),
    [sym_quantified] = STATE(1144),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1144),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [322] = {
    [sym_special_call] = STATE(978),
    [sym_prefix_cast] = STATE(978),
    [sym_unary_expr] = STATE(978),
    [sym_mul_expr] = STATE(978),
    [sym_add_expr] = STATE(978),
    [sym_in_expr] = STATE(978),
    [sym_comp_term] = STATE(978),
    [sym_instance_of] = STATE(978),
    [sym_negation] = STATE(978),
    [sym_if_term] = STATE(978),
    [sym_conjunction] = STATE(978),
    [sym_disjunction] = STATE(978),
    [sym_implication] = STATE(978),
    [sym_quantified] = STATE(978),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(978),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [323] = {
    [sym_special_call] = STATE(1145),
    [sym_prefix_cast] = STATE(1145),
    [sym_unary_expr] = STATE(1145),
    [sym_mul_expr] = STATE(1145),
    [sym_add_expr] = STATE(1145),
    [sym_in_expr] = STATE(1145),
    [sym_comp_term] = STATE(1145),
    [sym_instance_of] = STATE(1145),
    [sym_negation] = STATE(1145),
    [sym_if_term] = STATE(1145),
    [sym_conjunction] = STATE(1145),
    [sym_disjunction] = STATE(1145),
    [sym_implication] = STATE(1145),
    [sym_quantified] = STATE(1145),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1145),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [324] = {
    [sym_special_call] = STATE(399),
    [sym_prefix_cast] = STATE(399),
    [sym_unary_expr] = STATE(399),
    [sym_mul_expr] = STATE(399),
    [sym_add_expr] = STATE(399),
    [sym_in_expr] = STATE(399),
    [sym_comp_term] = STATE(399),
    [sym_instance_of] = STATE(399),
    [sym_negation] = STATE(399),
    [sym_if_term] = STATE(399),
    [sym_conjunction] = STATE(399),
    [sym_disjunction] = STATE(399),
    [sym_implication] = STATE(399),
    [sym_quantified] = STATE(399),
    [sym_quantifier] = STATE(1865),
    [sym_call_or_unqual_agg_expr] = STATE(517),
    [sym_qualified_expr] = STATE(517),
    [sym_super_ref] = STATE(517),
    [sym_aggregate] = STATE(517),
    [sym_range] = STATE(517),
    [sym_set_literal] = STATE(517),
    [sym_par_expr] = STATE(517),
    [sym_expr_annotation] = STATE(517),
    [sym__exprOrTerm] = STATE(399),
    [sym__primary] = STATE(517),
    [sym_literal] = STATE(517),
    [sym_bool] = STATE(513),
    [sym_variable] = STATE(517),
    [sym_unop] = STATE(297),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2015),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(421),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1866),
    [sym_aritylessPredicateExpr] = STATE(1477),
    [sym_varName] = STATE(598),
    [sym_aggId] = STATE(1778),
    [sym__lower_id] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(469),
    [anon_sym_not] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [sym_specialId] = ACTIONS(475),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(479),
    [sym_integer] = ACTIONS(481),
    [sym_float] = ACTIONS(483),
    [sym_string] = ACTIONS(483),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(485),
    [sym_result] = ACTIONS(487),
    [sym_super] = ACTIONS(489),
    [sym_this] = ACTIONS(487),
    [sym_true] = ACTIONS(485),
  },
  [325] = {
    [sym_special_call] = STATE(1146),
    [sym_prefix_cast] = STATE(1146),
    [sym_unary_expr] = STATE(1146),
    [sym_mul_expr] = STATE(1146),
    [sym_add_expr] = STATE(1146),
    [sym_in_expr] = STATE(1146),
    [sym_comp_term] = STATE(1146),
    [sym_instance_of] = STATE(1146),
    [sym_negation] = STATE(1146),
    [sym_if_term] = STATE(1146),
    [sym_conjunction] = STATE(1146),
    [sym_disjunction] = STATE(1146),
    [sym_implication] = STATE(1146),
    [sym_quantified] = STATE(1146),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1146),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [326] = {
    [sym_special_call] = STATE(1147),
    [sym_prefix_cast] = STATE(1147),
    [sym_unary_expr] = STATE(1147),
    [sym_mul_expr] = STATE(1147),
    [sym_add_expr] = STATE(1147),
    [sym_in_expr] = STATE(1147),
    [sym_comp_term] = STATE(1147),
    [sym_instance_of] = STATE(1147),
    [sym_negation] = STATE(1147),
    [sym_if_term] = STATE(1147),
    [sym_conjunction] = STATE(1147),
    [sym_disjunction] = STATE(1147),
    [sym_implication] = STATE(1147),
    [sym_quantified] = STATE(1147),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1147),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [327] = {
    [sym_special_call] = STATE(1138),
    [sym_prefix_cast] = STATE(1138),
    [sym_unary_expr] = STATE(1138),
    [sym_mul_expr] = STATE(1138),
    [sym_add_expr] = STATE(1138),
    [sym_in_expr] = STATE(1138),
    [sym_comp_term] = STATE(1138),
    [sym_instance_of] = STATE(1138),
    [sym_negation] = STATE(1138),
    [sym_if_term] = STATE(1138),
    [sym_conjunction] = STATE(1138),
    [sym_disjunction] = STATE(1138),
    [sym_implication] = STATE(1138),
    [sym_quantified] = STATE(1138),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1138),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1771),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [328] = {
    [sym_special_call] = STATE(1151),
    [sym_prefix_cast] = STATE(1151),
    [sym_unary_expr] = STATE(1151),
    [sym_mul_expr] = STATE(1151),
    [sym_add_expr] = STATE(1151),
    [sym_in_expr] = STATE(1151),
    [sym_comp_term] = STATE(1151),
    [sym_instance_of] = STATE(1151),
    [sym_negation] = STATE(1151),
    [sym_if_term] = STATE(1151),
    [sym_conjunction] = STATE(1151),
    [sym_disjunction] = STATE(1151),
    [sym_implication] = STATE(1151),
    [sym_quantified] = STATE(1151),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1151),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [329] = {
    [sym_special_call] = STATE(1152),
    [sym_prefix_cast] = STATE(1152),
    [sym_unary_expr] = STATE(1152),
    [sym_mul_expr] = STATE(1152),
    [sym_add_expr] = STATE(1152),
    [sym_in_expr] = STATE(1152),
    [sym_comp_term] = STATE(1152),
    [sym_instance_of] = STATE(1152),
    [sym_negation] = STATE(1152),
    [sym_if_term] = STATE(1152),
    [sym_conjunction] = STATE(1152),
    [sym_disjunction] = STATE(1152),
    [sym_implication] = STATE(1152),
    [sym_quantified] = STATE(1152),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1152),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [330] = {
    [sym_special_call] = STATE(983),
    [sym_prefix_cast] = STATE(983),
    [sym_unary_expr] = STATE(983),
    [sym_mul_expr] = STATE(983),
    [sym_add_expr] = STATE(983),
    [sym_in_expr] = STATE(983),
    [sym_comp_term] = STATE(983),
    [sym_instance_of] = STATE(983),
    [sym_negation] = STATE(983),
    [sym_if_term] = STATE(983),
    [sym_conjunction] = STATE(983),
    [sym_disjunction] = STATE(983),
    [sym_implication] = STATE(983),
    [sym_quantified] = STATE(983),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(983),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [331] = {
    [sym_special_call] = STATE(985),
    [sym_prefix_cast] = STATE(985),
    [sym_unary_expr] = STATE(985),
    [sym_mul_expr] = STATE(985),
    [sym_add_expr] = STATE(985),
    [sym_in_expr] = STATE(985),
    [sym_comp_term] = STATE(985),
    [sym_instance_of] = STATE(985),
    [sym_negation] = STATE(985),
    [sym_if_term] = STATE(985),
    [sym_conjunction] = STATE(985),
    [sym_disjunction] = STATE(985),
    [sym_implication] = STATE(985),
    [sym_quantified] = STATE(985),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(985),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [332] = {
    [sym_special_call] = STATE(1154),
    [sym_prefix_cast] = STATE(1154),
    [sym_unary_expr] = STATE(1154),
    [sym_mul_expr] = STATE(1154),
    [sym_add_expr] = STATE(1154),
    [sym_in_expr] = STATE(1154),
    [sym_comp_term] = STATE(1154),
    [sym_instance_of] = STATE(1154),
    [sym_negation] = STATE(1154),
    [sym_if_term] = STATE(1154),
    [sym_conjunction] = STATE(1154),
    [sym_disjunction] = STATE(1154),
    [sym_implication] = STATE(1154),
    [sym_quantified] = STATE(1154),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1154),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [333] = {
    [sym_special_call] = STATE(988),
    [sym_prefix_cast] = STATE(988),
    [sym_unary_expr] = STATE(988),
    [sym_mul_expr] = STATE(988),
    [sym_add_expr] = STATE(988),
    [sym_in_expr] = STATE(988),
    [sym_comp_term] = STATE(988),
    [sym_instance_of] = STATE(988),
    [sym_negation] = STATE(988),
    [sym_if_term] = STATE(988),
    [sym_conjunction] = STATE(988),
    [sym_disjunction] = STATE(988),
    [sym_implication] = STATE(988),
    [sym_quantified] = STATE(988),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(988),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [334] = {
    [sym_special_call] = STATE(1155),
    [sym_prefix_cast] = STATE(1155),
    [sym_unary_expr] = STATE(1155),
    [sym_mul_expr] = STATE(1155),
    [sym_add_expr] = STATE(1155),
    [sym_in_expr] = STATE(1155),
    [sym_comp_term] = STATE(1155),
    [sym_instance_of] = STATE(1155),
    [sym_negation] = STATE(1155),
    [sym_if_term] = STATE(1155),
    [sym_conjunction] = STATE(1155),
    [sym_disjunction] = STATE(1155),
    [sym_implication] = STATE(1155),
    [sym_quantified] = STATE(1155),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1155),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [335] = {
    [sym_special_call] = STATE(1087),
    [sym_prefix_cast] = STATE(1087),
    [sym_unary_expr] = STATE(1087),
    [sym_mul_expr] = STATE(1087),
    [sym_add_expr] = STATE(1087),
    [sym_in_expr] = STATE(1087),
    [sym_comp_term] = STATE(1087),
    [sym_instance_of] = STATE(1087),
    [sym_negation] = STATE(1087),
    [sym_if_term] = STATE(1087),
    [sym_conjunction] = STATE(1087),
    [sym_disjunction] = STATE(1087),
    [sym_implication] = STATE(1087),
    [sym_quantified] = STATE(1087),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1087),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [336] = {
    [sym_special_call] = STATE(1156),
    [sym_prefix_cast] = STATE(1156),
    [sym_unary_expr] = STATE(1156),
    [sym_mul_expr] = STATE(1156),
    [sym_add_expr] = STATE(1156),
    [sym_in_expr] = STATE(1156),
    [sym_comp_term] = STATE(1156),
    [sym_instance_of] = STATE(1156),
    [sym_negation] = STATE(1156),
    [sym_if_term] = STATE(1156),
    [sym_conjunction] = STATE(1156),
    [sym_disjunction] = STATE(1156),
    [sym_implication] = STATE(1156),
    [sym_quantified] = STATE(1156),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1156),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [337] = {
    [sym_special_call] = STATE(401),
    [sym_prefix_cast] = STATE(401),
    [sym_unary_expr] = STATE(401),
    [sym_mul_expr] = STATE(401),
    [sym_add_expr] = STATE(401),
    [sym_in_expr] = STATE(401),
    [sym_comp_term] = STATE(401),
    [sym_instance_of] = STATE(401),
    [sym_negation] = STATE(401),
    [sym_if_term] = STATE(401),
    [sym_conjunction] = STATE(401),
    [sym_disjunction] = STATE(401),
    [sym_implication] = STATE(401),
    [sym_quantified] = STATE(401),
    [sym_quantifier] = STATE(1865),
    [sym_call_or_unqual_agg_expr] = STATE(517),
    [sym_qualified_expr] = STATE(517),
    [sym_super_ref] = STATE(517),
    [sym_aggregate] = STATE(517),
    [sym_range] = STATE(517),
    [sym_set_literal] = STATE(517),
    [sym_par_expr] = STATE(517),
    [sym_expr_annotation] = STATE(517),
    [sym__exprOrTerm] = STATE(401),
    [sym__primary] = STATE(517),
    [sym_literal] = STATE(517),
    [sym_bool] = STATE(513),
    [sym_variable] = STATE(517),
    [sym_unop] = STATE(297),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(2015),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(421),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1866),
    [sym_aritylessPredicateExpr] = STATE(1477),
    [sym_varName] = STATE(598),
    [sym_aggId] = STATE(1778),
    [sym__lower_id] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(469),
    [anon_sym_not] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [sym_specialId] = ACTIONS(475),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(479),
    [sym_integer] = ACTIONS(481),
    [sym_float] = ACTIONS(483),
    [sym_string] = ACTIONS(483),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(485),
    [sym_result] = ACTIONS(487),
    [sym_super] = ACTIONS(489),
    [sym_this] = ACTIONS(487),
    [sym_true] = ACTIONS(485),
  },
  [338] = {
    [sym_special_call] = STATE(1157),
    [sym_prefix_cast] = STATE(1157),
    [sym_unary_expr] = STATE(1157),
    [sym_mul_expr] = STATE(1157),
    [sym_add_expr] = STATE(1157),
    [sym_in_expr] = STATE(1157),
    [sym_comp_term] = STATE(1157),
    [sym_instance_of] = STATE(1157),
    [sym_negation] = STATE(1157),
    [sym_if_term] = STATE(1157),
    [sym_conjunction] = STATE(1157),
    [sym_disjunction] = STATE(1157),
    [sym_implication] = STATE(1157),
    [sym_quantified] = STATE(1157),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1157),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [339] = {
    [sym_special_call] = STATE(1148),
    [sym_prefix_cast] = STATE(1148),
    [sym_unary_expr] = STATE(1148),
    [sym_mul_expr] = STATE(1148),
    [sym_add_expr] = STATE(1148),
    [sym_in_expr] = STATE(1148),
    [sym_comp_term] = STATE(1148),
    [sym_instance_of] = STATE(1148),
    [sym_negation] = STATE(1148),
    [sym_if_term] = STATE(1148),
    [sym_conjunction] = STATE(1148),
    [sym_disjunction] = STATE(1148),
    [sym_implication] = STATE(1148),
    [sym_quantified] = STATE(1148),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1148),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1800),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [340] = {
    [sym_special_call] = STATE(1158),
    [sym_prefix_cast] = STATE(1158),
    [sym_unary_expr] = STATE(1158),
    [sym_mul_expr] = STATE(1158),
    [sym_add_expr] = STATE(1158),
    [sym_in_expr] = STATE(1158),
    [sym_comp_term] = STATE(1158),
    [sym_instance_of] = STATE(1158),
    [sym_negation] = STATE(1158),
    [sym_if_term] = STATE(1158),
    [sym_conjunction] = STATE(1158),
    [sym_disjunction] = STATE(1158),
    [sym_implication] = STATE(1158),
    [sym_quantified] = STATE(1158),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1158),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [341] = {
    [sym_special_call] = STATE(1160),
    [sym_prefix_cast] = STATE(1160),
    [sym_unary_expr] = STATE(1160),
    [sym_mul_expr] = STATE(1160),
    [sym_add_expr] = STATE(1160),
    [sym_in_expr] = STATE(1160),
    [sym_comp_term] = STATE(1160),
    [sym_instance_of] = STATE(1160),
    [sym_negation] = STATE(1160),
    [sym_if_term] = STATE(1160),
    [sym_conjunction] = STATE(1160),
    [sym_disjunction] = STATE(1160),
    [sym_implication] = STATE(1160),
    [sym_quantified] = STATE(1160),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1160),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [342] = {
    [sym_special_call] = STATE(1161),
    [sym_prefix_cast] = STATE(1161),
    [sym_unary_expr] = STATE(1161),
    [sym_mul_expr] = STATE(1161),
    [sym_add_expr] = STATE(1161),
    [sym_in_expr] = STATE(1161),
    [sym_comp_term] = STATE(1161),
    [sym_instance_of] = STATE(1161),
    [sym_negation] = STATE(1161),
    [sym_if_term] = STATE(1161),
    [sym_conjunction] = STATE(1161),
    [sym_disjunction] = STATE(1161),
    [sym_implication] = STATE(1161),
    [sym_quantified] = STATE(1161),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1161),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [343] = {
    [sym_special_call] = STATE(1168),
    [sym_prefix_cast] = STATE(1168),
    [sym_unary_expr] = STATE(1168),
    [sym_mul_expr] = STATE(1168),
    [sym_add_expr] = STATE(1168),
    [sym_in_expr] = STATE(1168),
    [sym_comp_term] = STATE(1168),
    [sym_instance_of] = STATE(1168),
    [sym_negation] = STATE(1168),
    [sym_if_term] = STATE(1168),
    [sym_conjunction] = STATE(1168),
    [sym_disjunction] = STATE(1168),
    [sym_implication] = STATE(1168),
    [sym_quantified] = STATE(1168),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1168),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [344] = {
    [sym_special_call] = STATE(1163),
    [sym_prefix_cast] = STATE(1163),
    [sym_unary_expr] = STATE(1163),
    [sym_mul_expr] = STATE(1163),
    [sym_add_expr] = STATE(1163),
    [sym_in_expr] = STATE(1163),
    [sym_comp_term] = STATE(1163),
    [sym_instance_of] = STATE(1163),
    [sym_negation] = STATE(1163),
    [sym_if_term] = STATE(1163),
    [sym_conjunction] = STATE(1163),
    [sym_disjunction] = STATE(1163),
    [sym_implication] = STATE(1163),
    [sym_quantified] = STATE(1163),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1163),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [345] = {
    [sym_special_call] = STATE(1172),
    [sym_prefix_cast] = STATE(1172),
    [sym_unary_expr] = STATE(1172),
    [sym_mul_expr] = STATE(1172),
    [sym_add_expr] = STATE(1172),
    [sym_in_expr] = STATE(1172),
    [sym_comp_term] = STATE(1172),
    [sym_instance_of] = STATE(1172),
    [sym_negation] = STATE(1172),
    [sym_if_term] = STATE(1172),
    [sym_conjunction] = STATE(1172),
    [sym_disjunction] = STATE(1172),
    [sym_implication] = STATE(1172),
    [sym_quantified] = STATE(1172),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1172),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [346] = {
    [sym_special_call] = STATE(865),
    [sym_prefix_cast] = STATE(865),
    [sym_unary_expr] = STATE(865),
    [sym_mul_expr] = STATE(865),
    [sym_add_expr] = STATE(865),
    [sym_in_expr] = STATE(865),
    [sym_comp_term] = STATE(865),
    [sym_instance_of] = STATE(865),
    [sym_negation] = STATE(865),
    [sym_if_term] = STATE(865),
    [sym_conjunction] = STATE(865),
    [sym_disjunction] = STATE(865),
    [sym_implication] = STATE(865),
    [sym_quantified] = STATE(865),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(865),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [347] = {
    [sym_special_call] = STATE(1173),
    [sym_prefix_cast] = STATE(1173),
    [sym_unary_expr] = STATE(1173),
    [sym_mul_expr] = STATE(1173),
    [sym_add_expr] = STATE(1173),
    [sym_in_expr] = STATE(1173),
    [sym_comp_term] = STATE(1173),
    [sym_instance_of] = STATE(1173),
    [sym_negation] = STATE(1173),
    [sym_if_term] = STATE(1173),
    [sym_conjunction] = STATE(1173),
    [sym_disjunction] = STATE(1173),
    [sym_implication] = STATE(1173),
    [sym_quantified] = STATE(1173),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1173),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [348] = {
    [sym_special_call] = STATE(866),
    [sym_prefix_cast] = STATE(866),
    [sym_unary_expr] = STATE(866),
    [sym_mul_expr] = STATE(866),
    [sym_add_expr] = STATE(866),
    [sym_in_expr] = STATE(866),
    [sym_comp_term] = STATE(866),
    [sym_instance_of] = STATE(866),
    [sym_negation] = STATE(866),
    [sym_if_term] = STATE(866),
    [sym_conjunction] = STATE(866),
    [sym_disjunction] = STATE(866),
    [sym_implication] = STATE(866),
    [sym_quantified] = STATE(866),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(866),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [349] = {
    [sym_special_call] = STATE(1174),
    [sym_prefix_cast] = STATE(1174),
    [sym_unary_expr] = STATE(1174),
    [sym_mul_expr] = STATE(1174),
    [sym_add_expr] = STATE(1174),
    [sym_in_expr] = STATE(1174),
    [sym_comp_term] = STATE(1174),
    [sym_instance_of] = STATE(1174),
    [sym_negation] = STATE(1174),
    [sym_if_term] = STATE(1174),
    [sym_conjunction] = STATE(1174),
    [sym_disjunction] = STATE(1174),
    [sym_implication] = STATE(1174),
    [sym_quantified] = STATE(1174),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1174),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [350] = {
    [sym_special_call] = STATE(867),
    [sym_prefix_cast] = STATE(867),
    [sym_unary_expr] = STATE(867),
    [sym_mul_expr] = STATE(867),
    [sym_add_expr] = STATE(867),
    [sym_in_expr] = STATE(867),
    [sym_comp_term] = STATE(867),
    [sym_instance_of] = STATE(867),
    [sym_negation] = STATE(867),
    [sym_if_term] = STATE(867),
    [sym_conjunction] = STATE(867),
    [sym_disjunction] = STATE(867),
    [sym_implication] = STATE(867),
    [sym_quantified] = STATE(867),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(867),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [351] = {
    [sym_special_call] = STATE(1175),
    [sym_prefix_cast] = STATE(1175),
    [sym_unary_expr] = STATE(1175),
    [sym_mul_expr] = STATE(1175),
    [sym_add_expr] = STATE(1175),
    [sym_in_expr] = STATE(1175),
    [sym_comp_term] = STATE(1175),
    [sym_instance_of] = STATE(1175),
    [sym_negation] = STATE(1175),
    [sym_if_term] = STATE(1175),
    [sym_conjunction] = STATE(1175),
    [sym_disjunction] = STATE(1175),
    [sym_implication] = STATE(1175),
    [sym_quantified] = STATE(1175),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1175),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [352] = {
    [sym_special_call] = STATE(868),
    [sym_prefix_cast] = STATE(868),
    [sym_unary_expr] = STATE(868),
    [sym_mul_expr] = STATE(868),
    [sym_add_expr] = STATE(868),
    [sym_in_expr] = STATE(868),
    [sym_comp_term] = STATE(868),
    [sym_instance_of] = STATE(868),
    [sym_negation] = STATE(868),
    [sym_if_term] = STATE(868),
    [sym_conjunction] = STATE(868),
    [sym_disjunction] = STATE(868),
    [sym_implication] = STATE(868),
    [sym_quantified] = STATE(868),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(868),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [353] = {
    [sym_special_call] = STATE(1176),
    [sym_prefix_cast] = STATE(1176),
    [sym_unary_expr] = STATE(1176),
    [sym_mul_expr] = STATE(1176),
    [sym_add_expr] = STATE(1176),
    [sym_in_expr] = STATE(1176),
    [sym_comp_term] = STATE(1176),
    [sym_instance_of] = STATE(1176),
    [sym_negation] = STATE(1176),
    [sym_if_term] = STATE(1176),
    [sym_conjunction] = STATE(1176),
    [sym_disjunction] = STATE(1176),
    [sym_implication] = STATE(1176),
    [sym_quantified] = STATE(1176),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1176),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [354] = {
    [sym_special_call] = STATE(869),
    [sym_prefix_cast] = STATE(869),
    [sym_unary_expr] = STATE(869),
    [sym_mul_expr] = STATE(869),
    [sym_add_expr] = STATE(869),
    [sym_in_expr] = STATE(869),
    [sym_comp_term] = STATE(869),
    [sym_instance_of] = STATE(869),
    [sym_negation] = STATE(869),
    [sym_if_term] = STATE(869),
    [sym_conjunction] = STATE(869),
    [sym_disjunction] = STATE(869),
    [sym_implication] = STATE(869),
    [sym_quantified] = STATE(869),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(869),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [355] = {
    [sym_special_call] = STATE(1177),
    [sym_prefix_cast] = STATE(1177),
    [sym_unary_expr] = STATE(1177),
    [sym_mul_expr] = STATE(1177),
    [sym_add_expr] = STATE(1177),
    [sym_in_expr] = STATE(1177),
    [sym_comp_term] = STATE(1177),
    [sym_instance_of] = STATE(1177),
    [sym_negation] = STATE(1177),
    [sym_if_term] = STATE(1177),
    [sym_conjunction] = STATE(1177),
    [sym_disjunction] = STATE(1177),
    [sym_implication] = STATE(1177),
    [sym_quantified] = STATE(1177),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1177),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [356] = {
    [sym_special_call] = STATE(870),
    [sym_prefix_cast] = STATE(870),
    [sym_unary_expr] = STATE(870),
    [sym_mul_expr] = STATE(870),
    [sym_add_expr] = STATE(870),
    [sym_in_expr] = STATE(870),
    [sym_comp_term] = STATE(870),
    [sym_instance_of] = STATE(870),
    [sym_negation] = STATE(870),
    [sym_if_term] = STATE(870),
    [sym_conjunction] = STATE(870),
    [sym_disjunction] = STATE(870),
    [sym_implication] = STATE(870),
    [sym_quantified] = STATE(870),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(870),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [357] = {
    [sym_special_call] = STATE(1178),
    [sym_prefix_cast] = STATE(1178),
    [sym_unary_expr] = STATE(1178),
    [sym_mul_expr] = STATE(1178),
    [sym_add_expr] = STATE(1178),
    [sym_in_expr] = STATE(1178),
    [sym_comp_term] = STATE(1178),
    [sym_instance_of] = STATE(1178),
    [sym_negation] = STATE(1178),
    [sym_if_term] = STATE(1178),
    [sym_conjunction] = STATE(1178),
    [sym_disjunction] = STATE(1178),
    [sym_implication] = STATE(1178),
    [sym_quantified] = STATE(1178),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(1178),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(192),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_not] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(297),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
  [358] = {
    [sym_special_call] = STATE(897),
    [sym_prefix_cast] = STATE(897),
    [sym_unary_expr] = STATE(897),
    [sym_mul_expr] = STATE(897),
    [sym_add_expr] = STATE(897),
    [sym_in_expr] = STATE(897),
    [sym_comp_term] = STATE(897),
    [sym_instance_of] = STATE(897),
    [sym_negation] = STATE(897),
    [sym_if_term] = STATE(897),
    [sym_conjunction] = STATE(897),
    [sym_disjunction] = STATE(897),
    [sym_implication] = STATE(897),
    [sym_quantified] = STATE(897),
    [sym_quantifier] = STATE(1849),
    [sym_call_or_unqual_agg_expr] = STATE(778),
    [sym_qualified_expr] = STATE(778),
    [sym_super_ref] = STATE(778),
    [sym_aggregate] = STATE(778),
    [sym_range] = STATE(778),
    [sym_set_literal] = STATE(778),
    [sym_par_expr] = STATE(778),
    [sym_expr_annotation] = STATE(778),
    [sym__exprOrTerm] = STATE(897),
    [sym__primary] = STATE(778),
    [sym_literal] = STATE(778),
    [sym_bool] = STATE(767),
    [sym_variable] = STATE(778),
    [sym_unop] = STATE(222),
    [sym_literalId] = STATE(1596),
    [sym_annotName] = STATE(1876),
    [sym_moduleName] = STATE(1897),
    [sym_moduleExpr] = STATE(1880),
    [sym_moduleInstantiation] = STATE(1461),
    [sym_primitiveType] = STATE(1437),
    [sym_simpleId] = STATE(705),
    [sym_className] = STATE(1443),
    [sym_typeExpr] = STATE(1883),
    [sym_aritylessPredicateExpr] = STATE(1486),
    [sym_varName] = STATE(772),
    [sym_aggId] = STATE(1783),
    [sym__lower_id] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_not] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [sym_specialId] = ACTIONS(121),
    [anon_sym_exists] = ACTIONS(49),
    [anon_sym_forall] = ACTIONS(49),
    [anon_sym_forex] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_boolean] = ACTIONS(27),
    [anon_sym_date] = ACTIONS(27),
    [anon_sym_float] = ACTIONS(27),
    [anon_sym_int] = ACTIONS(27),
    [anon_sym_string] = ACTIONS(27),
    [sym_dbtype] = ACTIONS(29),
    [anon_sym_avg] = ACTIONS(55),
    [anon_sym_concat] = ACTIONS(55),
    [anon_sym_strictconcat] = ACTIONS(55),
    [anon_sym_count] = ACTIONS(55),
    [anon_sym_max] = ACTIONS(55),
    [anon_sym_min] = ACTIONS(55),
    [anon_sym_rank] = ACTIONS(55),
    [anon_sym_strictcount] = ACTIONS(55),
    [anon_sym_strictsum] = ACTIONS(55),
    [anon_sym_sum] = ACTIONS(55),
    [anon_sym_any] = ACTIONS(55),
    [anon_sym_unique] = ACTIONS(55),
    [sym__upper_id] = ACTIONS(127),
    [sym_integer] = ACTIONS(129),
    [sym_float] = ACTIONS(131),
    [sym_string] = ACTIONS(131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_false] = ACTIONS(133),
    [sym_result] = ACTIONS(135),
    [sym_super] = ACTIONS(137),
    [sym_this] = ACTIONS(135),
    [sym_true] = ACTIONS(133),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 27,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(323), 1,
      sym__lower_id,
    ACTIONS(333), 1,
      anon_sym_LBRACK,
    ACTIONS(335), 1,
      sym__upper_id,
    ACTIONS(337), 1,
      sym_integer,
    ACTIONS(345), 1,
      sym_super,
    ACTIONS(565), 1,
      anon_sym_LPAREN,
    STATE(419), 1,
      sym_simpleId,
    STATE(470), 1,
      sym_bool,
    STATE(472), 1,
      sym_varName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1472), 1,
      sym_aritylessPredicateExpr,
    STATE(1596), 1,
      sym_literalId,
    STATE(1773), 1,
      sym_aggId,
    STATE(1880), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2009), 1,
      sym_typeExpr,
    STATE(2014), 1,
      sym_annotName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(339), 2,
      sym_float,
      sym_string,
    ACTIONS(341), 2,
      sym_false,
      sym_true,
    ACTIONS(343), 2,
      sym_result,
      sym_this,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(479), 11,
      sym_call_or_unqual_agg_expr,
      sym_qualified_expr,
      sym_super_ref,
      sym_aggregate,
      sym_range,
      sym_set_literal,
      sym_par_expr,
      sym_expr_annotation,
      sym__primary,
      sym_literal,
      sym_variable,
    ACTIONS(55), 12,
      anon_sym_avg,
      anon_sym_concat,
      anon_sym_strictconcat,
      anon_sym_count,
      anon_sym_max,
      anon_sym_min,
      anon_sym_rank,
      anon_sym_strictcount,
      anon_sym_strictsum,
      anon_sym_sum,
      anon_sym_any,
      anon_sym_unique,
  [111] = 27,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(467), 1,
      sym__lower_id,
    ACTIONS(477), 1,
      anon_sym_LBRACK,
    ACTIONS(479), 1,
      sym__upper_id,
    ACTIONS(481), 1,
      sym_integer,
    ACTIONS(489), 1,
      sym_super,
    ACTIONS(567), 1,
      anon_sym_LPAREN,
    STATE(421), 1,
      sym_simpleId,
    STATE(513), 1,
      sym_bool,
    STATE(598), 1,
      sym_varName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1477), 1,
      sym_aritylessPredicateExpr,
    STATE(1596), 1,
      sym_literalId,
    STATE(1778), 1,
      sym_aggId,
    STATE(1866), 1,
      sym_typeExpr,
    STATE(1880), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2015), 1,
      sym_annotName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(483), 2,
      sym_float,
      sym_string,
    ACTIONS(485), 2,
      sym_false,
      sym_true,
    ACTIONS(487), 2,
      sym_result,
      sym_this,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(522), 11,
      sym_call_or_unqual_agg_expr,
      sym_qualified_expr,
      sym_super_ref,
      sym_aggregate,
      sym_range,
      sym_set_literal,
      sym_par_expr,
      sym_expr_annotation,
      sym__primary,
      sym_literal,
      sym_variable,
    ACTIONS(55), 12,
      anon_sym_avg,
      anon_sym_concat,
      anon_sym_strictconcat,
      anon_sym_count,
      anon_sym_max,
      anon_sym_min,
      anon_sym_rank,
      anon_sym_strictcount,
      anon_sym_strictsum,
      anon_sym_sum,
      anon_sym_any,
      anon_sym_unique,
  [222] = 27,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(35), 1,
      sym__lower_id,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym__upper_id,
    ACTIONS(59), 1,
      sym_integer,
    ACTIONS(67), 1,
      sym_super,
    ACTIONS(569), 1,
      anon_sym_LPAREN,
    STATE(860), 1,
      sym_simpleId,
    STATE(883), 1,
      sym_bool,
    STATE(891), 1,
      sym_varName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1482), 1,
      sym_aritylessPredicateExpr,
    STATE(1596), 1,
      sym_literalId,
    STATE(1769), 1,
      sym_aggId,
    STATE(1839), 1,
      sym_typeExpr,
    STATE(1880), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2013), 1,
      sym_annotName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(61), 2,
      sym_float,
      sym_string,
    ACTIONS(63), 2,
      sym_false,
      sym_true,
    ACTIONS(65), 2,
      sym_result,
      sym_this,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(992), 11,
      sym_call_or_unqual_agg_expr,
      sym_qualified_expr,
      sym_super_ref,
      sym_aggregate,
      sym_range,
      sym_set_literal,
      sym_par_expr,
      sym_expr_annotation,
      sym__primary,
      sym_literal,
      sym_variable,
    ACTIONS(55), 12,
      anon_sym_avg,
      anon_sym_concat,
      anon_sym_strictconcat,
      anon_sym_count,
      anon_sym_max,
      anon_sym_min,
      anon_sym_rank,
      anon_sym_strictcount,
      anon_sym_strictsum,
      anon_sym_sum,
      anon_sym_any,
      anon_sym_unique,
  [333] = 27,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(109), 1,
      sym__lower_id,
    ACTIONS(125), 1,
      anon_sym_LBRACK,
    ACTIONS(129), 1,
      sym_integer,
    ACTIONS(137), 1,
      sym_super,
    ACTIONS(297), 1,
      sym__upper_id,
    ACTIONS(571), 1,
      anon_sym_LPAREN,
    STATE(705), 1,
      sym_simpleId,
    STATE(767), 1,
      sym_bool,
    STATE(772), 1,
      sym_varName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1486), 1,
      sym_aritylessPredicateExpr,
    STATE(1596), 1,
      sym_literalId,
    STATE(1783), 1,
      sym_aggId,
    STATE(1876), 1,
      sym_annotName,
    STATE(1880), 1,
      sym_moduleExpr,
    STATE(1883), 1,
      sym_typeExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(131), 2,
      sym_float,
      sym_string,
    ACTIONS(133), 2,
      sym_false,
      sym_true,
    ACTIONS(135), 2,
      sym_result,
      sym_this,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(731), 11,
      sym_call_or_unqual_agg_expr,
      sym_qualified_expr,
      sym_super_ref,
      sym_aggregate,
      sym_range,
      sym_set_literal,
      sym_par_expr,
      sym_expr_annotation,
      sym__primary,
      sym_literal,
      sym_variable,
    ACTIONS(55), 12,
      anon_sym_avg,
      anon_sym_concat,
      anon_sym_strictconcat,
      anon_sym_count,
      anon_sym_max,
      anon_sym_min,
      anon_sym_rank,
      anon_sym_strictcount,
      anon_sym_strictsum,
      anon_sym_sum,
      anon_sym_any,
      anon_sym_unique,
  [444] = 27,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(533), 1,
      sym__lower_id,
    ACTIONS(543), 1,
      anon_sym_LBRACK,
    ACTIONS(545), 1,
      sym__upper_id,
    ACTIONS(547), 1,
      sym_integer,
    ACTIONS(555), 1,
      sym_super,
    ACTIONS(573), 1,
      anon_sym_LPAREN,
    STATE(871), 1,
      sym_simpleId,
    STATE(1007), 1,
      sym_bool,
    STATE(1012), 1,
      sym_varName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1475), 1,
      sym_aritylessPredicateExpr,
    STATE(1596), 1,
      sym_literalId,
    STATE(1761), 1,
      sym_aggId,
    STATE(1880), 1,
      sym_moduleExpr,
    STATE(1893), 1,
      sym_typeExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2016), 1,
      sym_annotName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(549), 2,
      sym_float,
      sym_string,
    ACTIONS(551), 2,
      sym_false,
      sym_true,
    ACTIONS(553), 2,
      sym_result,
      sym_this,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(903), 11,
      sym_call_or_unqual_agg_expr,
      sym_qualified_expr,
      sym_super_ref,
      sym_aggregate,
      sym_range,
      sym_set_literal,
      sym_par_expr,
      sym_expr_annotation,
      sym__primary,
      sym_literal,
      sym_variable,
    ACTIONS(55), 12,
      anon_sym_avg,
      anon_sym_concat,
      anon_sym_strictconcat,
      anon_sym_count,
      anon_sym_max,
      anon_sym_min,
      anon_sym_rank,
      anon_sym_strictcount,
      anon_sym_strictsum,
      anon_sym_sum,
      anon_sym_any,
      anon_sym_unique,
  [555] = 27,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(299), 1,
      sym__lower_id,
    ACTIONS(309), 1,
      anon_sym_LBRACK,
    ACTIONS(311), 1,
      sym__upper_id,
    ACTIONS(313), 1,
      sym_integer,
    ACTIONS(321), 1,
      sym_super,
    ACTIONS(575), 1,
      anon_sym_LPAREN,
    STATE(422), 1,
      sym_simpleId,
    STATE(424), 1,
      sym_bool,
    STATE(426), 1,
      sym_varName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1481), 1,
      sym_aritylessPredicateExpr,
    STATE(1596), 1,
      sym_literalId,
    STATE(1805), 1,
      sym_aggId,
    STATE(1880), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2001), 1,
      sym_typeExpr,
    STATE(2012), 1,
      sym_annotName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(315), 2,
      sym_float,
      sym_string,
    ACTIONS(317), 2,
      sym_false,
      sym_true,
    ACTIONS(319), 2,
      sym_result,
      sym_this,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(433), 11,
      sym_call_or_unqual_agg_expr,
      sym_qualified_expr,
      sym_super_ref,
      sym_aggregate,
      sym_range,
      sym_set_literal,
      sym_par_expr,
      sym_expr_annotation,
      sym__primary,
      sym_literal,
      sym_variable,
    ACTIONS(55), 12,
      anon_sym_avg,
      anon_sym_concat,
      anon_sym_strictconcat,
      anon_sym_count,
      anon_sym_max,
      anon_sym_min,
      anon_sym_rank,
      anon_sym_strictcount,
      anon_sym_strictsum,
      anon_sym_sum,
      anon_sym_any,
      anon_sym_unique,
  [666] = 27,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(109), 1,
      sym__lower_id,
    ACTIONS(125), 1,
      anon_sym_LBRACK,
    ACTIONS(127), 1,
      sym__upper_id,
    ACTIONS(129), 1,
      sym_integer,
    ACTIONS(137), 1,
      sym_super,
    ACTIONS(571), 1,
      anon_sym_LPAREN,
    STATE(705), 1,
      sym_simpleId,
    STATE(767), 1,
      sym_bool,
    STATE(772), 1,
      sym_varName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1486), 1,
      sym_aritylessPredicateExpr,
    STATE(1596), 1,
      sym_literalId,
    STATE(1783), 1,
      sym_aggId,
    STATE(1876), 1,
      sym_annotName,
    STATE(1880), 1,
      sym_moduleExpr,
    STATE(1883), 1,
      sym_typeExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(131), 2,
      sym_float,
      sym_string,
    ACTIONS(133), 2,
      sym_false,
      sym_true,
    ACTIONS(135), 2,
      sym_result,
      sym_this,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(731), 11,
      sym_call_or_unqual_agg_expr,
      sym_qualified_expr,
      sym_super_ref,
      sym_aggregate,
      sym_range,
      sym_set_literal,
      sym_par_expr,
      sym_expr_annotation,
      sym__primary,
      sym_literal,
      sym_variable,
    ACTIONS(55), 12,
      anon_sym_avg,
      anon_sym_concat,
      anon_sym_strictconcat,
      anon_sym_count,
      anon_sym_max,
      anon_sym_min,
      anon_sym_rank,
      anon_sym_strictcount,
      anon_sym_strictsum,
      anon_sym_sum,
      anon_sym_any,
      anon_sym_unique,
  [777] = 27,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(499), 1,
      sym__lower_id,
    ACTIONS(509), 1,
      anon_sym_LBRACK,
    ACTIONS(511), 1,
      sym__upper_id,
    ACTIONS(513), 1,
      sym_integer,
    ACTIONS(521), 1,
      sym_super,
    ACTIONS(577), 1,
      anon_sym_LPAREN,
    STATE(420), 1,
      sym_simpleId,
    STATE(556), 1,
      sym_bool,
    STATE(558), 1,
      sym_varName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1484), 1,
      sym_aritylessPredicateExpr,
    STATE(1596), 1,
      sym_literalId,
    STATE(1789), 1,
      sym_aggId,
    STATE(1880), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(1920), 1,
      sym_typeExpr,
    STATE(2017), 1,
      sym_annotName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(515), 2,
      sym_float,
      sym_string,
    ACTIONS(517), 2,
      sym_false,
      sym_true,
    ACTIONS(519), 2,
      sym_result,
      sym_this,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(565), 11,
      sym_call_or_unqual_agg_expr,
      sym_qualified_expr,
      sym_super_ref,
      sym_aggregate,
      sym_range,
      sym_set_literal,
      sym_par_expr,
      sym_expr_annotation,
      sym__primary,
      sym_literal,
      sym_variable,
    ACTIONS(55), 12,
      anon_sym_avg,
      anon_sym_concat,
      anon_sym_strictconcat,
      anon_sym_count,
      anon_sym_max,
      anon_sym_min,
      anon_sym_rank,
      anon_sym_strictcount,
      anon_sym_strictsum,
      anon_sym_sum,
      anon_sym_any,
      anon_sym_unique,
  [888] = 19,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(587), 1,
      anon_sym_or,
    ACTIONS(589), 1,
      anon_sym_instanceof,
    ACTIONS(591), 1,
      anon_sym_in,
    ACTIONS(593), 1,
      anon_sym_and,
    ACTIONS(595), 1,
      anon_sym_implies,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    STATE(312), 1,
      sym_compop,
    STATE(313), 1,
      sym_mulop,
    STATE(315), 1,
      sym_addop,
    STATE(1209), 1,
      sym_direction,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(603), 2,
      anon_sym_asc,
      anon_sym_desc,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(579), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(581), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [970] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(609), 1,
      anon_sym_LPAREN,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(613), 2,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(605), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH,
      anon_sym_PERCENT,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(607), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [1028] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(609), 1,
      anon_sym_LPAREN,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(613), 2,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(605), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH,
      anon_sym_PERCENT,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(607), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [1086] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(609), 1,
      anon_sym_LPAREN,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(613), 2,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(605), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH,
      anon_sym_PERCENT,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(607), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [1144] = 19,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(616), 1,
      anon_sym_or,
    ACTIONS(618), 1,
      anon_sym_instanceof,
    ACTIONS(620), 1,
      anon_sym_in,
    ACTIONS(622), 1,
      anon_sym_and,
    ACTIONS(624), 1,
      anon_sym_implies,
    STATE(187), 1,
      sym_compop,
    STATE(188), 1,
      sym_mulop,
    STATE(189), 1,
      sym_addop,
    STATE(1206), 1,
      sym_direction,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(626), 2,
      anon_sym_asc,
      anon_sym_desc,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(579), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(581), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [1226] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(609), 1,
      anon_sym_LPAREN,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(613), 2,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(605), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH,
      anon_sym_PERCENT,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(607), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [1284] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    STATE(312), 1,
      sym_compop,
    STATE(313), 1,
      sym_mulop,
    STATE(315), 1,
      sym_addop,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(628), 11,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(630), 23,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [1345] = 15,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(636), 1,
      anon_sym_instanceof,
    ACTIONS(638), 1,
      anon_sym_in,
    ACTIONS(640), 1,
      anon_sym_and,
    STATE(263), 1,
      sym_compop,
    STATE(264), 1,
      sym_mulop,
    STATE(270), 1,
      sym_addop,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(634), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(632), 18,
      anon_sym_module,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [1418] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(636), 1,
      anon_sym_instanceof,
    ACTIONS(638), 1,
      anon_sym_in,
    STATE(263), 1,
      sym_compop,
    STATE(264), 1,
      sym_mulop,
    STATE(270), 1,
      sym_addop,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(644), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(642), 19,
      anon_sym_module,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [1489] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    STATE(187), 1,
      sym_compop,
    STATE(188), 1,
      sym_mulop,
    STATE(189), 1,
      sym_addop,
    ACTIONS(648), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(646), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [1546] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(616), 1,
      anon_sym_or,
    ACTIONS(618), 1,
      anon_sym_instanceof,
    ACTIONS(620), 1,
      anon_sym_in,
    ACTIONS(622), 1,
      anon_sym_and,
    ACTIONS(624), 1,
      anon_sym_implies,
    STATE(187), 1,
      sym_compop,
    STATE(188), 1,
      sym_mulop,
    STATE(189), 1,
      sym_addop,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(652), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(650), 16,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [1623] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(636), 1,
      anon_sym_instanceof,
    ACTIONS(638), 1,
      anon_sym_in,
    ACTIONS(640), 1,
      anon_sym_and,
    ACTIONS(658), 1,
      anon_sym_or,
    STATE(263), 1,
      sym_compop,
    STATE(264), 1,
      sym_mulop,
    STATE(270), 1,
      sym_addop,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(656), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(654), 17,
      anon_sym_module,
      anon_sym_import,
      anon_sym_as,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [1698] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(636), 1,
      anon_sym_instanceof,
    ACTIONS(638), 1,
      anon_sym_in,
    STATE(263), 1,
      sym_compop,
    STATE(264), 1,
      sym_mulop,
    STATE(270), 1,
      sym_addop,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(662), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(660), 19,
      anon_sym_module,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [1769] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(609), 1,
      anon_sym_LPAREN,
    ACTIONS(664), 1,
      anon_sym_DOT,
    ACTIONS(613), 2,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(605), 12,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH,
      anon_sym_PERCENT,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(607), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [1826] = 15,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(589), 1,
      anon_sym_instanceof,
    ACTIONS(591), 1,
      anon_sym_in,
    ACTIONS(593), 1,
      anon_sym_and,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    STATE(312), 1,
      sym_compop,
    STATE(313), 1,
      sym_mulop,
    STATE(315), 1,
      sym_addop,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(634), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(632), 18,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_implies,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [1899] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(609), 1,
      anon_sym_LPAREN,
    ACTIONS(664), 1,
      anon_sym_DOT,
    ACTIONS(613), 2,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(605), 12,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH,
      anon_sym_PERCENT,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(607), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [1956] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(589), 1,
      anon_sym_instanceof,
    ACTIONS(591), 1,
      anon_sym_in,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    STATE(312), 1,
      sym_compop,
    STATE(313), 1,
      sym_mulop,
    STATE(315), 1,
      sym_addop,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(644), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(642), 19,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [2027] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(587), 1,
      anon_sym_or,
    ACTIONS(589), 1,
      anon_sym_instanceof,
    ACTIONS(591), 1,
      anon_sym_in,
    ACTIONS(593), 1,
      anon_sym_and,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    STATE(312), 1,
      sym_compop,
    STATE(313), 1,
      sym_mulop,
    STATE(315), 1,
      sym_addop,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(656), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(654), 17,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_implies,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [2102] = 18,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(636), 1,
      anon_sym_instanceof,
    ACTIONS(638), 1,
      anon_sym_in,
    ACTIONS(640), 1,
      anon_sym_and,
    ACTIONS(658), 1,
      anon_sym_or,
    ACTIONS(671), 1,
      anon_sym_as,
    ACTIONS(673), 1,
      anon_sym_implies,
    STATE(263), 1,
      sym_compop,
    STATE(264), 1,
      sym_mulop,
    STATE(270), 1,
      sym_addop,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(669), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(667), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [2181] = 11,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(591), 1,
      anon_sym_in,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    STATE(312), 1,
      sym_compop,
    STATE(313), 1,
      sym_mulop,
    STATE(315), 1,
      sym_addop,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(675), 9,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(677), 22,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [2246] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    STATE(263), 1,
      sym_compop,
    STATE(264), 1,
      sym_mulop,
    STATE(270), 1,
      sym_addop,
    ACTIONS(648), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(646), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [2303] = 11,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(638), 1,
      anon_sym_in,
    STATE(263), 1,
      sym_compop,
    STATE(264), 1,
      sym_mulop,
    STATE(270), 1,
      sym_addop,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(675), 9,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(677), 22,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [2368] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    STATE(205), 1,
      sym_compop,
    STATE(207), 1,
      sym_mulop,
    STATE(210), 1,
      sym_addop,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(628), 11,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(630), 23,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [2429] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    STATE(263), 1,
      sym_compop,
    STATE(264), 1,
      sym_mulop,
    STATE(270), 1,
      sym_addop,
    ACTIONS(681), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(679), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [2486] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    STATE(263), 1,
      sym_compop,
    STATE(264), 1,
      sym_mulop,
    STATE(270), 1,
      sym_addop,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(628), 11,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(630), 23,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [2547] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    STATE(187), 1,
      sym_compop,
    STATE(188), 1,
      sym_mulop,
    STATE(189), 1,
      sym_addop,
    ACTIONS(681), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(679), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [2604] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    STATE(312), 1,
      sym_compop,
    STATE(313), 1,
      sym_mulop,
    STATE(315), 1,
      sym_addop,
    ACTIONS(681), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(679), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [2661] = 15,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(618), 1,
      anon_sym_instanceof,
    ACTIONS(620), 1,
      anon_sym_in,
    ACTIONS(622), 1,
      anon_sym_and,
    STATE(187), 1,
      sym_compop,
    STATE(188), 1,
      sym_mulop,
    STATE(189), 1,
      sym_addop,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(634), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(632), 18,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_implies,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [2734] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(618), 1,
      anon_sym_instanceof,
    ACTIONS(620), 1,
      anon_sym_in,
    STATE(187), 1,
      sym_compop,
    STATE(188), 1,
      sym_mulop,
    STATE(189), 1,
      sym_addop,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(685), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(683), 19,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [2805] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    STATE(187), 1,
      sym_compop,
    STATE(188), 1,
      sym_mulop,
    STATE(189), 1,
      sym_addop,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(628), 11,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(630), 23,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [2866] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(636), 1,
      anon_sym_instanceof,
    ACTIONS(638), 1,
      anon_sym_in,
    ACTIONS(640), 1,
      anon_sym_and,
    ACTIONS(658), 1,
      anon_sym_or,
    ACTIONS(673), 1,
      anon_sym_implies,
    STATE(263), 1,
      sym_compop,
    STATE(264), 1,
      sym_mulop,
    STATE(270), 1,
      sym_addop,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(652), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(650), 16,
      anon_sym_module,
      anon_sym_import,
      anon_sym_as,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [2943] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(618), 1,
      anon_sym_instanceof,
    ACTIONS(620), 1,
      anon_sym_in,
    STATE(187), 1,
      sym_compop,
    STATE(188), 1,
      sym_mulop,
    STATE(189), 1,
      sym_addop,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(644), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(642), 19,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [3014] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(587), 1,
      anon_sym_or,
    ACTIONS(589), 1,
      anon_sym_instanceof,
    ACTIONS(591), 1,
      anon_sym_in,
    ACTIONS(593), 1,
      anon_sym_and,
    ACTIONS(595), 1,
      anon_sym_implies,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    STATE(312), 1,
      sym_compop,
    STATE(313), 1,
      sym_mulop,
    STATE(315), 1,
      sym_addop,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(652), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(650), 16,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [3091] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(636), 1,
      anon_sym_instanceof,
    ACTIONS(638), 1,
      anon_sym_in,
    STATE(263), 1,
      sym_compop,
    STATE(264), 1,
      sym_mulop,
    STATE(270), 1,
      sym_addop,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(685), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(683), 19,
      anon_sym_module,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [3162] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(589), 1,
      anon_sym_instanceof,
    ACTIONS(591), 1,
      anon_sym_in,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    STATE(312), 1,
      sym_compop,
    STATE(313), 1,
      sym_mulop,
    STATE(315), 1,
      sym_addop,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(685), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(683), 19,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [3233] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    STATE(205), 1,
      sym_compop,
    STATE(207), 1,
      sym_mulop,
    STATE(210), 1,
      sym_addop,
    ACTIONS(648), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(646), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [3290] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(687), 1,
      anon_sym_instanceof,
    ACTIONS(689), 1,
      anon_sym_in,
    STATE(205), 1,
      sym_compop,
    STATE(207), 1,
      sym_mulop,
    STATE(210), 1,
      sym_addop,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(662), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(660), 19,
      anon_sym_module,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [3361] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(609), 1,
      anon_sym_LPAREN,
    ACTIONS(664), 1,
      anon_sym_DOT,
    ACTIONS(613), 2,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(605), 12,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH,
      anon_sym_PERCENT,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(607), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [3418] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(687), 1,
      anon_sym_instanceof,
    ACTIONS(689), 1,
      anon_sym_in,
    ACTIONS(691), 1,
      anon_sym_or,
    ACTIONS(693), 1,
      anon_sym_and,
    ACTIONS(695), 1,
      anon_sym_implies,
    STATE(205), 1,
      sym_compop,
    STATE(207), 1,
      sym_mulop,
    STATE(210), 1,
      sym_addop,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(652), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(650), 16,
      anon_sym_module,
      anon_sym_import,
      anon_sym_as,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [3495] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(616), 1,
      anon_sym_or,
    ACTIONS(618), 1,
      anon_sym_instanceof,
    ACTIONS(620), 1,
      anon_sym_in,
    ACTIONS(622), 1,
      anon_sym_and,
    STATE(187), 1,
      sym_compop,
    STATE(188), 1,
      sym_mulop,
    STATE(189), 1,
      sym_addop,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(656), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(654), 17,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_implies,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [3570] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(609), 1,
      anon_sym_LPAREN,
    ACTIONS(664), 1,
      anon_sym_DOT,
    ACTIONS(613), 2,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(605), 12,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH,
      anon_sym_PERCENT,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(607), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [3627] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(687), 1,
      anon_sym_instanceof,
    ACTIONS(689), 1,
      anon_sym_in,
    STATE(205), 1,
      sym_compop,
    STATE(207), 1,
      sym_mulop,
    STATE(210), 1,
      sym_addop,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(685), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(683), 19,
      anon_sym_module,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [3698] = 15,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(687), 1,
      anon_sym_instanceof,
    ACTIONS(689), 1,
      anon_sym_in,
    ACTIONS(693), 1,
      anon_sym_and,
    STATE(205), 1,
      sym_compop,
    STATE(207), 1,
      sym_mulop,
    STATE(210), 1,
      sym_addop,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(634), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(632), 18,
      anon_sym_module,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [3771] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    STATE(312), 1,
      sym_compop,
    STATE(313), 1,
      sym_mulop,
    STATE(315), 1,
      sym_addop,
    ACTIONS(648), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(646), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [3828] = 11,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(620), 1,
      anon_sym_in,
    STATE(187), 1,
      sym_compop,
    STATE(188), 1,
      sym_mulop,
    STATE(189), 1,
      sym_addop,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(675), 9,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(677), 22,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [3893] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(589), 1,
      anon_sym_instanceof,
    ACTIONS(591), 1,
      anon_sym_in,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    STATE(312), 1,
      sym_compop,
    STATE(313), 1,
      sym_mulop,
    STATE(315), 1,
      sym_addop,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(662), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(660), 19,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [3964] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(618), 1,
      anon_sym_instanceof,
    ACTIONS(620), 1,
      anon_sym_in,
    STATE(187), 1,
      sym_compop,
    STATE(188), 1,
      sym_mulop,
    STATE(189), 1,
      sym_addop,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(662), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(660), 19,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [4035] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(687), 1,
      anon_sym_instanceof,
    ACTIONS(689), 1,
      anon_sym_in,
    STATE(205), 1,
      sym_compop,
    STATE(207), 1,
      sym_mulop,
    STATE(210), 1,
      sym_addop,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(644), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(642), 19,
      anon_sym_module,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [4106] = 18,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(687), 1,
      anon_sym_instanceof,
    ACTIONS(689), 1,
      anon_sym_in,
    ACTIONS(691), 1,
      anon_sym_or,
    ACTIONS(693), 1,
      anon_sym_and,
    ACTIONS(695), 1,
      anon_sym_implies,
    ACTIONS(697), 1,
      anon_sym_as,
    STATE(205), 1,
      sym_compop,
    STATE(207), 1,
      sym_mulop,
    STATE(210), 1,
      sym_addop,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(669), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(667), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [4185] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(687), 1,
      anon_sym_instanceof,
    ACTIONS(689), 1,
      anon_sym_in,
    ACTIONS(691), 1,
      anon_sym_or,
    ACTIONS(693), 1,
      anon_sym_and,
    STATE(205), 1,
      sym_compop,
    STATE(207), 1,
      sym_mulop,
    STATE(210), 1,
      sym_addop,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(656), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(654), 17,
      anon_sym_module,
      anon_sym_import,
      anon_sym_as,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [4260] = 11,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(689), 1,
      anon_sym_in,
    STATE(205), 1,
      sym_compop,
    STATE(207), 1,
      sym_mulop,
    STATE(210), 1,
      sym_addop,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(675), 9,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(677), 22,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [4325] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    STATE(205), 1,
      sym_compop,
    STATE(207), 1,
      sym_mulop,
    STATE(210), 1,
      sym_addop,
    ACTIONS(681), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(679), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [4382] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(701), 1,
      anon_sym_LT,
    ACTIONS(706), 1,
      anon_sym_COLON_COLON,
    ACTIONS(704), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(699), 23,
      anon_sym_module,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [4436] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(701), 1,
      anon_sym_LT,
    ACTIONS(706), 1,
      anon_sym_COLON_COLON,
    ACTIONS(704), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(699), 23,
      anon_sym_module,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [4490] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(701), 1,
      anon_sym_LT,
    ACTIONS(706), 1,
      anon_sym_COLON_COLON,
    ACTIONS(704), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(699), 23,
      anon_sym_module,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [4544] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(701), 1,
      anon_sym_LT,
    ACTIONS(706), 1,
      anon_sym_COLON_COLON,
    ACTIONS(704), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(699), 23,
      anon_sym_module,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [4598] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(710), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(708), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [4647] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(712), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(714), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [4696] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(716), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(718), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [4745] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(720), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(722), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [4794] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(724), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(726), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [4843] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(732), 1,
      anon_sym_DOT,
    ACTIONS(728), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(730), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [4894] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(734), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(736), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [4943] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(738), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(740), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [4992] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(742), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(744), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [5041] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(746), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(748), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [5090] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(732), 1,
      anon_sym_DOT,
    ACTIONS(750), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(752), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [5141] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(754), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(756), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [5190] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(758), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(760), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [5239] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(710), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(708), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [5288] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(762), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(764), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [5337] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(766), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(768), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [5386] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(770), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(772), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [5435] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(774), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(776), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [5484] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(778), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(780), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [5533] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(782), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(784), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [5582] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(786), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(788), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [5631] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(790), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(792), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [5680] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(794), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(796), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [5729] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(798), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(800), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [5778] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(802), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(804), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [5827] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(806), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(808), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [5876] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(810), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(812), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [5925] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(814), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(816), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [5974] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(818), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(820), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [6023] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(822), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(824), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [6072] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(826), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(828), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [6121] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(830), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(832), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [6170] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(834), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(836), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [6219] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(838), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(840), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [6268] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(842), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(844), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [6317] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(846), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(848), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [6366] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(850), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(852), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [6415] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(854), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(856), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [6464] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(858), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(860), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [6513] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(862), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(864), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [6562] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(866), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(868), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [6611] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(870), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(872), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [6660] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(874), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(876), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [6709] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(605), 1,
      anon_sym_COLON_COLON,
    ACTIONS(882), 1,
      anon_sym_LT,
    ACTIONS(878), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(880), 23,
      anon_sym_module,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [6762] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(887), 8,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_dbtype,
      sym__upper_id,
      sym_float,
      sym_string,
    ACTIONS(885), 30,
      anon_sym_not,
      anon_sym_if,
      sym_specialId,
      anon_sym_exists,
      anon_sym_forall,
      anon_sym_forex,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      anon_sym_avg,
      anon_sym_concat,
      anon_sym_strictconcat,
      anon_sym_count,
      anon_sym_max,
      anon_sym_min,
      anon_sym_rank,
      anon_sym_strictcount,
      anon_sym_strictsum,
      anon_sym_sum,
      anon_sym_any,
      anon_sym_unique,
      sym__lower_id,
      sym_integer,
      sym_false,
      sym_result,
      sym_super,
      sym_this,
      sym_true,
  [6809] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(891), 8,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_dbtype,
      sym__upper_id,
      sym_float,
      sym_string,
    ACTIONS(889), 30,
      anon_sym_not,
      anon_sym_if,
      sym_specialId,
      anon_sym_exists,
      anon_sym_forall,
      anon_sym_forex,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      anon_sym_avg,
      anon_sym_concat,
      anon_sym_strictconcat,
      anon_sym_count,
      anon_sym_max,
      anon_sym_min,
      anon_sym_rank,
      anon_sym_strictcount,
      anon_sym_strictsum,
      anon_sym_sum,
      anon_sym_any,
      anon_sym_unique,
      sym__lower_id,
      sym_integer,
      sym_false,
      sym_result,
      sym_super,
      sym_this,
      sym_true,
  [6856] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(895), 8,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_dbtype,
      sym__upper_id,
      sym_float,
      sym_string,
    ACTIONS(893), 30,
      anon_sym_not,
      anon_sym_if,
      sym_specialId,
      anon_sym_exists,
      anon_sym_forall,
      anon_sym_forex,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      anon_sym_avg,
      anon_sym_concat,
      anon_sym_strictconcat,
      anon_sym_count,
      anon_sym_max,
      anon_sym_min,
      anon_sym_rank,
      anon_sym_strictcount,
      anon_sym_strictsum,
      anon_sym_sum,
      anon_sym_any,
      anon_sym_unique,
      sym__lower_id,
      sym_integer,
      sym_false,
      sym_result,
      sym_super,
      sym_this,
      sym_true,
  [6903] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(712), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(714), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [6952] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(716), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(718), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [7001] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(720), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(722), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [7050] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(724), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(726), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [7099] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(897), 1,
      anon_sym_DOT,
    ACTIONS(728), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(730), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [7150] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(734), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(736), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [7199] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(738), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(740), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [7248] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(742), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(744), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [7297] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(746), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(748), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [7346] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(897), 1,
      anon_sym_DOT,
    ACTIONS(750), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(752), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [7397] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(754), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(756), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [7446] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(758), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(760), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [7495] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(710), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(708), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [7544] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(762), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(764), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [7593] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(766), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(768), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [7642] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(770), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(772), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [7691] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(774), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(776), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [7740] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(778), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(780), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [7789] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(782), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(784), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [7838] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(786), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(788), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [7887] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(790), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(792), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [7936] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(794), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(796), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [7985] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(798), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(800), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [8034] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(802), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(804), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [8083] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(806), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(808), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [8132] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(810), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(812), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [8181] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(814), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(816), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [8230] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(818), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(820), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [8279] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(822), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(824), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [8328] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(826), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(828), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [8377] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(830), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(832), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [8426] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(834), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(836), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [8475] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(838), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(840), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [8524] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(842), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(844), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [8573] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(846), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(848), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [8622] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(850), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(852), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [8671] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(854), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(856), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [8720] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(858), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(860), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [8769] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(862), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(864), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [8818] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(866), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(868), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [8867] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(870), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(872), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [8916] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(874), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(876), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [8965] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(605), 1,
      anon_sym_COLON_COLON,
    ACTIONS(882), 1,
      anon_sym_LT,
    ACTIONS(878), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(880), 23,
      anon_sym_module,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [9018] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(712), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(714), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [9067] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(716), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(718), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [9116] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(901), 8,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_dbtype,
      sym__upper_id,
      sym_float,
      sym_string,
    ACTIONS(899), 30,
      anon_sym_not,
      anon_sym_if,
      sym_specialId,
      anon_sym_exists,
      anon_sym_forall,
      anon_sym_forex,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      anon_sym_avg,
      anon_sym_concat,
      anon_sym_strictconcat,
      anon_sym_count,
      anon_sym_max,
      anon_sym_min,
      anon_sym_rank,
      anon_sym_strictcount,
      anon_sym_strictsum,
      anon_sym_sum,
      anon_sym_any,
      anon_sym_unique,
      sym__lower_id,
      sym_integer,
      sym_false,
      sym_result,
      sym_super,
      sym_this,
      sym_true,
  [9163] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(724), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(726), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [9212] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(903), 1,
      anon_sym_DOT,
    ACTIONS(728), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(730), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [9263] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(734), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(736), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [9312] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(738), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(740), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [9361] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(742), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(744), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [9410] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(746), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(748), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [9459] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(903), 1,
      anon_sym_DOT,
    ACTIONS(750), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(752), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [9510] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(754), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(756), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [9559] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(758), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(760), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [9608] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(710), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(708), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [9657] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(762), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(764), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [9706] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(766), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(768), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [9755] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(770), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(772), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [9804] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(774), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(776), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [9853] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(778), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(780), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [9902] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(782), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(784), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [9951] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(786), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(788), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [10000] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(790), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(792), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [10049] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(794), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(796), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [10098] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(798), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(800), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [10147] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(802), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(804), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [10196] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(806), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(808), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [10245] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(810), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(812), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [10294] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(814), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(816), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [10343] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(818), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(820), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [10392] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(822), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(824), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [10441] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(826), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(828), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [10490] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(830), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(832), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [10539] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(834), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(836), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [10588] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(838), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(840), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [10637] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(842), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(844), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [10686] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(846), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(848), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [10735] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(850), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(852), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [10784] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(854), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(856), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [10833] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(858), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(860), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [10882] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(862), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(864), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [10931] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(866), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(868), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [10980] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(870), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(872), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [11029] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(874), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(876), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [11078] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(605), 1,
      anon_sym_COLON_COLON,
    ACTIONS(882), 1,
      anon_sym_LT,
    ACTIONS(878), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(880), 23,
      anon_sym_module,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [11131] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(712), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(714), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [11180] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(716), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(718), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [11229] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(720), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(722), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [11278] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(724), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(726), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [11327] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(905), 1,
      anon_sym_DOT,
    ACTIONS(728), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(730), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [11378] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(734), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(736), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [11427] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(738), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(740), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [11476] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(742), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(744), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [11525] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(746), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(748), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [11574] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(905), 1,
      anon_sym_DOT,
    ACTIONS(750), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(752), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [11625] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(754), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(756), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [11674] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(758), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(760), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [11723] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(762), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(764), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [11772] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(766), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(768), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [11821] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(770), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(772), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [11870] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(774), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(776), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [11919] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(778), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(780), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [11968] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(782), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(784), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [12017] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(786), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(788), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [12066] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(790), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(792), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [12115] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(794), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(796), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [12164] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(798), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(800), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [12213] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(802), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(804), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [12262] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(806), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(808), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [12311] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(810), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(812), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [12360] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(814), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(816), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [12409] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(818), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(820), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [12458] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(822), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(824), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [12507] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(826), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(828), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [12556] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(830), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(832), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [12605] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(834), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(836), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [12654] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(838), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(840), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [12703] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(842), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(844), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [12752] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(846), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(848), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [12801] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(850), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(852), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [12850] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(854), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(856), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [12899] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(858), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(860), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [12948] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(862), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(864), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [12997] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(866), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(868), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [13046] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(870), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(872), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [13095] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(874), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(876), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [13144] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(605), 1,
      anon_sym_COLON_COLON,
    ACTIONS(882), 1,
      anon_sym_LT,
    ACTIONS(878), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(880), 23,
      anon_sym_module,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [13197] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(720), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(722), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [13246] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(907), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(909), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [13294] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(911), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(913), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [13342] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(915), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(917), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [13390] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(911), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(913), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [13438] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(919), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(921), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [13486] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(923), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(925), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [13534] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(927), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(929), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [13582] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(919), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(921), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [13630] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(931), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(933), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [13678] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(923), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(925), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [13726] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(927), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(929), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [13774] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(935), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(937), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [13822] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(939), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(941), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [13870] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(943), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(945), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [13918] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(947), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(949), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [13966] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(951), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(953), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [14014] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(911), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(913), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [14062] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(955), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(957), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [14110] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(943), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(945), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [14158] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(935), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(937), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [14206] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(939), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(941), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [14254] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(955), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(957), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [14302] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(935), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(937), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [14350] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(939), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(941), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [14398] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(947), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(949), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [14446] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(931), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(933), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [14494] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(947), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(949), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [14542] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(951), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(953), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [14590] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(907), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(909), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [14638] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(919), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(921), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [14686] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(931), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(933), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [14734] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(923), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(925), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [14782] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(951), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(953), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [14830] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(907), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(909), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [14878] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(961), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(959), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [14926] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(965), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(963), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [14974] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(927), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(929), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [15022] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(919), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(921), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [15070] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(931), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(933), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [15118] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(969), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(967), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [15166] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(915), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(917), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [15214] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(951), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(953), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [15262] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(907), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(909), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [15310] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(961), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(959), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [15358] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(965), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(963), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [15406] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(911), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(913), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [15454] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(961), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(959), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [15502] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(965), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(963), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [15550] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(943), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(945), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [15598] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(961), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(959), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [15646] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(923), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(925), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [15694] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(927), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(929), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [15742] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(965), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(963), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [15790] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(969), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(967), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [15838] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(943), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(945), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [15886] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(969), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(967), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [15934] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(915), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(917), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [15982] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(915), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(917), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [16030] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(955), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(957), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [16078] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(955), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(957), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [16126] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(969), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(967), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [16174] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(935), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(937), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [16222] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(939), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(941), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [16270] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(947), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(949), 24,
      anon_sym_module,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [16318] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(973), 1,
      anon_sym_RBRACE,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(664), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [16411] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(991), 1,
      sym__lower_id,
    ACTIONS(994), 1,
      anon_sym_module,
    ACTIONS(997), 1,
      anon_sym_RBRACE,
    ACTIONS(999), 1,
      anon_sym_import,
    ACTIONS(1002), 1,
      anon_sym_newtype,
    ACTIONS(1005), 1,
      anon_sym_from,
    ACTIONS(1008), 1,
      anon_sym_where,
    ACTIONS(1011), 1,
      anon_sym_select,
    ACTIONS(1014), 1,
      anon_sym_class,
    ACTIONS(1017), 1,
      sym_qldoc,
    ACTIONS(1023), 1,
      sym_dbtype,
    ACTIONS(1026), 1,
      sym__upper_id,
    ACTIONS(1029), 1,
      sym_predicate,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(664), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(1020), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [16504] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    ACTIONS(1032), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(664), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [16597] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    ACTIONS(1034), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(664), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [16690] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    ACTIONS(1036), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(664), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [16783] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    ACTIONS(1038), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(664), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [16876] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    ACTIONS(1040), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(664), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [16969] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    ACTIONS(1042), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(668), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [17062] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    ACTIONS(1044), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(665), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [17155] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    ACTIONS(1046), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(664), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [17248] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    ACTIONS(1048), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(675), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [17341] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(991), 1,
      sym__lower_id,
    ACTIONS(997), 1,
      ts_builtin_sym_end,
    ACTIONS(1023), 1,
      sym_dbtype,
    ACTIONS(1026), 1,
      sym__upper_id,
    ACTIONS(1050), 1,
      anon_sym_module,
    ACTIONS(1053), 1,
      anon_sym_import,
    ACTIONS(1056), 1,
      anon_sym_newtype,
    ACTIONS(1059), 1,
      anon_sym_from,
    ACTIONS(1062), 1,
      anon_sym_where,
    ACTIONS(1065), 1,
      anon_sym_select,
    ACTIONS(1068), 1,
      anon_sym_class,
    ACTIONS(1071), 1,
      sym_qldoc,
    ACTIONS(1074), 1,
      sym_predicate,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1792), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(674), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(702), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(1020), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1300), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [17434] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    ACTIONS(1077), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(664), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [17527] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    ACTIONS(1079), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(677), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [17620] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    ACTIONS(1081), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(664), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [17713] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    ACTIONS(1083), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(663), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [17806] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    ACTIONS(1085), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(666), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [17899] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    ACTIONS(1087), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(667), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [17992] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    ACTIONS(1089), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(684), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [18085] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    ACTIONS(1091), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(664), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [18178] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    ACTIONS(1093), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(686), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [18271] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    ACTIONS(1095), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(664), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [18364] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    ACTIONS(1097), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(687), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [18457] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    ACTIONS(1099), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(664), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [18550] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    ACTIONS(1101), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(664), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [18643] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    ACTIONS(1103), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(690), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [18736] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    ACTIONS(1105), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(691), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [18829] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    ACTIONS(1107), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(664), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [18922] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    ACTIONS(1109), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(664), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [19015] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    ACTIONS(1111), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(693), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [19108] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    ACTIONS(1113), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(664), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [19201] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    ACTIONS(1115), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(697), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [19294] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(11), 1,
      anon_sym_module,
    ACTIONS(13), 1,
      anon_sym_import,
    ACTIONS(15), 1,
      anon_sym_newtype,
    ACTIONS(17), 1,
      anon_sym_from,
    ACTIONS(19), 1,
      anon_sym_where,
    ACTIONS(21), 1,
      anon_sym_select,
    ACTIONS(23), 1,
      anon_sym_class,
    ACTIONS(25), 1,
      sym_qldoc,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(33), 1,
      sym_predicate,
    ACTIONS(1117), 1,
      ts_builtin_sym_end,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1792), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(674), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(702), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1300), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [19387] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    ACTIONS(1119), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(699), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [19480] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    ACTIONS(1121), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(664), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [19573] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    ACTIONS(1123), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(669), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [19666] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    ACTIONS(1125), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(664), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [19759] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    ACTIONS(1127), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(672), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [19852] = 27,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(987), 1,
      sym_qldoc,
    ACTIONS(989), 1,
      sym_predicate,
    ACTIONS(1129), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(682), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(703), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1228), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [19945] = 23,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(11), 1,
      anon_sym_module,
    ACTIONS(13), 1,
      anon_sym_import,
    ACTIONS(15), 1,
      anon_sym_newtype,
    ACTIONS(17), 1,
      anon_sym_from,
    ACTIONS(19), 1,
      anon_sym_where,
    ACTIONS(21), 1,
      anon_sym_select,
    ACTIONS(23), 1,
      anon_sym_class,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(33), 1,
      sym_predicate,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1792), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1185), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1306), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [20026] = 23,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(971), 1,
      anon_sym_module,
    ACTIONS(975), 1,
      anon_sym_import,
    ACTIONS(977), 1,
      anon_sym_newtype,
    ACTIONS(979), 1,
      anon_sym_from,
    ACTIONS(981), 1,
      anon_sym_where,
    ACTIONS(983), 1,
      anon_sym_select,
    ACTIONS(985), 1,
      anon_sym_class,
    ACTIONS(989), 1,
      sym_predicate,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1802), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1185), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
    STATE(1257), 6,
      sym_module,
      sym_importDirective,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [20107] = 6,
    ACTIONS(609), 1,
      anon_sym_LPAREN,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(613), 2,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(607), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(605), 21,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_COLON_COLON,
  [20152] = 5,
    ACTIONS(701), 1,
      anon_sym_LT,
    ACTIONS(706), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(699), 4,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(704), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [20193] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(872), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(870), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [20229] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1131), 1,
      anon_sym_RBRACE,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(768), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [20301] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    ACTIONS(1137), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(713), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [20373] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    ACTIONS(1139), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(768), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [20445] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    ACTIONS(1141), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(768), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [20517] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(876), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(874), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [20553] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(740), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(738), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [20589] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    ACTIONS(1143), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(768), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [20661] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(828), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(826), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [20697] = 5,
    ACTIONS(605), 1,
      anon_sym_COLON_COLON,
    ACTIONS(882), 1,
      anon_sym_LT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(880), 3,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(878), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [20737] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(744), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(742), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [20773] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(736), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(734), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [20809] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(748), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(746), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [20845] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(836), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(834), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [20881] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(840), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(838), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [20917] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(844), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(842), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [20953] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(848), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(846), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [20989] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(852), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(850), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [21025] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(856), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(854), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [21061] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    ACTIONS(1145), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(768), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [21133] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    ACTIONS(1147), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(764), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [21205] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    ACTIONS(1149), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(707), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [21277] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(832), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(830), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [21313] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    ACTIONS(1151), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(725), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [21385] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(860), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(858), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [21421] = 4,
    ACTIONS(1153), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(752), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(750), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [21459] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(756), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(754), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [21495] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(760), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(758), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [21531] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(708), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(710), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [21567] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(764), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(762), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [21603] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(768), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(766), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [21639] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(824), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(822), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [21675] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    ACTIONS(1155), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(739), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [21747] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    ACTIONS(1157), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(768), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [21819] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(816), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(814), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [21855] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    ACTIONS(1159), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(745), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [21927] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    ACTIONS(1161), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(768), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [21999] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    ACTIONS(1163), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(768), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [22071] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    ACTIONS(1165), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(748), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [22143] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    ACTIONS(1167), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(768), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [22215] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    ACTIONS(1169), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(749), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [22287] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    ACTIONS(1171), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(752), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [22359] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    ACTIONS(1173), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(768), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [22431] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    ACTIONS(1175), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(768), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [22503] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(864), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(862), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [22539] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(868), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(866), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [22575] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    ACTIONS(1177), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(768), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [22647] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    ACTIONS(1179), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(756), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [22719] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    ACTIONS(1181), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(757), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [22791] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    ACTIONS(1183), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(742), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [22863] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    ACTIONS(1185), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(768), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [22935] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    ACTIONS(1187), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(768), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [23007] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    ACTIONS(1189), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(759), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [23079] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    ACTIONS(1191), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(768), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [23151] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(820), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(818), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [23187] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(772), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(770), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [23223] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(776), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(774), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [23259] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(780), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(778), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [23295] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    ACTIONS(1193), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(768), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [23367] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(784), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(782), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [23403] = 7,
    ACTIONS(609), 1,
      anon_sym_LPAREN,
    ACTIONS(664), 1,
      anon_sym_RPAREN,
    ACTIONS(882), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(613), 2,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(607), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(605), 18,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_COLON_COLON,
  [23447] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(714), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(712), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [23483] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1195), 1,
      sym__lower_id,
    ACTIONS(1198), 1,
      anon_sym_RBRACE,
    ACTIONS(1200), 1,
      sym_qldoc,
    ACTIONS(1206), 1,
      sym_dbtype,
    ACTIONS(1209), 1,
      sym__upper_id,
    ACTIONS(1212), 1,
      sym_predicate,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(768), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(1203), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [23555] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    ACTIONS(1215), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(782), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [23627] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    ACTIONS(1217), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(784), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [23699] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(718), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(716), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [23735] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(722), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(720), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [23771] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(726), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(724), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [23807] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(788), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(786), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [23843] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(792), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(790), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [23879] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(796), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(794), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [23915] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(800), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(798), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [23951] = 4,
    ACTIONS(1153), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(730), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(728), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [23989] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(804), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(802), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [24025] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(808), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(806), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [24061] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(812), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(810), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [24097] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    ACTIONS(1219), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(768), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [24169] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    ACTIONS(1221), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(709), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [24241] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    ACTIONS(1223), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(768), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [24313] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    ACTIONS(1225), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(710), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [24385] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1133), 1,
      sym_qldoc,
    ACTIONS(1135), 1,
      sym_predicate,
    ACTIONS(1227), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    STATE(743), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(835), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1438), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [24457] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(652), 7,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [24516] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(949), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(947), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [24551] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(959), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(961), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [24586] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(963), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(965), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [24621] = 6,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(646), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(648), 19,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [24662] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(957), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(955), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [24697] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(933), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(931), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [24732] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(925), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(923), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [24767] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(945), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(943), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [24802] = 12,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(662), 10,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [24855] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(953), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(951), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [24890] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(929), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(927), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [24925] = 13,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(634), 9,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_implies,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [24980] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(967), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(969), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [25015] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(917), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(915), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [25050] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(909), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(907), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [25085] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(937), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(935), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [25120] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(941), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(939), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [25155] = 12,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(644), 10,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [25208] = 14,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(656), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_implies,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [25265] = 10,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1233), 1,
      anon_sym_in,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(677), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(675), 15,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [25314] = 6,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(679), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(681), 19,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [25355] = 8,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(630), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
    ACTIONS(628), 17,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
  [25400] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(921), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(919), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [25435] = 12,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(685), 10,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [25488] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(913), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(911), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_select,
      anon_sym_instanceof,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [25523] = 8,
    ACTIONS(609), 1,
      anon_sym_LPAREN,
    ACTIONS(664), 1,
      anon_sym_DOT,
    ACTIONS(878), 1,
      sym__upper_id,
    ACTIONS(880), 1,
      sym__lower_id,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(613), 2,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(605), 9,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_COLON_COLON,
    ACTIONS(607), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_as,
      anon_sym_or,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
      anon_sym_order,
  [25567] = 8,
    ACTIONS(609), 1,
      anon_sym_LPAREN,
    ACTIONS(664), 1,
      anon_sym_DOT,
    ACTIONS(878), 1,
      sym__upper_id,
    ACTIONS(880), 1,
      sym__lower_id,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(613), 2,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(607), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_as,
      anon_sym_or,
      anon_sym_instanceof,
      anon_sym_in,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_SLASH,
    ACTIONS(605), 10,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_COLON_COLON,
  [25611] = 6,
    ACTIONS(609), 1,
      anon_sym_LPAREN,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(613), 2,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(607), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(605), 16,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_COLON_COLON,
  [25650] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(605), 8,
      ts_builtin_sym_end,
      anon_sym_LT,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(607), 16,
      anon_sym_module,
      anon_sym_import,
      anon_sym_as,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [25685] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(605), 8,
      anon_sym_LT,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(607), 16,
      anon_sym_module,
      anon_sym_import,
      anon_sym_as,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [25720] = 6,
    ACTIONS(609), 1,
      anon_sym_LPAREN,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(613), 2,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(607), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(605), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_order,
      anon_sym_COLON_COLON,
  [25759] = 17,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1239), 1,
      anon_sym_or,
    ACTIONS(1241), 1,
      anon_sym_instanceof,
    ACTIONS(1243), 1,
      anon_sym_in,
    ACTIONS(1245), 1,
      anon_sym_and,
    ACTIONS(1247), 1,
      anon_sym_implies,
    STATE(178), 1,
      sym_compop,
    STATE(179), 1,
      sym_mulop,
    STATE(180), 1,
      sym_addop,
    STATE(1772), 1,
      sym_direction,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(579), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1249), 2,
      anon_sym_asc,
      anon_sym_desc,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [25820] = 12,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(662), 7,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
  [25870] = 6,
    STATE(178), 1,
      sym_compop,
    STATE(179), 1,
      sym_mulop,
    STATE(180), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(646), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(648), 16,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [25908] = 13,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1241), 1,
      anon_sym_instanceof,
    ACTIONS(1243), 1,
      anon_sym_in,
    ACTIONS(1245), 1,
      anon_sym_and,
    STATE(178), 1,
      sym_compop,
    STATE(179), 1,
      sym_mulop,
    STATE(180), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(634), 6,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_implies,
      anon_sym_asc,
      anon_sym_desc,
  [25960] = 12,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1241), 1,
      anon_sym_instanceof,
    ACTIONS(1243), 1,
      anon_sym_in,
    STATE(178), 1,
      sym_compop,
    STATE(179), 1,
      sym_mulop,
    STATE(180), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(644), 7,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_asc,
      anon_sym_desc,
  [26010] = 14,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1239), 1,
      anon_sym_or,
    ACTIONS(1241), 1,
      anon_sym_instanceof,
    ACTIONS(1243), 1,
      anon_sym_in,
    ACTIONS(1245), 1,
      anon_sym_and,
    STATE(178), 1,
      sym_compop,
    STATE(179), 1,
      sym_mulop,
    STATE(180), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(656), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_implies,
      anon_sym_asc,
      anon_sym_desc,
  [26064] = 10,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1243), 1,
      anon_sym_in,
    STATE(178), 1,
      sym_compop,
    STATE(179), 1,
      sym_mulop,
    STATE(180), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(677), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(675), 12,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_asc,
      anon_sym_desc,
  [26110] = 6,
    STATE(178), 1,
      sym_compop,
    STATE(179), 1,
      sym_mulop,
    STATE(180), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(679), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(681), 16,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [26148] = 8,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    STATE(178), 1,
      sym_compop,
    STATE(179), 1,
      sym_mulop,
    STATE(180), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(630), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
    ACTIONS(628), 14,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_asc,
      anon_sym_desc,
  [26190] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1239), 1,
      anon_sym_or,
    ACTIONS(1241), 1,
      anon_sym_instanceof,
    ACTIONS(1243), 1,
      anon_sym_in,
    ACTIONS(1245), 1,
      anon_sym_and,
    ACTIONS(1247), 1,
      anon_sym_implies,
    STATE(178), 1,
      sym_compop,
    STATE(179), 1,
      sym_mulop,
    STATE(180), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(652), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_asc,
      anon_sym_desc,
  [26246] = 12,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1241), 1,
      anon_sym_instanceof,
    ACTIONS(1243), 1,
      anon_sym_in,
    STATE(178), 1,
      sym_compop,
    STATE(179), 1,
      sym_mulop,
    STATE(180), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(685), 7,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_asc,
      anon_sym_desc,
  [26296] = 6,
    ACTIONS(609), 1,
      anon_sym_LPAREN,
    ACTIONS(664), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(613), 2,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(607), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(605), 15,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
      anon_sym_COLON_COLON,
  [26334] = 18,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1253), 1,
      anon_sym_COMMA,
    ACTIONS(1255), 1,
      anon_sym_RBRACK,
    ACTIONS(1257), 1,
      anon_sym_DOT_DOT,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    STATE(1715), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [26396] = 6,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(646), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(648), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [26434] = 6,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(679), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(681), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
  [26472] = 8,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(630), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
    ACTIONS(628), 14,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
  [26514] = 17,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(1135), 1,
      sym_predicate,
    STATE(1392), 1,
      sym_annotName,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1529), 1,
      sym_typeExpr,
    STATE(1646), 1,
      sym_className,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2002), 1,
      sym_varDecl,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1185), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(1436), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [26574] = 12,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(685), 7,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
  [26624] = 18,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1259), 1,
      anon_sym_COMMA,
    ACTIONS(1261), 1,
      anon_sym_RBRACK,
    ACTIONS(1263), 1,
      anon_sym_DOT_DOT,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    STATE(1613), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [26686] = 14,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(632), 1,
      anon_sym_or,
    ACTIONS(1265), 1,
      anon_sym_instanceof,
    ACTIONS(1267), 1,
      anon_sym_in,
    ACTIONS(1269), 1,
      anon_sym_and,
    STATE(243), 1,
      sym_compop,
    STATE(245), 1,
      sym_mulop,
    STATE(248), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(634), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_implies,
      anon_sym_order,
  [26740] = 13,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(660), 1,
      anon_sym_or,
    ACTIONS(1265), 1,
      anon_sym_instanceof,
    ACTIONS(1267), 1,
      anon_sym_in,
    STATE(243), 1,
      sym_compop,
    STATE(245), 1,
      sym_mulop,
    STATE(248), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(662), 6,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
  [26792] = 12,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1241), 1,
      anon_sym_instanceof,
    ACTIONS(1243), 1,
      anon_sym_in,
    STATE(178), 1,
      sym_compop,
    STATE(179), 1,
      sym_mulop,
    STATE(180), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(662), 7,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_asc,
      anon_sym_desc,
  [26842] = 14,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1265), 1,
      anon_sym_instanceof,
    ACTIONS(1267), 1,
      anon_sym_in,
    ACTIONS(1269), 1,
      anon_sym_and,
    ACTIONS(1271), 1,
      anon_sym_or,
    STATE(243), 1,
      sym_compop,
    STATE(245), 1,
      sym_mulop,
    STATE(248), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(656), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_implies,
      anon_sym_order,
  [26896] = 10,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1267), 1,
      anon_sym_in,
    STATE(243), 1,
      sym_compop,
    STATE(245), 1,
      sym_mulop,
    STATE(248), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(677), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
    ACTIONS(675), 11,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_order,
  [26942] = 6,
    STATE(243), 1,
      sym_compop,
    STATE(245), 1,
      sym_mulop,
    STATE(248), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(646), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(648), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [26980] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1265), 1,
      anon_sym_instanceof,
    ACTIONS(1267), 1,
      anon_sym_in,
    ACTIONS(1269), 1,
      anon_sym_and,
    ACTIONS(1271), 1,
      anon_sym_or,
    ACTIONS(1273), 1,
      anon_sym_implies,
    STATE(243), 1,
      sym_compop,
    STATE(245), 1,
      sym_mulop,
    STATE(248), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(652), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_order,
  [27036] = 18,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1275), 1,
      anon_sym_COMMA,
    ACTIONS(1277), 1,
      anon_sym_RBRACK,
    ACTIONS(1279), 1,
      anon_sym_DOT_DOT,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    STATE(1699), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [27098] = 18,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1281), 1,
      anon_sym_COMMA,
    ACTIONS(1283), 1,
      anon_sym_RBRACK,
    ACTIONS(1285), 1,
      anon_sym_DOT_DOT,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    STATE(1747), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [27160] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1265), 1,
      anon_sym_instanceof,
    ACTIONS(1267), 1,
      anon_sym_in,
    ACTIONS(1269), 1,
      anon_sym_and,
    ACTIONS(1271), 1,
      anon_sym_or,
    ACTIONS(1273), 1,
      anon_sym_implies,
    ACTIONS(1287), 1,
      anon_sym_as,
    STATE(243), 1,
      sym_compop,
    STATE(245), 1,
      sym_mulop,
    STATE(248), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(669), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_order,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [27218] = 18,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1289), 1,
      anon_sym_COMMA,
    ACTIONS(1291), 1,
      anon_sym_RBRACK,
    ACTIONS(1293), 1,
      anon_sym_DOT_DOT,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    STATE(1686), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [27280] = 18,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1295), 1,
      anon_sym_COMMA,
    ACTIONS(1297), 1,
      anon_sym_RBRACK,
    ACTIONS(1299), 1,
      anon_sym_DOT_DOT,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    STATE(1626), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [27342] = 18,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1301), 1,
      anon_sym_COMMA,
    ACTIONS(1303), 1,
      anon_sym_RBRACK,
    ACTIONS(1305), 1,
      anon_sym_DOT_DOT,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    STATE(1647), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [27404] = 13,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(683), 1,
      anon_sym_or,
    ACTIONS(1265), 1,
      anon_sym_instanceof,
    ACTIONS(1267), 1,
      anon_sym_in,
    STATE(243), 1,
      sym_compop,
    STATE(245), 1,
      sym_mulop,
    STATE(248), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(685), 6,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
  [27456] = 13,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(634), 6,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_implies,
      anon_sym_PIPE,
  [27508] = 12,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(644), 7,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
  [27558] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(652), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_PIPE,
  [27614] = 14,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(656), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_implies,
      anon_sym_PIPE,
  [27668] = 10,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1251), 1,
      anon_sym_in,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(677), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(675), 12,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [27714] = 6,
    STATE(243), 1,
      sym_compop,
    STATE(245), 1,
      sym_mulop,
    STATE(248), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(679), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(681), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [27752] = 8,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    STATE(243), 1,
      sym_compop,
    STATE(245), 1,
      sym_mulop,
    STATE(248), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(630), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
    ACTIONS(628), 13,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_order,
  [27794] = 13,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(642), 1,
      anon_sym_or,
    ACTIONS(1265), 1,
      anon_sym_instanceof,
    ACTIONS(1267), 1,
      anon_sym_in,
    STATE(243), 1,
      sym_compop,
    STATE(245), 1,
      sym_mulop,
    STATE(248), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(644), 6,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
  [27846] = 5,
    ACTIONS(701), 1,
      anon_sym_LT,
    ACTIONS(706), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(699), 4,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(704), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [27881] = 17,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1313), 1,
      anon_sym_COMMA,
    ACTIONS(1315), 1,
      anon_sym_RBRACK,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    STATE(1630), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [27940] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1319), 1,
      anon_sym_LT,
    ACTIONS(1321), 1,
      anon_sym_DOT,
    ACTIONS(706), 5,
      ts_builtin_sym_end,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1317), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_as,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [27977] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1319), 1,
      anon_sym_LT,
    ACTIONS(1321), 1,
      anon_sym_DOT,
    ACTIONS(706), 5,
      anon_sym_RBRACE,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1317), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_as,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [28014] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1287), 1,
      anon_sym_as,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(669), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [28071] = 17,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1313), 1,
      anon_sym_COMMA,
    ACTIONS(1323), 1,
      anon_sym_RBRACK,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    STATE(1736), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [28130] = 17,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1313), 1,
      anon_sym_COMMA,
    ACTIONS(1325), 1,
      anon_sym_RBRACK,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    STATE(1739), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [28189] = 17,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1313), 1,
      anon_sym_COMMA,
    ACTIONS(1327), 1,
      anon_sym_RBRACK,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    STATE(1741), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [28248] = 17,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1313), 1,
      anon_sym_COMMA,
    ACTIONS(1329), 1,
      anon_sym_RBRACK,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    STATE(1743), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [28307] = 17,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1313), 1,
      anon_sym_COMMA,
    ACTIONS(1331), 1,
      anon_sym_RBRACK,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    STATE(1745), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [28366] = 17,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1313), 1,
      anon_sym_COMMA,
    ACTIONS(1333), 1,
      anon_sym_RBRACK,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    STATE(1748), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [28425] = 5,
    ACTIONS(701), 1,
      anon_sym_LT,
    ACTIONS(706), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(699), 3,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(704), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [28460] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(848), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(846), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [28490] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(784), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(782), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [28520] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(740), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(738), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [28550] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(788), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(786), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [28580] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(792), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(790), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [28610] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(796), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(794), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [28640] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(800), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(798), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [28670] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(804), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(802), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [28700] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1335), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [28754] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(744), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(742), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [28784] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(808), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(806), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [28814] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(714), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(712), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [28844] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1341), 1,
      anon_sym_LBRACE,
    STATE(1189), 1,
      sym_body,
    ACTIONS(1337), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1339), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [28880] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(718), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(716), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [28910] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1341), 1,
      anon_sym_LBRACE,
    STATE(1195), 1,
      sym_body,
    ACTIONS(1343), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1345), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [28946] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(748), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(746), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [28976] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(780), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(778), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [29006] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(756), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(754), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [29036] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(812), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(810), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [29066] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(722), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(720), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [29096] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1351), 1,
      anon_sym_COMMA,
    STATE(892), 1,
      aux_sym_asExprs_repeat1,
    ACTIONS(1347), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1349), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [29132] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(760), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(758), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [29162] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(708), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(710), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [29192] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1356), 1,
      anon_sym_LBRACE,
    STATE(1188), 1,
      sym_body,
    ACTIONS(1358), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1354), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [29228] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(726), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(724), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [29258] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1360), 1,
      anon_sym_RPAREN,
    ACTIONS(1362), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [29314] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1364), 1,
      anon_sym_RPAREN,
    ACTIONS(1366), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [29370] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(764), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(762), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [29400] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(768), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(766), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [29430] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1356), 1,
      anon_sym_LBRACE,
    STATE(1190), 1,
      sym_body,
    ACTIONS(1370), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1368), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [29466] = 4,
    ACTIONS(1372), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(730), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(728), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [29498] = 4,
    ACTIONS(1374), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(752), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(750), 16,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [29530] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(772), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(770), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [29560] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(776), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(774), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [29590] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1376), 1,
      anon_sym_RPAREN,
    ACTIONS(1378), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [29646] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1380), 1,
      anon_sym_RPAREN,
    ACTIONS(1382), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [29702] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(780), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(778), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [29732] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(816), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(814), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [29762] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1341), 1,
      anon_sym_LBRACE,
    STATE(1197), 1,
      sym_body,
    ACTIONS(1384), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1386), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [29798] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(820), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(818), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [29828] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1390), 1,
      anon_sym_COMMA,
    STATE(932), 1,
      aux_sym_asExprs_repeat1,
    ACTIONS(1392), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1388), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [29864] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(784), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(782), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [29894] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(736), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(734), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [29924] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1394), 1,
      anon_sym_RPAREN,
    ACTIONS(1396), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [29980] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1398), 1,
      anon_sym_RPAREN,
    ACTIONS(1400), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [30036] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1356), 1,
      anon_sym_LBRACE,
    STATE(1218), 1,
      sym_body,
    ACTIONS(1404), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1402), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [30072] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(788), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(786), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [30102] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(792), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(790), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [30132] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(824), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(822), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [30162] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(796), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(794), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [30192] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(828), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(826), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [30222] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(832), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(830), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [30252] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(836), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(834), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [30282] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(800), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(798), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [30312] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1410), 1,
      anon_sym_COMMA,
    STATE(892), 1,
      aux_sym_asExprs_repeat1,
    ACTIONS(1406), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1408), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [30348] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(840), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(838), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [30378] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(804), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(802), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [30408] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1356), 1,
      anon_sym_LBRACE,
    STATE(1220), 1,
      sym_body,
    ACTIONS(1337), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1339), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [30444] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1356), 1,
      anon_sym_LBRACE,
    STATE(1222), 1,
      sym_body,
    ACTIONS(1343), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1345), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [30480] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(740), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(738), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [30510] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1390), 1,
      anon_sym_COMMA,
    STATE(1005), 1,
      aux_sym_asExprs_repeat1,
    ACTIONS(1406), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1408), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [30546] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1319), 1,
      anon_sym_LT,
    ACTIONS(1414), 5,
      anon_sym_RBRACE,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1412), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_as,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [30580] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1356), 1,
      anon_sym_LBRACE,
    STATE(1223), 1,
      sym_body,
    ACTIONS(1384), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1386), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [30616] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(844), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(842), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [30646] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(808), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(806), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [30676] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1416), 1,
      anon_sym_RPAREN,
    ACTIONS(1418), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [30732] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(744), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(742), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [30762] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1420), 1,
      anon_sym_RPAREN,
    ACTIONS(1422), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [30818] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1424), 1,
      anon_sym_RPAREN,
    ACTIONS(1426), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [30874] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1428), 1,
      anon_sym_RPAREN,
    ACTIONS(1430), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [30930] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1432), 1,
      anon_sym_RPAREN,
    ACTIONS(1434), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [30986] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1436), 1,
      anon_sym_RPAREN,
    ACTIONS(1438), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [31042] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(812), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(810), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [31072] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(756), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(754), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [31102] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1440), 1,
      anon_sym_RPAREN,
    ACTIONS(1442), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [31158] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(852), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(850), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [31188] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1444), 1,
      anon_sym_RPAREN,
    ACTIONS(1446), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [31244] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1448), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [31298] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1450), 1,
      anon_sym_RPAREN,
    ACTIONS(1452), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [31354] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1454), 1,
      anon_sym_RPAREN,
    ACTIONS(1456), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [31410] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1458), 1,
      anon_sym_RPAREN,
    ACTIONS(1460), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [31466] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1462), 1,
      anon_sym_RPAREN,
    ACTIONS(1464), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [31522] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1466), 1,
      anon_sym_RPAREN,
    ACTIONS(1468), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [31578] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(776), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(774), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [31608] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(772), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(770), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [31638] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(816), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(814), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [31668] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1470), 1,
      anon_sym_RPAREN,
    ACTIONS(1472), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [31724] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1474), 1,
      anon_sym_RPAREN,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [31780] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1478), 1,
      anon_sym_RPAREN,
    ACTIONS(1480), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [31836] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1482), 1,
      anon_sym_RPAREN,
    ACTIONS(1484), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [31892] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1486), 1,
      anon_sym_RPAREN,
    ACTIONS(1488), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [31948] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1490), 1,
      anon_sym_RPAREN,
    ACTIONS(1492), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [32004] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(860), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(858), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [32034] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1494), 1,
      anon_sym_RPAREN,
    ACTIONS(1496), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [32090] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1498), 1,
      anon_sym_RPAREN,
    ACTIONS(1500), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [32146] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1319), 1,
      anon_sym_LT,
    ACTIONS(1414), 5,
      ts_builtin_sym_end,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1412), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_as,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [32180] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(820), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(818), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [32210] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1502), 1,
      anon_sym_RPAREN,
    ACTIONS(1504), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [32266] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1356), 1,
      anon_sym_LBRACE,
    STATE(1203), 1,
      sym_body,
    ACTIONS(1508), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1506), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [32302] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1356), 1,
      anon_sym_LBRACE,
    STATE(1204), 1,
      sym_body,
    ACTIONS(1512), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1510), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [32338] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(748), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(746), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [32368] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1514), 1,
      anon_sym_RPAREN,
    ACTIONS(1516), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [32424] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1518), 1,
      anon_sym_RPAREN,
    ACTIONS(1520), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [32480] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(864), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(862), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [32510] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1522), 1,
      anon_sym_RPAREN,
    ACTIONS(1524), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [32566] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1526), 1,
      anon_sym_RPAREN,
    ACTIONS(1528), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [32622] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1530), 1,
      anon_sym_RPAREN,
    ACTIONS(1532), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [32678] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1534), 1,
      anon_sym_RPAREN,
    ACTIONS(1536), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [32734] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(824), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(822), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [32764] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(868), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(866), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [32794] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(828), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(826), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [32824] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1538), 1,
      anon_sym_RPAREN,
    ACTIONS(1540), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [32880] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1542), 1,
      anon_sym_RPAREN,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [32936] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1546), 1,
      anon_sym_RPAREN,
    ACTIONS(1548), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [32992] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(872), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(870), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [33022] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1550), 1,
      anon_sym_RPAREN,
    ACTIONS(1552), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [33078] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1554), 1,
      anon_sym_RPAREN,
    ACTIONS(1556), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [33134] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1558), 1,
      anon_sym_RPAREN,
    ACTIONS(1560), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [33190] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1562), 1,
      anon_sym_RPAREN,
    ACTIONS(1564), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [33246] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(832), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(830), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [33276] = 4,
    ACTIONS(1372), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(752), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(750), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [33308] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(836), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(834), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [33338] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1341), 1,
      anon_sym_LBRACE,
    STATE(1214), 1,
      sym_body,
    ACTIONS(1404), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1402), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [33374] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(876), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(874), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [33404] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1356), 1,
      anon_sym_LBRACE,
    STATE(1187), 1,
      sym_body,
    ACTIONS(1568), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1566), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [33440] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(760), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(758), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [33470] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1341), 1,
      anon_sym_LBRACE,
    STATE(1216), 1,
      sym_body,
    ACTIONS(1508), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1506), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [33506] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(708), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(710), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [33536] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1570), 1,
      anon_sym_RPAREN,
    ACTIONS(1572), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [33592] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1341), 1,
      anon_sym_LBRACE,
    STATE(1219), 1,
      sym_body,
    ACTIONS(1512), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1510), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [33628] = 5,
    ACTIONS(605), 1,
      anon_sym_COLON_COLON,
    ACTIONS(882), 1,
      anon_sym_LT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(880), 4,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(878), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [33662] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(764), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(762), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [33692] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(768), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(766), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [33722] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1574), 1,
      anon_sym_COMMA,
    STATE(1005), 1,
      aux_sym_asExprs_repeat1,
    ACTIONS(1347), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1349), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [33758] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(840), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(838), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [33788] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(714), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(712), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [33818] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1577), 1,
      anon_sym_RPAREN,
    ACTIONS(1579), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [33874] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(844), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(842), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [33904] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1581), 1,
      anon_sym_RPAREN,
    ACTIONS(1583), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [33960] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(718), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(716), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [33990] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(722), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(720), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [34020] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(726), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(724), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [34050] = 4,
    ACTIONS(1374), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(730), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(728), 16,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [34082] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(848), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(846), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [34112] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(852), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(850), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [34142] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(856), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(854), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [34172] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1341), 1,
      anon_sym_LBRACE,
    STATE(1224), 1,
      sym_body,
    ACTIONS(1358), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1354), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [34208] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1341), 1,
      anon_sym_LBRACE,
    STATE(1191), 1,
      sym_body,
    ACTIONS(1370), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1368), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [34244] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(860), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(858), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [34274] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(864), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(862), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [34304] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(868), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(866), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [34334] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(872), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(870), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [34364] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(876), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(874), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [34394] = 5,
    ACTIONS(605), 1,
      anon_sym_COLON_COLON,
    ACTIONS(882), 1,
      anon_sym_LT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(880), 3,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(878), 16,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [34428] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1410), 1,
      anon_sym_COMMA,
    STATE(926), 1,
      aux_sym_asExprs_repeat1,
    ACTIONS(1392), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1388), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [34464] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1341), 1,
      anon_sym_LBRACE,
    STATE(1205), 1,
      sym_body,
    ACTIONS(1568), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1566), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [34500] = 16,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1585), 1,
      anon_sym_RPAREN,
    ACTIONS(1587), 1,
      anon_sym_PIPE,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [34556] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(736), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(734), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [34586] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(856), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(854), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [34616] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1589), 1,
      anon_sym_RBRACE,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [34669] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1595), 1,
      anon_sym_order,
    STATE(1282), 1,
      sym_orderBys,
    ACTIONS(1593), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1591), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [34704] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1595), 1,
      anon_sym_order,
    STATE(1372), 1,
      sym_orderBys,
    ACTIONS(1599), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1597), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [34739] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1605), 1,
      anon_sym_or,
    STATE(1034), 1,
      aux_sym_datatypeBranches_repeat1,
    ACTIONS(1603), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1601), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [34774] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1608), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [34827] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1614), 1,
      anon_sym_or,
    STATE(1114), 1,
      aux_sym_datatypeBranches_repeat1,
    ACTIONS(1610), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1612), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [34862] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1616), 1,
      anon_sym_select,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [34915] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1622), 1,
      anon_sym_order,
    STATE(1283), 1,
      sym_orderBys,
    ACTIONS(1618), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1620), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [34950] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1628), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1624), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1626), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_as,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [34983] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(937), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(935), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [35012] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(941), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(939), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [35041] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(949), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(947), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [35070] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(706), 5,
      anon_sym_RBRACE,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1317), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_as,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [35101] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1630), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [35154] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(921), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(919), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [35183] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(933), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(931), 16,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [35212] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(953), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(951), 16,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [35241] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(909), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(907), 16,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [35270] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(704), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(699), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [35301] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(959), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(961), 16,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [35330] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(963), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(965), 16,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [35359] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1414), 5,
      anon_sym_RBRACE,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1412), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_as,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [35390] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(967), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(969), 16,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [35419] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(917), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(915), 16,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [35448] = 17,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(1632), 1,
      sym__lower_id,
    ACTIONS(1634), 1,
      sym__upper_id,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1466), 1,
      sym_moduleExpr,
    STATE(1495), 1,
      sym_predicateExpr,
    STATE(1506), 1,
      sym_typeExpr,
    STATE(1596), 1,
      sym_literalId,
    STATE(1627), 1,
      sym_signatureExpr,
    STATE(1633), 1,
      sym_moduleParam,
    STATE(1882), 1,
      sym_aritylessPredicateExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [35505] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(933), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(931), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [35534] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(913), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(911), 16,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [35563] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(953), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(951), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [35592] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(909), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(907), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [35621] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(925), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(923), 16,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [35650] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(929), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(927), 16,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [35679] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(945), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(943), 16,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [35708] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1638), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1636), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [35739] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(957), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(955), 16,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [35768] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1347), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1349), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [35799] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(937), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(935), 16,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [35828] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(941), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(939), 16,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [35857] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(949), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(947), 16,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [35886] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1642), 5,
      anon_sym_RBRACE,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1640), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_as,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [35917] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(959), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(961), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [35946] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(963), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(965), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [35975] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(921), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(919), 16,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_asc,
      anon_sym_desc,
  [36004] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1646), 1,
      anon_sym_COMMA,
    STATE(1082), 1,
      aux_sym_orderBys_repeat1,
    ACTIONS(1648), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1644), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [36039] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1652), 5,
      anon_sym_RBRACE,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1650), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_as,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [36070] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(967), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(969), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [36099] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1654), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [36152] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(917), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(915), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [36181] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(706), 5,
      ts_builtin_sym_end,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1317), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_as,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [36212] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1638), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1636), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [36243] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1347), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1349), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [36274] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1656), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [36327] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1646), 1,
      anon_sym_COMMA,
    STATE(1089), 1,
      aux_sym_orderBys_repeat1,
    ACTIONS(1660), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1658), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [36362] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(913), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(911), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [36391] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1662), 1,
      anon_sym_else,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [36444] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1664), 1,
      anon_sym_RBRACK,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [36497] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1666), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1624), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1626), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_as,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [36530] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1668), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [36583] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1674), 1,
      anon_sym_COMMA,
    STATE(1088), 1,
      aux_sym_orderBys_repeat1,
    ACTIONS(1670), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1672), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [36618] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1677), 1,
      anon_sym_COMMA,
    STATE(1089), 1,
      aux_sym_orderBys_repeat1,
    ACTIONS(1670), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1672), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [36653] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(925), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(923), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [36682] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(929), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(927), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [36711] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1680), 1,
      anon_sym_RBRACE,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [36764] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(945), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(943), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [36793] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1682), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [36846] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1595), 1,
      anon_sym_order,
    STATE(1287), 1,
      sym_orderBys,
    ACTIONS(1686), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1684), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [36881] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1688), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [36934] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(957), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_in,
      anon_sym_SLASH,
    ACTIONS(955), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_instanceof,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_order,
  [36963] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1690), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [37016] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1666), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1694), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1692), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_as,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [37049] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1595), 1,
      anon_sym_order,
    STATE(1302), 1,
      sym_orderBys,
    ACTIONS(1698), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1696), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [37084] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(704), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(699), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_order,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [37115] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1700), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [37168] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1628), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1694), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1692), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_as,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [37201] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1702), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [37254] = 17,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(1632), 1,
      sym__lower_id,
    ACTIONS(1634), 1,
      sym__upper_id,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1466), 1,
      sym_moduleExpr,
    STATE(1495), 1,
      sym_predicateExpr,
    STATE(1506), 1,
      sym_typeExpr,
    STATE(1596), 1,
      sym_literalId,
    STATE(1627), 1,
      sym_signatureExpr,
    STATE(1767), 1,
      sym_moduleParam,
    STATE(1882), 1,
      sym_aritylessPredicateExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [37311] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1704), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [37364] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1706), 1,
      anon_sym_else,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [37417] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1708), 1,
      anon_sym_RBRACK,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [37470] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1622), 1,
      anon_sym_order,
    STATE(1365), 1,
      sym_orderBys,
    ACTIONS(1698), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1696), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [37505] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1710), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [37558] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1712), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [37611] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1714), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [37664] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1716), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [37717] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1614), 1,
      anon_sym_or,
    STATE(1164), 1,
      aux_sym_datatypeBranches_repeat1,
    ACTIONS(1718), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1720), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [37752] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1722), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [37805] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1622), 1,
      anon_sym_order,
    STATE(1350), 1,
      sym_orderBys,
    ACTIONS(1724), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1726), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [37840] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1728), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [37893] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1730), 1,
      anon_sym_select,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [37946] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1732), 1,
      anon_sym_else,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [37999] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1734), 1,
      anon_sym_RBRACK,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [38052] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1736), 1,
      anon_sym_else,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [38105] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1738), 1,
      anon_sym_RBRACK,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [38158] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1740), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [38211] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1742), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [38264] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1744), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [38317] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1746), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [38370] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1414), 5,
      ts_builtin_sym_end,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1412), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_as,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [38401] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1748), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [38454] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1750), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [38507] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1752), 1,
      anon_sym_else,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [38560] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1754), 1,
      anon_sym_RBRACK,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [38613] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1756), 1,
      anon_sym_or,
    STATE(1165), 1,
      aux_sym_datatypeBranches_repeat1,
    ACTIONS(1610), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1612), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [38648] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1758), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [38701] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1595), 1,
      anon_sym_order,
    STATE(1352), 1,
      sym_orderBys,
    ACTIONS(1618), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1620), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [38736] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1760), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [38789] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1762), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [38842] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1764), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [38895] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1766), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [38948] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1768), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [39001] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1770), 1,
      anon_sym_else,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [39054] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1772), 1,
      anon_sym_RBRACK,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [39107] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1774), 1,
      anon_sym_COMMA,
    STATE(1169), 1,
      aux_sym_orderBys_repeat1,
    ACTIONS(1648), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1644), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [39142] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1776), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [39195] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1778), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [39248] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1780), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [39301] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1782), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [39354] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1784), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [39407] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1786), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [39460] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1788), 1,
      anon_sym_then,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [39513] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1790), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [39566] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1792), 1,
      anon_sym_else,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [39619] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1794), 1,
      anon_sym_RBRACK,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [39672] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1796), 1,
      anon_sym_RBRACE,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [39725] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1798), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [39778] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1800), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [39831] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1802), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [39884] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1804), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [39937] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1806), 1,
      anon_sym_else,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [39990] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1642), 5,
      ts_builtin_sym_end,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1640), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_as,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [40021] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1808), 1,
      anon_sym_select,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [40074] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1810), 1,
      anon_sym_select,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [40127] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1812), 1,
      anon_sym_select,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [40180] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1814), 1,
      anon_sym_select,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [40233] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1816), 1,
      anon_sym_or,
    STATE(1164), 1,
      aux_sym_datatypeBranches_repeat1,
    ACTIONS(1603), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1601), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [40268] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1756), 1,
      anon_sym_or,
    STATE(1034), 1,
      aux_sym_datatypeBranches_repeat1,
    ACTIONS(1718), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1720), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [40303] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1622), 1,
      anon_sym_order,
    STATE(1389), 1,
      sym_orderBys,
    ACTIONS(1593), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1591), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [40338] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1595), 1,
      anon_sym_order,
    STATE(1280), 1,
      sym_orderBys,
    ACTIONS(1724), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1726), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [40373] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1819), 1,
      anon_sym_select,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [40426] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1774), 1,
      anon_sym_COMMA,
    STATE(1088), 1,
      aux_sym_orderBys_repeat1,
    ACTIONS(1660), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1658), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [40461] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1652), 5,
      ts_builtin_sym_end,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1650), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_as,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [40492] = 17,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(1632), 1,
      sym__lower_id,
    ACTIONS(1634), 1,
      sym__upper_id,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1466), 1,
      sym_moduleExpr,
    STATE(1495), 1,
      sym_predicateExpr,
    STATE(1506), 1,
      sym_typeExpr,
    STATE(1596), 1,
      sym_literalId,
    STATE(1627), 1,
      sym_signatureExpr,
    STATE(1669), 1,
      sym_moduleParam,
    STATE(1882), 1,
      sym_aritylessPredicateExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [40549] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1821), 1,
      anon_sym_then,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [40602] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1823), 1,
      anon_sym_then,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [40655] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1825), 1,
      anon_sym_then,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [40708] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1827), 1,
      anon_sym_then,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [40761] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1829), 1,
      anon_sym_then,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [40814] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1831), 1,
      anon_sym_then,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [40867] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1833), 1,
      anon_sym_then,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [40920] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1622), 1,
      anon_sym_order,
    STATE(1233), 1,
      sym_orderBys,
    ACTIONS(1599), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1597), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [40955] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1835), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [41008] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1622), 1,
      anon_sym_order,
    STATE(1297), 1,
      sym_orderBys,
    ACTIONS(1686), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1684), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [41043] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1251), 1,
      anon_sym_in,
    ACTIONS(1307), 1,
      anon_sym_and,
    ACTIONS(1309), 1,
      anon_sym_or,
    ACTIONS(1311), 1,
      anon_sym_implies,
    ACTIONS(1837), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_compop,
    STATE(230), 1,
      sym_mulop,
    STATE(231), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [41096] = 15,
    ACTIONS(601), 1,
      anon_sym_SLASH,
    ACTIONS(1229), 1,
      anon_sym_or,
    ACTIONS(1231), 1,
      anon_sym_instanceof,
    ACTIONS(1233), 1,
      anon_sym_in,
    ACTIONS(1235), 1,
      anon_sym_and,
    ACTIONS(1237), 1,
      anon_sym_implies,
    ACTIONS(1839), 1,
      anon_sym_select,
    STATE(204), 1,
      sym_compop,
    STATE(206), 1,
      sym_mulop,
    STATE(208), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(583), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(597), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(599), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(585), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [41149] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1843), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1841), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [41179] = 6,
    ACTIONS(1845), 1,
      sym__lower_id,
    STATE(1392), 1,
      sym_annotName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1850), 2,
      sym_dbtype,
      sym__upper_id,
    STATE(1185), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(1848), 13,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_predicate,
  [41213] = 4,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(605), 2,
      anon_sym_LT,
      anon_sym_COLON_COLON,
    ACTIONS(611), 3,
      anon_sym_LBRACK,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1852), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [41243] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1856), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1854), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [41273] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1343), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1345), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [41303] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1508), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1506), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [41333] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1384), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1386), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [41363] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1384), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1386), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [41393] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1858), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1860), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [41423] = 16,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(1632), 1,
      sym__lower_id,
    ACTIONS(1634), 1,
      sym__upper_id,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1466), 1,
      sym_moduleExpr,
    STATE(1495), 1,
      sym_predicateExpr,
    STATE(1506), 1,
      sym_typeExpr,
    STATE(1596), 1,
      sym_literalId,
    STATE(1697), 1,
      sym_signatureExpr,
    STATE(1882), 1,
      sym_aritylessPredicateExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [41477] = 16,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(1632), 1,
      sym__lower_id,
    ACTIONS(1634), 1,
      sym__upper_id,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1466), 1,
      sym_moduleExpr,
    STATE(1495), 1,
      sym_predicateExpr,
    STATE(1506), 1,
      sym_typeExpr,
    STATE(1513), 1,
      sym_signatureExpr,
    STATE(1596), 1,
      sym_literalId,
    STATE(1882), 1,
      sym_aritylessPredicateExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [41531] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1512), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1510), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [41561] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1670), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1672), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [41591] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1862), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1864), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [41621] = 16,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(1632), 1,
      sym__lower_id,
    ACTIONS(1634), 1,
      sym__upper_id,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1466), 1,
      sym_moduleExpr,
    STATE(1495), 1,
      sym_predicateExpr,
    STATE(1506), 1,
      sym_typeExpr,
    STATE(1535), 1,
      sym_signatureExpr,
    STATE(1596), 1,
      sym_literalId,
    STATE(1882), 1,
      sym_aritylessPredicateExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [41675] = 16,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(1632), 1,
      sym__lower_id,
    ACTIONS(1634), 1,
      sym__upper_id,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1466), 1,
      sym_moduleExpr,
    STATE(1495), 1,
      sym_predicateExpr,
    STATE(1506), 1,
      sym_typeExpr,
    STATE(1516), 1,
      sym_signatureExpr,
    STATE(1596), 1,
      sym_literalId,
    STATE(1882), 1,
      sym_aritylessPredicateExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [41729] = 16,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(1632), 1,
      sym__lower_id,
    ACTIONS(1634), 1,
      sym__upper_id,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1466), 1,
      sym_moduleExpr,
    STATE(1495), 1,
      sym_predicateExpr,
    STATE(1506), 1,
      sym_typeExpr,
    STATE(1527), 1,
      sym_signatureExpr,
    STATE(1596), 1,
      sym_literalId,
    STATE(1882), 1,
      sym_aritylessPredicateExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [41783] = 16,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(1632), 1,
      sym__lower_id,
    ACTIONS(1634), 1,
      sym__upper_id,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1466), 1,
      sym_moduleExpr,
    STATE(1495), 1,
      sym_predicateExpr,
    STATE(1506), 1,
      sym_typeExpr,
    STATE(1596), 1,
      sym_literalId,
    STATE(1696), 1,
      sym_signatureExpr,
    STATE(1882), 1,
      sym_aritylessPredicateExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [41837] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1603), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1601), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [41867] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1568), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1566), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [41897] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1868), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1866), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [41927] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1856), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1854), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [41957] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1872), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1870), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [41987] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1858), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1860), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [42017] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1843), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1841), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [42047] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1872), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1870), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [42077] = 16,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(1632), 1,
      sym__lower_id,
    ACTIONS(1634), 1,
      sym__upper_id,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1466), 1,
      sym_moduleExpr,
    STATE(1495), 1,
      sym_predicateExpr,
    STATE(1506), 1,
      sym_typeExpr,
    STATE(1536), 1,
      sym_signatureExpr,
    STATE(1596), 1,
      sym_literalId,
    STATE(1882), 1,
      sym_aritylessPredicateExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [42131] = 16,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(1632), 1,
      sym__lower_id,
    ACTIONS(1634), 1,
      sym__upper_id,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1466), 1,
      sym_moduleExpr,
    STATE(1495), 1,
      sym_predicateExpr,
    STATE(1506), 1,
      sym_typeExpr,
    STATE(1596), 1,
      sym_literalId,
    STATE(1688), 1,
      sym_signatureExpr,
    STATE(1882), 1,
      sym_aritylessPredicateExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [42185] = 16,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(1632), 1,
      sym__lower_id,
    ACTIONS(1634), 1,
      sym__upper_id,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1466), 1,
      sym_moduleExpr,
    STATE(1495), 1,
      sym_predicateExpr,
    STATE(1506), 1,
      sym_typeExpr,
    STATE(1509), 1,
      sym_signatureExpr,
    STATE(1596), 1,
      sym_literalId,
    STATE(1882), 1,
      sym_aritylessPredicateExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [42239] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1603), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1601), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [42269] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1370), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1368), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [42299] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1878), 1,
      anon_sym_as,
    ACTIONS(1874), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1876), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [42331] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1568), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1566), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [42361] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1880), 1,
      anon_sym_as,
    ACTIONS(1874), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1876), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [42393] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1370), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1368), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [42423] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1868), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1866), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [42453] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1508), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1506), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [42483] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1670), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1672), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [42513] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1512), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1510), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [42543] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1862), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1864), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [42573] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1343), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1345), 15,
      anon_sym_module,
      anon_sym_import,
      anon_sym_or,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [42603] = 16,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(1632), 1,
      sym__lower_id,
    ACTIONS(1634), 1,
      sym__upper_id,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1466), 1,
      sym_moduleExpr,
    STATE(1495), 1,
      sym_predicateExpr,
    STATE(1506), 1,
      sym_typeExpr,
    STATE(1596), 1,
      sym_literalId,
    STATE(1665), 1,
      sym_signatureExpr,
    STATE(1882), 1,
      sym_aritylessPredicateExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [42657] = 16,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(1632), 1,
      sym__lower_id,
    ACTIONS(1634), 1,
      sym__upper_id,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1466), 1,
      sym_moduleExpr,
    STATE(1495), 1,
      sym_predicateExpr,
    STATE(1506), 1,
      sym_typeExpr,
    STATE(1596), 1,
      sym_literalId,
    STATE(1766), 1,
      sym_signatureExpr,
    STATE(1882), 1,
      sym_aritylessPredicateExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [42711] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1884), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1882), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [42740] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1888), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1886), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [42769] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1892), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1890), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [42798] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1896), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1894), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [42827] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1900), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1898), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [42856] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1904), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1902), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [42885] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1906), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1908), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [42914] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1912), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1910), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [42943] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1916), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1914), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [42972] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1920), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1918), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [43001] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1924), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1922), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [43030] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1926), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1928), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [43059] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1932), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1930), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [43088] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1936), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1934), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [43117] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1319), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1938), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [43146] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1942), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1940), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [43175] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1946), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1944), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [43204] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1950), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1948), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [43233] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1954), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1952), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [43262] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1956), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1958), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [43291] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1960), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1962), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [43320] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1964), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1966), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [43349] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1968), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1970), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [43378] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1972), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1974), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [43407] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1956), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1958), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [43436] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1960), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1962), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [43465] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1976), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1978), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [43494] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1968), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1970), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [43523] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1982), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1980), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [43552] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1986), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1984), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [43581] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1990), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1988), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [43610] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1972), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1974), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [43639] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1994), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1992), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [43668] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1998), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1996), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [43697] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2002), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2000), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [43726] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2006), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2004), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [43755] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2008), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2010), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [43784] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2014), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2012), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [43813] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1982), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1980), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [43842] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2018), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2016), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [43871] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2022), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2020), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [43900] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2026), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2024), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [43929] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2030), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2028), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [43958] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2034), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2032), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [43987] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2038), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2036), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [44016] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2042), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2040), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [44045] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2044), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2046), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [44074] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2050), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2048), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [44103] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2052), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2054), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [44132] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2056), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2058), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [44161] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1942), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1940), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [44190] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2062), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2060), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [44219] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2066), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2064), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [44248] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1593), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1591), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [44277] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2070), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2068), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [44306] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1599), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1597), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [44335] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1724), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1726), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [44364] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2074), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2072), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [44393] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2078), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2076), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [44422] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2082), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2080), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [44451] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1698), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1696), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [44480] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1986), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1984), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [44509] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1994), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1992), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [44538] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2086), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2084), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [44567] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2090), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2088), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [44596] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1319), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1938), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [44625] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1946), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1944), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [44654] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1998), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1996), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [44683] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2092), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2094), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [44712] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2098), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2096), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [44741] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1698), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1696), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [44770] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2102), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2100), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [44799] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2106), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2104), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [44828] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1888), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1886), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [44857] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1924), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1922), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [44886] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1618), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1620), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [44915] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2108), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2110), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [44944] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2002), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2000), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [44973] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2112), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2114), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [45002] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1990), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1988), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [45031] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1884), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1882), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [45060] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1976), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1978), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [45089] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2116), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2118), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [45118] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2116), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2118), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [45147] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2122), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2120), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [45176] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1920), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1918), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [45205] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2022), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2020), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [45234] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2026), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2024), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [45263] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2124), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2126), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [45292] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2128), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2130), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [45321] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2030), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2028), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [45350] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2108), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2110), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [45379] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2112), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2114), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [45408] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2132), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2134), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [45437] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1900), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1898), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [45466] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2136), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2138), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [45495] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2142), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2140), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [45524] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2034), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2032), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [45553] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1926), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1928), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [45582] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1964), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1966), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [45611] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2008), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2010), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [45640] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2144), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2146), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [45669] = 15,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(2148), 1,
      sym__lower_id,
    ACTIONS(2150), 1,
      anon_sym_where,
    ACTIONS(2152), 1,
      anon_sym_select,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1576), 1,
      sym_varDecl,
    STATE(1588), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [45720] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2098), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2096), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [45749] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2092), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2094), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [45778] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2038), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2036), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [45807] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2042), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2040), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [45836] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1932), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1930), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [45865] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2154), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2156), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [45894] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2158), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2160), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [45923] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2050), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2048), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [45952] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2162), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2164), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [45981] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2062), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2060), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [46010] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2066), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2064), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [46039] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2044), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2046), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [46068] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2166), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2168), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [46097] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(611), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1852), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [46124] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2170), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2172), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [46153] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2052), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2054), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [46182] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2056), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2058), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [46211] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2174), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2176), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [46240] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2070), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2068), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [46269] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2102), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2100), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [46298] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1593), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1591), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [46327] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1936), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1934), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [46356] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1724), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1726), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [46385] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1904), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1902), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [46414] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2122), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2120), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [46443] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2106), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2104), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [46472] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1912), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1910), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [46501] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1916), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1914), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [46530] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2124), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2126), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [46559] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2128), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2130), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [46588] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2132), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2134), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [46617] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2136), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2138), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [46646] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2144), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2146), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [46675] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2180), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2178), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [46704] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2074), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2072), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [46733] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1618), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1620), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [46762] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2180), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2178), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [46791] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2182), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2184), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [46820] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2154), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2156), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [46849] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2158), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2160), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [46878] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2186), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2188), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [46907] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1892), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1890), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [46936] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1906), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1908), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [46965] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1896), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1894), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [46994] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1950), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1948), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [47023] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1954), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1952), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [47052] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2166), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2168), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [47081] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2170), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2172), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [47110] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2006), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2004), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [47139] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2014), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2012), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [47168] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2018), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2016), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [47197] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2086), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2084), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [47226] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2142), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2140), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [47255] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2078), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2076), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [47284] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2174), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2176), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [47313] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2082), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2080), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [47342] = 15,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(2148), 1,
      sym__lower_id,
    ACTIONS(2190), 1,
      anon_sym_where,
    ACTIONS(2192), 1,
      anon_sym_select,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1561), 1,
      sym_varDecl,
    STATE(1588), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [47393] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2090), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2088), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [47422] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2182), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2184), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [47451] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1599), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(1597), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [47480] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2186), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2188), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [47509] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2162), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2164), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [47538] = 4,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2198), 2,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2194), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [47566] = 14,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(2148), 1,
      sym__lower_id,
    ACTIONS(2200), 1,
      anon_sym_RPAREN,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1588), 1,
      sym_typeExpr,
    STATE(1624), 1,
      sym_varDecl,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [47614] = 14,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(2148), 1,
      sym__lower_id,
    ACTIONS(2202), 1,
      anon_sym_RPAREN,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1588), 1,
      sym_typeExpr,
    STATE(1734), 1,
      sym_varDecl,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [47662] = 14,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(2148), 1,
      sym__lower_id,
    ACTIONS(2204), 1,
      anon_sym_RPAREN,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1588), 1,
      sym_typeExpr,
    STATE(1636), 1,
      sym_varDecl,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [47710] = 14,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(2148), 1,
      sym__lower_id,
    ACTIONS(2206), 1,
      anon_sym_RPAREN,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1588), 1,
      sym_typeExpr,
    STATE(1723), 1,
      sym_varDecl,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [47758] = 14,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(2148), 1,
      sym__lower_id,
    ACTIONS(2208), 1,
      anon_sym_RPAREN,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1588), 1,
      sym_typeExpr,
    STATE(1740), 1,
      sym_varDecl,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [47806] = 14,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(2148), 1,
      sym__lower_id,
    ACTIONS(2210), 1,
      anon_sym_RPAREN,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1588), 1,
      sym_typeExpr,
    STATE(1694), 1,
      sym_varDecl,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [47854] = 14,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(2148), 1,
      sym__lower_id,
    ACTIONS(2212), 1,
      anon_sym_RPAREN,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1588), 1,
      sym_typeExpr,
    STATE(1652), 1,
      sym_varDecl,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [47902] = 14,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(2148), 1,
      sym__lower_id,
    ACTIONS(2214), 1,
      anon_sym_RPAREN,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1588), 1,
      sym_typeExpr,
    STATE(1752), 1,
      sym_varDecl,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [47950] = 14,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(2148), 1,
      sym__lower_id,
    ACTIONS(2216), 1,
      anon_sym_RPAREN,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1588), 1,
      sym_typeExpr,
    STATE(1673), 1,
      sym_varDecl,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [47998] = 13,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(2148), 1,
      sym__lower_id,
    ACTIONS(2218), 1,
      anon_sym_SEMI,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1721), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [48043] = 13,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(2148), 1,
      sym__lower_id,
    ACTIONS(2220), 1,
      anon_sym_SEMI,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1618), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [48088] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2224), 2,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2222), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [48113] = 13,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(2148), 1,
      sym__lower_id,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1520), 1,
      sym_varDecl,
    STATE(1588), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [48158] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2228), 2,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2226), 14,
      anon_sym_module,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_class,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [48183] = 12,
    ACTIONS(2148), 1,
      sym__lower_id,
    ACTIONS(2232), 1,
      sym_dbtype,
    ACTIONS(2234), 1,
      sym__upper_id,
    STATE(1048), 1,
      sym_typeExpr,
    STATE(1067), 1,
      sym_primitiveType,
    STATE(1068), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1897), 1,
      sym_moduleName,
    STATE(1957), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2230), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [48225] = 12,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(2148), 1,
      sym__lower_id,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(2005), 1,
      sym_typeExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [48267] = 12,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(2148), 1,
      sym__lower_id,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1601), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [48309] = 12,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(2148), 1,
      sym__lower_id,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1554), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [48351] = 12,
    ACTIONS(2148), 1,
      sym__lower_id,
    ACTIONS(2238), 1,
      sym_dbtype,
    ACTIONS(2240), 1,
      sym__upper_id,
    STATE(632), 1,
      sym_typeExpr,
    STATE(661), 1,
      sym_primitiveType,
    STATE(662), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1852), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2236), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [48393] = 12,
    ACTIONS(2148), 1,
      sym__lower_id,
    ACTIONS(2244), 1,
      sym_dbtype,
    ACTIONS(2246), 1,
      sym__upper_id,
    STATE(622), 1,
      sym_primitiveType,
    STATE(625), 1,
      sym_className,
    STATE(627), 1,
      sym_typeExpr,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1897), 1,
      sym_moduleName,
    STATE(1973), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2242), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [48435] = 12,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(2148), 1,
      sym__lower_id,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1566), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [48477] = 12,
    ACTIONS(2148), 1,
      sym__lower_id,
    ACTIONS(2250), 1,
      sym_dbtype,
    ACTIONS(2252), 1,
      sym__upper_id,
    STATE(1041), 1,
      sym_primitiveType,
    STATE(1042), 1,
      sym_className,
    STATE(1059), 1,
      sym_typeExpr,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1897), 1,
      sym_moduleName,
    STATE(1947), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2248), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [48519] = 12,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(2148), 1,
      sym__lower_id,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1889), 1,
      sym_typeExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [48561] = 12,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(2148), 1,
      sym__lower_id,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1811), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [48603] = 12,
    ACTIONS(2148), 1,
      sym__lower_id,
    ACTIONS(2256), 1,
      sym_dbtype,
    ACTIONS(2258), 1,
      sym__upper_id,
    STATE(599), 1,
      sym_typeExpr,
    STATE(619), 1,
      sym_primitiveType,
    STATE(623), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1897), 1,
      sym_moduleName,
    STATE(1965), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2254), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [48645] = 12,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(2148), 1,
      sym__lower_id,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(1976), 1,
      sym_typeExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [48687] = 12,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(2148), 1,
      sym__lower_id,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1863), 1,
      sym_typeExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [48729] = 12,
    ACTIONS(2148), 1,
      sym__lower_id,
    ACTIONS(2262), 1,
      sym_dbtype,
    ACTIONS(2264), 1,
      sym__upper_id,
    STATE(611), 1,
      sym_primitiveType,
    STATE(613), 1,
      sym_className,
    STATE(641), 1,
      sym_typeExpr,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1887), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2260), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [48771] = 12,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(2148), 1,
      sym__lower_id,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1793), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [48813] = 12,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(2148), 1,
      sym__lower_id,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(1903), 1,
      sym_typeExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [48855] = 12,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(2148), 1,
      sym__lower_id,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1532), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [48897] = 12,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(2148), 1,
      sym__lower_id,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1602), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [48939] = 12,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(2148), 1,
      sym__lower_id,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1881), 1,
      sym_typeExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [48981] = 12,
    ACTIONS(2148), 1,
      sym__lower_id,
    ACTIONS(2268), 1,
      sym_dbtype,
    ACTIONS(2270), 1,
      sym__upper_id,
    STATE(788), 1,
      sym_className,
    STATE(802), 1,
      sym_typeExpr,
    STATE(804), 1,
      sym_primitiveType,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1877), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2266), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [49023] = 12,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(2148), 1,
      sym__lower_id,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1799), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [49065] = 12,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(2148), 1,
      sym__lower_id,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1605), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [49107] = 12,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(2148), 1,
      sym__lower_id,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1599), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [49149] = 12,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(2148), 1,
      sym__lower_id,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1533), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [49191] = 12,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(2148), 1,
      sym__lower_id,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1847), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [49233] = 12,
    ACTIONS(29), 1,
      sym_dbtype,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(2148), 1,
      sym__lower_id,
    STATE(1437), 1,
      sym_primitiveType,
    STATE(1443), 1,
      sym_className,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1552), 1,
      sym_typeExpr,
    STATE(1853), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(27), 5,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
  [49275] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(605), 15,
      anon_sym_LT,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_implements,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_where,
      anon_sym_select,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RBRACK,
      anon_sym_order,
      anon_sym_COLON_COLON,
  [49297] = 6,
    ACTIONS(2272), 1,
      anon_sym_SLASH,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(605), 2,
      anon_sym_LT,
      anon_sym_COLON_COLON,
    ACTIONS(878), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    ACTIONS(609), 3,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(664), 6,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LBRACE,
      anon_sym_EQ,
      sym__upper_id,
      sym__lower_id,
  [49326] = 4,
    ACTIONS(2272), 1,
      anon_sym_SLASH,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(609), 3,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(605), 8,
      anon_sym_LT,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      sym__upper_id,
      sym__lower_id,
  [49349] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2276), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2274), 7,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [49371] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(941), 3,
      anon_sym_or,
      anon_sym_instanceof,
      sym__lower_id,
    ACTIONS(939), 8,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_DOT,
      sym__upper_id,
  [49391] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2280), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2278), 7,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [49413] = 4,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(605), 2,
      anon_sym_LT,
      anon_sym_COLON_COLON,
    ACTIONS(880), 3,
      anon_sym_or,
      anon_sym_instanceof,
      sym__lower_id,
    ACTIONS(878), 6,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__upper_id,
  [49435] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2284), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2282), 7,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [49457] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(937), 3,
      anon_sym_or,
      anon_sym_instanceof,
      sym__lower_id,
    ACTIONS(935), 8,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_DOT,
      sym__upper_id,
  [49477] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(921), 3,
      anon_sym_or,
      anon_sym_instanceof,
      sym__lower_id,
    ACTIONS(919), 8,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_DOT,
      sym__upper_id,
  [49497] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(949), 3,
      anon_sym_or,
      anon_sym_instanceof,
      sym__lower_id,
    ACTIONS(947), 8,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_DOT,
      sym__upper_id,
  [49517] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2288), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2286), 7,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [49539] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2292), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2290), 7,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [49561] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2296), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2294), 7,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [49583] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2300), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym_dbtype,
      sym__upper_id,
    ACTIONS(2298), 7,
      anon_sym_boolean,
      anon_sym_date,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_predicate,
  [49605] = 10,
    ACTIONS(2304), 1,
      anon_sym_RPAREN,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1596), 1,
      sym_literalId,
    STATE(1662), 1,
      sym_predicateExpr,
    STATE(1832), 1,
      sym_moduleExpr,
    STATE(1882), 1,
      sym_aritylessPredicateExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2302), 2,
      sym__upper_id,
      sym__lower_id,
  [49638] = 10,
    ACTIONS(2306), 1,
      anon_sym_RPAREN,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1596), 1,
      sym_literalId,
    STATE(1737), 1,
      sym_predicateExpr,
    STATE(1832), 1,
      sym_moduleExpr,
    STATE(1882), 1,
      sym_aritylessPredicateExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2302), 2,
      sym__upper_id,
      sym__lower_id,
  [49671] = 9,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1596), 1,
      sym_literalId,
    STATE(1774), 1,
      sym_predicateExpr,
    STATE(1832), 1,
      sym_moduleExpr,
    STATE(1882), 1,
      sym_aritylessPredicateExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2302), 2,
      sym__upper_id,
      sym__lower_id,
  [49701] = 3,
    ACTIONS(1319), 1,
      anon_sym_LT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(706), 8,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      sym__upper_id,
      sym__lower_id,
  [49719] = 9,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1596), 1,
      sym_literalId,
    STATE(1832), 1,
      sym_moduleExpr,
    STATE(1882), 1,
      sym_aritylessPredicateExpr,
    STATE(1897), 1,
      sym_moduleName,
    STATE(1964), 1,
      sym_predicateExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2302), 2,
      sym__upper_id,
      sym__lower_id,
  [49749] = 9,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1596), 1,
      sym_literalId,
    STATE(1826), 1,
      sym_predicateExpr,
    STATE(1832), 1,
      sym_moduleExpr,
    STATE(1882), 1,
      sym_aritylessPredicateExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2302), 2,
      sym__upper_id,
      sym__lower_id,
  [49779] = 3,
    ACTIONS(1319), 1,
      anon_sym_LT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1414), 8,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      sym__upper_id,
      sym__lower_id,
  [49797] = 8,
    STATE(863), 1,
      sym_simpleId,
    STATE(1043), 1,
      sym_moduleInstantiation,
    STATE(1086), 1,
      sym_moduleExpr,
    STATE(1217), 1,
      sym_importModuleExpr,
    STATE(1465), 1,
      aux_sym_importModuleExpr_repeat1,
    STATE(1963), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2308), 2,
      sym__upper_id,
      sym__lower_id,
  [49824] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1652), 8,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      sym__upper_id,
      sym__lower_id,
  [49839] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1642), 8,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      sym__upper_id,
      sym__lower_id,
  [49854] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1414), 8,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      sym__upper_id,
      sym__lower_id,
  [49869] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2310), 1,
      sym__lower_id,
    ACTIONS(2312), 1,
      sym_qldoc,
    ACTIONS(2314), 1,
      sym__upper_id,
    STATE(1132), 1,
      sym_datatypeBranch,
    STATE(1299), 1,
      sym_datatypeBranches,
    STATE(1392), 1,
      sym_annotName,
    STATE(1794), 1,
      sym_annotation,
    STATE(2011), 1,
      sym_className,
  [49900] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2310), 1,
      sym__lower_id,
    ACTIONS(2314), 1,
      sym__upper_id,
    ACTIONS(2316), 1,
      sym_qldoc,
    STATE(1036), 1,
      sym_datatypeBranch,
    STATE(1355), 1,
      sym_datatypeBranches,
    STATE(1392), 1,
      sym_annotName,
    STATE(1763), 1,
      sym_annotation,
    STATE(1915), 1,
      sym_className,
  [49931] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(706), 8,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      sym__upper_id,
      sym__lower_id,
  [49946] = 8,
    STATE(862), 1,
      sym_simpleId,
    STATE(1039), 1,
      sym_moduleExpr,
    STATE(1078), 1,
      sym_moduleInstantiation,
    STATE(1215), 1,
      sym_importModuleExpr,
    STATE(1490), 1,
      aux_sym_importModuleExpr_repeat1,
    STATE(1948), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2318), 2,
      sym__upper_id,
      sym__lower_id,
  [49973] = 4,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(605), 2,
      anon_sym_LT,
      anon_sym_COLON_COLON,
    ACTIONS(609), 3,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(878), 3,
      anon_sym_DOT,
      sym__upper_id,
      sym__lower_id,
  [49992] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2320), 8,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__upper_id,
      sym__lower_id,
  [50007] = 7,
    STATE(863), 1,
      sym_simpleId,
    STATE(1043), 1,
      sym_moduleInstantiation,
    STATE(1099), 1,
      sym_moduleExpr,
    STATE(1581), 1,
      aux_sym_importModuleExpr_repeat1,
    STATE(1963), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2308), 2,
      sym__upper_id,
      sym__lower_id,
  [50031] = 3,
    ACTIONS(2324), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2322), 6,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LBRACE,
      anon_sym_EQ,
      sym__upper_id,
      sym__lower_id,
  [50047] = 8,
    ACTIONS(2302), 1,
      sym__lower_id,
    ACTIONS(2326), 1,
      sym__upper_id,
    STATE(1442), 1,
      sym_className,
    STATE(1454), 1,
      sym_simpleId,
    STATE(1458), 1,
      sym_moduleInstantiation,
    STATE(1548), 1,
      sym_literalId,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [50073] = 5,
    ACTIONS(1356), 1,
      anon_sym_LBRACE,
    ACTIONS(2328), 1,
      anon_sym_EQ,
    ACTIONS(2330), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1445), 4,
      sym__optbody,
      sym_empty,
      sym_body,
      sym_higherOrderTerm,
  [50093] = 5,
    ACTIONS(1356), 1,
      anon_sym_LBRACE,
    ACTIONS(2328), 1,
      anon_sym_EQ,
    ACTIONS(2330), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1244), 4,
      sym__optbody,
      sym_empty,
      sym_body,
      sym_higherOrderTerm,
  [50113] = 7,
    ACTIONS(2332), 1,
      anon_sym_LBRACE,
    ACTIONS(2334), 1,
      anon_sym_EQ,
    ACTIONS(2336), 1,
      anon_sym_SEMI,
    ACTIONS(2338), 1,
      anon_sym_extends,
    ACTIONS(2340), 1,
      anon_sym_instanceof,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1381), 2,
      sym_typeAliasBody,
      sym_typeUnionBody,
  [50137] = 5,
    ACTIONS(1356), 1,
      anon_sym_LBRACE,
    ACTIONS(2328), 1,
      anon_sym_EQ,
    ACTIONS(2330), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1447), 4,
      sym__optbody,
      sym_empty,
      sym_body,
      sym_higherOrderTerm,
  [50157] = 5,
    ACTIONS(2342), 1,
      anon_sym_LPAREN,
    STATE(1607), 1,
      sym_closure,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2344), 2,
      anon_sym_PLUS,
      anon_sym_STAR,
    STATE(476), 3,
      sym_call_body,
      sym_unqual_agg_body,
      sym__call_or_unqual_agg_body,
  [50177] = 5,
    ACTIONS(1341), 1,
      anon_sym_LBRACE,
    ACTIONS(2346), 1,
      anon_sym_EQ,
    ACTIONS(2348), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1336), 4,
      sym__optbody,
      sym_empty,
      sym_body,
      sym_higherOrderTerm,
  [50197] = 5,
    ACTIONS(1341), 1,
      anon_sym_LBRACE,
    ACTIONS(2346), 1,
      anon_sym_EQ,
    ACTIONS(2348), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1382), 4,
      sym__optbody,
      sym_empty,
      sym_body,
      sym_higherOrderTerm,
  [50217] = 5,
    ACTIONS(2350), 1,
      anon_sym_LPAREN,
    STATE(1556), 1,
      sym_closure,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2344), 2,
      anon_sym_PLUS,
      anon_sym_STAR,
    STATE(874), 3,
      sym_call_body,
      sym_unqual_agg_body,
      sym__call_or_unqual_agg_body,
  [50237] = 8,
    ACTIONS(1634), 1,
      sym__upper_id,
    ACTIONS(2302), 1,
      sym__lower_id,
    STATE(1442), 1,
      sym_className,
    STATE(1454), 1,
      sym_simpleId,
    STATE(1458), 1,
      sym_moduleInstantiation,
    STATE(1548), 1,
      sym_literalId,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [50263] = 5,
    ACTIONS(2352), 1,
      anon_sym_LPAREN,
    STATE(1547), 1,
      sym_closure,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2344), 2,
      anon_sym_PLUS,
      anon_sym_STAR,
    STATE(519), 3,
      sym_call_body,
      sym_unqual_agg_body,
      sym__call_or_unqual_agg_body,
  [50283] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(704), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_where,
      anon_sym_select,
      anon_sym_PIPE,
      anon_sym_order,
  [50297] = 5,
    ACTIONS(1341), 1,
      anon_sym_LBRACE,
    ACTIONS(2346), 1,
      anon_sym_EQ,
    ACTIONS(2348), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1374), 4,
      sym__optbody,
      sym_empty,
      sym_body,
      sym_higherOrderTerm,
  [50317] = 7,
    ACTIONS(2354), 1,
      anon_sym_LBRACE,
    ACTIONS(2356), 1,
      anon_sym_EQ,
    ACTIONS(2358), 1,
      anon_sym_SEMI,
    ACTIONS(2360), 1,
      anon_sym_extends,
    ACTIONS(2362), 1,
      anon_sym_instanceof,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1290), 2,
      sym_typeAliasBody,
      sym_typeUnionBody,
  [50341] = 5,
    ACTIONS(2364), 1,
      anon_sym_LPAREN,
    STATE(1584), 1,
      sym_closure,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2344), 2,
      anon_sym_PLUS,
      anon_sym_STAR,
    STATE(430), 3,
      sym_call_body,
      sym_unqual_agg_body,
      sym__call_or_unqual_agg_body,
  [50361] = 5,
    ACTIONS(2366), 1,
      anon_sym_LPAREN,
    STATE(1591), 1,
      sym_closure,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2344), 2,
      anon_sym_PLUS,
      anon_sym_STAR,
    STATE(931), 3,
      sym_call_body,
      sym_unqual_agg_body,
      sym__call_or_unqual_agg_body,
  [50381] = 5,
    ACTIONS(1356), 1,
      anon_sym_LBRACE,
    ACTIONS(2328), 1,
      anon_sym_EQ,
    ACTIONS(2330), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1446), 4,
      sym__optbody,
      sym_empty,
      sym_body,
      sym_higherOrderTerm,
  [50401] = 5,
    ACTIONS(2368), 1,
      anon_sym_LPAREN,
    STATE(1564), 1,
      sym_closure,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2344), 2,
      anon_sym_PLUS,
      anon_sym_STAR,
    STATE(562), 3,
      sym_call_body,
      sym_unqual_agg_body,
      sym__call_or_unqual_agg_body,
  [50421] = 5,
    ACTIONS(1356), 1,
      anon_sym_LBRACE,
    ACTIONS(2328), 1,
      anon_sym_EQ,
    ACTIONS(2330), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1323), 4,
      sym__optbody,
      sym_empty,
      sym_body,
      sym_higherOrderTerm,
  [50441] = 5,
    ACTIONS(2370), 1,
      anon_sym_LPAREN,
    STATE(1603), 1,
      sym_closure,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2344), 2,
      anon_sym_PLUS,
      anon_sym_STAR,
    STATE(712), 3,
      sym_call_body,
      sym_unqual_agg_body,
      sym__call_or_unqual_agg_body,
  [50461] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2310), 1,
      sym__lower_id,
    ACTIONS(2312), 1,
      sym_qldoc,
    ACTIONS(2314), 1,
      sym__upper_id,
    STATE(1213), 1,
      sym_datatypeBranch,
    STATE(1392), 1,
      sym_annotName,
    STATE(1794), 1,
      sym_annotation,
    STATE(2011), 1,
      sym_className,
  [50489] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(2310), 1,
      sym__lower_id,
    ACTIONS(2314), 1,
      sym__upper_id,
    ACTIONS(2316), 1,
      sym_qldoc,
    STATE(1202), 1,
      sym_datatypeBranch,
    STATE(1392), 1,
      sym_annotName,
    STATE(1763), 1,
      sym_annotation,
    STATE(1915), 1,
      sym_className,
  [50517] = 5,
    ACTIONS(1356), 1,
      anon_sym_LBRACE,
    ACTIONS(2328), 1,
      anon_sym_EQ,
    ACTIONS(2330), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1369), 4,
      sym__optbody,
      sym_empty,
      sym_body,
      sym_higherOrderTerm,
  [50537] = 7,
    STATE(862), 1,
      sym_simpleId,
    STATE(1078), 1,
      sym_moduleInstantiation,
    STATE(1103), 1,
      sym_moduleExpr,
    STATE(1581), 1,
      aux_sym_importModuleExpr_repeat1,
    STATE(1948), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2318), 2,
      sym__upper_id,
      sym__lower_id,
  [50561] = 7,
    ACTIONS(2264), 1,
      sym__upper_id,
    ACTIONS(2372), 1,
      sym__lower_id,
    STATE(628), 1,
      sym_className,
    STATE(1454), 1,
      sym_simpleId,
    STATE(1458), 1,
      sym_moduleInstantiation,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [50584] = 6,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1775), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2372), 2,
      sym__upper_id,
      sym__lower_id,
  [50605] = 7,
    ACTIONS(2258), 1,
      sym__upper_id,
    ACTIONS(2372), 1,
      sym__lower_id,
    STATE(603), 1,
      sym_className,
    STATE(1454), 1,
      sym_simpleId,
    STATE(1458), 1,
      sym_moduleInstantiation,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [50628] = 7,
    ACTIONS(2252), 1,
      sym__upper_id,
    ACTIONS(2372), 1,
      sym__lower_id,
    STATE(1045), 1,
      sym_className,
    STATE(1454), 1,
      sym_simpleId,
    STATE(1458), 1,
      sym_moduleInstantiation,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [50651] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2374), 6,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LBRACE,
      anon_sym_EQ,
      sym__upper_id,
      sym__lower_id,
  [50664] = 7,
    ACTIONS(2234), 1,
      sym__upper_id,
    ACTIONS(2372), 1,
      sym__lower_id,
    STATE(1072), 1,
      sym_className,
    STATE(1454), 1,
      sym_simpleId,
    STATE(1458), 1,
      sym_moduleInstantiation,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [50687] = 7,
    ACTIONS(2246), 1,
      sym__upper_id,
    ACTIONS(2372), 1,
      sym__lower_id,
    STATE(636), 1,
      sym_className,
    STATE(1454), 1,
      sym_simpleId,
    STATE(1458), 1,
      sym_moduleInstantiation,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [50710] = 6,
    ACTIONS(2148), 1,
      sym__lower_id,
    ACTIONS(2372), 1,
      sym__upper_id,
    STATE(1765), 1,
      sym_annotArg,
    STATE(1804), 1,
      sym_simpleId,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2376), 2,
      sym_result,
      sym_this,
  [50731] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2378), 6,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_where,
      anon_sym_select,
      anon_sym_PIPE,
  [50744] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(878), 6,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_extends,
      anon_sym_instanceof,
  [50757] = 4,
    ACTIONS(2380), 1,
      anon_sym_COMMA,
    STATE(1501), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2383), 4,
      anon_sym_RPAREN,
      anon_sym_where,
      anon_sym_select,
      anon_sym_PIPE,
  [50774] = 7,
    ACTIONS(31), 1,
      sym__upper_id,
    ACTIONS(2372), 1,
      sym__lower_id,
    STATE(1442), 1,
      sym_className,
    STATE(1454), 1,
      sym_simpleId,
    STATE(1458), 1,
      sym_moduleInstantiation,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [50797] = 7,
    ACTIONS(2240), 1,
      sym__upper_id,
    ACTIONS(2372), 1,
      sym__lower_id,
    STATE(606), 1,
      sym_className,
    STATE(1454), 1,
      sym_simpleId,
    STATE(1458), 1,
      sym_moduleInstantiation,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [50820] = 6,
    STATE(1451), 1,
      sym_simpleId,
    STATE(1461), 1,
      sym_moduleInstantiation,
    STATE(1782), 1,
      sym_moduleExpr,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2372), 2,
      sym__upper_id,
      sym__lower_id,
  [50841] = 6,
    ACTIONS(2148), 1,
      sym__lower_id,
    ACTIONS(2372), 1,
      sym__upper_id,
    STATE(1753), 1,
      sym_annotArg,
    STATE(1804), 1,
      sym_simpleId,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2376), 2,
      sym_result,
      sym_this,
  [50862] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2385), 6,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LBRACE,
      anon_sym_EQ,
      sym__upper_id,
      sym__lower_id,
  [50875] = 7,
    ACTIONS(2270), 1,
      sym__upper_id,
    ACTIONS(2372), 1,
      sym__lower_id,
    STATE(810), 1,
      sym_className,
    STATE(1454), 1,
      sym_simpleId,
    STATE(1458), 1,
      sym_moduleInstantiation,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [50898] = 6,
    STATE(1454), 1,
      sym_simpleId,
    STATE(1458), 1,
      sym_moduleInstantiation,
    STATE(1548), 1,
      sym_literalId,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2302), 2,
      sym__upper_id,
      sym__lower_id,
  [50919] = 6,
    ACTIONS(2387), 1,
      anon_sym_COMMA,
    ACTIONS(2389), 1,
      anon_sym_LBRACE,
    ACTIONS(2391), 1,
      anon_sym_EQ,
    STATE(1277), 1,
      sym_moduleAliasBody,
    STATE(1524), 1,
      aux_sym_module_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [50939] = 5,
    ACTIONS(2393), 1,
      anon_sym_DOT,
    STATE(1478), 1,
      sym_simpleId,
    STATE(1499), 1,
      sym_varName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2372), 2,
      sym__upper_id,
      sym__lower_id,
  [50957] = 6,
    ACTIONS(2387), 1,
      anon_sym_COMMA,
    ACTIONS(2395), 1,
      anon_sym_LBRACE,
    ACTIONS(2397), 1,
      anon_sym_EQ,
    STATE(1240), 1,
      sym_moduleAliasBody,
    STATE(1589), 1,
      aux_sym_module_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [50977] = 5,
    STATE(933), 1,
      sym_simpleId,
    STATE(1052), 1,
      sym_moduleInstantiation,
    STATE(1963), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2308), 2,
      sym__upper_id,
      sym__lower_id,
  [50995] = 6,
    ACTIONS(2387), 1,
      anon_sym_COMMA,
    ACTIONS(2397), 1,
      anon_sym_EQ,
    ACTIONS(2399), 1,
      anon_sym_LBRACE,
    STATE(1341), 1,
      sym_moduleAliasBody,
    STATE(1531), 1,
      aux_sym_module_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51015] = 6,
    ACTIONS(2310), 1,
      sym__lower_id,
    ACTIONS(2314), 1,
      sym__upper_id,
    STATE(1392), 1,
      sym_annotName,
    STATE(1796), 1,
      sym_annotation,
    STATE(1868), 1,
      sym_className,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51035] = 5,
    STATE(967), 1,
      sym_simpleId,
    STATE(1127), 1,
      sym_moduleInstantiation,
    STATE(1948), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2318), 2,
      sym__upper_id,
      sym__lower_id,
  [51053] = 6,
    ACTIONS(2387), 1,
      anon_sym_COMMA,
    ACTIONS(2397), 1,
      anon_sym_EQ,
    ACTIONS(2401), 1,
      anon_sym_LBRACE,
    STATE(1242), 1,
      sym_moduleAliasBody,
    STATE(1518), 1,
      aux_sym_module_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51073] = 4,
    ACTIONS(2403), 1,
      anon_sym_COMMA,
    STATE(1517), 1,
      aux_sym_dataclass_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2406), 3,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_instanceof,
  [51089] = 6,
    ACTIONS(2387), 1,
      anon_sym_COMMA,
    ACTIONS(2397), 1,
      anon_sym_EQ,
    ACTIONS(2408), 1,
      anon_sym_LBRACE,
    STATE(1261), 1,
      sym_moduleAliasBody,
    STATE(1589), 1,
      aux_sym_module_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51109] = 6,
    ACTIONS(2387), 1,
      anon_sym_COMMA,
    ACTIONS(2391), 1,
      anon_sym_EQ,
    ACTIONS(2410), 1,
      anon_sym_LBRACE,
    STATE(1351), 1,
      sym_moduleAliasBody,
    STATE(1589), 1,
      aux_sym_module_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51129] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2383), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_where,
      anon_sym_select,
      anon_sym_PIPE,
  [51141] = 5,
    ACTIONS(2412), 1,
      anon_sym_DOT,
    STATE(1478), 1,
      sym_simpleId,
    STATE(1499), 1,
      sym_varName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2372), 2,
      sym__upper_id,
      sym__lower_id,
  [51159] = 6,
    ACTIONS(2414), 1,
      anon_sym_COMMA,
    ACTIONS(2416), 1,
      anon_sym_LBRACE,
    ACTIONS(2418), 1,
      anon_sym_SEMI,
    ACTIONS(2420), 1,
      anon_sym_instanceof,
    STATE(1517), 1,
      aux_sym_dataclass_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51179] = 6,
    ACTIONS(2387), 1,
      anon_sym_COMMA,
    ACTIONS(2391), 1,
      anon_sym_EQ,
    ACTIONS(2422), 1,
      anon_sym_LBRACE,
    STATE(1347), 1,
      sym_moduleAliasBody,
    STATE(1589), 1,
      aux_sym_module_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51199] = 6,
    ACTIONS(2387), 1,
      anon_sym_COMMA,
    ACTIONS(2391), 1,
      anon_sym_EQ,
    ACTIONS(2424), 1,
      anon_sym_LBRACE,
    STATE(1304), 1,
      sym_moduleAliasBody,
    STATE(1589), 1,
      aux_sym_module_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51219] = 6,
    ACTIONS(2414), 1,
      anon_sym_COMMA,
    ACTIONS(2426), 1,
      anon_sym_LBRACE,
    ACTIONS(2428), 1,
      anon_sym_SEMI,
    ACTIONS(2430), 1,
      anon_sym_instanceof,
    STATE(1517), 1,
      aux_sym_dataclass_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51239] = 6,
    ACTIONS(2391), 1,
      anon_sym_EQ,
    ACTIONS(2432), 1,
      anon_sym_LT,
    ACTIONS(2434), 1,
      anon_sym_implements,
    ACTIONS(2436), 1,
      anon_sym_LBRACE,
    STATE(1250), 1,
      sym_moduleAliasBody,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51259] = 6,
    ACTIONS(2387), 1,
      anon_sym_COMMA,
    ACTIONS(2391), 1,
      anon_sym_EQ,
    ACTIONS(2438), 1,
      anon_sym_LBRACE,
    STATE(1248), 1,
      sym_moduleAliasBody,
    STATE(1519), 1,
      aux_sym_module_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51279] = 6,
    ACTIONS(2397), 1,
      anon_sym_EQ,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2442), 1,
      anon_sym_implements,
    ACTIONS(2444), 1,
      anon_sym_LBRACE,
    STATE(1258), 1,
      sym_moduleAliasBody,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51299] = 6,
    ACTIONS(2372), 1,
      sym__upper_id,
    ACTIONS(2446), 1,
      sym__lower_id,
    STATE(1478), 1,
      sym_simpleId,
    STATE(1499), 1,
      sym_varName,
    STATE(1998), 1,
      sym_predicateName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51319] = 6,
    ACTIONS(2310), 1,
      sym__lower_id,
    ACTIONS(2314), 1,
      sym__upper_id,
    STATE(1392), 1,
      sym_annotName,
    STATE(1788), 1,
      sym_annotation,
    STATE(1937), 1,
      sym_className,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51339] = 6,
    ACTIONS(2387), 1,
      anon_sym_COMMA,
    ACTIONS(2397), 1,
      anon_sym_EQ,
    ACTIONS(2448), 1,
      anon_sym_LBRACE,
    STATE(1384), 1,
      sym_moduleAliasBody,
    STATE(1589), 1,
      aux_sym_module_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51359] = 6,
    ACTIONS(2414), 1,
      anon_sym_COMMA,
    ACTIONS(2450), 1,
      anon_sym_LBRACE,
    ACTIONS(2452), 1,
      anon_sym_SEMI,
    ACTIONS(2454), 1,
      anon_sym_instanceof,
    STATE(1525), 1,
      aux_sym_dataclass_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51379] = 6,
    ACTIONS(2414), 1,
      anon_sym_COMMA,
    ACTIONS(2456), 1,
      anon_sym_LBRACE,
    ACTIONS(2458), 1,
      anon_sym_SEMI,
    ACTIONS(2460), 1,
      anon_sym_instanceof,
    STATE(1522), 1,
      aux_sym_dataclass_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51399] = 5,
    STATE(1454), 1,
      sym_simpleId,
    STATE(1458), 1,
      sym_moduleInstantiation,
    STATE(1897), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2372), 2,
      sym__upper_id,
      sym__lower_id,
  [51417] = 6,
    ACTIONS(2387), 1,
      anon_sym_COMMA,
    ACTIONS(2397), 1,
      anon_sym_EQ,
    ACTIONS(2462), 1,
      anon_sym_LBRACE,
    STATE(1326), 1,
      sym_moduleAliasBody,
    STATE(1511), 1,
      aux_sym_module_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51437] = 6,
    ACTIONS(2387), 1,
      anon_sym_COMMA,
    ACTIONS(2391), 1,
      anon_sym_EQ,
    ACTIONS(2464), 1,
      anon_sym_LBRACE,
    STATE(1273), 1,
      sym_moduleAliasBody,
    STATE(1523), 1,
      aux_sym_module_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51457] = 4,
    ACTIONS(2466), 1,
      anon_sym_LPAREN,
    STATE(1902), 1,
      sym_closure,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2344), 2,
      anon_sym_PLUS,
      anon_sym_STAR,
  [51472] = 4,
    STATE(1478), 1,
      sym_simpleId,
    STATE(1656), 1,
      sym_varName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2372), 2,
      sym__upper_id,
      sym__lower_id,
  [51487] = 4,
    STATE(1079), 1,
      sym_varName,
    STATE(1101), 1,
      sym_simpleId,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2318), 2,
      sym__upper_id,
      sym__lower_id,
  [51502] = 5,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2470), 1,
      anon_sym_RPAREN,
    ACTIONS(2472), 1,
      anon_sym_PIPE,
    STATE(1501), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51519] = 4,
    ACTIONS(2474), 1,
      anon_sym_COMMA,
    STATE(1572), 1,
      aux_sym_asExprs_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1406), 2,
      anon_sym_RPAREN,
      anon_sym_order,
  [51534] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2476), 4,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_STAR,
  [51545] = 4,
    ACTIONS(2478), 1,
      anon_sym_LPAREN,
    STATE(1822), 1,
      sym_closure,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2344), 2,
      anon_sym_PLUS,
      anon_sym_STAR,
  [51560] = 5,
    ACTIONS(2414), 1,
      anon_sym_COMMA,
    ACTIONS(2480), 1,
      anon_sym_LBRACE,
    ACTIONS(2482), 1,
      anon_sym_SEMI,
    STATE(1517), 1,
      aux_sym_dataclass_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51577] = 5,
    ACTIONS(2484), 1,
      sym__lower_id,
    ACTIONS(2486), 1,
      anon_sym_LPAREN,
    STATE(523), 1,
      sym_qualifiedRhs,
    STATE(1597), 1,
      sym_predicateName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51594] = 5,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2488), 1,
      anon_sym_RPAREN,
    ACTIONS(2490), 1,
      anon_sym_PIPE,
    STATE(1501), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51611] = 3,
    ACTIONS(2352), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(526), 3,
      sym_call_body,
      sym_unqual_agg_body,
      sym__call_or_unqual_agg_body,
  [51624] = 3,
    ACTIONS(2494), 1,
      anon_sym_SLASH,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2492), 3,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_STAR,
  [51637] = 5,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2496), 1,
      anon_sym_RPAREN,
    ACTIONS(2498), 1,
      anon_sym_PIPE,
    STATE(1551), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51654] = 5,
    ACTIONS(2397), 1,
      anon_sym_EQ,
    ACTIONS(2500), 1,
      anon_sym_implements,
    ACTIONS(2502), 1,
      anon_sym_LBRACE,
    STATE(1262), 1,
      sym_moduleAliasBody,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51671] = 5,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2504), 1,
      anon_sym_RPAREN,
    ACTIONS(2506), 1,
      anon_sym_PIPE,
    STATE(1501), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51688] = 5,
    ACTIONS(2414), 1,
      anon_sym_COMMA,
    ACTIONS(2508), 1,
      anon_sym_LBRACE,
    ACTIONS(2510), 1,
      anon_sym_SEMI,
    STATE(1571), 1,
      aux_sym_dataclass_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51705] = 5,
    ACTIONS(1839), 1,
      anon_sym_select,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2512), 1,
      anon_sym_where,
    STATE(1501), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51722] = 5,
    ACTIONS(2414), 1,
      anon_sym_COMMA,
    ACTIONS(2514), 1,
      anon_sym_LBRACE,
    ACTIONS(2516), 1,
      anon_sym_SEMI,
    STATE(1565), 1,
      aux_sym_dataclass_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51739] = 5,
    ACTIONS(2484), 1,
      sym__lower_id,
    ACTIONS(2518), 1,
      anon_sym_LPAREN,
    STATE(889), 1,
      sym_qualifiedRhs,
    STATE(1537), 1,
      sym_predicateName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51756] = 3,
    ACTIONS(2350), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(899), 3,
      sym_call_body,
      sym_unqual_agg_body,
      sym__call_or_unqual_agg_body,
  [51769] = 5,
    ACTIONS(461), 1,
      anon_sym_RPAREN,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2520), 1,
      anon_sym_PIPE,
    STATE(1501), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51786] = 5,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2522), 1,
      anon_sym_RPAREN,
    ACTIONS(2524), 1,
      anon_sym_PIPE,
    STATE(1559), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51803] = 5,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2526), 1,
      anon_sym_RPAREN,
    ACTIONS(2528), 1,
      anon_sym_PIPE,
    STATE(1501), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51820] = 4,
    STATE(1241), 1,
      sym_simpleId,
    STATE(1349), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2318), 2,
      sym__upper_id,
      sym__lower_id,
  [51835] = 5,
    ACTIONS(1819), 1,
      anon_sym_select,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2530), 1,
      anon_sym_where,
    STATE(1553), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51852] = 4,
    ACTIONS(2474), 1,
      anon_sym_COMMA,
    STATE(1541), 1,
      aux_sym_asExprs_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1392), 2,
      anon_sym_RPAREN,
      anon_sym_order,
  [51867] = 5,
    ACTIONS(2484), 1,
      sym__lower_id,
    ACTIONS(2532), 1,
      anon_sym_LPAREN,
    STATE(566), 1,
      sym_qualifiedRhs,
    STATE(1604), 1,
      sym_predicateName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51884] = 3,
    ACTIONS(2368), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(568), 3,
      sym_call_body,
      sym_unqual_agg_body,
      sym__call_or_unqual_agg_body,
  [51897] = 5,
    ACTIONS(2414), 1,
      anon_sym_COMMA,
    ACTIONS(2534), 1,
      anon_sym_LBRACE,
    ACTIONS(2536), 1,
      anon_sym_SEMI,
    STATE(1517), 1,
      aux_sym_dataclass_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51914] = 5,
    ACTIONS(2414), 1,
      anon_sym_COMMA,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(2540), 1,
      anon_sym_SEMI,
    STATE(1574), 1,
      aux_sym_dataclass_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51931] = 5,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2542), 1,
      anon_sym_RPAREN,
    ACTIONS(2544), 1,
      anon_sym_PIPE,
    STATE(1569), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51948] = 4,
    STATE(1292), 1,
      sym_simpleId,
    STATE(1298), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2308), 2,
      sym__upper_id,
      sym__lower_id,
  [51963] = 5,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2546), 1,
      anon_sym_RPAREN,
    ACTIONS(2548), 1,
      anon_sym_PIPE,
    STATE(1501), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51980] = 5,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2550), 1,
      anon_sym_RPAREN,
    ACTIONS(2552), 1,
      anon_sym_PIPE,
    STATE(1546), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [51997] = 5,
    ACTIONS(2414), 1,
      anon_sym_COMMA,
    ACTIONS(2554), 1,
      anon_sym_LBRACE,
    ACTIONS(2556), 1,
      anon_sym_SEMI,
    STATE(1517), 1,
      aux_sym_dataclass_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52014] = 4,
    ACTIONS(2558), 1,
      anon_sym_COMMA,
    STATE(1572), 1,
      aux_sym_asExprs_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1347), 2,
      anon_sym_RPAREN,
      anon_sym_order,
  [52029] = 5,
    ACTIONS(391), 1,
      anon_sym_RPAREN,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2561), 1,
      anon_sym_PIPE,
    STATE(1557), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52046] = 5,
    ACTIONS(2414), 1,
      anon_sym_COMMA,
    ACTIONS(2563), 1,
      anon_sym_LBRACE,
    ACTIONS(2565), 1,
      anon_sym_SEMI,
    STATE(1517), 1,
      aux_sym_dataclass_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52063] = 4,
    STATE(1528), 1,
      sym_moduleName,
    STATE(1583), 1,
      sym_simpleId,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2372), 2,
      sym__upper_id,
      sym__lower_id,
  [52078] = 5,
    ACTIONS(1808), 1,
      anon_sym_select,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2567), 1,
      anon_sym_where,
    STATE(1611), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52095] = 5,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2569), 1,
      anon_sym_RPAREN,
    ACTIONS(2571), 1,
      anon_sym_PIPE,
    STATE(1501), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52112] = 5,
    ACTIONS(2484), 1,
      sym__lower_id,
    ACTIONS(2573), 1,
      anon_sym_LPAREN,
    STATE(732), 1,
      sym_qualifiedRhs,
    STATE(1543), 1,
      sym_predicateName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52129] = 5,
    ACTIONS(2414), 1,
      anon_sym_COMMA,
    ACTIONS(2575), 1,
      anon_sym_LBRACE,
    ACTIONS(2577), 1,
      anon_sym_SEMI,
    STATE(1517), 1,
      aux_sym_dataclass_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52146] = 5,
    ACTIONS(2484), 1,
      sym__lower_id,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    STATE(434), 1,
      sym_qualifiedRhs,
    STATE(1582), 1,
      sym_predicateName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52163] = 4,
    STATE(1581), 1,
      aux_sym_importModuleExpr_repeat1,
    STATE(1870), 1,
      sym_simpleId,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2581), 2,
      sym__upper_id,
      sym__lower_id,
  [52178] = 4,
    ACTIONS(2584), 1,
      anon_sym_LPAREN,
    STATE(1879), 1,
      sym_closure,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2344), 2,
      anon_sym_PLUS,
      anon_sym_STAR,
  [52193] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1319), 4,
      anon_sym_LT,
      anon_sym_implements,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [52204] = 3,
    ACTIONS(2364), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(437), 3,
      sym_call_body,
      sym_unqual_agg_body,
      sym__call_or_unqual_agg_body,
  [52217] = 5,
    ACTIONS(2391), 1,
      anon_sym_EQ,
    ACTIONS(2586), 1,
      anon_sym_implements,
    ACTIONS(2588), 1,
      anon_sym_LBRACE,
    STATE(1378), 1,
      sym_moduleAliasBody,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52234] = 4,
    ACTIONS(2590), 1,
      anon_sym_LPAREN,
    STATE(1821), 1,
      sym_closure,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2344), 2,
      anon_sym_PLUS,
      anon_sym_STAR,
  [52249] = 4,
    STATE(1049), 1,
      sym_simpleId,
    STATE(1063), 1,
      sym_varName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2308), 2,
      sym__upper_id,
      sym__lower_id,
  [52264] = 4,
    STATE(1478), 1,
      sym_simpleId,
    STATE(1499), 1,
      sym_varName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2372), 2,
      sym__upper_id,
      sym__lower_id,
  [52279] = 4,
    ACTIONS(2592), 1,
      anon_sym_COMMA,
    STATE(1589), 1,
      aux_sym_module_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2595), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [52294] = 5,
    ACTIONS(2484), 1,
      sym__lower_id,
    ACTIONS(2597), 1,
      anon_sym_LPAREN,
    STATE(945), 1,
      sym_qualifiedRhs,
    STATE(1586), 1,
      sym_predicateName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52311] = 3,
    ACTIONS(2366), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1003), 3,
      sym_call_body,
      sym_unqual_agg_body,
      sym__call_or_unqual_agg_body,
  [52324] = 4,
    ACTIONS(2599), 1,
      anon_sym_LPAREN,
    STATE(1848), 1,
      sym_closure,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2344), 2,
      anon_sym_PLUS,
      anon_sym_STAR,
  [52339] = 5,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2601), 1,
      anon_sym_RPAREN,
    ACTIONS(2603), 1,
      anon_sym_PIPE,
    STATE(1598), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52356] = 5,
    ACTIONS(2391), 1,
      anon_sym_EQ,
    ACTIONS(2605), 1,
      anon_sym_implements,
    ACTIONS(2607), 1,
      anon_sym_LBRACE,
    STATE(1342), 1,
      sym_moduleAliasBody,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52373] = 5,
    ACTIONS(2414), 1,
      anon_sym_COMMA,
    ACTIONS(2609), 1,
      anon_sym_LBRACE,
    ACTIONS(2611), 1,
      anon_sym_SEMI,
    STATE(1517), 1,
      aux_sym_dataclass_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52390] = 3,
    ACTIONS(2615), 1,
      anon_sym_SLASH,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2613), 3,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_STAR,
  [52403] = 4,
    ACTIONS(2617), 1,
      anon_sym_LPAREN,
    STATE(1875), 1,
      sym_closure,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2344), 2,
      anon_sym_PLUS,
      anon_sym_STAR,
  [52418] = 5,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2619), 1,
      anon_sym_RPAREN,
    ACTIONS(2621), 1,
      anon_sym_PIPE,
    STATE(1501), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52435] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2406), 4,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_instanceof,
  [52446] = 5,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2623), 1,
      anon_sym_RPAREN,
    ACTIONS(2625), 1,
      anon_sym_PIPE,
    STATE(1540), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52463] = 5,
    ACTIONS(2414), 1,
      anon_sym_COMMA,
    ACTIONS(2627), 1,
      anon_sym_LBRACE,
    ACTIONS(2629), 1,
      anon_sym_SEMI,
    STATE(1595), 1,
      aux_sym_dataclass_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52480] = 5,
    ACTIONS(2414), 1,
      anon_sym_COMMA,
    ACTIONS(2631), 1,
      anon_sym_LBRACE,
    ACTIONS(2633), 1,
      anon_sym_SEMI,
    STATE(1579), 1,
      aux_sym_dataclass_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52497] = 3,
    ACTIONS(2370), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(735), 3,
      sym_call_body,
      sym_unqual_agg_body,
      sym__call_or_unqual_agg_body,
  [52510] = 4,
    ACTIONS(2635), 1,
      anon_sym_LPAREN,
    STATE(1929), 1,
      sym_closure,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2344), 2,
      anon_sym_PLUS,
      anon_sym_STAR,
  [52525] = 5,
    ACTIONS(2414), 1,
      anon_sym_COMMA,
    ACTIONS(2637), 1,
      anon_sym_LBRACE,
    ACTIONS(2639), 1,
      anon_sym_SEMI,
    STATE(1544), 1,
      aux_sym_dataclass_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52542] = 5,
    ACTIONS(2484), 1,
      sym__lower_id,
    ACTIONS(2641), 1,
      anon_sym_LPAREN,
    STATE(480), 1,
      sym_qualifiedRhs,
    STATE(1592), 1,
      sym_predicateName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52559] = 3,
    ACTIONS(2342), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(483), 3,
      sym_call_body,
      sym_unqual_agg_body,
      sym__call_or_unqual_agg_body,
  [52572] = 4,
    STATE(1526), 1,
      sym_moduleName,
    STATE(1583), 1,
      sym_simpleId,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2372), 2,
      sym__upper_id,
      sym__lower_id,
  [52587] = 5,
    ACTIONS(2397), 1,
      anon_sym_EQ,
    ACTIONS(2643), 1,
      anon_sym_implements,
    ACTIONS(2645), 1,
      anon_sym_LBRACE,
    STATE(1376), 1,
      sym_moduleAliasBody,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52604] = 5,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2647), 1,
      anon_sym_RPAREN,
    ACTIONS(2649), 1,
      anon_sym_PIPE,
    STATE(1577), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52621] = 5,
    ACTIONS(1810), 1,
      anon_sym_select,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2651), 1,
      anon_sym_where,
    STATE(1501), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52638] = 4,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2653), 1,
      anon_sym_RPAREN,
    STATE(1501), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52652] = 4,
    ACTIONS(531), 1,
      anon_sym_RBRACK,
    ACTIONS(2655), 1,
      anon_sym_COMMA,
    STATE(1689), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52666] = 4,
    ACTIONS(1347), 1,
      anon_sym_RPAREN,
    ACTIONS(2657), 1,
      anon_sym_COMMA,
    STATE(1614), 1,
      aux_sym_asExprs_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52680] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2662), 1,
      anon_sym_RPAREN,
    STATE(1709), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52694] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2664), 1,
      anon_sym_RPAREN,
    STATE(1709), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52708] = 4,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2666), 1,
      anon_sym_PIPE,
    STATE(1501), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52722] = 4,
    ACTIONS(2668), 1,
      anon_sym_SEMI,
    ACTIONS(2670), 1,
      anon_sym_or,
    STATE(1645), 1,
      aux_sym_typeUnionBody_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52736] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2672), 1,
      anon_sym_RPAREN,
    STATE(1709), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52750] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2662), 1,
      anon_sym_RPAREN,
    STATE(1641), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52764] = 4,
    ACTIONS(2674), 1,
      anon_sym_RPAREN,
    ACTIONS(2676), 1,
      anon_sym_order,
    STATE(1916), 1,
      sym_orderBys,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52778] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2678), 1,
      anon_sym_RPAREN,
    STATE(1631), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52792] = 4,
    ACTIONS(2676), 1,
      anon_sym_order,
    ACTIONS(2680), 1,
      anon_sym_RPAREN,
    STATE(1925), 1,
      sym_orderBys,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52806] = 4,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2682), 1,
      anon_sym_RPAREN,
    STATE(1648), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52820] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2684), 1,
      anon_sym_RPAREN,
    STATE(1709), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52834] = 4,
    ACTIONS(557), 1,
      anon_sym_RBRACK,
    ACTIONS(2686), 1,
      anon_sym_COMMA,
    STATE(1689), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52848] = 3,
    STATE(1780), 1,
      sym_simpleId,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2372), 2,
      sym__upper_id,
      sym__lower_id,
  [52860] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2688), 1,
      anon_sym_RPAREN,
    STATE(1632), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52874] = 4,
    ACTIONS(1660), 1,
      anon_sym_RPAREN,
    ACTIONS(2690), 1,
      anon_sym_COMMA,
    STATE(1700), 1,
      aux_sym_orderBys_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52888] = 4,
    ACTIONS(1313), 1,
      anon_sym_COMMA,
    ACTIONS(2692), 1,
      anon_sym_RBRACK,
    STATE(1689), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52902] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2694), 1,
      anon_sym_RPAREN,
    STATE(1709), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52916] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2696), 1,
      anon_sym_RPAREN,
    STATE(1709), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52930] = 4,
    ACTIONS(2698), 1,
      anon_sym_COMMA,
    ACTIONS(2700), 1,
      anon_sym_GT,
    STATE(1704), 1,
      aux_sym_module_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52944] = 4,
    ACTIONS(247), 1,
      anon_sym_RPAREN,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    STATE(1639), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52958] = 4,
    ACTIONS(255), 1,
      anon_sym_RPAREN,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    STATE(1714), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52972] = 4,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2702), 1,
      anon_sym_RPAREN,
    STATE(1654), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [52986] = 4,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2704), 1,
      anon_sym_RPAREN,
    STATE(1501), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53000] = 4,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2706), 1,
      anon_sym_RPAREN,
    STATE(1501), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53014] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2708), 1,
      anon_sym_RPAREN,
    STATE(1709), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53028] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2708), 1,
      anon_sym_RPAREN,
    STATE(1644), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53042] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2710), 1,
      anon_sym_RPAREN,
    STATE(1709), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53056] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2712), 1,
      anon_sym_RPAREN,
    STATE(1709), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53070] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2712), 1,
      anon_sym_RPAREN,
    STATE(1658), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53084] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2714), 1,
      anon_sym_RPAREN,
    STATE(1709), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53098] = 4,
    ACTIONS(2670), 1,
      anon_sym_or,
    ACTIONS(2716), 1,
      anon_sym_SEMI,
    STATE(1698), 1,
      aux_sym_typeUnionBody_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53112] = 3,
    ACTIONS(2718), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(947), 2,
      sym__upper_id,
      sym__lower_id,
  [53124] = 4,
    ACTIONS(491), 1,
      anon_sym_RBRACK,
    ACTIONS(2720), 1,
      anon_sym_COMMA,
    STATE(1689), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53138] = 4,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2722), 1,
      anon_sym_RPAREN,
    STATE(1501), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53152] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2724), 1,
      anon_sym_RPAREN,
    STATE(1653), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53166] = 4,
    ACTIONS(2726), 1,
      anon_sym_EQ,
    ACTIONS(2728), 1,
      anon_sym_LPAREN,
    STATE(1291), 1,
      sym_predicateAliasBody,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53180] = 4,
    ACTIONS(2670), 1,
      anon_sym_or,
    ACTIONS(2730), 1,
      anon_sym_SEMI,
    STATE(1698), 1,
      aux_sym_typeUnionBody_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53194] = 4,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2732), 1,
      anon_sym_RPAREN,
    STATE(1666), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53208] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2734), 1,
      anon_sym_RPAREN,
    STATE(1709), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53222] = 4,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2736), 1,
      anon_sym_RPAREN,
    STATE(1501), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53236] = 4,
    ACTIONS(275), 1,
      anon_sym_RPAREN,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    STATE(1660), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53250] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1638), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_order,
  [53260] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1347), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_order,
  [53270] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2738), 1,
      anon_sym_RPAREN,
    STATE(1709), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53284] = 4,
    ACTIONS(191), 1,
      anon_sym_RPAREN,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    STATE(1615), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53298] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2740), 1,
      anon_sym_RPAREN,
    STATE(1709), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53312] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2740), 1,
      anon_sym_RPAREN,
    STATE(1663), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53326] = 4,
    ACTIONS(2742), 1,
      anon_sym_COMMA,
    ACTIONS(2744), 1,
      anon_sym_RPAREN,
    STATE(1727), 1,
      aux_sym_higherOrderTerm_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53340] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2746), 1,
      anon_sym_RPAREN,
    STATE(1709), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53354] = 4,
    ACTIONS(2748), 1,
      anon_sym_COMMA,
    ACTIONS(2751), 1,
      anon_sym_RPAREN,
    STATE(1664), 1,
      aux_sym_higherOrderTerm_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53368] = 4,
    ACTIONS(2753), 1,
      anon_sym_COMMA,
    ACTIONS(2755), 1,
      anon_sym_GT,
    STATE(1695), 1,
      aux_sym_moduleInstantiation_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53382] = 4,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2757), 1,
      anon_sym_RPAREN,
    STATE(1501), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53396] = 4,
    ACTIONS(2676), 1,
      anon_sym_order,
    ACTIONS(2759), 1,
      anon_sym_RPAREN,
    STATE(1844), 1,
      sym_orderBys,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53410] = 4,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2761), 1,
      anon_sym_RPAREN,
    STATE(1501), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53424] = 4,
    ACTIONS(2698), 1,
      anon_sym_COMMA,
    ACTIONS(2763), 1,
      anon_sym_GT,
    STATE(1675), 1,
      aux_sym_module_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53438] = 4,
    ACTIONS(1392), 1,
      anon_sym_RPAREN,
    ACTIONS(2765), 1,
      anon_sym_COMMA,
    STATE(1750), 1,
      aux_sym_asExprs_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53452] = 3,
    STATE(1930), 1,
      sym_literalId,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2767), 2,
      sym__upper_id,
      sym__lower_id,
  [53464] = 4,
    ACTIONS(207), 1,
      anon_sym_RPAREN,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    STATE(1676), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53478] = 4,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2769), 1,
      anon_sym_RPAREN,
    STATE(1677), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53492] = 4,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2771), 1,
      anon_sym_PIPE,
    STATE(1678), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53506] = 4,
    ACTIONS(2698), 1,
      anon_sym_COMMA,
    ACTIONS(2773), 1,
      anon_sym_GT,
    STATE(1687), 1,
      aux_sym_module_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53520] = 4,
    ACTIONS(211), 1,
      anon_sym_RPAREN,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    STATE(1709), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53534] = 4,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2775), 1,
      anon_sym_RPAREN,
    STATE(1501), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53548] = 4,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2777), 1,
      anon_sym_PIPE,
    STATE(1501), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53562] = 4,
    ACTIONS(211), 1,
      anon_sym_RPAREN,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    STATE(1680), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53576] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2779), 1,
      anon_sym_RPAREN,
    STATE(1709), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53590] = 4,
    ACTIONS(2781), 1,
      anon_sym_COMMA,
    ACTIONS(2784), 1,
      anon_sym_RBRACK,
    STATE(1681), 1,
      aux_sym_annotation_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53604] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2779), 1,
      anon_sym_RPAREN,
    STATE(1684), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53618] = 4,
    ACTIONS(2786), 1,
      anon_sym_COMMA,
    ACTIONS(2789), 1,
      anon_sym_GT,
    STATE(1683), 1,
      aux_sym_moduleInstantiation_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53632] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2791), 1,
      anon_sym_RPAREN,
    STATE(1709), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53646] = 4,
    ACTIONS(2793), 1,
      anon_sym_COMMA,
    ACTIONS(2795), 1,
      anon_sym_RBRACK,
    STATE(1681), 1,
      aux_sym_annotation_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53660] = 4,
    ACTIONS(523), 1,
      anon_sym_RBRACK,
    ACTIONS(2797), 1,
      anon_sym_COMMA,
    STATE(1689), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53674] = 4,
    ACTIONS(2799), 1,
      anon_sym_COMMA,
    ACTIONS(2802), 1,
      anon_sym_GT,
    STATE(1687), 1,
      aux_sym_module_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53688] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2804), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [53698] = 4,
    ACTIONS(1448), 1,
      anon_sym_RBRACK,
    ACTIONS(2806), 1,
      anon_sym_COMMA,
    STATE(1689), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53712] = 4,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2809), 1,
      anon_sym_PIPE,
    STATE(1692), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53726] = 4,
    ACTIONS(2676), 1,
      anon_sym_order,
    ACTIONS(2811), 1,
      anon_sym_RPAREN,
    STATE(1862), 1,
      sym_orderBys,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53740] = 4,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2813), 1,
      anon_sym_PIPE,
    STATE(1501), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53754] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2815), 1,
      anon_sym_RPAREN,
    STATE(1722), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53768] = 4,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2817), 1,
      anon_sym_RPAREN,
    STATE(1612), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53782] = 4,
    ACTIONS(2753), 1,
      anon_sym_COMMA,
    ACTIONS(2819), 1,
      anon_sym_GT,
    STATE(1683), 1,
      aux_sym_moduleInstantiation_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53796] = 4,
    ACTIONS(2753), 1,
      anon_sym_COMMA,
    ACTIONS(2821), 1,
      anon_sym_GT,
    STATE(1710), 1,
      aux_sym_moduleInstantiation_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53810] = 4,
    ACTIONS(2753), 1,
      anon_sym_COMMA,
    ACTIONS(2823), 1,
      anon_sym_GT,
    STATE(1742), 1,
      aux_sym_moduleInstantiation_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53824] = 4,
    ACTIONS(2825), 1,
      anon_sym_SEMI,
    ACTIONS(2827), 1,
      anon_sym_or,
    STATE(1698), 1,
      aux_sym_typeUnionBody_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53838] = 4,
    ACTIONS(495), 1,
      anon_sym_RBRACK,
    ACTIONS(2830), 1,
      anon_sym_COMMA,
    STATE(1689), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53852] = 4,
    ACTIONS(1670), 1,
      anon_sym_RPAREN,
    ACTIONS(2832), 1,
      anon_sym_COMMA,
    STATE(1700), 1,
      aux_sym_orderBys_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53866] = 4,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2835), 1,
      anon_sym_PIPE,
    STATE(1702), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53880] = 4,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2837), 1,
      anon_sym_PIPE,
    STATE(1501), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53894] = 4,
    ACTIONS(2676), 1,
      anon_sym_order,
    ACTIONS(2839), 1,
      anon_sym_RPAREN,
    STATE(1980), 1,
      sym_orderBys,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53908] = 4,
    ACTIONS(2698), 1,
      anon_sym_COMMA,
    ACTIONS(2841), 1,
      anon_sym_GT,
    STATE(1687), 1,
      aux_sym_module_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53922] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2843), 1,
      anon_sym_RPAREN,
    STATE(1716), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53936] = 4,
    ACTIONS(195), 1,
      anon_sym_RPAREN,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    STATE(1756), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53950] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2845), 1,
      anon_sym_RPAREN,
    STATE(1709), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53964] = 4,
    ACTIONS(1648), 1,
      anon_sym_RPAREN,
    ACTIONS(2690), 1,
      anon_sym_COMMA,
    STATE(1629), 1,
      aux_sym_orderBys_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53978] = 4,
    ACTIONS(2847), 1,
      anon_sym_COMMA,
    ACTIONS(2850), 1,
      anon_sym_RPAREN,
    STATE(1709), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [53992] = 4,
    ACTIONS(2753), 1,
      anon_sym_COMMA,
    ACTIONS(2852), 1,
      anon_sym_GT,
    STATE(1683), 1,
      aux_sym_moduleInstantiation_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54006] = 4,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2854), 1,
      anon_sym_PIPE,
    STATE(1712), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54020] = 4,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2856), 1,
      anon_sym_PIPE,
    STATE(1501), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54034] = 4,
    ACTIONS(2676), 1,
      anon_sym_order,
    ACTIONS(2858), 1,
      anon_sym_RPAREN,
    STATE(1952), 1,
      sym_orderBys,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54048] = 4,
    ACTIONS(183), 1,
      anon_sym_RPAREN,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    STATE(1709), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54062] = 4,
    ACTIONS(529), 1,
      anon_sym_RBRACK,
    ACTIONS(2860), 1,
      anon_sym_COMMA,
    STATE(1689), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54076] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2862), 1,
      anon_sym_RPAREN,
    STATE(1709), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54090] = 4,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2864), 1,
      anon_sym_RPAREN,
    STATE(1501), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54104] = 4,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2866), 1,
      anon_sym_PIPE,
    STATE(1720), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54118] = 4,
    ACTIONS(175), 1,
      anon_sym_RPAREN,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    STATE(1728), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54132] = 4,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2868), 1,
      anon_sym_PIPE,
    STATE(1501), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54146] = 4,
    ACTIONS(2670), 1,
      anon_sym_or,
    ACTIONS(2870), 1,
      anon_sym_SEMI,
    STATE(1651), 1,
      aux_sym_typeUnionBody_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54160] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2872), 1,
      anon_sym_RPAREN,
    STATE(1709), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54174] = 4,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2874), 1,
      anon_sym_RPAREN,
    STATE(1637), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54188] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2876), 1,
      anon_sym_RPAREN,
    STATE(1744), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54202] = 4,
    ACTIONS(183), 1,
      anon_sym_RPAREN,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    STATE(1755), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54216] = 4,
    ACTIONS(219), 1,
      anon_sym_RPAREN,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    STATE(1751), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54230] = 4,
    ACTIONS(2742), 1,
      anon_sym_COMMA,
    ACTIONS(2878), 1,
      anon_sym_RPAREN,
    STATE(1664), 1,
      aux_sym_higherOrderTerm_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54244] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2880), 1,
      anon_sym_RPAREN,
    STATE(1709), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54258] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2880), 1,
      anon_sym_RPAREN,
    STATE(1733), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54272] = 4,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2882), 1,
      anon_sym_PIPE,
    STATE(1731), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54286] = 4,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2884), 1,
      anon_sym_PIPE,
    STATE(1501), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54300] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2886), 1,
      anon_sym_RPAREN,
    STATE(1625), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54314] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2888), 1,
      anon_sym_RPAREN,
    STATE(1709), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54328] = 4,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2890), 1,
      anon_sym_RPAREN,
    STATE(1638), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54342] = 4,
    ACTIONS(279), 1,
      anon_sym_RPAREN,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    STATE(1642), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54356] = 4,
    ACTIONS(1313), 1,
      anon_sym_COMMA,
    ACTIONS(2892), 1,
      anon_sym_RBRACK,
    STATE(1689), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54370] = 4,
    ACTIONS(2742), 1,
      anon_sym_COMMA,
    ACTIONS(2894), 1,
      anon_sym_RPAREN,
    STATE(1738), 1,
      aux_sym_higherOrderTerm_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54384] = 4,
    ACTIONS(2742), 1,
      anon_sym_COMMA,
    ACTIONS(2896), 1,
      anon_sym_RPAREN,
    STATE(1664), 1,
      aux_sym_higherOrderTerm_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54398] = 4,
    ACTIONS(1313), 1,
      anon_sym_COMMA,
    ACTIONS(2898), 1,
      anon_sym_RBRACK,
    STATE(1689), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54412] = 4,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2900), 1,
      anon_sym_RPAREN,
    STATE(1668), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54426] = 4,
    ACTIONS(1313), 1,
      anon_sym_COMMA,
    ACTIONS(2902), 1,
      anon_sym_RBRACK,
    STATE(1689), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54440] = 4,
    ACTIONS(2753), 1,
      anon_sym_COMMA,
    ACTIONS(2904), 1,
      anon_sym_GT,
    STATE(1683), 1,
      aux_sym_moduleInstantiation_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54454] = 4,
    ACTIONS(1313), 1,
      anon_sym_COMMA,
    ACTIONS(2906), 1,
      anon_sym_RBRACK,
    STATE(1689), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54468] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2908), 1,
      anon_sym_RPAREN,
    STATE(1709), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54482] = 4,
    ACTIONS(1313), 1,
      anon_sym_COMMA,
    ACTIONS(2910), 1,
      anon_sym_RBRACK,
    STATE(1689), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54496] = 4,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2912), 1,
      anon_sym_PIPE,
    STATE(1617), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54510] = 4,
    ACTIONS(559), 1,
      anon_sym_RBRACK,
    ACTIONS(2914), 1,
      anon_sym_COMMA,
    STATE(1689), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54524] = 4,
    ACTIONS(1313), 1,
      anon_sym_COMMA,
    ACTIONS(2916), 1,
      anon_sym_RBRACK,
    STATE(1689), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54538] = 4,
    ACTIONS(2676), 1,
      anon_sym_order,
    ACTIONS(2918), 1,
      anon_sym_RPAREN,
    STATE(1992), 1,
      sym_orderBys,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54552] = 4,
    ACTIONS(1406), 1,
      anon_sym_RPAREN,
    ACTIONS(2765), 1,
      anon_sym_COMMA,
    STATE(1614), 1,
      aux_sym_asExprs_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54566] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2920), 1,
      anon_sym_RPAREN,
    STATE(1709), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54580] = 4,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2922), 1,
      anon_sym_RPAREN,
    STATE(1717), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54594] = 4,
    ACTIONS(2793), 1,
      anon_sym_COMMA,
    ACTIONS(2924), 1,
      anon_sym_RBRACK,
    STATE(1685), 1,
      aux_sym_annotation_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54608] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2926), 1,
      anon_sym_RPAREN,
    STATE(1707), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54622] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2678), 1,
      anon_sym_RPAREN,
    STATE(1709), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54636] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2928), 1,
      anon_sym_RPAREN,
    STATE(1709), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54650] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2928), 1,
      anon_sym_RPAREN,
    STATE(1619), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54664] = 4,
    ACTIONS(2930), 1,
      anon_sym_EQ,
    ACTIONS(2932), 1,
      anon_sym_LPAREN,
    STATE(1387), 1,
      sym_predicateAliasBody,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54678] = 3,
    STATE(1988), 1,
      sym_literalId,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2767), 2,
      sym__upper_id,
      sym__lower_id,
  [54690] = 4,
    ACTIONS(2660), 1,
      anon_sym_COMMA,
    ACTIONS(2920), 1,
      anon_sym_RPAREN,
    STATE(1616), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54704] = 3,
    ACTIONS(2934), 1,
      anon_sym_LPAREN,
    ACTIONS(2936), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54715] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2938), 2,
      sym__upper_id,
      sym__lower_id,
  [54724] = 3,
    ACTIONS(2314), 1,
      sym__upper_id,
    STATE(1937), 1,
      sym_className,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54735] = 3,
    ACTIONS(2310), 1,
      sym__lower_id,
    STATE(1900), 1,
      sym_annotName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54746] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2784), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [54755] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2789), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [54764] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2940), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [54773] = 3,
    ACTIONS(605), 1,
      anon_sym_SEMI,
    ACTIONS(2476), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54784] = 3,
    ACTIONS(2942), 1,
      anon_sym_LPAREN,
    ACTIONS(2944), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54795] = 3,
    ACTIONS(2412), 1,
      anon_sym_DOT,
    ACTIONS(2946), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54806] = 3,
    ACTIONS(2412), 1,
      anon_sym_DOT,
    ACTIONS(2948), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54817] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1872), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [54826] = 3,
    ACTIONS(2950), 1,
      anon_sym_LPAREN,
    ACTIONS(2952), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54837] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2751), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [54846] = 3,
    ACTIONS(2954), 1,
      anon_sym_SEMI,
    ACTIONS(2956), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54857] = 3,
    ACTIONS(2314), 1,
      sym__upper_id,
    STATE(1845), 1,
      sym_className,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54868] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2958), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
  [54877] = 3,
    ACTIONS(2960), 1,
      anon_sym_LPAREN,
    ACTIONS(2962), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54888] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2850), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [54897] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2964), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [54906] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1670), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [54915] = 3,
    ACTIONS(2956), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2966), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54926] = 3,
    ACTIONS(2968), 1,
      anon_sym_LPAREN,
    ACTIONS(2970), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54937] = 3,
    ACTIONS(2310), 1,
      sym__lower_id,
    STATE(2003), 1,
      sym_annotName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54948] = 3,
    ACTIONS(2412), 1,
      anon_sym_DOT,
    ACTIONS(2972), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54959] = 3,
    ACTIONS(2412), 1,
      anon_sym_DOT,
    ACTIONS(2974), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54970] = 3,
    ACTIONS(2412), 1,
      anon_sym_DOT,
    ACTIONS(2976), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54981] = 3,
    ACTIONS(2314), 1,
      sym__upper_id,
    STATE(1827), 1,
      sym_className,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [54992] = 3,
    ACTIONS(2978), 1,
      anon_sym_LPAREN,
    ACTIONS(2980), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55003] = 3,
    ACTIONS(2484), 1,
      sym__lower_id,
    STATE(1998), 1,
      sym_predicateName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55014] = 3,
    ACTIONS(2314), 1,
      sym__upper_id,
    STATE(1985), 1,
      sym_className,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55025] = 3,
    ACTIONS(2484), 1,
      sym__lower_id,
    STATE(1758), 1,
      sym_predicateName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55036] = 3,
    ACTIONS(2982), 1,
      anon_sym_SEMI,
    ACTIONS(2984), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55047] = 3,
    ACTIONS(2314), 1,
      sym__upper_id,
    STATE(1868), 1,
      sym_className,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55058] = 3,
    ACTIONS(2412), 1,
      anon_sym_DOT,
    ACTIONS(2986), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55069] = 3,
    ACTIONS(2314), 1,
      sym__upper_id,
    STATE(1921), 1,
      sym_className,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55080] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1843), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [55089] = 3,
    ACTIONS(2412), 1,
      anon_sym_DOT,
    ACTIONS(2988), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55100] = 3,
    ACTIONS(2990), 1,
      anon_sym_SEMI,
    ACTIONS(2992), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55111] = 3,
    ACTIONS(2412), 1,
      anon_sym_DOT,
    ACTIONS(2994), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55122] = 3,
    ACTIONS(2314), 1,
      sym__upper_id,
    STATE(1480), 1,
      sym_className,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55133] = 3,
    ACTIONS(2484), 1,
      sym__lower_id,
    STATE(1650), 1,
      sym_predicateName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55144] = 3,
    ACTIONS(2314), 1,
      sym__upper_id,
    STATE(1470), 1,
      sym_className,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55155] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2996), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [55164] = 3,
    ACTIONS(2998), 1,
      anon_sym_LPAREN,
    ACTIONS(3000), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55175] = 3,
    ACTIONS(2310), 1,
      sym__lower_id,
    STATE(1987), 1,
      sym_annotName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55186] = 3,
    ACTIONS(2310), 1,
      sym__lower_id,
    STATE(1991), 1,
      sym_annotName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55197] = 3,
    ACTIONS(2310), 1,
      sym__lower_id,
    STATE(1994), 1,
      sym_annotName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55208] = 3,
    ACTIONS(2310), 1,
      sym__lower_id,
    STATE(1997), 1,
      sym_annotName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55219] = 3,
    ACTIONS(2310), 1,
      sym__lower_id,
    STATE(2000), 1,
      sym_annotName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55230] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2825), 2,
      anon_sym_SEMI,
      anon_sym_or,
  [55239] = 2,
    ACTIONS(3002), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55247] = 2,
    ACTIONS(3004), 1,
      anon_sym_by,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55255] = 2,
    ACTIONS(3006), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55263] = 2,
    ACTIONS(3008), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55271] = 2,
    ACTIONS(3010), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55279] = 2,
    ACTIONS(1277), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55287] = 2,
    ACTIONS(3012), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55295] = 2,
    ACTIONS(3014), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55303] = 2,
    ACTIONS(1303), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55311] = 2,
    ACTIONS(3016), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55319] = 2,
    ACTIONS(3018), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55327] = 2,
    ACTIONS(85), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55335] = 2,
    ACTIONS(3020), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55343] = 2,
    ACTIONS(3022), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55351] = 2,
    ACTIONS(3024), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55359] = 2,
    ACTIONS(3026), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55367] = 2,
    ACTIONS(3028), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55375] = 2,
    ACTIONS(3030), 1,
      sym_super,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55383] = 2,
    ACTIONS(3032), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55391] = 2,
    ACTIONS(75), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55399] = 2,
    ACTIONS(3034), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55407] = 2,
    ACTIONS(95), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55415] = 2,
    ACTIONS(3036), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55423] = 2,
    ACTIONS(3038), 1,
      sym_integer,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55431] = 2,
    ACTIONS(3040), 1,
      sym_super,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55439] = 2,
    ACTIONS(3042), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55447] = 2,
    ACTIONS(3044), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55455] = 2,
    ACTIONS(2393), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55463] = 2,
    ACTIONS(3046), 1,
      anon_sym_by,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55471] = 2,
    ACTIONS(3048), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55479] = 2,
    ACTIONS(3050), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55487] = 2,
    ACTIONS(3052), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55495] = 2,
    ACTIONS(3054), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55503] = 2,
    ACTIONS(3056), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55511] = 2,
    ACTIONS(3058), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55519] = 2,
    ACTIONS(3060), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55527] = 2,
    ACTIONS(3062), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55535] = 2,
    ACTIONS(3064), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55543] = 2,
    ACTIONS(3066), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55551] = 2,
    ACTIONS(3068), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55559] = 2,
    ACTIONS(3070), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55567] = 2,
    ACTIONS(3072), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55575] = 2,
    ACTIONS(3074), 1,
      anon_sym_by,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55583] = 2,
    ACTIONS(3076), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55591] = 2,
    ACTIONS(3078), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55599] = 2,
    ACTIONS(3080), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55607] = 2,
    ACTIONS(3082), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55615] = 2,
    ACTIONS(3084), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55623] = 2,
    ACTIONS(3086), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55631] = 2,
    ACTIONS(3088), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55639] = 2,
    ACTIONS(3090), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55647] = 2,
    ACTIONS(3092), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55655] = 2,
    ACTIONS(3094), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55663] = 2,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55671] = 2,
    ACTIONS(3098), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55679] = 2,
    ACTIONS(89), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55687] = 2,
    ACTIONS(3100), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55695] = 2,
    ACTIONS(3102), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55703] = 2,
    ACTIONS(1321), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55711] = 2,
    ACTIONS(3104), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55719] = 2,
    ACTIONS(3106), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55727] = 2,
    ACTIONS(3108), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55735] = 2,
    ACTIONS(1261), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55743] = 2,
    ACTIONS(3110), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55751] = 2,
    ACTIONS(3112), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55759] = 2,
    ACTIONS(3114), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55767] = 2,
    ACTIONS(3116), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55775] = 2,
    ACTIONS(3118), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55783] = 2,
    ACTIONS(2324), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55791] = 2,
    ACTIONS(3120), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55799] = 2,
    ACTIONS(3122), 1,
      anon_sym_SLASH,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55807] = 2,
    ACTIONS(2412), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55815] = 2,
    ACTIONS(3124), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55823] = 2,
    ACTIONS(3126), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55831] = 2,
    ACTIONS(3128), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55839] = 2,
    ACTIONS(3130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55847] = 2,
    ACTIONS(3132), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55855] = 2,
    ACTIONS(3134), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55863] = 2,
    ACTIONS(3136), 1,
      sym_super,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55871] = 2,
    ACTIONS(3138), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55879] = 2,
    ACTIONS(3140), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55887] = 2,
    ACTIONS(3142), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55895] = 2,
    ACTIONS(103), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55903] = 2,
    ACTIONS(3144), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55911] = 2,
    ACTIONS(3146), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55919] = 2,
    ACTIONS(3148), 1,
      anon_sym_LT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55927] = 2,
    ACTIONS(3150), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55935] = 2,
    ACTIONS(3152), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55943] = 2,
    ACTIONS(3154), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55951] = 2,
    ACTIONS(3156), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55959] = 2,
    ACTIONS(3158), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55967] = 2,
    ACTIONS(3160), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55975] = 2,
    ACTIONS(3162), 1,
      sym_super,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55983] = 2,
    ACTIONS(3164), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55991] = 2,
    ACTIONS(3166), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [55999] = 2,
    ACTIONS(3168), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56007] = 2,
    ACTIONS(3170), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56015] = 2,
    ACTIONS(3172), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56023] = 2,
    ACTIONS(3174), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56031] = 2,
    ACTIONS(3176), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56039] = 2,
    ACTIONS(3178), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56047] = 2,
    ACTIONS(3180), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56055] = 2,
    ACTIONS(3182), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56063] = 2,
    ACTIONS(3184), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56071] = 2,
    ACTIONS(3186), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56079] = 2,
    ACTIONS(1297), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56087] = 2,
    ACTIONS(3188), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56095] = 2,
    ACTIONS(3190), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56103] = 2,
    ACTIONS(3192), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56111] = 2,
    ACTIONS(3194), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56119] = 2,
    ACTIONS(3196), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56127] = 2,
    ACTIONS(3198), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56135] = 2,
    ACTIONS(3200), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56143] = 2,
    ACTIONS(3202), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56151] = 2,
    ACTIONS(3204), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56159] = 2,
    ACTIONS(3206), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56167] = 2,
    ACTIONS(609), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56175] = 2,
    ACTIONS(3208), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56183] = 2,
    ACTIONS(3210), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56191] = 2,
    ACTIONS(3212), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56199] = 2,
    ACTIONS(3214), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56207] = 2,
    ACTIONS(3216), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56215] = 2,
    ACTIONS(3218), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56223] = 2,
    ACTIONS(3220), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56231] = 2,
    ACTIONS(87), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56239] = 2,
    ACTIONS(3222), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56247] = 2,
    ACTIONS(3224), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56255] = 2,
    ACTIONS(3226), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56263] = 2,
    ACTIONS(79), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56271] = 2,
    ACTIONS(3228), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56279] = 2,
    ACTIONS(3230), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56287] = 2,
    ACTIONS(3232), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56295] = 2,
    ACTIONS(3234), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56303] = 2,
    ACTIONS(3236), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56311] = 2,
    ACTIONS(3238), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56319] = 2,
    ACTIONS(3240), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56327] = 2,
    ACTIONS(3242), 1,
      anon_sym_LT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56335] = 2,
    ACTIONS(3244), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56343] = 2,
    ACTIONS(3246), 1,
      sym_super,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56351] = 2,
    ACTIONS(3248), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56359] = 2,
    ACTIONS(3250), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56367] = 2,
    ACTIONS(3252), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56375] = 2,
    ACTIONS(3254), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56383] = 2,
    ACTIONS(3256), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56391] = 2,
    ACTIONS(3258), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56399] = 2,
    ACTIONS(3260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56407] = 2,
    ACTIONS(3262), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56415] = 2,
    ACTIONS(3264), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56423] = 2,
    ACTIONS(1283), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56431] = 2,
    ACTIONS(3266), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56439] = 2,
    ACTIONS(3268), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56447] = 2,
    ACTIONS(3270), 1,
      anon_sym_LT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56455] = 2,
    ACTIONS(3272), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56463] = 2,
    ACTIONS(3274), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56471] = 2,
    ACTIONS(3276), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56479] = 2,
    ACTIONS(3278), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56487] = 2,
    ACTIONS(3280), 1,
      sym_super,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56495] = 2,
    ACTIONS(3282), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56503] = 2,
    ACTIONS(3284), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56511] = 2,
    ACTIONS(3286), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56519] = 2,
    ACTIONS(3288), 1,
      sym_super,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56527] = 2,
    ACTIONS(3290), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56535] = 2,
    ACTIONS(3292), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56543] = 2,
    ACTIONS(1291), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56551] = 2,
    ACTIONS(3294), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56559] = 2,
    ACTIONS(3296), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56567] = 2,
    ACTIONS(3298), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56575] = 2,
    ACTIONS(3300), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56583] = 2,
    ACTIONS(3302), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56591] = 2,
    ACTIONS(3304), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56599] = 2,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56607] = 2,
    ACTIONS(3308), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56615] = 2,
    ACTIONS(3310), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56623] = 2,
    ACTIONS(3312), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56631] = 2,
    ACTIONS(3314), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56639] = 2,
    ACTIONS(3316), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56647] = 2,
    ACTIONS(3318), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56655] = 2,
    ACTIONS(1255), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56663] = 2,
    ACTIONS(3320), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56671] = 2,
    ACTIONS(3322), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56679] = 2,
    ACTIONS(3324), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56687] = 2,
    ACTIONS(3326), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56695] = 2,
    ACTIONS(3328), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56703] = 2,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56711] = 2,
    ACTIONS(3332), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56719] = 2,
    ACTIONS(3334), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56727] = 2,
    ACTIONS(3336), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56735] = 2,
    ACTIONS(3338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56743] = 2,
    ACTIONS(3340), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56751] = 2,
    ACTIONS(3342), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56759] = 2,
    ACTIONS(3344), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56767] = 2,
    ACTIONS(3346), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56775] = 2,
    ACTIONS(3348), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56783] = 2,
    ACTIONS(3350), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56791] = 2,
    ACTIONS(3352), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56799] = 2,
    ACTIONS(3354), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56807] = 2,
    ACTIONS(3356), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56815] = 2,
    ACTIONS(3358), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56823] = 2,
    ACTIONS(3360), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56831] = 2,
    ACTIONS(3362), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56839] = 2,
    ACTIONS(3364), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56847] = 2,
    ACTIONS(3366), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56855] = 2,
    ACTIONS(3368), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56863] = 2,
    ACTIONS(3370), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56871] = 2,
    ACTIONS(3372), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56879] = 2,
    ACTIONS(3374), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [56887] = 2,
    ACTIONS(3376), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(359)] = 0,
  [SMALL_STATE(360)] = 111,
  [SMALL_STATE(361)] = 222,
  [SMALL_STATE(362)] = 333,
  [SMALL_STATE(363)] = 444,
  [SMALL_STATE(364)] = 555,
  [SMALL_STATE(365)] = 666,
  [SMALL_STATE(366)] = 777,
  [SMALL_STATE(367)] = 888,
  [SMALL_STATE(368)] = 970,
  [SMALL_STATE(369)] = 1028,
  [SMALL_STATE(370)] = 1086,
  [SMALL_STATE(371)] = 1144,
  [SMALL_STATE(372)] = 1226,
  [SMALL_STATE(373)] = 1284,
  [SMALL_STATE(374)] = 1345,
  [SMALL_STATE(375)] = 1418,
  [SMALL_STATE(376)] = 1489,
  [SMALL_STATE(377)] = 1546,
  [SMALL_STATE(378)] = 1623,
  [SMALL_STATE(379)] = 1698,
  [SMALL_STATE(380)] = 1769,
  [SMALL_STATE(381)] = 1826,
  [SMALL_STATE(382)] = 1899,
  [SMALL_STATE(383)] = 1956,
  [SMALL_STATE(384)] = 2027,
  [SMALL_STATE(385)] = 2102,
  [SMALL_STATE(386)] = 2181,
  [SMALL_STATE(387)] = 2246,
  [SMALL_STATE(388)] = 2303,
  [SMALL_STATE(389)] = 2368,
  [SMALL_STATE(390)] = 2429,
  [SMALL_STATE(391)] = 2486,
  [SMALL_STATE(392)] = 2547,
  [SMALL_STATE(393)] = 2604,
  [SMALL_STATE(394)] = 2661,
  [SMALL_STATE(395)] = 2734,
  [SMALL_STATE(396)] = 2805,
  [SMALL_STATE(397)] = 2866,
  [SMALL_STATE(398)] = 2943,
  [SMALL_STATE(399)] = 3014,
  [SMALL_STATE(400)] = 3091,
  [SMALL_STATE(401)] = 3162,
  [SMALL_STATE(402)] = 3233,
  [SMALL_STATE(403)] = 3290,
  [SMALL_STATE(404)] = 3361,
  [SMALL_STATE(405)] = 3418,
  [SMALL_STATE(406)] = 3495,
  [SMALL_STATE(407)] = 3570,
  [SMALL_STATE(408)] = 3627,
  [SMALL_STATE(409)] = 3698,
  [SMALL_STATE(410)] = 3771,
  [SMALL_STATE(411)] = 3828,
  [SMALL_STATE(412)] = 3893,
  [SMALL_STATE(413)] = 3964,
  [SMALL_STATE(414)] = 4035,
  [SMALL_STATE(415)] = 4106,
  [SMALL_STATE(416)] = 4185,
  [SMALL_STATE(417)] = 4260,
  [SMALL_STATE(418)] = 4325,
  [SMALL_STATE(419)] = 4382,
  [SMALL_STATE(420)] = 4436,
  [SMALL_STATE(421)] = 4490,
  [SMALL_STATE(422)] = 4544,
  [SMALL_STATE(423)] = 4598,
  [SMALL_STATE(424)] = 4647,
  [SMALL_STATE(425)] = 4696,
  [SMALL_STATE(426)] = 4745,
  [SMALL_STATE(427)] = 4794,
  [SMALL_STATE(428)] = 4843,
  [SMALL_STATE(429)] = 4894,
  [SMALL_STATE(430)] = 4943,
  [SMALL_STATE(431)] = 4992,
  [SMALL_STATE(432)] = 5041,
  [SMALL_STATE(433)] = 5090,
  [SMALL_STATE(434)] = 5141,
  [SMALL_STATE(435)] = 5190,
  [SMALL_STATE(436)] = 5239,
  [SMALL_STATE(437)] = 5288,
  [SMALL_STATE(438)] = 5337,
  [SMALL_STATE(439)] = 5386,
  [SMALL_STATE(440)] = 5435,
  [SMALL_STATE(441)] = 5484,
  [SMALL_STATE(442)] = 5533,
  [SMALL_STATE(443)] = 5582,
  [SMALL_STATE(444)] = 5631,
  [SMALL_STATE(445)] = 5680,
  [SMALL_STATE(446)] = 5729,
  [SMALL_STATE(447)] = 5778,
  [SMALL_STATE(448)] = 5827,
  [SMALL_STATE(449)] = 5876,
  [SMALL_STATE(450)] = 5925,
  [SMALL_STATE(451)] = 5974,
  [SMALL_STATE(452)] = 6023,
  [SMALL_STATE(453)] = 6072,
  [SMALL_STATE(454)] = 6121,
  [SMALL_STATE(455)] = 6170,
  [SMALL_STATE(456)] = 6219,
  [SMALL_STATE(457)] = 6268,
  [SMALL_STATE(458)] = 6317,
  [SMALL_STATE(459)] = 6366,
  [SMALL_STATE(460)] = 6415,
  [SMALL_STATE(461)] = 6464,
  [SMALL_STATE(462)] = 6513,
  [SMALL_STATE(463)] = 6562,
  [SMALL_STATE(464)] = 6611,
  [SMALL_STATE(465)] = 6660,
  [SMALL_STATE(466)] = 6709,
  [SMALL_STATE(467)] = 6762,
  [SMALL_STATE(468)] = 6809,
  [SMALL_STATE(469)] = 6856,
  [SMALL_STATE(470)] = 6903,
  [SMALL_STATE(471)] = 6952,
  [SMALL_STATE(472)] = 7001,
  [SMALL_STATE(473)] = 7050,
  [SMALL_STATE(474)] = 7099,
  [SMALL_STATE(475)] = 7150,
  [SMALL_STATE(476)] = 7199,
  [SMALL_STATE(477)] = 7248,
  [SMALL_STATE(478)] = 7297,
  [SMALL_STATE(479)] = 7346,
  [SMALL_STATE(480)] = 7397,
  [SMALL_STATE(481)] = 7446,
  [SMALL_STATE(482)] = 7495,
  [SMALL_STATE(483)] = 7544,
  [SMALL_STATE(484)] = 7593,
  [SMALL_STATE(485)] = 7642,
  [SMALL_STATE(486)] = 7691,
  [SMALL_STATE(487)] = 7740,
  [SMALL_STATE(488)] = 7789,
  [SMALL_STATE(489)] = 7838,
  [SMALL_STATE(490)] = 7887,
  [SMALL_STATE(491)] = 7936,
  [SMALL_STATE(492)] = 7985,
  [SMALL_STATE(493)] = 8034,
  [SMALL_STATE(494)] = 8083,
  [SMALL_STATE(495)] = 8132,
  [SMALL_STATE(496)] = 8181,
  [SMALL_STATE(497)] = 8230,
  [SMALL_STATE(498)] = 8279,
  [SMALL_STATE(499)] = 8328,
  [SMALL_STATE(500)] = 8377,
  [SMALL_STATE(501)] = 8426,
  [SMALL_STATE(502)] = 8475,
  [SMALL_STATE(503)] = 8524,
  [SMALL_STATE(504)] = 8573,
  [SMALL_STATE(505)] = 8622,
  [SMALL_STATE(506)] = 8671,
  [SMALL_STATE(507)] = 8720,
  [SMALL_STATE(508)] = 8769,
  [SMALL_STATE(509)] = 8818,
  [SMALL_STATE(510)] = 8867,
  [SMALL_STATE(511)] = 8916,
  [SMALL_STATE(512)] = 8965,
  [SMALL_STATE(513)] = 9018,
  [SMALL_STATE(514)] = 9067,
  [SMALL_STATE(515)] = 9116,
  [SMALL_STATE(516)] = 9163,
  [SMALL_STATE(517)] = 9212,
  [SMALL_STATE(518)] = 9263,
  [SMALL_STATE(519)] = 9312,
  [SMALL_STATE(520)] = 9361,
  [SMALL_STATE(521)] = 9410,
  [SMALL_STATE(522)] = 9459,
  [SMALL_STATE(523)] = 9510,
  [SMALL_STATE(524)] = 9559,
  [SMALL_STATE(525)] = 9608,
  [SMALL_STATE(526)] = 9657,
  [SMALL_STATE(527)] = 9706,
  [SMALL_STATE(528)] = 9755,
  [SMALL_STATE(529)] = 9804,
  [SMALL_STATE(530)] = 9853,
  [SMALL_STATE(531)] = 9902,
  [SMALL_STATE(532)] = 9951,
  [SMALL_STATE(533)] = 10000,
  [SMALL_STATE(534)] = 10049,
  [SMALL_STATE(535)] = 10098,
  [SMALL_STATE(536)] = 10147,
  [SMALL_STATE(537)] = 10196,
  [SMALL_STATE(538)] = 10245,
  [SMALL_STATE(539)] = 10294,
  [SMALL_STATE(540)] = 10343,
  [SMALL_STATE(541)] = 10392,
  [SMALL_STATE(542)] = 10441,
  [SMALL_STATE(543)] = 10490,
  [SMALL_STATE(544)] = 10539,
  [SMALL_STATE(545)] = 10588,
  [SMALL_STATE(546)] = 10637,
  [SMALL_STATE(547)] = 10686,
  [SMALL_STATE(548)] = 10735,
  [SMALL_STATE(549)] = 10784,
  [SMALL_STATE(550)] = 10833,
  [SMALL_STATE(551)] = 10882,
  [SMALL_STATE(552)] = 10931,
  [SMALL_STATE(553)] = 10980,
  [SMALL_STATE(554)] = 11029,
  [SMALL_STATE(555)] = 11078,
  [SMALL_STATE(556)] = 11131,
  [SMALL_STATE(557)] = 11180,
  [SMALL_STATE(558)] = 11229,
  [SMALL_STATE(559)] = 11278,
  [SMALL_STATE(560)] = 11327,
  [SMALL_STATE(561)] = 11378,
  [SMALL_STATE(562)] = 11427,
  [SMALL_STATE(563)] = 11476,
  [SMALL_STATE(564)] = 11525,
  [SMALL_STATE(565)] = 11574,
  [SMALL_STATE(566)] = 11625,
  [SMALL_STATE(567)] = 11674,
  [SMALL_STATE(568)] = 11723,
  [SMALL_STATE(569)] = 11772,
  [SMALL_STATE(570)] = 11821,
  [SMALL_STATE(571)] = 11870,
  [SMALL_STATE(572)] = 11919,
  [SMALL_STATE(573)] = 11968,
  [SMALL_STATE(574)] = 12017,
  [SMALL_STATE(575)] = 12066,
  [SMALL_STATE(576)] = 12115,
  [SMALL_STATE(577)] = 12164,
  [SMALL_STATE(578)] = 12213,
  [SMALL_STATE(579)] = 12262,
  [SMALL_STATE(580)] = 12311,
  [SMALL_STATE(581)] = 12360,
  [SMALL_STATE(582)] = 12409,
  [SMALL_STATE(583)] = 12458,
  [SMALL_STATE(584)] = 12507,
  [SMALL_STATE(585)] = 12556,
  [SMALL_STATE(586)] = 12605,
  [SMALL_STATE(587)] = 12654,
  [SMALL_STATE(588)] = 12703,
  [SMALL_STATE(589)] = 12752,
  [SMALL_STATE(590)] = 12801,
  [SMALL_STATE(591)] = 12850,
  [SMALL_STATE(592)] = 12899,
  [SMALL_STATE(593)] = 12948,
  [SMALL_STATE(594)] = 12997,
  [SMALL_STATE(595)] = 13046,
  [SMALL_STATE(596)] = 13095,
  [SMALL_STATE(597)] = 13144,
  [SMALL_STATE(598)] = 13197,
  [SMALL_STATE(599)] = 13246,
  [SMALL_STATE(600)] = 13294,
  [SMALL_STATE(601)] = 13342,
  [SMALL_STATE(602)] = 13390,
  [SMALL_STATE(603)] = 13438,
  [SMALL_STATE(604)] = 13486,
  [SMALL_STATE(605)] = 13534,
  [SMALL_STATE(606)] = 13582,
  [SMALL_STATE(607)] = 13630,
  [SMALL_STATE(608)] = 13678,
  [SMALL_STATE(609)] = 13726,
  [SMALL_STATE(610)] = 13774,
  [SMALL_STATE(611)] = 13822,
  [SMALL_STATE(612)] = 13870,
  [SMALL_STATE(613)] = 13918,
  [SMALL_STATE(614)] = 13966,
  [SMALL_STATE(615)] = 14014,
  [SMALL_STATE(616)] = 14062,
  [SMALL_STATE(617)] = 14110,
  [SMALL_STATE(618)] = 14158,
  [SMALL_STATE(619)] = 14206,
  [SMALL_STATE(620)] = 14254,
  [SMALL_STATE(621)] = 14302,
  [SMALL_STATE(622)] = 14350,
  [SMALL_STATE(623)] = 14398,
  [SMALL_STATE(624)] = 14446,
  [SMALL_STATE(625)] = 14494,
  [SMALL_STATE(626)] = 14542,
  [SMALL_STATE(627)] = 14590,
  [SMALL_STATE(628)] = 14638,
  [SMALL_STATE(629)] = 14686,
  [SMALL_STATE(630)] = 14734,
  [SMALL_STATE(631)] = 14782,
  [SMALL_STATE(632)] = 14830,
  [SMALL_STATE(633)] = 14878,
  [SMALL_STATE(634)] = 14926,
  [SMALL_STATE(635)] = 14974,
  [SMALL_STATE(636)] = 15022,
  [SMALL_STATE(637)] = 15070,
  [SMALL_STATE(638)] = 15118,
  [SMALL_STATE(639)] = 15166,
  [SMALL_STATE(640)] = 15214,
  [SMALL_STATE(641)] = 15262,
  [SMALL_STATE(642)] = 15310,
  [SMALL_STATE(643)] = 15358,
  [SMALL_STATE(644)] = 15406,
  [SMALL_STATE(645)] = 15454,
  [SMALL_STATE(646)] = 15502,
  [SMALL_STATE(647)] = 15550,
  [SMALL_STATE(648)] = 15598,
  [SMALL_STATE(649)] = 15646,
  [SMALL_STATE(650)] = 15694,
  [SMALL_STATE(651)] = 15742,
  [SMALL_STATE(652)] = 15790,
  [SMALL_STATE(653)] = 15838,
  [SMALL_STATE(654)] = 15886,
  [SMALL_STATE(655)] = 15934,
  [SMALL_STATE(656)] = 15982,
  [SMALL_STATE(657)] = 16030,
  [SMALL_STATE(658)] = 16078,
  [SMALL_STATE(659)] = 16126,
  [SMALL_STATE(660)] = 16174,
  [SMALL_STATE(661)] = 16222,
  [SMALL_STATE(662)] = 16270,
  [SMALL_STATE(663)] = 16318,
  [SMALL_STATE(664)] = 16411,
  [SMALL_STATE(665)] = 16504,
  [SMALL_STATE(666)] = 16597,
  [SMALL_STATE(667)] = 16690,
  [SMALL_STATE(668)] = 16783,
  [SMALL_STATE(669)] = 16876,
  [SMALL_STATE(670)] = 16969,
  [SMALL_STATE(671)] = 17062,
  [SMALL_STATE(672)] = 17155,
  [SMALL_STATE(673)] = 17248,
  [SMALL_STATE(674)] = 17341,
  [SMALL_STATE(675)] = 17434,
  [SMALL_STATE(676)] = 17527,
  [SMALL_STATE(677)] = 17620,
  [SMALL_STATE(678)] = 17713,
  [SMALL_STATE(679)] = 17806,
  [SMALL_STATE(680)] = 17899,
  [SMALL_STATE(681)] = 17992,
  [SMALL_STATE(682)] = 18085,
  [SMALL_STATE(683)] = 18178,
  [SMALL_STATE(684)] = 18271,
  [SMALL_STATE(685)] = 18364,
  [SMALL_STATE(686)] = 18457,
  [SMALL_STATE(687)] = 18550,
  [SMALL_STATE(688)] = 18643,
  [SMALL_STATE(689)] = 18736,
  [SMALL_STATE(690)] = 18829,
  [SMALL_STATE(691)] = 18922,
  [SMALL_STATE(692)] = 19015,
  [SMALL_STATE(693)] = 19108,
  [SMALL_STATE(694)] = 19201,
  [SMALL_STATE(695)] = 19294,
  [SMALL_STATE(696)] = 19387,
  [SMALL_STATE(697)] = 19480,
  [SMALL_STATE(698)] = 19573,
  [SMALL_STATE(699)] = 19666,
  [SMALL_STATE(700)] = 19759,
  [SMALL_STATE(701)] = 19852,
  [SMALL_STATE(702)] = 19945,
  [SMALL_STATE(703)] = 20026,
  [SMALL_STATE(704)] = 20107,
  [SMALL_STATE(705)] = 20152,
  [SMALL_STATE(706)] = 20193,
  [SMALL_STATE(707)] = 20229,
  [SMALL_STATE(708)] = 20301,
  [SMALL_STATE(709)] = 20373,
  [SMALL_STATE(710)] = 20445,
  [SMALL_STATE(711)] = 20517,
  [SMALL_STATE(712)] = 20553,
  [SMALL_STATE(713)] = 20589,
  [SMALL_STATE(714)] = 20661,
  [SMALL_STATE(715)] = 20697,
  [SMALL_STATE(716)] = 20737,
  [SMALL_STATE(717)] = 20773,
  [SMALL_STATE(718)] = 20809,
  [SMALL_STATE(719)] = 20845,
  [SMALL_STATE(720)] = 20881,
  [SMALL_STATE(721)] = 20917,
  [SMALL_STATE(722)] = 20953,
  [SMALL_STATE(723)] = 20989,
  [SMALL_STATE(724)] = 21025,
  [SMALL_STATE(725)] = 21061,
  [SMALL_STATE(726)] = 21133,
  [SMALL_STATE(727)] = 21205,
  [SMALL_STATE(728)] = 21277,
  [SMALL_STATE(729)] = 21313,
  [SMALL_STATE(730)] = 21385,
  [SMALL_STATE(731)] = 21421,
  [SMALL_STATE(732)] = 21459,
  [SMALL_STATE(733)] = 21495,
  [SMALL_STATE(734)] = 21531,
  [SMALL_STATE(735)] = 21567,
  [SMALL_STATE(736)] = 21603,
  [SMALL_STATE(737)] = 21639,
  [SMALL_STATE(738)] = 21675,
  [SMALL_STATE(739)] = 21747,
  [SMALL_STATE(740)] = 21819,
  [SMALL_STATE(741)] = 21855,
  [SMALL_STATE(742)] = 21927,
  [SMALL_STATE(743)] = 21999,
  [SMALL_STATE(744)] = 22071,
  [SMALL_STATE(745)] = 22143,
  [SMALL_STATE(746)] = 22215,
  [SMALL_STATE(747)] = 22287,
  [SMALL_STATE(748)] = 22359,
  [SMALL_STATE(749)] = 22431,
  [SMALL_STATE(750)] = 22503,
  [SMALL_STATE(751)] = 22539,
  [SMALL_STATE(752)] = 22575,
  [SMALL_STATE(753)] = 22647,
  [SMALL_STATE(754)] = 22719,
  [SMALL_STATE(755)] = 22791,
  [SMALL_STATE(756)] = 22863,
  [SMALL_STATE(757)] = 22935,
  [SMALL_STATE(758)] = 23007,
  [SMALL_STATE(759)] = 23079,
  [SMALL_STATE(760)] = 23151,
  [SMALL_STATE(761)] = 23187,
  [SMALL_STATE(762)] = 23223,
  [SMALL_STATE(763)] = 23259,
  [SMALL_STATE(764)] = 23295,
  [SMALL_STATE(765)] = 23367,
  [SMALL_STATE(766)] = 23403,
  [SMALL_STATE(767)] = 23447,
  [SMALL_STATE(768)] = 23483,
  [SMALL_STATE(769)] = 23555,
  [SMALL_STATE(770)] = 23627,
  [SMALL_STATE(771)] = 23699,
  [SMALL_STATE(772)] = 23735,
  [SMALL_STATE(773)] = 23771,
  [SMALL_STATE(774)] = 23807,
  [SMALL_STATE(775)] = 23843,
  [SMALL_STATE(776)] = 23879,
  [SMALL_STATE(777)] = 23915,
  [SMALL_STATE(778)] = 23951,
  [SMALL_STATE(779)] = 23989,
  [SMALL_STATE(780)] = 24025,
  [SMALL_STATE(781)] = 24061,
  [SMALL_STATE(782)] = 24097,
  [SMALL_STATE(783)] = 24169,
  [SMALL_STATE(784)] = 24241,
  [SMALL_STATE(785)] = 24313,
  [SMALL_STATE(786)] = 24385,
  [SMALL_STATE(787)] = 24457,
  [SMALL_STATE(788)] = 24516,
  [SMALL_STATE(789)] = 24551,
  [SMALL_STATE(790)] = 24586,
  [SMALL_STATE(791)] = 24621,
  [SMALL_STATE(792)] = 24662,
  [SMALL_STATE(793)] = 24697,
  [SMALL_STATE(794)] = 24732,
  [SMALL_STATE(795)] = 24767,
  [SMALL_STATE(796)] = 24802,
  [SMALL_STATE(797)] = 24855,
  [SMALL_STATE(798)] = 24890,
  [SMALL_STATE(799)] = 24925,
  [SMALL_STATE(800)] = 24980,
  [SMALL_STATE(801)] = 25015,
  [SMALL_STATE(802)] = 25050,
  [SMALL_STATE(803)] = 25085,
  [SMALL_STATE(804)] = 25120,
  [SMALL_STATE(805)] = 25155,
  [SMALL_STATE(806)] = 25208,
  [SMALL_STATE(807)] = 25265,
  [SMALL_STATE(808)] = 25314,
  [SMALL_STATE(809)] = 25355,
  [SMALL_STATE(810)] = 25400,
  [SMALL_STATE(811)] = 25435,
  [SMALL_STATE(812)] = 25488,
  [SMALL_STATE(813)] = 25523,
  [SMALL_STATE(814)] = 25567,
  [SMALL_STATE(815)] = 25611,
  [SMALL_STATE(816)] = 25650,
  [SMALL_STATE(817)] = 25685,
  [SMALL_STATE(818)] = 25720,
  [SMALL_STATE(819)] = 25759,
  [SMALL_STATE(820)] = 25820,
  [SMALL_STATE(821)] = 25870,
  [SMALL_STATE(822)] = 25908,
  [SMALL_STATE(823)] = 25960,
  [SMALL_STATE(824)] = 26010,
  [SMALL_STATE(825)] = 26064,
  [SMALL_STATE(826)] = 26110,
  [SMALL_STATE(827)] = 26148,
  [SMALL_STATE(828)] = 26190,
  [SMALL_STATE(829)] = 26246,
  [SMALL_STATE(830)] = 26296,
  [SMALL_STATE(831)] = 26334,
  [SMALL_STATE(832)] = 26396,
  [SMALL_STATE(833)] = 26434,
  [SMALL_STATE(834)] = 26472,
  [SMALL_STATE(835)] = 26514,
  [SMALL_STATE(836)] = 26574,
  [SMALL_STATE(837)] = 26624,
  [SMALL_STATE(838)] = 26686,
  [SMALL_STATE(839)] = 26740,
  [SMALL_STATE(840)] = 26792,
  [SMALL_STATE(841)] = 26842,
  [SMALL_STATE(842)] = 26896,
  [SMALL_STATE(843)] = 26942,
  [SMALL_STATE(844)] = 26980,
  [SMALL_STATE(845)] = 27036,
  [SMALL_STATE(846)] = 27098,
  [SMALL_STATE(847)] = 27160,
  [SMALL_STATE(848)] = 27218,
  [SMALL_STATE(849)] = 27280,
  [SMALL_STATE(850)] = 27342,
  [SMALL_STATE(851)] = 27404,
  [SMALL_STATE(852)] = 27456,
  [SMALL_STATE(853)] = 27508,
  [SMALL_STATE(854)] = 27558,
  [SMALL_STATE(855)] = 27614,
  [SMALL_STATE(856)] = 27668,
  [SMALL_STATE(857)] = 27714,
  [SMALL_STATE(858)] = 27752,
  [SMALL_STATE(859)] = 27794,
  [SMALL_STATE(860)] = 27846,
  [SMALL_STATE(861)] = 27881,
  [SMALL_STATE(862)] = 27940,
  [SMALL_STATE(863)] = 27977,
  [SMALL_STATE(864)] = 28014,
  [SMALL_STATE(865)] = 28071,
  [SMALL_STATE(866)] = 28130,
  [SMALL_STATE(867)] = 28189,
  [SMALL_STATE(868)] = 28248,
  [SMALL_STATE(869)] = 28307,
  [SMALL_STATE(870)] = 28366,
  [SMALL_STATE(871)] = 28425,
  [SMALL_STATE(872)] = 28460,
  [SMALL_STATE(873)] = 28490,
  [SMALL_STATE(874)] = 28520,
  [SMALL_STATE(875)] = 28550,
  [SMALL_STATE(876)] = 28580,
  [SMALL_STATE(877)] = 28610,
  [SMALL_STATE(878)] = 28640,
  [SMALL_STATE(879)] = 28670,
  [SMALL_STATE(880)] = 28700,
  [SMALL_STATE(881)] = 28754,
  [SMALL_STATE(882)] = 28784,
  [SMALL_STATE(883)] = 28814,
  [SMALL_STATE(884)] = 28844,
  [SMALL_STATE(885)] = 28880,
  [SMALL_STATE(886)] = 28910,
  [SMALL_STATE(887)] = 28946,
  [SMALL_STATE(888)] = 28976,
  [SMALL_STATE(889)] = 29006,
  [SMALL_STATE(890)] = 29036,
  [SMALL_STATE(891)] = 29066,
  [SMALL_STATE(892)] = 29096,
  [SMALL_STATE(893)] = 29132,
  [SMALL_STATE(894)] = 29162,
  [SMALL_STATE(895)] = 29192,
  [SMALL_STATE(896)] = 29228,
  [SMALL_STATE(897)] = 29258,
  [SMALL_STATE(898)] = 29314,
  [SMALL_STATE(899)] = 29370,
  [SMALL_STATE(900)] = 29400,
  [SMALL_STATE(901)] = 29430,
  [SMALL_STATE(902)] = 29466,
  [SMALL_STATE(903)] = 29498,
  [SMALL_STATE(904)] = 29530,
  [SMALL_STATE(905)] = 29560,
  [SMALL_STATE(906)] = 29590,
  [SMALL_STATE(907)] = 29646,
  [SMALL_STATE(908)] = 29702,
  [SMALL_STATE(909)] = 29732,
  [SMALL_STATE(910)] = 29762,
  [SMALL_STATE(911)] = 29798,
  [SMALL_STATE(912)] = 29828,
  [SMALL_STATE(913)] = 29864,
  [SMALL_STATE(914)] = 29894,
  [SMALL_STATE(915)] = 29924,
  [SMALL_STATE(916)] = 29980,
  [SMALL_STATE(917)] = 30036,
  [SMALL_STATE(918)] = 30072,
  [SMALL_STATE(919)] = 30102,
  [SMALL_STATE(920)] = 30132,
  [SMALL_STATE(921)] = 30162,
  [SMALL_STATE(922)] = 30192,
  [SMALL_STATE(923)] = 30222,
  [SMALL_STATE(924)] = 30252,
  [SMALL_STATE(925)] = 30282,
  [SMALL_STATE(926)] = 30312,
  [SMALL_STATE(927)] = 30348,
  [SMALL_STATE(928)] = 30378,
  [SMALL_STATE(929)] = 30408,
  [SMALL_STATE(930)] = 30444,
  [SMALL_STATE(931)] = 30480,
  [SMALL_STATE(932)] = 30510,
  [SMALL_STATE(933)] = 30546,
  [SMALL_STATE(934)] = 30580,
  [SMALL_STATE(935)] = 30616,
  [SMALL_STATE(936)] = 30646,
  [SMALL_STATE(937)] = 30676,
  [SMALL_STATE(938)] = 30732,
  [SMALL_STATE(939)] = 30762,
  [SMALL_STATE(940)] = 30818,
  [SMALL_STATE(941)] = 30874,
  [SMALL_STATE(942)] = 30930,
  [SMALL_STATE(943)] = 30986,
  [SMALL_STATE(944)] = 31042,
  [SMALL_STATE(945)] = 31072,
  [SMALL_STATE(946)] = 31102,
  [SMALL_STATE(947)] = 31158,
  [SMALL_STATE(948)] = 31188,
  [SMALL_STATE(949)] = 31244,
  [SMALL_STATE(950)] = 31298,
  [SMALL_STATE(951)] = 31354,
  [SMALL_STATE(952)] = 31410,
  [SMALL_STATE(953)] = 31466,
  [SMALL_STATE(954)] = 31522,
  [SMALL_STATE(955)] = 31578,
  [SMALL_STATE(956)] = 31608,
  [SMALL_STATE(957)] = 31638,
  [SMALL_STATE(958)] = 31668,
  [SMALL_STATE(959)] = 31724,
  [SMALL_STATE(960)] = 31780,
  [SMALL_STATE(961)] = 31836,
  [SMALL_STATE(962)] = 31892,
  [SMALL_STATE(963)] = 31948,
  [SMALL_STATE(964)] = 32004,
  [SMALL_STATE(965)] = 32034,
  [SMALL_STATE(966)] = 32090,
  [SMALL_STATE(967)] = 32146,
  [SMALL_STATE(968)] = 32180,
  [SMALL_STATE(969)] = 32210,
  [SMALL_STATE(970)] = 32266,
  [SMALL_STATE(971)] = 32302,
  [SMALL_STATE(972)] = 32338,
  [SMALL_STATE(973)] = 32368,
  [SMALL_STATE(974)] = 32424,
  [SMALL_STATE(975)] = 32480,
  [SMALL_STATE(976)] = 32510,
  [SMALL_STATE(977)] = 32566,
  [SMALL_STATE(978)] = 32622,
  [SMALL_STATE(979)] = 32678,
  [SMALL_STATE(980)] = 32734,
  [SMALL_STATE(981)] = 32764,
  [SMALL_STATE(982)] = 32794,
  [SMALL_STATE(983)] = 32824,
  [SMALL_STATE(984)] = 32880,
  [SMALL_STATE(985)] = 32936,
  [SMALL_STATE(986)] = 32992,
  [SMALL_STATE(987)] = 33022,
  [SMALL_STATE(988)] = 33078,
  [SMALL_STATE(989)] = 33134,
  [SMALL_STATE(990)] = 33190,
  [SMALL_STATE(991)] = 33246,
  [SMALL_STATE(992)] = 33276,
  [SMALL_STATE(993)] = 33308,
  [SMALL_STATE(994)] = 33338,
  [SMALL_STATE(995)] = 33374,
  [SMALL_STATE(996)] = 33404,
  [SMALL_STATE(997)] = 33440,
  [SMALL_STATE(998)] = 33470,
  [SMALL_STATE(999)] = 33506,
  [SMALL_STATE(1000)] = 33536,
  [SMALL_STATE(1001)] = 33592,
  [SMALL_STATE(1002)] = 33628,
  [SMALL_STATE(1003)] = 33662,
  [SMALL_STATE(1004)] = 33692,
  [SMALL_STATE(1005)] = 33722,
  [SMALL_STATE(1006)] = 33758,
  [SMALL_STATE(1007)] = 33788,
  [SMALL_STATE(1008)] = 33818,
  [SMALL_STATE(1009)] = 33874,
  [SMALL_STATE(1010)] = 33904,
  [SMALL_STATE(1011)] = 33960,
  [SMALL_STATE(1012)] = 33990,
  [SMALL_STATE(1013)] = 34020,
  [SMALL_STATE(1014)] = 34050,
  [SMALL_STATE(1015)] = 34082,
  [SMALL_STATE(1016)] = 34112,
  [SMALL_STATE(1017)] = 34142,
  [SMALL_STATE(1018)] = 34172,
  [SMALL_STATE(1019)] = 34208,
  [SMALL_STATE(1020)] = 34244,
  [SMALL_STATE(1021)] = 34274,
  [SMALL_STATE(1022)] = 34304,
  [SMALL_STATE(1023)] = 34334,
  [SMALL_STATE(1024)] = 34364,
  [SMALL_STATE(1025)] = 34394,
  [SMALL_STATE(1026)] = 34428,
  [SMALL_STATE(1027)] = 34464,
  [SMALL_STATE(1028)] = 34500,
  [SMALL_STATE(1029)] = 34556,
  [SMALL_STATE(1030)] = 34586,
  [SMALL_STATE(1031)] = 34616,
  [SMALL_STATE(1032)] = 34669,
  [SMALL_STATE(1033)] = 34704,
  [SMALL_STATE(1034)] = 34739,
  [SMALL_STATE(1035)] = 34774,
  [SMALL_STATE(1036)] = 34827,
  [SMALL_STATE(1037)] = 34862,
  [SMALL_STATE(1038)] = 34915,
  [SMALL_STATE(1039)] = 34950,
  [SMALL_STATE(1040)] = 34983,
  [SMALL_STATE(1041)] = 35012,
  [SMALL_STATE(1042)] = 35041,
  [SMALL_STATE(1043)] = 35070,
  [SMALL_STATE(1044)] = 35101,
  [SMALL_STATE(1045)] = 35154,
  [SMALL_STATE(1046)] = 35183,
  [SMALL_STATE(1047)] = 35212,
  [SMALL_STATE(1048)] = 35241,
  [SMALL_STATE(1049)] = 35270,
  [SMALL_STATE(1050)] = 35301,
  [SMALL_STATE(1051)] = 35330,
  [SMALL_STATE(1052)] = 35359,
  [SMALL_STATE(1053)] = 35390,
  [SMALL_STATE(1054)] = 35419,
  [SMALL_STATE(1055)] = 35448,
  [SMALL_STATE(1056)] = 35505,
  [SMALL_STATE(1057)] = 35534,
  [SMALL_STATE(1058)] = 35563,
  [SMALL_STATE(1059)] = 35592,
  [SMALL_STATE(1060)] = 35621,
  [SMALL_STATE(1061)] = 35650,
  [SMALL_STATE(1062)] = 35679,
  [SMALL_STATE(1063)] = 35708,
  [SMALL_STATE(1064)] = 35739,
  [SMALL_STATE(1065)] = 35768,
  [SMALL_STATE(1066)] = 35799,
  [SMALL_STATE(1067)] = 35828,
  [SMALL_STATE(1068)] = 35857,
  [SMALL_STATE(1069)] = 35886,
  [SMALL_STATE(1070)] = 35917,
  [SMALL_STATE(1071)] = 35946,
  [SMALL_STATE(1072)] = 35975,
  [SMALL_STATE(1073)] = 36004,
  [SMALL_STATE(1074)] = 36039,
  [SMALL_STATE(1075)] = 36070,
  [SMALL_STATE(1076)] = 36099,
  [SMALL_STATE(1077)] = 36152,
  [SMALL_STATE(1078)] = 36181,
  [SMALL_STATE(1079)] = 36212,
  [SMALL_STATE(1080)] = 36243,
  [SMALL_STATE(1081)] = 36274,
  [SMALL_STATE(1082)] = 36327,
  [SMALL_STATE(1083)] = 36362,
  [SMALL_STATE(1084)] = 36391,
  [SMALL_STATE(1085)] = 36444,
  [SMALL_STATE(1086)] = 36497,
  [SMALL_STATE(1087)] = 36530,
  [SMALL_STATE(1088)] = 36583,
  [SMALL_STATE(1089)] = 36618,
  [SMALL_STATE(1090)] = 36653,
  [SMALL_STATE(1091)] = 36682,
  [SMALL_STATE(1092)] = 36711,
  [SMALL_STATE(1093)] = 36764,
  [SMALL_STATE(1094)] = 36793,
  [SMALL_STATE(1095)] = 36846,
  [SMALL_STATE(1096)] = 36881,
  [SMALL_STATE(1097)] = 36934,
  [SMALL_STATE(1098)] = 36963,
  [SMALL_STATE(1099)] = 37016,
  [SMALL_STATE(1100)] = 37049,
  [SMALL_STATE(1101)] = 37084,
  [SMALL_STATE(1102)] = 37115,
  [SMALL_STATE(1103)] = 37168,
  [SMALL_STATE(1104)] = 37201,
  [SMALL_STATE(1105)] = 37254,
  [SMALL_STATE(1106)] = 37311,
  [SMALL_STATE(1107)] = 37364,
  [SMALL_STATE(1108)] = 37417,
  [SMALL_STATE(1109)] = 37470,
  [SMALL_STATE(1110)] = 37505,
  [SMALL_STATE(1111)] = 37558,
  [SMALL_STATE(1112)] = 37611,
  [SMALL_STATE(1113)] = 37664,
  [SMALL_STATE(1114)] = 37717,
  [SMALL_STATE(1115)] = 37752,
  [SMALL_STATE(1116)] = 37805,
  [SMALL_STATE(1117)] = 37840,
  [SMALL_STATE(1118)] = 37893,
  [SMALL_STATE(1119)] = 37946,
  [SMALL_STATE(1120)] = 37999,
  [SMALL_STATE(1121)] = 38052,
  [SMALL_STATE(1122)] = 38105,
  [SMALL_STATE(1123)] = 38158,
  [SMALL_STATE(1124)] = 38211,
  [SMALL_STATE(1125)] = 38264,
  [SMALL_STATE(1126)] = 38317,
  [SMALL_STATE(1127)] = 38370,
  [SMALL_STATE(1128)] = 38401,
  [SMALL_STATE(1129)] = 38454,
  [SMALL_STATE(1130)] = 38507,
  [SMALL_STATE(1131)] = 38560,
  [SMALL_STATE(1132)] = 38613,
  [SMALL_STATE(1133)] = 38648,
  [SMALL_STATE(1134)] = 38701,
  [SMALL_STATE(1135)] = 38736,
  [SMALL_STATE(1136)] = 38789,
  [SMALL_STATE(1137)] = 38842,
  [SMALL_STATE(1138)] = 38895,
  [SMALL_STATE(1139)] = 38948,
  [SMALL_STATE(1140)] = 39001,
  [SMALL_STATE(1141)] = 39054,
  [SMALL_STATE(1142)] = 39107,
  [SMALL_STATE(1143)] = 39142,
  [SMALL_STATE(1144)] = 39195,
  [SMALL_STATE(1145)] = 39248,
  [SMALL_STATE(1146)] = 39301,
  [SMALL_STATE(1147)] = 39354,
  [SMALL_STATE(1148)] = 39407,
  [SMALL_STATE(1149)] = 39460,
  [SMALL_STATE(1150)] = 39513,
  [SMALL_STATE(1151)] = 39566,
  [SMALL_STATE(1152)] = 39619,
  [SMALL_STATE(1153)] = 39672,
  [SMALL_STATE(1154)] = 39725,
  [SMALL_STATE(1155)] = 39778,
  [SMALL_STATE(1156)] = 39831,
  [SMALL_STATE(1157)] = 39884,
  [SMALL_STATE(1158)] = 39937,
  [SMALL_STATE(1159)] = 39990,
  [SMALL_STATE(1160)] = 40021,
  [SMALL_STATE(1161)] = 40074,
  [SMALL_STATE(1162)] = 40127,
  [SMALL_STATE(1163)] = 40180,
  [SMALL_STATE(1164)] = 40233,
  [SMALL_STATE(1165)] = 40268,
  [SMALL_STATE(1166)] = 40303,
  [SMALL_STATE(1167)] = 40338,
  [SMALL_STATE(1168)] = 40373,
  [SMALL_STATE(1169)] = 40426,
  [SMALL_STATE(1170)] = 40461,
  [SMALL_STATE(1171)] = 40492,
  [SMALL_STATE(1172)] = 40549,
  [SMALL_STATE(1173)] = 40602,
  [SMALL_STATE(1174)] = 40655,
  [SMALL_STATE(1175)] = 40708,
  [SMALL_STATE(1176)] = 40761,
  [SMALL_STATE(1177)] = 40814,
  [SMALL_STATE(1178)] = 40867,
  [SMALL_STATE(1179)] = 40920,
  [SMALL_STATE(1180)] = 40955,
  [SMALL_STATE(1181)] = 41008,
  [SMALL_STATE(1182)] = 41043,
  [SMALL_STATE(1183)] = 41096,
  [SMALL_STATE(1184)] = 41149,
  [SMALL_STATE(1185)] = 41179,
  [SMALL_STATE(1186)] = 41213,
  [SMALL_STATE(1187)] = 41243,
  [SMALL_STATE(1188)] = 41273,
  [SMALL_STATE(1189)] = 41303,
  [SMALL_STATE(1190)] = 41333,
  [SMALL_STATE(1191)] = 41363,
  [SMALL_STATE(1192)] = 41393,
  [SMALL_STATE(1193)] = 41423,
  [SMALL_STATE(1194)] = 41477,
  [SMALL_STATE(1195)] = 41531,
  [SMALL_STATE(1196)] = 41561,
  [SMALL_STATE(1197)] = 41591,
  [SMALL_STATE(1198)] = 41621,
  [SMALL_STATE(1199)] = 41675,
  [SMALL_STATE(1200)] = 41729,
  [SMALL_STATE(1201)] = 41783,
  [SMALL_STATE(1202)] = 41837,
  [SMALL_STATE(1203)] = 41867,
  [SMALL_STATE(1204)] = 41897,
  [SMALL_STATE(1205)] = 41927,
  [SMALL_STATE(1206)] = 41957,
  [SMALL_STATE(1207)] = 41987,
  [SMALL_STATE(1208)] = 42017,
  [SMALL_STATE(1209)] = 42047,
  [SMALL_STATE(1210)] = 42077,
  [SMALL_STATE(1211)] = 42131,
  [SMALL_STATE(1212)] = 42185,
  [SMALL_STATE(1213)] = 42239,
  [SMALL_STATE(1214)] = 42269,
  [SMALL_STATE(1215)] = 42299,
  [SMALL_STATE(1216)] = 42331,
  [SMALL_STATE(1217)] = 42361,
  [SMALL_STATE(1218)] = 42393,
  [SMALL_STATE(1219)] = 42423,
  [SMALL_STATE(1220)] = 42453,
  [SMALL_STATE(1221)] = 42483,
  [SMALL_STATE(1222)] = 42513,
  [SMALL_STATE(1223)] = 42543,
  [SMALL_STATE(1224)] = 42573,
  [SMALL_STATE(1225)] = 42603,
  [SMALL_STATE(1226)] = 42657,
  [SMALL_STATE(1227)] = 42711,
  [SMALL_STATE(1228)] = 42740,
  [SMALL_STATE(1229)] = 42769,
  [SMALL_STATE(1230)] = 42798,
  [SMALL_STATE(1231)] = 42827,
  [SMALL_STATE(1232)] = 42856,
  [SMALL_STATE(1233)] = 42885,
  [SMALL_STATE(1234)] = 42914,
  [SMALL_STATE(1235)] = 42943,
  [SMALL_STATE(1236)] = 42972,
  [SMALL_STATE(1237)] = 43001,
  [SMALL_STATE(1238)] = 43030,
  [SMALL_STATE(1239)] = 43059,
  [SMALL_STATE(1240)] = 43088,
  [SMALL_STATE(1241)] = 43117,
  [SMALL_STATE(1242)] = 43146,
  [SMALL_STATE(1243)] = 43175,
  [SMALL_STATE(1244)] = 43204,
  [SMALL_STATE(1245)] = 43233,
  [SMALL_STATE(1246)] = 43262,
  [SMALL_STATE(1247)] = 43291,
  [SMALL_STATE(1248)] = 43320,
  [SMALL_STATE(1249)] = 43349,
  [SMALL_STATE(1250)] = 43378,
  [SMALL_STATE(1251)] = 43407,
  [SMALL_STATE(1252)] = 43436,
  [SMALL_STATE(1253)] = 43465,
  [SMALL_STATE(1254)] = 43494,
  [SMALL_STATE(1255)] = 43523,
  [SMALL_STATE(1256)] = 43552,
  [SMALL_STATE(1257)] = 43581,
  [SMALL_STATE(1258)] = 43610,
  [SMALL_STATE(1259)] = 43639,
  [SMALL_STATE(1260)] = 43668,
  [SMALL_STATE(1261)] = 43697,
  [SMALL_STATE(1262)] = 43726,
  [SMALL_STATE(1263)] = 43755,
  [SMALL_STATE(1264)] = 43784,
  [SMALL_STATE(1265)] = 43813,
  [SMALL_STATE(1266)] = 43842,
  [SMALL_STATE(1267)] = 43871,
  [SMALL_STATE(1268)] = 43900,
  [SMALL_STATE(1269)] = 43929,
  [SMALL_STATE(1270)] = 43958,
  [SMALL_STATE(1271)] = 43987,
  [SMALL_STATE(1272)] = 44016,
  [SMALL_STATE(1273)] = 44045,
  [SMALL_STATE(1274)] = 44074,
  [SMALL_STATE(1275)] = 44103,
  [SMALL_STATE(1276)] = 44132,
  [SMALL_STATE(1277)] = 44161,
  [SMALL_STATE(1278)] = 44190,
  [SMALL_STATE(1279)] = 44219,
  [SMALL_STATE(1280)] = 44248,
  [SMALL_STATE(1281)] = 44277,
  [SMALL_STATE(1282)] = 44306,
  [SMALL_STATE(1283)] = 44335,
  [SMALL_STATE(1284)] = 44364,
  [SMALL_STATE(1285)] = 44393,
  [SMALL_STATE(1286)] = 44422,
  [SMALL_STATE(1287)] = 44451,
  [SMALL_STATE(1288)] = 44480,
  [SMALL_STATE(1289)] = 44509,
  [SMALL_STATE(1290)] = 44538,
  [SMALL_STATE(1291)] = 44567,
  [SMALL_STATE(1292)] = 44596,
  [SMALL_STATE(1293)] = 44625,
  [SMALL_STATE(1294)] = 44654,
  [SMALL_STATE(1295)] = 44683,
  [SMALL_STATE(1296)] = 44712,
  [SMALL_STATE(1297)] = 44741,
  [SMALL_STATE(1298)] = 44770,
  [SMALL_STATE(1299)] = 44799,
  [SMALL_STATE(1300)] = 44828,
  [SMALL_STATE(1301)] = 44857,
  [SMALL_STATE(1302)] = 44886,
  [SMALL_STATE(1303)] = 44915,
  [SMALL_STATE(1304)] = 44944,
  [SMALL_STATE(1305)] = 44973,
  [SMALL_STATE(1306)] = 45002,
  [SMALL_STATE(1307)] = 45031,
  [SMALL_STATE(1308)] = 45060,
  [SMALL_STATE(1309)] = 45089,
  [SMALL_STATE(1310)] = 45118,
  [SMALL_STATE(1311)] = 45147,
  [SMALL_STATE(1312)] = 45176,
  [SMALL_STATE(1313)] = 45205,
  [SMALL_STATE(1314)] = 45234,
  [SMALL_STATE(1315)] = 45263,
  [SMALL_STATE(1316)] = 45292,
  [SMALL_STATE(1317)] = 45321,
  [SMALL_STATE(1318)] = 45350,
  [SMALL_STATE(1319)] = 45379,
  [SMALL_STATE(1320)] = 45408,
  [SMALL_STATE(1321)] = 45437,
  [SMALL_STATE(1322)] = 45466,
  [SMALL_STATE(1323)] = 45495,
  [SMALL_STATE(1324)] = 45524,
  [SMALL_STATE(1325)] = 45553,
  [SMALL_STATE(1326)] = 45582,
  [SMALL_STATE(1327)] = 45611,
  [SMALL_STATE(1328)] = 45640,
  [SMALL_STATE(1329)] = 45669,
  [SMALL_STATE(1330)] = 45720,
  [SMALL_STATE(1331)] = 45749,
  [SMALL_STATE(1332)] = 45778,
  [SMALL_STATE(1333)] = 45807,
  [SMALL_STATE(1334)] = 45836,
  [SMALL_STATE(1335)] = 45865,
  [SMALL_STATE(1336)] = 45894,
  [SMALL_STATE(1337)] = 45923,
  [SMALL_STATE(1338)] = 45952,
  [SMALL_STATE(1339)] = 45981,
  [SMALL_STATE(1340)] = 46010,
  [SMALL_STATE(1341)] = 46039,
  [SMALL_STATE(1342)] = 46068,
  [SMALL_STATE(1343)] = 46097,
  [SMALL_STATE(1344)] = 46124,
  [SMALL_STATE(1345)] = 46153,
  [SMALL_STATE(1346)] = 46182,
  [SMALL_STATE(1347)] = 46211,
  [SMALL_STATE(1348)] = 46240,
  [SMALL_STATE(1349)] = 46269,
  [SMALL_STATE(1350)] = 46298,
  [SMALL_STATE(1351)] = 46327,
  [SMALL_STATE(1352)] = 46356,
  [SMALL_STATE(1353)] = 46385,
  [SMALL_STATE(1354)] = 46414,
  [SMALL_STATE(1355)] = 46443,
  [SMALL_STATE(1356)] = 46472,
  [SMALL_STATE(1357)] = 46501,
  [SMALL_STATE(1358)] = 46530,
  [SMALL_STATE(1359)] = 46559,
  [SMALL_STATE(1360)] = 46588,
  [SMALL_STATE(1361)] = 46617,
  [SMALL_STATE(1362)] = 46646,
  [SMALL_STATE(1363)] = 46675,
  [SMALL_STATE(1364)] = 46704,
  [SMALL_STATE(1365)] = 46733,
  [SMALL_STATE(1366)] = 46762,
  [SMALL_STATE(1367)] = 46791,
  [SMALL_STATE(1368)] = 46820,
  [SMALL_STATE(1369)] = 46849,
  [SMALL_STATE(1370)] = 46878,
  [SMALL_STATE(1371)] = 46907,
  [SMALL_STATE(1372)] = 46936,
  [SMALL_STATE(1373)] = 46965,
  [SMALL_STATE(1374)] = 46994,
  [SMALL_STATE(1375)] = 47023,
  [SMALL_STATE(1376)] = 47052,
  [SMALL_STATE(1377)] = 47081,
  [SMALL_STATE(1378)] = 47110,
  [SMALL_STATE(1379)] = 47139,
  [SMALL_STATE(1380)] = 47168,
  [SMALL_STATE(1381)] = 47197,
  [SMALL_STATE(1382)] = 47226,
  [SMALL_STATE(1383)] = 47255,
  [SMALL_STATE(1384)] = 47284,
  [SMALL_STATE(1385)] = 47313,
  [SMALL_STATE(1386)] = 47342,
  [SMALL_STATE(1387)] = 47393,
  [SMALL_STATE(1388)] = 47422,
  [SMALL_STATE(1389)] = 47451,
  [SMALL_STATE(1390)] = 47480,
  [SMALL_STATE(1391)] = 47509,
  [SMALL_STATE(1392)] = 47538,
  [SMALL_STATE(1393)] = 47566,
  [SMALL_STATE(1394)] = 47614,
  [SMALL_STATE(1395)] = 47662,
  [SMALL_STATE(1396)] = 47710,
  [SMALL_STATE(1397)] = 47758,
  [SMALL_STATE(1398)] = 47806,
  [SMALL_STATE(1399)] = 47854,
  [SMALL_STATE(1400)] = 47902,
  [SMALL_STATE(1401)] = 47950,
  [SMALL_STATE(1402)] = 47998,
  [SMALL_STATE(1403)] = 48043,
  [SMALL_STATE(1404)] = 48088,
  [SMALL_STATE(1405)] = 48113,
  [SMALL_STATE(1406)] = 48158,
  [SMALL_STATE(1407)] = 48183,
  [SMALL_STATE(1408)] = 48225,
  [SMALL_STATE(1409)] = 48267,
  [SMALL_STATE(1410)] = 48309,
  [SMALL_STATE(1411)] = 48351,
  [SMALL_STATE(1412)] = 48393,
  [SMALL_STATE(1413)] = 48435,
  [SMALL_STATE(1414)] = 48477,
  [SMALL_STATE(1415)] = 48519,
  [SMALL_STATE(1416)] = 48561,
  [SMALL_STATE(1417)] = 48603,
  [SMALL_STATE(1418)] = 48645,
  [SMALL_STATE(1419)] = 48687,
  [SMALL_STATE(1420)] = 48729,
  [SMALL_STATE(1421)] = 48771,
  [SMALL_STATE(1422)] = 48813,
  [SMALL_STATE(1423)] = 48855,
  [SMALL_STATE(1424)] = 48897,
  [SMALL_STATE(1425)] = 48939,
  [SMALL_STATE(1426)] = 48981,
  [SMALL_STATE(1427)] = 49023,
  [SMALL_STATE(1428)] = 49065,
  [SMALL_STATE(1429)] = 49107,
  [SMALL_STATE(1430)] = 49149,
  [SMALL_STATE(1431)] = 49191,
  [SMALL_STATE(1432)] = 49233,
  [SMALL_STATE(1433)] = 49275,
  [SMALL_STATE(1434)] = 49297,
  [SMALL_STATE(1435)] = 49326,
  [SMALL_STATE(1436)] = 49349,
  [SMALL_STATE(1437)] = 49371,
  [SMALL_STATE(1438)] = 49391,
  [SMALL_STATE(1439)] = 49413,
  [SMALL_STATE(1440)] = 49435,
  [SMALL_STATE(1441)] = 49457,
  [SMALL_STATE(1442)] = 49477,
  [SMALL_STATE(1443)] = 49497,
  [SMALL_STATE(1444)] = 49517,
  [SMALL_STATE(1445)] = 49539,
  [SMALL_STATE(1446)] = 49561,
  [SMALL_STATE(1447)] = 49583,
  [SMALL_STATE(1448)] = 49605,
  [SMALL_STATE(1449)] = 49638,
  [SMALL_STATE(1450)] = 49671,
  [SMALL_STATE(1451)] = 49701,
  [SMALL_STATE(1452)] = 49719,
  [SMALL_STATE(1453)] = 49749,
  [SMALL_STATE(1454)] = 49779,
  [SMALL_STATE(1455)] = 49797,
  [SMALL_STATE(1456)] = 49824,
  [SMALL_STATE(1457)] = 49839,
  [SMALL_STATE(1458)] = 49854,
  [SMALL_STATE(1459)] = 49869,
  [SMALL_STATE(1460)] = 49900,
  [SMALL_STATE(1461)] = 49931,
  [SMALL_STATE(1462)] = 49946,
  [SMALL_STATE(1463)] = 49973,
  [SMALL_STATE(1464)] = 49992,
  [SMALL_STATE(1465)] = 50007,
  [SMALL_STATE(1466)] = 50031,
  [SMALL_STATE(1467)] = 50047,
  [SMALL_STATE(1468)] = 50073,
  [SMALL_STATE(1469)] = 50093,
  [SMALL_STATE(1470)] = 50113,
  [SMALL_STATE(1471)] = 50137,
  [SMALL_STATE(1472)] = 50157,
  [SMALL_STATE(1473)] = 50177,
  [SMALL_STATE(1474)] = 50197,
  [SMALL_STATE(1475)] = 50217,
  [SMALL_STATE(1476)] = 50237,
  [SMALL_STATE(1477)] = 50263,
  [SMALL_STATE(1478)] = 50283,
  [SMALL_STATE(1479)] = 50297,
  [SMALL_STATE(1480)] = 50317,
  [SMALL_STATE(1481)] = 50341,
  [SMALL_STATE(1482)] = 50361,
  [SMALL_STATE(1483)] = 50381,
  [SMALL_STATE(1484)] = 50401,
  [SMALL_STATE(1485)] = 50421,
  [SMALL_STATE(1486)] = 50441,
  [SMALL_STATE(1487)] = 50461,
  [SMALL_STATE(1488)] = 50489,
  [SMALL_STATE(1489)] = 50517,
  [SMALL_STATE(1490)] = 50537,
  [SMALL_STATE(1491)] = 50561,
  [SMALL_STATE(1492)] = 50584,
  [SMALL_STATE(1493)] = 50605,
  [SMALL_STATE(1494)] = 50628,
  [SMALL_STATE(1495)] = 50651,
  [SMALL_STATE(1496)] = 50664,
  [SMALL_STATE(1497)] = 50687,
  [SMALL_STATE(1498)] = 50710,
  [SMALL_STATE(1499)] = 50731,
  [SMALL_STATE(1500)] = 50744,
  [SMALL_STATE(1501)] = 50757,
  [SMALL_STATE(1502)] = 50774,
  [SMALL_STATE(1503)] = 50797,
  [SMALL_STATE(1504)] = 50820,
  [SMALL_STATE(1505)] = 50841,
  [SMALL_STATE(1506)] = 50862,
  [SMALL_STATE(1507)] = 50875,
  [SMALL_STATE(1508)] = 50898,
  [SMALL_STATE(1509)] = 50919,
  [SMALL_STATE(1510)] = 50939,
  [SMALL_STATE(1511)] = 50957,
  [SMALL_STATE(1512)] = 50977,
  [SMALL_STATE(1513)] = 50995,
  [SMALL_STATE(1514)] = 51015,
  [SMALL_STATE(1515)] = 51035,
  [SMALL_STATE(1516)] = 51053,
  [SMALL_STATE(1517)] = 51073,
  [SMALL_STATE(1518)] = 51089,
  [SMALL_STATE(1519)] = 51109,
  [SMALL_STATE(1520)] = 51129,
  [SMALL_STATE(1521)] = 51141,
  [SMALL_STATE(1522)] = 51159,
  [SMALL_STATE(1523)] = 51179,
  [SMALL_STATE(1524)] = 51199,
  [SMALL_STATE(1525)] = 51219,
  [SMALL_STATE(1526)] = 51239,
  [SMALL_STATE(1527)] = 51259,
  [SMALL_STATE(1528)] = 51279,
  [SMALL_STATE(1529)] = 51299,
  [SMALL_STATE(1530)] = 51319,
  [SMALL_STATE(1531)] = 51339,
  [SMALL_STATE(1532)] = 51359,
  [SMALL_STATE(1533)] = 51379,
  [SMALL_STATE(1534)] = 51399,
  [SMALL_STATE(1535)] = 51417,
  [SMALL_STATE(1536)] = 51437,
  [SMALL_STATE(1537)] = 51457,
  [SMALL_STATE(1538)] = 51472,
  [SMALL_STATE(1539)] = 51487,
  [SMALL_STATE(1540)] = 51502,
  [SMALL_STATE(1541)] = 51519,
  [SMALL_STATE(1542)] = 51534,
  [SMALL_STATE(1543)] = 51545,
  [SMALL_STATE(1544)] = 51560,
  [SMALL_STATE(1545)] = 51577,
  [SMALL_STATE(1546)] = 51594,
  [SMALL_STATE(1547)] = 51611,
  [SMALL_STATE(1548)] = 51624,
  [SMALL_STATE(1549)] = 51637,
  [SMALL_STATE(1550)] = 51654,
  [SMALL_STATE(1551)] = 51671,
  [SMALL_STATE(1552)] = 51688,
  [SMALL_STATE(1553)] = 51705,
  [SMALL_STATE(1554)] = 51722,
  [SMALL_STATE(1555)] = 51739,
  [SMALL_STATE(1556)] = 51756,
  [SMALL_STATE(1557)] = 51769,
  [SMALL_STATE(1558)] = 51786,
  [SMALL_STATE(1559)] = 51803,
  [SMALL_STATE(1560)] = 51820,
  [SMALL_STATE(1561)] = 51835,
  [SMALL_STATE(1562)] = 51852,
  [SMALL_STATE(1563)] = 51867,
  [SMALL_STATE(1564)] = 51884,
  [SMALL_STATE(1565)] = 51897,
  [SMALL_STATE(1566)] = 51914,
  [SMALL_STATE(1567)] = 51931,
  [SMALL_STATE(1568)] = 51948,
  [SMALL_STATE(1569)] = 51963,
  [SMALL_STATE(1570)] = 51980,
  [SMALL_STATE(1571)] = 51997,
  [SMALL_STATE(1572)] = 52014,
  [SMALL_STATE(1573)] = 52029,
  [SMALL_STATE(1574)] = 52046,
  [SMALL_STATE(1575)] = 52063,
  [SMALL_STATE(1576)] = 52078,
  [SMALL_STATE(1577)] = 52095,
  [SMALL_STATE(1578)] = 52112,
  [SMALL_STATE(1579)] = 52129,
  [SMALL_STATE(1580)] = 52146,
  [SMALL_STATE(1581)] = 52163,
  [SMALL_STATE(1582)] = 52178,
  [SMALL_STATE(1583)] = 52193,
  [SMALL_STATE(1584)] = 52204,
  [SMALL_STATE(1585)] = 52217,
  [SMALL_STATE(1586)] = 52234,
  [SMALL_STATE(1587)] = 52249,
  [SMALL_STATE(1588)] = 52264,
  [SMALL_STATE(1589)] = 52279,
  [SMALL_STATE(1590)] = 52294,
  [SMALL_STATE(1591)] = 52311,
  [SMALL_STATE(1592)] = 52324,
  [SMALL_STATE(1593)] = 52339,
  [SMALL_STATE(1594)] = 52356,
  [SMALL_STATE(1595)] = 52373,
  [SMALL_STATE(1596)] = 52390,
  [SMALL_STATE(1597)] = 52403,
  [SMALL_STATE(1598)] = 52418,
  [SMALL_STATE(1599)] = 52435,
  [SMALL_STATE(1600)] = 52446,
  [SMALL_STATE(1601)] = 52463,
  [SMALL_STATE(1602)] = 52480,
  [SMALL_STATE(1603)] = 52497,
  [SMALL_STATE(1604)] = 52510,
  [SMALL_STATE(1605)] = 52525,
  [SMALL_STATE(1606)] = 52542,
  [SMALL_STATE(1607)] = 52559,
  [SMALL_STATE(1608)] = 52572,
  [SMALL_STATE(1609)] = 52587,
  [SMALL_STATE(1610)] = 52604,
  [SMALL_STATE(1611)] = 52621,
  [SMALL_STATE(1612)] = 52638,
  [SMALL_STATE(1613)] = 52652,
  [SMALL_STATE(1614)] = 52666,
  [SMALL_STATE(1615)] = 52680,
  [SMALL_STATE(1616)] = 52694,
  [SMALL_STATE(1617)] = 52708,
  [SMALL_STATE(1618)] = 52722,
  [SMALL_STATE(1619)] = 52736,
  [SMALL_STATE(1620)] = 52750,
  [SMALL_STATE(1621)] = 52764,
  [SMALL_STATE(1622)] = 52778,
  [SMALL_STATE(1623)] = 52792,
  [SMALL_STATE(1624)] = 52806,
  [SMALL_STATE(1625)] = 52820,
  [SMALL_STATE(1626)] = 52834,
  [SMALL_STATE(1627)] = 52848,
  [SMALL_STATE(1628)] = 52860,
  [SMALL_STATE(1629)] = 52874,
  [SMALL_STATE(1630)] = 52888,
  [SMALL_STATE(1631)] = 52902,
  [SMALL_STATE(1632)] = 52916,
  [SMALL_STATE(1633)] = 52930,
  [SMALL_STATE(1634)] = 52944,
  [SMALL_STATE(1635)] = 52958,
  [SMALL_STATE(1636)] = 52972,
  [SMALL_STATE(1637)] = 52986,
  [SMALL_STATE(1638)] = 53000,
  [SMALL_STATE(1639)] = 53014,
  [SMALL_STATE(1640)] = 53028,
  [SMALL_STATE(1641)] = 53042,
  [SMALL_STATE(1642)] = 53056,
  [SMALL_STATE(1643)] = 53070,
  [SMALL_STATE(1644)] = 53084,
  [SMALL_STATE(1645)] = 53098,
  [SMALL_STATE(1646)] = 53112,
  [SMALL_STATE(1647)] = 53124,
  [SMALL_STATE(1648)] = 53138,
  [SMALL_STATE(1649)] = 53152,
  [SMALL_STATE(1650)] = 53166,
  [SMALL_STATE(1651)] = 53180,
  [SMALL_STATE(1652)] = 53194,
  [SMALL_STATE(1653)] = 53208,
  [SMALL_STATE(1654)] = 53222,
  [SMALL_STATE(1655)] = 53236,
  [SMALL_STATE(1656)] = 53250,
  [SMALL_STATE(1657)] = 53260,
  [SMALL_STATE(1658)] = 53270,
  [SMALL_STATE(1659)] = 53284,
  [SMALL_STATE(1660)] = 53298,
  [SMALL_STATE(1661)] = 53312,
  [SMALL_STATE(1662)] = 53326,
  [SMALL_STATE(1663)] = 53340,
  [SMALL_STATE(1664)] = 53354,
  [SMALL_STATE(1665)] = 53368,
  [SMALL_STATE(1666)] = 53382,
  [SMALL_STATE(1667)] = 53396,
  [SMALL_STATE(1668)] = 53410,
  [SMALL_STATE(1669)] = 53424,
  [SMALL_STATE(1670)] = 53438,
  [SMALL_STATE(1671)] = 53452,
  [SMALL_STATE(1672)] = 53464,
  [SMALL_STATE(1673)] = 53478,
  [SMALL_STATE(1674)] = 53492,
  [SMALL_STATE(1675)] = 53506,
  [SMALL_STATE(1676)] = 53520,
  [SMALL_STATE(1677)] = 53534,
  [SMALL_STATE(1678)] = 53548,
  [SMALL_STATE(1679)] = 53562,
  [SMALL_STATE(1680)] = 53576,
  [SMALL_STATE(1681)] = 53590,
  [SMALL_STATE(1682)] = 53604,
  [SMALL_STATE(1683)] = 53618,
  [SMALL_STATE(1684)] = 53632,
  [SMALL_STATE(1685)] = 53646,
  [SMALL_STATE(1686)] = 53660,
  [SMALL_STATE(1687)] = 53674,
  [SMALL_STATE(1688)] = 53688,
  [SMALL_STATE(1689)] = 53698,
  [SMALL_STATE(1690)] = 53712,
  [SMALL_STATE(1691)] = 53726,
  [SMALL_STATE(1692)] = 53740,
  [SMALL_STATE(1693)] = 53754,
  [SMALL_STATE(1694)] = 53768,
  [SMALL_STATE(1695)] = 53782,
  [SMALL_STATE(1696)] = 53796,
  [SMALL_STATE(1697)] = 53810,
  [SMALL_STATE(1698)] = 53824,
  [SMALL_STATE(1699)] = 53838,
  [SMALL_STATE(1700)] = 53852,
  [SMALL_STATE(1701)] = 53866,
  [SMALL_STATE(1702)] = 53880,
  [SMALL_STATE(1703)] = 53894,
  [SMALL_STATE(1704)] = 53908,
  [SMALL_STATE(1705)] = 53922,
  [SMALL_STATE(1706)] = 53936,
  [SMALL_STATE(1707)] = 53950,
  [SMALL_STATE(1708)] = 53964,
  [SMALL_STATE(1709)] = 53978,
  [SMALL_STATE(1710)] = 53992,
  [SMALL_STATE(1711)] = 54006,
  [SMALL_STATE(1712)] = 54020,
  [SMALL_STATE(1713)] = 54034,
  [SMALL_STATE(1714)] = 54048,
  [SMALL_STATE(1715)] = 54062,
  [SMALL_STATE(1716)] = 54076,
  [SMALL_STATE(1717)] = 54090,
  [SMALL_STATE(1718)] = 54104,
  [SMALL_STATE(1719)] = 54118,
  [SMALL_STATE(1720)] = 54132,
  [SMALL_STATE(1721)] = 54146,
  [SMALL_STATE(1722)] = 54160,
  [SMALL_STATE(1723)] = 54174,
  [SMALL_STATE(1724)] = 54188,
  [SMALL_STATE(1725)] = 54202,
  [SMALL_STATE(1726)] = 54216,
  [SMALL_STATE(1727)] = 54230,
  [SMALL_STATE(1728)] = 54244,
  [SMALL_STATE(1729)] = 54258,
  [SMALL_STATE(1730)] = 54272,
  [SMALL_STATE(1731)] = 54286,
  [SMALL_STATE(1732)] = 54300,
  [SMALL_STATE(1733)] = 54314,
  [SMALL_STATE(1734)] = 54328,
  [SMALL_STATE(1735)] = 54342,
  [SMALL_STATE(1736)] = 54356,
  [SMALL_STATE(1737)] = 54370,
  [SMALL_STATE(1738)] = 54384,
  [SMALL_STATE(1739)] = 54398,
  [SMALL_STATE(1740)] = 54412,
  [SMALL_STATE(1741)] = 54426,
  [SMALL_STATE(1742)] = 54440,
  [SMALL_STATE(1743)] = 54454,
  [SMALL_STATE(1744)] = 54468,
  [SMALL_STATE(1745)] = 54482,
  [SMALL_STATE(1746)] = 54496,
  [SMALL_STATE(1747)] = 54510,
  [SMALL_STATE(1748)] = 54524,
  [SMALL_STATE(1749)] = 54538,
  [SMALL_STATE(1750)] = 54552,
  [SMALL_STATE(1751)] = 54566,
  [SMALL_STATE(1752)] = 54580,
  [SMALL_STATE(1753)] = 54594,
  [SMALL_STATE(1754)] = 54608,
  [SMALL_STATE(1755)] = 54622,
  [SMALL_STATE(1756)] = 54636,
  [SMALL_STATE(1757)] = 54650,
  [SMALL_STATE(1758)] = 54664,
  [SMALL_STATE(1759)] = 54678,
  [SMALL_STATE(1760)] = 54690,
  [SMALL_STATE(1761)] = 54704,
  [SMALL_STATE(1762)] = 54715,
  [SMALL_STATE(1763)] = 54724,
  [SMALL_STATE(1764)] = 54735,
  [SMALL_STATE(1765)] = 54746,
  [SMALL_STATE(1766)] = 54755,
  [SMALL_STATE(1767)] = 54764,
  [SMALL_STATE(1768)] = 54773,
  [SMALL_STATE(1769)] = 54784,
  [SMALL_STATE(1770)] = 54795,
  [SMALL_STATE(1771)] = 54806,
  [SMALL_STATE(1772)] = 54817,
  [SMALL_STATE(1773)] = 54826,
  [SMALL_STATE(1774)] = 54837,
  [SMALL_STATE(1775)] = 54846,
  [SMALL_STATE(1776)] = 54857,
  [SMALL_STATE(1777)] = 54868,
  [SMALL_STATE(1778)] = 54877,
  [SMALL_STATE(1779)] = 54888,
  [SMALL_STATE(1780)] = 54897,
  [SMALL_STATE(1781)] = 54906,
  [SMALL_STATE(1782)] = 54915,
  [SMALL_STATE(1783)] = 54926,
  [SMALL_STATE(1784)] = 54937,
  [SMALL_STATE(1785)] = 54948,
  [SMALL_STATE(1786)] = 54959,
  [SMALL_STATE(1787)] = 54970,
  [SMALL_STATE(1788)] = 54981,
  [SMALL_STATE(1789)] = 54992,
  [SMALL_STATE(1790)] = 55003,
  [SMALL_STATE(1791)] = 55014,
  [SMALL_STATE(1792)] = 55025,
  [SMALL_STATE(1793)] = 55036,
  [SMALL_STATE(1794)] = 55047,
  [SMALL_STATE(1795)] = 55058,
  [SMALL_STATE(1796)] = 55069,
  [SMALL_STATE(1797)] = 55080,
  [SMALL_STATE(1798)] = 55089,
  [SMALL_STATE(1799)] = 55100,
  [SMALL_STATE(1800)] = 55111,
  [SMALL_STATE(1801)] = 55122,
  [SMALL_STATE(1802)] = 55133,
  [SMALL_STATE(1803)] = 55144,
  [SMALL_STATE(1804)] = 55155,
  [SMALL_STATE(1805)] = 55164,
  [SMALL_STATE(1806)] = 55175,
  [SMALL_STATE(1807)] = 55186,
  [SMALL_STATE(1808)] = 55197,
  [SMALL_STATE(1809)] = 55208,
  [SMALL_STATE(1810)] = 55219,
  [SMALL_STATE(1811)] = 55230,
  [SMALL_STATE(1812)] = 55239,
  [SMALL_STATE(1813)] = 55247,
  [SMALL_STATE(1814)] = 55255,
  [SMALL_STATE(1815)] = 55263,
  [SMALL_STATE(1816)] = 55271,
  [SMALL_STATE(1817)] = 55279,
  [SMALL_STATE(1818)] = 55287,
  [SMALL_STATE(1819)] = 55295,
  [SMALL_STATE(1820)] = 55303,
  [SMALL_STATE(1821)] = 55311,
  [SMALL_STATE(1822)] = 55319,
  [SMALL_STATE(1823)] = 55327,
  [SMALL_STATE(1824)] = 55335,
  [SMALL_STATE(1825)] = 55343,
  [SMALL_STATE(1826)] = 55351,
  [SMALL_STATE(1827)] = 55359,
  [SMALL_STATE(1828)] = 55367,
  [SMALL_STATE(1829)] = 55375,
  [SMALL_STATE(1830)] = 55383,
  [SMALL_STATE(1831)] = 55391,
  [SMALL_STATE(1832)] = 55399,
  [SMALL_STATE(1833)] = 55407,
  [SMALL_STATE(1834)] = 55415,
  [SMALL_STATE(1835)] = 55423,
  [SMALL_STATE(1836)] = 55431,
  [SMALL_STATE(1837)] = 55439,
  [SMALL_STATE(1838)] = 55447,
  [SMALL_STATE(1839)] = 55455,
  [SMALL_STATE(1840)] = 55463,
  [SMALL_STATE(1841)] = 55471,
  [SMALL_STATE(1842)] = 55479,
  [SMALL_STATE(1843)] = 55487,
  [SMALL_STATE(1844)] = 55495,
  [SMALL_STATE(1845)] = 55503,
  [SMALL_STATE(1846)] = 55511,
  [SMALL_STATE(1847)] = 55519,
  [SMALL_STATE(1848)] = 55527,
  [SMALL_STATE(1849)] = 55535,
  [SMALL_STATE(1850)] = 55543,
  [SMALL_STATE(1851)] = 55551,
  [SMALL_STATE(1852)] = 55559,
  [SMALL_STATE(1853)] = 55567,
  [SMALL_STATE(1854)] = 55575,
  [SMALL_STATE(1855)] = 55583,
  [SMALL_STATE(1856)] = 55591,
  [SMALL_STATE(1857)] = 55599,
  [SMALL_STATE(1858)] = 55607,
  [SMALL_STATE(1859)] = 55615,
  [SMALL_STATE(1860)] = 55623,
  [SMALL_STATE(1861)] = 55631,
  [SMALL_STATE(1862)] = 55639,
  [SMALL_STATE(1863)] = 55647,
  [SMALL_STATE(1864)] = 55655,
  [SMALL_STATE(1865)] = 55663,
  [SMALL_STATE(1866)] = 55671,
  [SMALL_STATE(1867)] = 55679,
  [SMALL_STATE(1868)] = 55687,
  [SMALL_STATE(1869)] = 55695,
  [SMALL_STATE(1870)] = 55703,
  [SMALL_STATE(1871)] = 55711,
  [SMALL_STATE(1872)] = 55719,
  [SMALL_STATE(1873)] = 55727,
  [SMALL_STATE(1874)] = 55735,
  [SMALL_STATE(1875)] = 55743,
  [SMALL_STATE(1876)] = 55751,
  [SMALL_STATE(1877)] = 55759,
  [SMALL_STATE(1878)] = 55767,
  [SMALL_STATE(1879)] = 55775,
  [SMALL_STATE(1880)] = 55783,
  [SMALL_STATE(1881)] = 55791,
  [SMALL_STATE(1882)] = 55799,
  [SMALL_STATE(1883)] = 55807,
  [SMALL_STATE(1884)] = 55815,
  [SMALL_STATE(1885)] = 55823,
  [SMALL_STATE(1886)] = 55831,
  [SMALL_STATE(1887)] = 55839,
  [SMALL_STATE(1888)] = 55847,
  [SMALL_STATE(1889)] = 55855,
  [SMALL_STATE(1890)] = 55863,
  [SMALL_STATE(1891)] = 55871,
  [SMALL_STATE(1892)] = 55879,
  [SMALL_STATE(1893)] = 55887,
  [SMALL_STATE(1894)] = 55895,
  [SMALL_STATE(1895)] = 55903,
  [SMALL_STATE(1896)] = 55911,
  [SMALL_STATE(1897)] = 55919,
  [SMALL_STATE(1898)] = 55927,
  [SMALL_STATE(1899)] = 55935,
  [SMALL_STATE(1900)] = 55943,
  [SMALL_STATE(1901)] = 55951,
  [SMALL_STATE(1902)] = 55959,
  [SMALL_STATE(1903)] = 55967,
  [SMALL_STATE(1904)] = 55975,
  [SMALL_STATE(1905)] = 55983,
  [SMALL_STATE(1906)] = 55991,
  [SMALL_STATE(1907)] = 55999,
  [SMALL_STATE(1908)] = 56007,
  [SMALL_STATE(1909)] = 56015,
  [SMALL_STATE(1910)] = 56023,
  [SMALL_STATE(1911)] = 56031,
  [SMALL_STATE(1912)] = 56039,
  [SMALL_STATE(1913)] = 56047,
  [SMALL_STATE(1914)] = 56055,
  [SMALL_STATE(1915)] = 56063,
  [SMALL_STATE(1916)] = 56071,
  [SMALL_STATE(1917)] = 56079,
  [SMALL_STATE(1918)] = 56087,
  [SMALL_STATE(1919)] = 56095,
  [SMALL_STATE(1920)] = 56103,
  [SMALL_STATE(1921)] = 56111,
  [SMALL_STATE(1922)] = 56119,
  [SMALL_STATE(1923)] = 56127,
  [SMALL_STATE(1924)] = 56135,
  [SMALL_STATE(1925)] = 56143,
  [SMALL_STATE(1926)] = 56151,
  [SMALL_STATE(1927)] = 56159,
  [SMALL_STATE(1928)] = 56167,
  [SMALL_STATE(1929)] = 56175,
  [SMALL_STATE(1930)] = 56183,
  [SMALL_STATE(1931)] = 56191,
  [SMALL_STATE(1932)] = 56199,
  [SMALL_STATE(1933)] = 56207,
  [SMALL_STATE(1934)] = 56215,
  [SMALL_STATE(1935)] = 56223,
  [SMALL_STATE(1936)] = 56231,
  [SMALL_STATE(1937)] = 56239,
  [SMALL_STATE(1938)] = 56247,
  [SMALL_STATE(1939)] = 56255,
  [SMALL_STATE(1940)] = 56263,
  [SMALL_STATE(1941)] = 56271,
  [SMALL_STATE(1942)] = 56279,
  [SMALL_STATE(1943)] = 56287,
  [SMALL_STATE(1944)] = 56295,
  [SMALL_STATE(1945)] = 56303,
  [SMALL_STATE(1946)] = 56311,
  [SMALL_STATE(1947)] = 56319,
  [SMALL_STATE(1948)] = 56327,
  [SMALL_STATE(1949)] = 56335,
  [SMALL_STATE(1950)] = 56343,
  [SMALL_STATE(1951)] = 56351,
  [SMALL_STATE(1952)] = 56359,
  [SMALL_STATE(1953)] = 56367,
  [SMALL_STATE(1954)] = 56375,
  [SMALL_STATE(1955)] = 56383,
  [SMALL_STATE(1956)] = 56391,
  [SMALL_STATE(1957)] = 56399,
  [SMALL_STATE(1958)] = 56407,
  [SMALL_STATE(1959)] = 56415,
  [SMALL_STATE(1960)] = 56423,
  [SMALL_STATE(1961)] = 56431,
  [SMALL_STATE(1962)] = 56439,
  [SMALL_STATE(1963)] = 56447,
  [SMALL_STATE(1964)] = 56455,
  [SMALL_STATE(1965)] = 56463,
  [SMALL_STATE(1966)] = 56471,
  [SMALL_STATE(1967)] = 56479,
  [SMALL_STATE(1968)] = 56487,
  [SMALL_STATE(1969)] = 56495,
  [SMALL_STATE(1970)] = 56503,
  [SMALL_STATE(1971)] = 56511,
  [SMALL_STATE(1972)] = 56519,
  [SMALL_STATE(1973)] = 56527,
  [SMALL_STATE(1974)] = 56535,
  [SMALL_STATE(1975)] = 56543,
  [SMALL_STATE(1976)] = 56551,
  [SMALL_STATE(1977)] = 56559,
  [SMALL_STATE(1978)] = 56567,
  [SMALL_STATE(1979)] = 56575,
  [SMALL_STATE(1980)] = 56583,
  [SMALL_STATE(1981)] = 56591,
  [SMALL_STATE(1982)] = 56599,
  [SMALL_STATE(1983)] = 56607,
  [SMALL_STATE(1984)] = 56615,
  [SMALL_STATE(1985)] = 56623,
  [SMALL_STATE(1986)] = 56631,
  [SMALL_STATE(1987)] = 56639,
  [SMALL_STATE(1988)] = 56647,
  [SMALL_STATE(1989)] = 56655,
  [SMALL_STATE(1990)] = 56663,
  [SMALL_STATE(1991)] = 56671,
  [SMALL_STATE(1992)] = 56679,
  [SMALL_STATE(1993)] = 56687,
  [SMALL_STATE(1994)] = 56695,
  [SMALL_STATE(1995)] = 56703,
  [SMALL_STATE(1996)] = 56711,
  [SMALL_STATE(1997)] = 56719,
  [SMALL_STATE(1998)] = 56727,
  [SMALL_STATE(1999)] = 56735,
  [SMALL_STATE(2000)] = 56743,
  [SMALL_STATE(2001)] = 56751,
  [SMALL_STATE(2002)] = 56759,
  [SMALL_STATE(2003)] = 56767,
  [SMALL_STATE(2004)] = 56775,
  [SMALL_STATE(2005)] = 56783,
  [SMALL_STATE(2006)] = 56791,
  [SMALL_STATE(2007)] = 56799,
  [SMALL_STATE(2008)] = 56807,
  [SMALL_STATE(2009)] = 56815,
  [SMALL_STATE(2010)] = 56823,
  [SMALL_STATE(2011)] = 56831,
  [SMALL_STATE(2012)] = 56839,
  [SMALL_STATE(2013)] = 56847,
  [SMALL_STATE(2014)] = 56855,
  [SMALL_STATE(2015)] = 56863,
  [SMALL_STATE(2016)] = 56871,
  [SMALL_STATE(2017)] = 56879,
  [SMALL_STATE(2018)] = 56887,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [7] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ql, 0, 0, 0),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1186),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1608),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1462),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1776),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1386),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(343),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1803),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1441),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1792),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(818),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(221),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(349),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2007),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1872),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1777),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(883),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(885),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(891),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(896),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(704),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(347),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1983),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(771),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(772),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(773),
  [139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1726),
  [219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(240),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(256),
  [295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(368),
  [301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(193),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(345),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1993),
  [309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(424),
  [315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(425),
  [319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(426),
  [321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(427),
  [323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(351),
  [331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1837),
  [333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(470),
  [339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(471),
  [343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(472),
  [345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(473),
  [347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1989),
  [349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1817),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1960),
  [381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_full_aggregate_body, 1, 0, 0),
  [393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1975),
  [405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_full_aggregate_body, 3, 0, 0),
  [423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1917),
  [427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1820),
  [443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_full_aggregate_body, 2, 0, 0),
  [463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(370),
  [469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(244),
  [473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(353),
  [475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1864),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(513),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(514),
  [487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(598),
  [489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(516),
  [491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(265),
  [505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1918),
  [509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(556),
  [515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(557),
  [519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(558),
  [521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(559),
  [523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(815),
  [535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(255),
  [539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1891),
  [543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1007),
  [549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1011),
  [553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1012),
  [555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1013),
  [557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_orderBy, 1, 0, 0),
  [581] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_orderBy, 1, 0, 0),
  [583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(467),
  [585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(300),
  [589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1420),
  [591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(360),
  [593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(309),
  [595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(310),
  [597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(469),
  [603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1208),
  [605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simpleId, 1, 0, 0),
  [607] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_simpleId, 1, 0, 0),
  [609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literalId, 1, 0, 0),
  [611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotName, 1, 0, 0),
  [613] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_literalId, 1, 0, 0), REDUCE(sym_simpleId, 1, 0, 0),
  [616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1412),
  [620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(366),
  [622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(185),
  [624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(186),
  [626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1184),
  [628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_add_expr, 3, 0, 12),
  [630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_add_expr, 3, 0, 12),
  [632] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_disjunction, 3, 0, 12),
  [634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_disjunction, 3, 0, 12),
  [636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1411),
  [638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(359),
  [640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conjunction, 3, 0, 12),
  [644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conjunction, 3, 0, 12),
  [646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expr, 2, 0, 0),
  [648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expr, 2, 0, 0),
  [650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefix_cast, 4, 10, 0),
  [652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefix_cast, 4, 10, 0),
  [654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_implication, 3, 0, 12),
  [656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implication, 3, 0, 12),
  [658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_negation, 2, 0, 0),
  [662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_negation, 2, 0, 0),
  [664] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_simpleId, 1, 0, 0), REDUCE(sym_className, 1, 0, 0),
  [667] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_asExpr, 1, 0, 0),
  [669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asExpr, 1, 0, 0),
  [671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1587),
  [673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comp_term, 3, 0, 12),
  [677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comp_term, 3, 0, 12),
  [679] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mul_expr, 3, 0, 12),
  [681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mul_expr, 3, 0, 12),
  [683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_term, 6, 0, 36),
  [685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_term, 6, 0, 36),
  [687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1417),
  [689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(364),
  [691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1539),
  [699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_varName, 1, 0, 0),
  [701] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_moduleName, 1, 0, 0), REDUCE(sym_varName, 1, 0, 0),
  [704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_varName, 1, 0, 0),
  [706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_moduleExpr, 1, 0, 0),
  [708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_body, 2, 0, 0),
  [710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_body, 2, 0, 0),
  [712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal, 1, 0, 0),
  [714] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal, 1, 0, 0),
  [716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bool, 1, 0, 0),
  [718] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bool, 1, 0, 0),
  [720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable, 1, 0, 0),
  [722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable, 1, 0, 0),
  [724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_super_ref, 1, 0, 0),
  [726] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_super_ref, 1, 0, 0),
  [728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exprOrTerm, 1, 0, 0),
  [730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exprOrTerm, 1, 0, 0),
  [732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_literal, 2, 0, 0),
  [736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_literal, 2, 0, 0),
  [738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_or_unqual_agg_expr, 2, 10, 0),
  [740] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_or_unqual_agg_expr, 2, 10, 0),
  [742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_par_expr, 3, 0, 0),
  [744] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_par_expr, 3, 0, 0),
  [746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_literal, 3, 0, 0),
  [748] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_literal, 3, 0, 0),
  [750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_in_expr, 3, 0, 12),
  [752] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_in_expr, 3, 0, 12),
  [754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_expr, 3, 0, 0),
  [756] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_expr, 3, 0, 0),
  [758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_super_ref, 3, 0, 0),
  [760] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_super_ref, 3, 0, 0),
  [762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_or_unqual_agg_expr, 3, 10, 0),
  [764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_or_unqual_agg_expr, 3, 10, 0),
  [766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_aggregate, 3, 0, 0),
  [768] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_aggregate, 3, 0, 0),
  [770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_literal, 4, 0, 0),
  [772] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_literal, 4, 0, 0),
  [774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unqual_agg_body, 3, 0, 0),
  [776] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unqual_agg_body, 3, 0, 0),
  [778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_body, 3, 0, 0),
  [780] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_body, 3, 0, 0),
  [782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_aggregate, 4, 0, 0),
  [784] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_aggregate, 4, 0, 0),
  [786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range, 5, 0, 29),
  [788] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range, 5, 0, 29),
  [790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_literal, 5, 0, 0),
  [792] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_literal, 5, 0, 0),
  [794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualifiedRhs, 3, 0, 0),
  [796] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualifiedRhs, 3, 0, 0),
  [798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualifiedRhs, 3, 0, 1),
  [800] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualifiedRhs, 3, 0, 1),
  [802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unqual_agg_body, 4, 0, 31),
  [804] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unqual_agg_body, 4, 0, 31),
  [806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_body, 4, 0, 0),
  [808] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_body, 4, 0, 0),
  [810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unqual_agg_body, 4, 0, 0),
  [812] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unqual_agg_body, 4, 0, 0),
  [814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualifiedRhs, 4, 0, 1),
  [816] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualifiedRhs, 4, 0, 1),
  [818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unqual_agg_body, 5, 0, 38),
  [820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unqual_agg_body, 5, 0, 38),
  [822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unqual_agg_body, 5, 0, 39),
  [824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unqual_agg_body, 5, 0, 39),
  [826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unqual_agg_body, 5, 0, 0),
  [828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unqual_agg_body, 5, 0, 0),
  [830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_aggregate, 6, 0, 0),
  [832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_aggregate, 6, 0, 0),
  [834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualifiedRhs, 5, 0, 1),
  [836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualifiedRhs, 5, 0, 1),
  [838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expr_annotation, 7, 0, 47),
  [840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expr_annotation, 7, 0, 47),
  [842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unqual_agg_body, 6, 0, 48),
  [844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unqual_agg_body, 6, 0, 48),
  [846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unqual_agg_body, 6, 0, 49),
  [848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unqual_agg_body, 6, 0, 49),
  [850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unqual_agg_body, 6, 0, 50),
  [852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unqual_agg_body, 6, 0, 50),
  [854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_aggregate, 7, 0, 0),
  [856] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_aggregate, 7, 0, 0),
  [858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualifiedRhs, 6, 0, 1),
  [860] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualifiedRhs, 6, 0, 1),
  [862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unqual_agg_body, 7, 0, 60),
  [864] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unqual_agg_body, 7, 0, 60),
  [866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unqual_agg_body, 7, 0, 61),
  [868] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unqual_agg_body, 7, 0, 61),
  [870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_aggregate, 8, 0, 0),
  [872] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_aggregate, 8, 0, 0),
  [874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unqual_agg_body, 8, 0, 69),
  [876] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unqual_agg_body, 8, 0, 69),
  [878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_className, 1, 0, 0),
  [880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_className, 1, 0, 0),
  [882] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_simpleId, 1, 0, 0), REDUCE(sym_className, 1, 0, 0),
  [885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compop, 1, 0, 0),
  [887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compop, 1, 0, 0),
  [889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_addop, 1, 0, 0),
  [891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_addop, 1, 0, 0),
  [893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mulop, 1, 0, 0),
  [895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mulop, 1, 0, 0),
  [897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [899] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unop, 1, 0, 0),
  [901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unop, 1, 0, 0),
  [903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instance_of, 3, 0, 0),
  [909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instance_of, 3, 0, 0),
  [911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quantified, 6, 0, 37),
  [913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quantified, 6, 0, 37),
  [915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quantified, 5, 0, 0),
  [917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quantified, 5, 0, 0),
  [919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typeExpr, 3, 0, 11),
  [921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typeExpr, 3, 0, 11),
  [923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quantified, 7, 0, 45),
  [925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quantified, 7, 0, 45),
  [927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quantified, 7, 0, 46),
  [929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quantified, 7, 0, 46),
  [931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_special_call, 3, 0, 0),
  [933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_special_call, 3, 0, 0),
  [935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitiveType, 1, 0, 0),
  [937] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primitiveType, 1, 0, 0),
  [939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typeExpr, 1, 0, 0),
  [941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typeExpr, 1, 0, 0),
  [943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quantified, 8, 0, 59),
  [945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quantified, 8, 0, 59),
  [947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typeExpr, 1, 0, 1),
  [949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typeExpr, 1, 0, 1),
  [951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quantified, 3, 0, 0),
  [953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quantified, 3, 0, 0),
  [955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quantified, 9, 0, 68),
  [957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quantified, 9, 0, 68),
  [959] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quantified, 4, 0, 17),
  [961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quantified, 4, 0, 17),
  [963] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quantified, 4, 0, 0),
  [965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quantified, 4, 0, 0),
  [967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quantified, 5, 0, 30),
  [969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quantified, 5, 0, 30),
  [971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1575),
  [973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1455),
  [977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1791),
  [979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1329),
  [981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1801),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1802),
  [991] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ql_repeat1, 2, 0, 0), SHIFT_REPEAT(1186),
  [994] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ql_repeat1, 2, 0, 0), SHIFT_REPEAT(1575),
  [997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ql_repeat1, 2, 0, 0),
  [999] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ql_repeat1, 2, 0, 0), SHIFT_REPEAT(1455),
  [1002] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ql_repeat1, 2, 0, 0), SHIFT_REPEAT(1791),
  [1005] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ql_repeat1, 2, 0, 0), SHIFT_REPEAT(1329),
  [1008] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ql_repeat1, 2, 0, 0), SHIFT_REPEAT(341),
  [1011] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ql_repeat1, 2, 0, 0), SHIFT_REPEAT(67),
  [1014] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ql_repeat1, 2, 0, 0), SHIFT_REPEAT(1801),
  [1017] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_ql_repeat1, 2, 0, 0), SHIFT_REPEAT(1228),
  [1020] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ql_repeat1, 2, 0, 0), SHIFT_REPEAT(1441),
  [1023] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_ql_repeat1, 2, 0, 0), SHIFT_REPEAT(1437),
  [1026] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_ql_repeat1, 2, 0, 0), SHIFT_REPEAT(1439),
  [1029] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ql_repeat1, 2, 0, 0), SHIFT_REPEAT(1802),
  [1032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [1034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [1036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [1038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [1040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [1042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [1044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [1046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [1048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [1050] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ql_repeat1, 2, 0, 0), SHIFT_REPEAT(1608),
  [1053] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ql_repeat1, 2, 0, 0), SHIFT_REPEAT(1462),
  [1056] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ql_repeat1, 2, 0, 0), SHIFT_REPEAT(1776),
  [1059] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ql_repeat1, 2, 0, 0), SHIFT_REPEAT(1386),
  [1062] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ql_repeat1, 2, 0, 0), SHIFT_REPEAT(343),
  [1065] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ql_repeat1, 2, 0, 0), SHIFT_REPEAT(66),
  [1068] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ql_repeat1, 2, 0, 0), SHIFT_REPEAT(1803),
  [1071] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_ql_repeat1, 2, 0, 0), SHIFT_REPEAT(1300),
  [1074] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ql_repeat1, 2, 0, 0), SHIFT_REPEAT(1792),
  [1077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [1083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [1087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [1091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [1093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [1095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [1097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [1099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [1101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [1103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [1105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [1107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [1109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [1111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [1113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [1115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [1117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ql, 1, 0, 0),
  [1119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [1121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [1123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [1125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [1127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [1129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [1131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [1133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1790),
  [1137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [1139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [1141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [1143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [1145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [1147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [1149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [1151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [1153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1578),
  [1155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [1157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [1159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [1161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [1163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [1165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [1167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [1169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [1171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [1173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [1175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [1177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [1179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [1181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [1183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [1185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [1187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [1189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [1191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [1193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [1195] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_dataclass_repeat2, 2, 0, 0), SHIFT_REPEAT(1186),
  [1198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dataclass_repeat2, 2, 0, 0),
  [1200] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dataclass_repeat2, 2, 0, 0), SHIFT_REPEAT(1438),
  [1203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_dataclass_repeat2, 2, 0, 0), SHIFT_REPEAT(1441),
  [1206] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dataclass_repeat2, 2, 0, 0), SHIFT_REPEAT(1437),
  [1209] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dataclass_repeat2, 2, 0, 0), SHIFT_REPEAT(1439),
  [1212] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_dataclass_repeat2, 2, 0, 0), SHIFT_REPEAT(1790),
  [1215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [1217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [1219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [1221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [1223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [1225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [1227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [1229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [1233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(362),
  [1235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [1237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [1239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [1241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [1243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [1245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [1247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [1249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [1251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(365),
  [1253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [1255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [1257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [1259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [1261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [1263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [1265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [1267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [1269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [1271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(239),
  [1273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [1275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [1281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [1283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [1285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [1287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [1289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [1295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [1297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [1299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [1301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [1303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [1305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [1307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [1309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [1315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [1317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_moduleExpr, 1, 0, 0),
  [1319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_moduleName, 1, 0, 0),
  [1321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [1323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1895),
  [1325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1824),
  [1327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [1331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1905),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1932),
  [1335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_arg, 1, 0, 0),
  [1337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_datatypeBranch, 5, 0, 10),
  [1339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_datatypeBranch, 5, 0, 10),
  [1341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [1343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_datatypeBranch, 5, 0, 2),
  [1345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_datatypeBranch, 5, 0, 2),
  [1347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_asExprs_repeat1, 2, 0, 0),
  [1349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_asExprs_repeat1, 2, 0, 0),
  [1351] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_asExprs_repeat1, 2, 0, 0), SHIFT_REPEAT(149),
  [1354] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_datatypeBranch, 4, 0, 2),
  [1356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [1358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_datatypeBranch, 4, 0, 2),
  [1360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [1362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [1364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [1366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [1368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_datatypeBranch, 4, 0, 1),
  [1370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_datatypeBranch, 4, 0, 1),
  [1372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [1374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [1376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [1378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [1380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [1382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [1384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_datatypeBranch, 5, 0, 1),
  [1386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_datatypeBranch, 5, 0, 1),
  [1388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_asExprs, 1, 0, 0),
  [1390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [1392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asExprs, 1, 0, 0),
  [1394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [1396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [1398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [1400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [1402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_datatypeBranch, 3, 0, 1),
  [1404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_datatypeBranch, 3, 0, 1),
  [1406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asExprs, 2, 0, 0),
  [1408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_asExprs, 2, 0, 0),
  [1410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [1412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_moduleExpr, 3, 0, 10),
  [1414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_moduleExpr, 3, 0, 10),
  [1416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [1418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [1420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [1422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [1424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [1426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [1428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [1430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [1432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [1434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [1436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [1438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [1440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [1442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [1444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [1446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [1448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_aggregate_repeat1, 2, 0, 0),
  [1450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [1452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [1454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [1456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [1458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [1460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [1462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [1464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [1466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [1468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [1470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [1472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [1474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [1476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [1478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [1480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [1482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [1484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [1486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [1488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [1490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [1492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [1494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [1496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [1498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [1500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [1502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_full_aggregate_body, 2, 0, 18),
  [1504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [1506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_datatypeBranch, 6, 0, 10),
  [1508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_datatypeBranch, 6, 0, 10),
  [1510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_datatypeBranch, 6, 0, 2),
  [1512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_datatypeBranch, 6, 0, 2),
  [1514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [1516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [1518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [1520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [1522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [1524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [1526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [1528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [1530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [1532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [1534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [1536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [1538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [1540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [1542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [1544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [1546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [1548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [1550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [1552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [1554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [1556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [1558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [1560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [1562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_full_aggregate_body, 4, 0, 39),
  [1564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [1566] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_datatypeBranch, 7, 0, 10),
  [1568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_datatypeBranch, 7, 0, 10),
  [1570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [1572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [1574] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_asExprs_repeat1, 2, 0, 0), SHIFT_REPEAT(153),
  [1577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [1579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [1581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_full_aggregate_body, 3, 0, 31),
  [1583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [1585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [1587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [1589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [1591] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_select, 6, 0, 0),
  [1593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select, 6, 0, 0),
  [1595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1813),
  [1597] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_select, 7, 0, 0),
  [1599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select, 7, 0, 0),
  [1601] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_datatypeBranches_repeat1, 2, 0, 0),
  [1603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_datatypeBranches_repeat1, 2, 0, 0),
  [1605] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_datatypeBranches_repeat1, 2, 0, 0), SHIFT_REPEAT(1487),
  [1608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [1610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_datatypeBranches, 1, 0, 0),
  [1612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_datatypeBranches, 1, 0, 0),
  [1614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1488),
  [1616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [1618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select, 4, 0, 0),
  [1620] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_select, 4, 0, 0),
  [1622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1854),
  [1624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_importModuleExpr, 1, 0, 0),
  [1626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_importModuleExpr, 1, 0, 0),
  [1628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [1630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [1632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1435),
  [1634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [1636] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_asExpr, 3, 0, 0),
  [1638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asExpr, 3, 0, 0),
  [1640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_moduleInstantiation, 4, 0, 1),
  [1642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_moduleInstantiation, 4, 0, 1),
  [1644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_orderBys, 3, 0, 0),
  [1646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [1648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_orderBys, 3, 0, 0),
  [1650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_moduleInstantiation, 5, 0, 1),
  [1652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_moduleInstantiation, 5, 0, 1),
  [1654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [1656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [1658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_orderBys, 4, 0, 0),
  [1660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_orderBys, 4, 0, 0),
  [1662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [1664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [1666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [1668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [1670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_orderBys_repeat1, 2, 0, 0),
  [1672] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_orderBys_repeat1, 2, 0, 0),
  [1674] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_orderBys_repeat1, 2, 0, 0), SHIFT_REPEAT(163),
  [1677] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_orderBys_repeat1, 2, 0, 0), SHIFT_REPEAT(165),
  [1680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [1682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [1684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_select, 2, 0, 0),
  [1686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select, 2, 0, 0),
  [1688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [1690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [1692] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_importModuleExpr, 2, 0, 4),
  [1694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_importModuleExpr, 2, 0, 4),
  [1696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_select, 3, 0, 0),
  [1698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select, 3, 0, 0),
  [1700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [1702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [1704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [1706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [1708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [1710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [1712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [1714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [1716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [1718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_datatypeBranches, 2, 0, 0),
  [1720] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_datatypeBranches, 2, 0, 0),
  [1722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [1724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select, 5, 0, 0),
  [1726] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_select, 5, 0, 0),
  [1728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [1730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [1732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [1734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [1736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [1738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [1740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [1742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [1744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [1746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [1748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [1750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [1752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [1754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [1756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1487),
  [1758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [1760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [1762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [1764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [1766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [1768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [1770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [1772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [1774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [1776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [1778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [1780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [1782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [1784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [1786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [1788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [1790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [1792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [1794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [1796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [1798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [1800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [1802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [1804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [1806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [1808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [1810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [1812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [1814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [1816] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_datatypeBranches_repeat1, 2, 0, 0), SHIFT_REPEAT(1488),
  [1819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [1821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [1823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [1825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [1827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [1829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [1831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [1833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [1835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [1837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [1839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [1841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_direction, 1, 0, 0),
  [1843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_direction, 1, 0, 0),
  [1845] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_moduleMember_repeat1, 2, 0, 0), SHIFT_REPEAT(1343),
  [1848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_moduleMember_repeat1, 2, 0, 0),
  [1850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_moduleMember_repeat1, 2, 0, 0),
  [1852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotName, 1, 0, 0),
  [1854] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_datatypeBranch, 8, 0, 10),
  [1856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_datatypeBranch, 8, 0, 10),
  [1858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_body, 3, 0, 0),
  [1860] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_body, 3, 0, 0),
  [1862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_datatypeBranch, 6, 0, 1),
  [1864] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_datatypeBranch, 6, 0, 1),
  [1866] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_datatypeBranch, 7, 0, 2),
  [1868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_datatypeBranch, 7, 0, 2),
  [1870] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_orderBy, 2, 0, 0),
  [1872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_orderBy, 2, 0, 0),
  [1874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_importDirective, 2, 0, 0),
  [1876] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_importDirective, 2, 0, 0),
  [1878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1560),
  [1880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1568),
  [1882] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 8, 0, 27),
  [1884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 8, 0, 27),
  [1886] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_moduleMember, 1, 0, 0),
  [1888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_moduleMember, 1, 0, 0),
  [1890] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dataclass, 6, 0, 21),
  [1892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dataclass, 6, 0, 21),
  [1894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dataclass, 6, 0, 34),
  [1896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dataclass, 6, 0, 34),
  [1898] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typeUnionBody, 6, 0, 0),
  [1900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typeUnionBody, 6, 0, 0),
  [1902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dataclass, 8, 0, 43),
  [1904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dataclass, 8, 0, 43),
  [1906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select, 8, 0, 0),
  [1908] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_select, 8, 0, 0),
  [1910] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dataclass, 8, 0, 55),
  [1912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dataclass, 8, 0, 55),
  [1914] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dataclass, 8, 0, 33),
  [1916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dataclass, 8, 0, 33),
  [1918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dataclass, 8, 0, 56),
  [1920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dataclass, 8, 0, 56),
  [1922] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dataclass, 8, 0, 34),
  [1924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dataclass, 8, 0, 34),
  [1926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dataclass, 4, 0, 2),
  [1928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dataclass, 4, 0, 2),
  [1930] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 9, 0, 44),
  [1932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 9, 0, 44),
  [1934] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 9, 0, 57),
  [1936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 9, 0, 57),
  [1938] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_moduleName, 1, 0, 0),
  [1940] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 9, 0, 58),
  [1942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 9, 0, 58),
  [1944] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 9, 0, 35),
  [1946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 9, 0, 35),
  [1948] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_classlessPredicate, 6, 0, 6),
  [1950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_classlessPredicate, 6, 0, 6),
  [1952] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 7, 0, 24),
  [1954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 7, 0, 24),
  [1956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dataclass, 9, 0, 43),
  [1958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dataclass, 9, 0, 43),
  [1960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dataclass, 9, 0, 55),
  [1962] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dataclass, 9, 0, 55),
  [1964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 8, 0, 44),
  [1966] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 8, 0, 44),
  [1968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dataclass, 9, 0, 56),
  [1970] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dataclass, 9, 0, 56),
  [1972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 3, 0, 2),
  [1974] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 3, 0, 2),
  [1976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typeUnionBody, 5, 0, 0),
  [1978] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typeUnionBody, 5, 0, 0),
  [1980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dataclass, 9, 0, 66),
  [1982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dataclass, 9, 0, 66),
  [1984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 10, 0, 44),
  [1986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 10, 0, 44),
  [1988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_moduleMember, 2, 0, 0),
  [1990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_moduleMember, 2, 0, 0),
  [1992] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 10, 0, 57),
  [1994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 10, 0, 57),
  [1996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 10, 0, 58),
  [1998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 10, 0, 58),
  [2000] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 10, 0, 67),
  [2002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 10, 0, 67),
  [2004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 7, 0, 35),
  [2006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 7, 0, 35),
  [2008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 8, 0, 24),
  [2010] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 8, 0, 24),
  [2012] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 7, 0, 16),
  [2014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 7, 0, 16),
  [2016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 7, 0, 27),
  [2018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 7, 0, 27),
  [2020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dataclass, 10, 0, 55),
  [2022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dataclass, 10, 0, 55),
  [2024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dataclass, 10, 0, 56),
  [2026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dataclass, 10, 0, 56),
  [2028] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dataclass, 10, 0, 66),
  [2030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dataclass, 10, 0, 66),
  [2032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_higherOrderTerm, 6, 0, 2),
  [2034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_higherOrderTerm, 6, 0, 2),
  [2036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 11, 0, 57),
  [2038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 11, 0, 57),
  [2040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 11, 0, 58),
  [2042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 11, 0, 58),
  [2044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 5, 0, 16),
  [2046] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 5, 0, 16),
  [2048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 11, 0, 67),
  [2050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 11, 0, 67),
  [2052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 5, 0, 2),
  [2054] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 5, 0, 2),
  [2056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_moduleAliasBody, 3, 0, 0),
  [2058] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_moduleAliasBody, 3, 0, 0),
  [2060] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dataclass, 11, 0, 66),
  [2062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dataclass, 11, 0, 66),
  [2064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_higherOrderTerm, 7, 0, 2),
  [2066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_higherOrderTerm, 7, 0, 2),
  [2068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 12, 0, 67),
  [2070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 12, 0, 67),
  [2072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_higherOrderTerm, 8, 0, 2),
  [2074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_higherOrderTerm, 8, 0, 2),
  [2076] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_higherOrderTerm, 9, 0, 2),
  [2078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_higherOrderTerm, 9, 0, 2),
  [2080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_higherOrderTerm, 10, 0, 2),
  [2082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_higherOrderTerm, 10, 0, 2),
  [2084] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dataclass, 3, 0, 2),
  [2086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dataclass, 3, 0, 2),
  [2088] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_classlessPredicate, 3, 0, 6),
  [2090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_classlessPredicate, 3, 0, 6),
  [2092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 8, 0, 35),
  [2094] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 8, 0, 35),
  [2096] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 4, 0, 2),
  [2098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 4, 0, 2),
  [2100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_importDirective, 4, 0, 0),
  [2102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_importDirective, 4, 0, 0),
  [2104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_datatype, 4, 0, 2),
  [2106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_datatype, 4, 0, 2),
  [2108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dataclass, 7, 0, 21),
  [2110] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dataclass, 7, 0, 21),
  [2112] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dataclass, 7, 0, 34),
  [2114] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dataclass, 7, 0, 34),
  [2116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dataclass, 7, 0, 20),
  [2118] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dataclass, 7, 0, 20),
  [2120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dataclass, 7, 0, 43),
  [2122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dataclass, 7, 0, 43),
  [2124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dataclass, 5, 0, 2),
  [2126] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dataclass, 5, 0, 2),
  [2128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typeAliasBody, 3, 0, 0),
  [2130] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typeAliasBody, 3, 0, 0),
  [2132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dataclass, 5, 0, 20),
  [2134] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dataclass, 5, 0, 20),
  [2136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dataclass, 5, 0, 21),
  [2138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dataclass, 5, 0, 21),
  [2140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_classlessPredicate, 7, 0, 6),
  [2142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_classlessPredicate, 7, 0, 6),
  [2144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_predicateAliasBody, 3, 0, 0),
  [2146] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_predicateAliasBody, 3, 0, 0),
  [2148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1433),
  [2150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [2152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(68),
  [2154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty, 1, 0, 0),
  [2156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty, 1, 0, 0),
  [2158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_classlessPredicate, 5, 0, 6),
  [2160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_classlessPredicate, 5, 0, 6),
  [2162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dataclass, 7, 0, 33),
  [2164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dataclass, 7, 0, 33),
  [2166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 6, 0, 24),
  [2168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 6, 0, 24),
  [2170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 6, 0, 16),
  [2172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 6, 0, 16),
  [2174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 6, 0, 27),
  [2176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 6, 0, 27),
  [2178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typeUnionBody, 4, 0, 0),
  [2180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typeUnionBody, 4, 0, 0),
  [2182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dataclass, 6, 0, 20),
  [2184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dataclass, 6, 0, 20),
  [2186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dataclass, 6, 0, 33),
  [2188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dataclass, 6, 0, 33),
  [2190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(209),
  [2192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(77),
  [2194] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation, 1, 0, 1),
  [2196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [2198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation, 1, 0, 1),
  [2200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [2202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [2204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [2206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [2208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [2210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [2212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [2214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [2216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [2218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [2220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [2222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation, 5, 0, 22),
  [2224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation, 5, 0, 22),
  [2226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation, 4, 0, 14),
  [2228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation, 4, 0, 14),
  [2230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1066),
  [2232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [2234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [2236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(660),
  [2238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [2240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [2242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(621),
  [2244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [2246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [2248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1040),
  [2250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [2252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [2254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(618),
  [2256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [2258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [2260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(610),
  [2262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [2264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [2266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(803),
  [2268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [2270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [2272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literalId, 1, 0, 0),
  [2274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_classMember, 2, 0, 0),
  [2276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_classMember, 2, 0, 0),
  [2278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_classMember, 1, 0, 0),
  [2280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_classMember, 1, 0, 0),
  [2282] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_charpred, 6, 0, 65),
  [2284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_charpred, 6, 0, 65),
  [2286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field, 2, 0, 0),
  [2288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 2, 0, 0),
  [2290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_memberPredicate, 6, 0, 6),
  [2292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_memberPredicate, 6, 0, 6),
  [2294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_memberPredicate, 5, 0, 6),
  [2296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_memberPredicate, 5, 0, 6),
  [2298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_memberPredicate, 7, 0, 6),
  [2300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_memberPredicate, 7, 0, 6),
  [2302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [2304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [2306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1986),
  [2308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [2310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [2312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1514),
  [2314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [2316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [2318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [2320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_predicateExpr, 3, 0, 0),
  [2322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_signatureExpr, 1, 0, 7),
  [2324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [2326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [2328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [2330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [2332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [2334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [2336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [2338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [2340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [2342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [2344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [2346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [2348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [2350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [2352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [2354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [2356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [2358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [2360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [2362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [2364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [2366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [2368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [2370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [2372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [2374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_signatureExpr, 1, 0, 9),
  [2376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1804),
  [2378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_varDecl, 2, 0, 0),
  [2380] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_classlessPredicate_repeat1, 2, 0, 0), SHIFT_REPEAT(1405),
  [2383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_classlessPredicate_repeat1, 2, 0, 0),
  [2385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_signatureExpr, 1, 0, 8),
  [2387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [2389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [2391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [2393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1829),
  [2395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [2397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [2399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [2401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [2403] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dataclass_repeat1, 2, 0, 0), SHIFT_REPEAT(1429),
  [2406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dataclass_repeat1, 2, 0, 0),
  [2408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [2410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [2412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [2414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [2418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [2420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [2422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [2424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [2426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [2428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [2430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [2432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [2434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [2438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [2440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [2442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [2444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [2446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [2448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [2450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [2452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [2456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [2458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [2460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [2462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [2464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [2466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [2468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [2470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [2472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [2474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [2476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_predicateName, 1, 0, 0),
  [2478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [2480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [2482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [2484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [2486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [2488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [2490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [2492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_aritylessPredicateExpr, 3, 0, 11),
  [2494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_aritylessPredicateExpr, 3, 0, 11),
  [2496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [2498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [2500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [2502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [2504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [2506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [2508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [2510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [2512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [2514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [2516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [2518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [2520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [2522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [2524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [2526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [2528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [2530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [2532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [2534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [2536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [2538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [2540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [2542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [2544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [2546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [2548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [2550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [2552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [2554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [2556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [2558] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_asExprs_repeat1, 2, 0, 0), SHIFT_REPEAT(171),
  [2561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [2563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [2565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [2567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [2569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [2571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [2573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [2575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [2577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [2579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [2581] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_importModuleExpr_repeat1, 2, 0, 5), SHIFT_REPEAT(1433),
  [2584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [2586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [2588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [2590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [2592] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat2, 2, 0, 28), SHIFT_REPEAT(1211),
  [2595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_repeat2, 2, 0, 28),
  [2597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [2599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [2601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [2603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [2605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [2607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [2609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [2611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [2613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_aritylessPredicateExpr, 1, 0, 1),
  [2615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_aritylessPredicateExpr, 1, 0, 1),
  [2617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [2619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [2621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [2623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [2625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [2627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [2629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [2631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [2633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [2635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [2637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [2639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [2641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [2643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [2645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [2647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [2649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [2651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [2653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [2655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [2657] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_asExprs_repeat1, 2, 0, 0), SHIFT_REPEAT(157),
  [2660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [2662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [2664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [2666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [2668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [2670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [2672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [2674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_full_aggregate_body, 5, 0, 53),
  [2676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1840),
  [2678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [2680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_full_aggregate_body, 5, 0, 54),
  [2682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [2684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [2686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [2688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [2690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [2692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [2694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [2696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [2698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [2700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [2702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [2704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [2706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [2708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [2710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [2712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [2714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [2716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [2718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [2720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [2722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [2724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [2726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [2728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [2730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [2732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [2734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [2736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [2738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [2740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [2742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [2744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [2746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [2748] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_higherOrderTerm_repeat1, 2, 0, 0), SHIFT_REPEAT(1450),
  [2751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_higherOrderTerm_repeat1, 2, 0, 0),
  [2753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [2755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [2757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [2759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expr_aggregate_body, 1, 0, 13),
  [2761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [2763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [2765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [2767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [2769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [2771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [2773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [2775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [2777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [2779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [2781] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_annotation_repeat1, 2, 0, 0), SHIFT_REPEAT(1498),
  [2784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_annotation_repeat1, 2, 0, 0),
  [2786] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_moduleInstantiation_repeat1, 2, 0, 0), SHIFT_REPEAT(1226),
  [2789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_moduleInstantiation_repeat1, 2, 0, 0),
  [2791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [2793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [2795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [2797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [2799] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 25), SHIFT_REPEAT(1105),
  [2802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 25),
  [2804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_repeat2, 2, 0, 26),
  [2806] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_aggregate_repeat1, 2, 0, 0), SHIFT_REPEAT(246),
  [2809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [2811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_full_aggregate_body, 4, 0, 42),
  [2813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [2815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [2817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [2819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [2821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [2823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [2825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_typeUnionBody_repeat1, 2, 0, 0),
  [2827] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_typeUnionBody_repeat1, 2, 0, 0), SHIFT_REPEAT(1416),
  [2830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [2832] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_orderBys_repeat1, 2, 0, 0), SHIFT_REPEAT(166),
  [2835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [2837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [2839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_full_aggregate_body, 4, 0, 41),
  [2841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [2843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [2845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [2847] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_higherOrderTerm_repeat2, 2, 0, 0), SHIFT_REPEAT(93),
  [2850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_higherOrderTerm_repeat2, 2, 0, 0),
  [2852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [2854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [2856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [2858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_full_aggregate_body, 3, 0, 32),
  [2860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [2862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [2864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [2866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [2868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [2870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [2872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [2874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [2876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [2878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [2880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [2882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [2884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [2886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [2888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [2890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [2892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [2894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1990),
  [2896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2004),
  [2898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [2900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [2902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [2904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [2906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [2908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [2910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [2912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [2914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [2916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [2918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_full_aggregate_body, 6, 0, 64),
  [2920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [2922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [2924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [2926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [2928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [2930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [2932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [2934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [2936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [2938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_importModuleExpr_repeat1, 2, 0, 3),
  [2940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 23),
  [2942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [2944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [2946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [2948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [2950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [2952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [2954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [2956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [2958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_aggId, 1, 0, 0),
  [2960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [2962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [2964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_moduleParam, 2, 0, 15),
  [2966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [2968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [2970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [2972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [2974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [2976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [2978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [2980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [2982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [2984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [2986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [2988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [2990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [2992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [2994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [2996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotArg, 1, 0, 0),
  [2998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [3000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [3002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [3004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [3006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [3008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [3010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [3012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [3014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [3016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [3018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [3020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [3022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [3024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [3026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [3028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [3030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [3032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [3034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [3036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [3038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [3040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [3042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [3044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [3046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [3048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [3050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [3052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [3054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expr_aggregate_body, 2, 0, 19),
  [3056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [3058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [3060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [3062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [3064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [3066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [3068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [3070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [3072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [3074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [3076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [3078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [3080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [3082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [3084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [3086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [3088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [3090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_full_aggregate_body, 5, 0, 52),
  [3092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [3094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [3096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [3098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1950),
  [3100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [3102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [3104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [3106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quantifier, 1, 0, 0),
  [3108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [3110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [3112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [3114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [3116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [3118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [3120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [3122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1835),
  [3124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [3126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [3128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [3130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [3132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [3134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [3136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [3138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1908),
  [3140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [3142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1904),
  [3144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [3146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [3148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [3150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_closure, 1, 0, 0),
  [3152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [3154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [3156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [3158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [3160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [3162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [3164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [3166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [3168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [3170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [3172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [3174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [3176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [3178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [3180] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [3182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [3184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [3186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_full_aggregate_body, 6, 0, 62),
  [3188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [3190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [3192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [3194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [3196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [3198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [3200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [3202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_full_aggregate_body, 6, 0, 63),
  [3204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [3206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [3208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [3210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [3212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [3214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [3216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [3218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [3220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [3222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [3224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [3226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [3228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [3230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [3232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [3234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [3236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [3238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [3240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [3242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [3244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [3246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [3248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [3250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_full_aggregate_body, 4, 0, 40),
  [3252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [3254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [3256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [3258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [3260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [3262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [3264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [3266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [3268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [3270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [3272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [3274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [3276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [3278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [3280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [3282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [3284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [3286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [3288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [3290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [3292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [3294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [3296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [3298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [3300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [3302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_full_aggregate_body, 5, 0, 51),
  [3304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [3306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [3308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1842),
  [3310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [3312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [3314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [3316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [3318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [3320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [3322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1966),
  [3324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_full_aggregate_body, 7, 0, 70),
  [3326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1981),
  [3328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1970),
  [3330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [3332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [3334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [3336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [3338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [3340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1978),
  [3342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1968),
  [3344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [3346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [3348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [3350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [3352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [3354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [3356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [3358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1972),
  [3360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [3362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [3364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1806),
  [3366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [3368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [3370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [3372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [3374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [3376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_ql(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym__lower_id,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
